(define (domain petri)
(:requirements :typing :strips :fluents)
(:types transition place - object)
(:predicates (incoming ?p - place ?t - transition) 
             (outgoing ?t - transition ?p - place)
	    
)

(:functions  (number-of-tokens ?p - place)
	     (incoming-tokens ?t - transition ?p - place)
	     (outgoing-tokens ?t - transition ?p - place)
)
 

(:action fire-transition
	:parameters (?t - transition)
	:precondition 
  		(forall (?p - place)
    			(or (not (incoming ?p ?t)) 
        		    (>= (number-of-tokens ?p) (incoming-tokens ?t ?p))
			)
		)
	:effect
		(and 	(forall(?p - place)
			   (when
					(incoming ?p ?t)
					(decrease (number-of-tokens ?p ) (incoming-tokens ?t ?p ) )
				
			   )
			)
			
			(forall(?p - place)
			   (when
					(outgoing ?t ?p)
					(increase (number-of-tokens ?p ) (outgoing-tokens ?t ?p ) )
				
			   )
			)
			
		)
)

		

)
