#ifndef READERSGTXLREADER_H
#define READERSGTXLREADER_H

#include "gts.h"
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include "algorithm.h"

namespace algorithms {


namespace readers {

class GTXLREADER: public ALGORITHM
{

public:
    GTXLREADER();

    ~GTXLREADER();
    
    virtual void initialize(char *filename);
    
    virtual void run(GTS &GraphGrammar);
   
    
  //  static const IDTYPE lastUsedID = 1;
    
private:

//    HYPERGRAPH * initialGraph;
//    std::list<pair<HYPERGRAPH,HYPERGRAPH> > rules;

   // GTS GraphGrammar;

    xmlDocPtr doc; 
     
    HYPERGRAPH ReadHypergraph(xmlNodePtr node, set<string> &ids, IDTYPE lastID);
    
    xmlNodePtr GetChildrenNode(xmlNodePtr parent, char* child_name);
    
    xmlNodePtr GetNextChild(xmlNodePtr child1, char* child_name);
    
    xmlNodePtr GetRelend(xmlNodePtr rel, int order);
    
//    IDTYPE createNewID();
    
    
    
};
};
};

using namespace algorithms;
using namespace readers;

#endif
