/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "abstraction_refinement.h"

namespace algorithms {

namespace refinement {

ABSTRACTION_REFINEMENT::ABSTRACTION_REFINEMENT()
{
 this->ID = ALGORITHM_REFINEMENT;
 this->name = "abstraction_refinement";
 au=NULL;
}


ABSTRACTION_REFINEMENT::~ABSTRACTION_REFINEMENT()
{
}

void ABSTRACTION_REFINEMENT::initialize(GTS* i_grammar, ALGORITHM* i_gxlwriter)
{
	if(au==NULL)
	 	au = load("call_unfolding");
	au->initialize(i_grammar, i_gxlwriter);
}

void ABSTRACTION_REFINEMENT::run(PETRIGRAPH* pg)
{
	if(au==NULL)
	{
		cout << "\nABSTRACTION_REFINEMENT: internal error, pointer to zero\n";
		exit(1);
	}	
	
	au->run(pg);
}

}

}


