/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ABSTRACTION_REFINEMENT_H
#define ABSTRACTION_REFINEMENT_H

#include "algorithm.h"
#include "approximated_unfolding.h"

namespace algorithms {

namespace refinement {

class ABSTRACTION_REFINEMENT : public ALGORITHM {
public:
    ABSTRACTION_REFINEMENT();

    ~ABSTRACTION_REFINEMENT();
    
    // This class calls the APPROXIMATED_UNFOLDING algorithm.
    // The purpose of this class is to have a point
    // telling the database that we make the refinement 
    virtual void initialize(GTS* i_grammar, ALGORITHM* i_gxlwriter);
    virtual void run(PETRIGRAPH* pg);
    
private:

    ALGORITHM * au;    

};

};

};

using namespace algorithms;
using namespace refinement;

#endif
