/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef AGGREADER_H
#define AGGREADER_H
#include "gts.h"
#include "petrigraph.h"

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include <exception>
#include "algorithm.h"
#include "globals.h"

using namespace data_structures;

namespace algorithms{

	namespace readers{

 	class AGGREADER : public ALGORITHM{
		public:
			AGGREADER();
    		virtual ~AGGREADER();
			void start();
			virtual void 	initialize(char *filename);
			virtual void 	run(GTS &GraphGrammar);
		private:
			HYPERGRAPH initial;
			map<string, VERTEX> 	vertexes;
			map<string, EDGE>		edges;
			map<string, int>		lines;
			map<string, EXPRESSION> exprs;
			map<string, int>		numOfExprs;
		//Fürs xml Parsen
			xmlDocPtr 		doc;
			xmlNodePtr 		GetNextChild(xmlNodePtr child1, char* child_name);
			xmlNodePtr 		GetChildrenNode(xmlNodePtr parent, char* child_name);
		//Eigene Methoden
			void 			readTypes(xmlNodePtr types);
			HYPERGRAPH 		readHypergraph(xmlNodePtr graph);
			void			readRules(xmlNodePtr firstRule, GTS& GraphGrammar);
			bool 			isVertex(string ID);
			string getProp(xmlNodePtr ptr, char* name);
			TYPES types(string input);
			string between(string search, char first, char second);
			string untill(string search, char till);
			IDTYPE getID(string xmlID);
		};
	}
}

#endif
