/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "algorithm.h"
#include "algorithm_storage.h"
#include "binding.h"

namespace algorithm
{
   ALGORITHM::ALGORITHM()
   {
      this->ID = ALGORITHM_NONE;
      this->lablist = list<LABEL>();
      this->name = "none";
      this->reusable = false;
   }

   ALGORITHM::~ALGORITHM()
   {
   }
   
   string ALGORITHM::getName()
   {
   	return name;
   }
   
   list<LABEL> ALGORITHM::getIdentifiers()
   {
      return this->lablist;
   }
   
   /////////////////////////////// initializes ////////////////////////////////////
      
   void ALGORITHM::initialize()
   {
      cerr << "error: method initialize of abstract class ALGORITHM called.\n";
      cerr << "this ALGORITHM has ID " << this->ID << " and name '" << this->name << "'.\n";
      exit(-1);
   }
   void ALGORITHM::initialize( PETRIGRAPH* i_petrigraph, IDTYPE i_prule_id, 
                               RULE* i_prule)
   {
      cerr << "warning: possibly this ALGORITHM should be a FIRST_MATCHHANDLER";
      cerr << " (ID " << ALGORITHM_FIRST_MATCHHANDLER << ").\n";
      this->ALGORITHM::initialize();
   }
   void ALGORITHM::initialize( PETRIGRAPH* i_petrigraph, IDTYPE i_prule_id, 
                               RULE* i_prule, bool* i_canFold, bool* i_canUnfold)
   {
      cerr << "warning: possibly this ALGORITHM should be a FIRST_MATCHHANDLER";
      cerr << " (ID " << ALGORITHM_FIRST_MATCHHANDLER << ").\n";
      this->ALGORITHM::initialize();
   }
   void ALGORITHM::initialize( PETRIGRAPH* i_petrigraph, IDTYPE i_prule_id, 
                               RULE* i_prule, bool* i_canFold,
			       bool* i_canUnfold, MATCH* i_phicpy, MATCH* i_phi2cpy )
   {
      cerr << "warning: possibly this ALGORITHM should be a FIRST_MATCHHANDLER";
      cerr << " (ID " << ALGORITHM_FIRST_MATCHHANDLER << ").\n";
      this->ALGORITHM::initialize();
   }
   void ALGORITHM::initialize( PETRIGRAPH* i_petrigraph, IDTYPE i_prule_id,
                               RULE* i_prule, MARKING* i_phi_E_L, MATCH* i_match_first )
   {
      cerr << "warning: possibly this ALGORITHM should be a SECOND_MATCHHANDLER";
      cerr << " (ID " << ALGORITHM_SECOND_MATCHHANDLER << ").\n";
      this->ALGORITHM::initialize();
   }
   void ALGORITHM::initialize( PETRIGRAPH * i_petrigraph, IDTYPE i_prule_id, RULE * i_prule,
                               bool * i_canFold, bool * i_canUnfold,
                               MATCH* m1, MATCH* m2, MARKING* i_phi_E_L)
   {
      cerr << "warning: possibly this ALGORITHM should be a TRIVIAL_MATCHHANDLER";
      cerr << " (ID " << ALGORITHM_TRIVIAL_MATCHHANDLER << ").\n";
      cerr << "warning: possibly this ALGORITHM should be a FIRST_MATCHHANDLER";
      cerr << " (ID " << ALGORITHM_FIRST_MATCHHANDLER << ").\n";
      cerr << "warning: possibly this ALGORITHM should be a SECOND_MATCHHANDLER";
      cerr << " (ID " << ALGORITHM_SECOND_MATCHHANDLER << ").\n";
      this->ALGORITHM::initialize();
   }
   void ALGORITHM::initialize(HYPERGRAPH* i_t)
   {
      cerr << "warning: possibly this ALGORITHM should be a FINDMATCH";
      cerr << " (ID " << ALGORITHM_FINDMATCH << ").\n";
      cerr << "warning: possibly this ALGORITHM should be a FIND_ALL_MATCHES";
      cerr << " (ID " << ALGORITHM_FIND_ALL_MATCHES << ").\n";
      this->ALGORITHM::initialize();
   }
   void ALGORITHM::initialize(HYPERGRAPH* i_t, MATCH* phi, MATCH* phi2, bool* icf, bool* icu, PETRIGRAPH* pg)
   {
      cerr << "warning: possibly this ALGORITHM should be a FINDMATCH";
      cerr << " (ID " << ALGORITHM_FINDMATCH << ").\n";
      this->ALGORITHM::initialize();
   }
   void ALGORITHM::initialize(PTNET* i_ptnet)
   {
      cerr << "warning: possibly this ALGORITHM should be a CAUSALITY_RELATION";
      cerr << " (ID " << ALGORITHM_CAUSALITY_RELATION << ").\n";
      cerr << "warning: possibly this ALGORITHM should be a WRITE_LLNET";
      cerr << " (ID " << ALGORITHM_WRITE_LLNET << ").\n";
      cerr << "warning: possibly this ALGORITHM should be a COVERABILITY.\n";
      cerr << " (ID " << ALGORITHM_COVERABILITY << ").\n";
      this->ALGORITHM::initialize();
   }
   void ALGORITHM::initialize(PETRIGRAPH* pg)
   {
      cerr << "warning: possibly this ALGORITHM should be a FOLD";
      cerr << " (ID " << ALGORITHM_FOLD << ").\n";
      cerr << "warning: possibly this ALGORITHM should be a MERGE_PETRIGRAPH";
      cerr << " (ID " << ALGORITHM_MERGE_PETRIGRAPH << ").\n";
      cerr << "warning: possibly this ALGORITHM should be a MERGE_PETRIGRAPH_UF";
      cerr << " (ID " << ALGORITHM_MERGE_PETRIGRAPH_UF << ").\n";
      cerr << "warning: possibly this ALGORITHM should be a REDUCE_TRANSITIONS";
      cerr << " (ID " << ALGORITHM_REDUCE_TRANSITIONS << ").\n";
      cerr << "warning: possibly this ALGORITHM should be an UNFOLD";
      cerr << " (ID " << ALGORITHM_UNFOLD << ").\n";
      this->ALGORITHM::initialize();
   }
   void ALGORITHM::initialize(GTS* i_grammar, ALGORITHM* i_gxlwriter)
   {
      cerr << "warning: possibly this ALGORITHM should be an APPROXIMATED_UNFOLDING";
      cerr << " (ID " << ALGORITHM_APPROXIMATED_UNFOLDING << ").\n";
      this->ALGORITHM::initialize();
   }
   void ALGORITHM::initialize( PTNET* i_ptnet,
                               map<IDTYPE, unsigned>* pp2l, map<unsigned, IDTYPE>* pl2p,
		               map<IDTYPE, unsigned>* tp2l, map<unsigned, IDTYPE>* tl2p )
   {
      cerr << "warning: possibly this ALGORITHM should be a WRITE_LLNET";
      cerr << " (ID " << ALGORITHM_WRITE_LLNET << ").\n";
      this->ALGORITHM::initialize();
   }
   void ALGORITHM::initialize(char *filename)
   {
      cerr << "warning: possibly this ALGORITHM should be a READER";
      cerr << " (ID " << ALGORITHM_GTXL_READER << ").\n";
      this->ALGORITHM::initialize();
   }
   bool ALGORITHM::initialize(list<string> files)
   {
      cerr << "warning: possibly this ALGORITHM should be a SCENARIO.\n";
      this->ALGORITHM::initialize();
      return false;
   }
   void ALGORITHM::initialize(BINDING pb)
   {
      cerr << "warning: possibly this ALGORITHM should be an ATTRIBUTE ENGINE.\n";
      this->ALGORITHM::initialize();
   }
   
   ///////////////////////////////// runs //////////////////////////////////////////
         
   void ALGORITHM::run()
   {
      cerr << "error: method initialize of abstract class ALGORITHM called.\n";
      cerr << "this ALGORITHM has ID " << this->ID << " and name '" << this->name << "'.\n";
      exit(-1);
   }
   bool ALGORITHM::run(MATCH* match)
   {
      cerr << "warning: possibly this ALGORITHM should be a FIRST_MATCHHANDLER";
      cerr << " (ID " << ALGORITHM_FIRST_MATCHHANDLER << ").\n";
      cerr << "warning: possibly this ALGORITHM should be a SECOND_MATCHHANDLER";
      cerr << " (ID " << ALGORITHM_SECOND_MATCHHANDLER << ").\n";
      cerr << "warning: possibly this ALGORITHM should be a TRIVIAL_MATCHHANDLER";
      cerr << " (ID " << ALGORITHM_TRIVIAL_MATCHHANDLER << ").\n";
      this->ALGORITHM::run();
      return false;
   }
   bool ALGORITHM::run(MATCH* phi_in, MATCH* phi2_out)
   {
      cerr << "warning: possibly this ALGORITHM should be a FIRST_MATCHHANDLER";
      cerr << " (ID " << ALGORITHM_FIRST_MATCHHANDLER << ").\n";
      this->ALGORITHM::run();
      return false;
   }
   MATCH* ALGORITHM::run(HYPERGRAPH* hgraph, bool* found, IDTYPE ruleid, MARKING* phi_E_L)
   {
      cerr << "warning: possibly this ALGORITHM should be a FINDMATCH";
      cerr << " (ID " << ALGORITHM_FINDMATCH << ").\n";
      this->ALGORITHM::run();
      return NULL;
   }
   MATCH* ALGORITHM::run(HYPERGRAPH* hgraph, bool* found, IDTYPE ruleid)
   {
      cerr << "warning: possibly this ALGORITHM should be a FINDMATCH";
      cerr << " (ID " << ALGORITHM_FINDMATCH << ").\n";
      this->ALGORITHM::run();
      return NULL;
   }
   MATCH* ALGORITHM::run(HYPERGRAPH* hgraph, IDTYPE ruleid)
   {
      cerr << "warning: possibly this ALGORITHM should be a FINDMATCH";
      cerr << " (ID " << ALGORITHM_FINDMATCH << ").\n";
      this->ALGORITHM::run();
      return NULL;
   }
   list<MATCH> ALGORITHM::run(HYPERGRAPH* hgraph, ALGORITHM* i_matchhandler, bool surjective)
   {
      cerr << "warning: possibly this ALGORITHM should be a FIND_ALL_MATCHES";
      cerr << " (ID " << ALGORITHM_FIND_ALL_MATCHES << ").\n";
      this->ALGORITHM::run();
      return list<MATCH>();
   }
   bool ALGORITHM::run(IDTYPE elem1, IDTYPE elem2)
   {
      cerr << "warning: possibly this ALGORITHM should be a CAUSALITY_RELATION";
      cerr << " (ID " << ALGORITHM_CAUSALITY_RELATION << ").\n";
      this->ALGORITHM::run();
      return false;
   }
   void ALGORITHM::run( set< pair<IDTYPE, IDTYPE> > vunion,
	                set< pair<IDTYPE, IDTYPE> > eunion,
			set< pair<IDTYPE, IDTYPE> > tunion )
   {
      cerr << "warning: possibly this ALGORITHM should be a MERGE_PETRIGRAPH";
      cerr << " (ID " << ALGORITHM_MERGE_PETRIGRAPH << ").\n";
      cerr << "warning: possibly this ALGORITHM should be a MERGE_PETRIGRAPH_UF";
      cerr << " (ID " << ALGORITHM_MERGE_PETRIGRAPH_UF << ").\n";
      this->ALGORITHM::run();
   }
   void ALGORITHM::run( map<IDTYPE, IDTYPE> vunion,
	                map<IDTYPE, IDTYPE> eunion, map<IDTYPE, IDTYPE> tunion ) 
   {
      cerr << "warning: possibly this ALGORITHM should be a MERGE_PETRIGRAPH";
      cerr << " (ID " << ALGORITHM_MERGE_PETRIGRAPH << ").\n";
      cerr << "warning: possibly this ALGORITHM should be a MERGE_PETRIGRAPH_UF";
      cerr << " (ID " << ALGORITHM_MERGE_PETRIGRAPH_UF << ").\n";
      this->ALGORITHM::run();
   }
   void ALGORITHM::run(RULE* r, MATCH phi2, MATCH phi)
   {
      cerr << "warning: possibly this ALGORITHM should be a FOLD";
      cerr << " (ID " << ALGORITHM_FOLD << ").\n";
      this->ALGORITHM::run();
   }
   void ALGORITHM::run(RULE* r, MATCH phi)
   {
      cerr << "warning: possibly this ALGORITHM should be an UNFOLD";
      cerr << " (ID " << ALGORITHM_UNFOLD << ").\n";
      this->ALGORITHM::run();
   }
   void ALGORITHM::run(PETRIGRAPH* pg)
   {
      cerr << "warning: possibly this ALGORITHM should be an APPROXIMATED_UNFOLDING";
      cerr << " (ID " << ALGORITHM_APPROXIMATED_UNFOLDING << ").\n";
      this->ALGORITHM::run();
   }
   void ALGORITHM::run(PETRIGRAPH &PtGraph, char const* id_name)
   {
      cerr << "warning: possibly this ALGORITHM should be an GXLWRITER";
      cerr << " (ID " << ALGORITHM_GXLWRITER << ").\n";
      this->ALGORITHM::run();
   }
   void ALGORITHM::run(char* filename)
   {
      cerr << "warning: possibly this ALGORITHM should be a WRITE_LLNET";
      cerr << " (ID " << ALGORITHM_WRITE_LLNET << ").\n";
      this->ALGORITHM::run();
   }
   void ALGORITHM::run(GTS& GraphGrammar)
   {
      cerr << "warning: possibly this ALGORITHM should be a GTXLREADER";
      cerr << " (ID " << ALGORITHM_GTXL_READER << ").\n";
      this->ALGORITHM::run();
   }

   bool ALGORITHM::run(MARKING m, long * psize)
   {
      cerr << "warning: possibly this ALGORITHM should be a COVERABILITY";
      cerr << " (ID " << ALGORITHM_COVERABILITY << ").\n";
      this->ALGORITHM::run();
   }

   bool ALGORITHM::run(MATCH m, long * psize)
   {
      cerr << "warning: possibly this ALGORITHM should be a COVERABILITY";
      cerr << " (ID " << ALGORITHM_COVERABILITY << ").\n";
      this->ALGORITHM::run();
   }

   void ALGORITHM::run(PETRIGRAPH &PtGraph, GTS &GraphGrammar)
   {
      cerr << "warning: possibly this ALGORITHM should be a GXL READER";
      cerr << " (ID " << ALGORITHM_COVERABILITY << ").\n";
      this->ALGORITHM::run();
   }
   list<MARKING> ALGORITHM::run(int type)
   {
      cerr << "warning: possibly this ALGORITHM should be a MARKING READER";
      this->ALGORITHM::run();
   }
   EXPRESSION ALGORITHM::run(EXPRESSION & e)
   {
      cerr << "warning: possibly this ALGORITHM should be an ATTRIBUTE ENGINE";
      this->ALGORITHM::run();
   }
   string ALGORITHM::run(EXPRESSION & e, PRINT_TYPE type)
   {
      cerr << "warning: possibly this ALGORITHM should be an ATTRIBUTE ENGINE";
      this->ALGORITHM::run();
   }
   bool ALGORITHM::run(list<EXPRESSION> guards)
   {
      cerr << "warning: possibly this ALGORITHM should be an ATTRIBUTE ENGINE";
      this->ALGORITHM::run();
   }

   bool ALGORITHM::run(list<MARKING> m, char * tracefile)
   {
      cerr << "warning: possibly this ALGORITHM should be a COVERABILITY or BWRA";
      this->ALGORITHM::run();
   }

   bool ALGORITHM::run(IDTYPE trans_id, TABLE * * table)
   {
      cerr << "warning: possibly this ALGORITHM should be an ATTRIBUTE ENGINE";
      this->ALGORITHM::run();
   }


   bool ALGORITHM::refine()
   {
      cerr << "warning: possibly this ALGORITHM should be an EXPRESSION ENGINE";
      this->ALGORITHM::run();
   }

   void ALGORITHM::evaluate(ExpressionElement & e)
   {
      cerr << "warning: possibly this ALGORITHM should be an EXPRESSION ENGINE";
      this->ALGORITHM::run();
   }

   //////////////////////////////// other ///////////////////////////////////
   
   
   void ALGORITHM::setPath(PATH_DB& p)
   {
      this->path = PATH_DB();
      PATH_DB::iterator thi;
      for(thi = p.begin(); thi != p.end(); thi++)
      {
         this->path.push_back(*thi);
      }
   }
   ALGORITHM* ALGORITHM::load(LABEL lb)
   {
	 PATH_DB np = this->path;
	 np.push_back(pair<string, LABEL>(this->name, lb));
	 ALGORITHM* retv = storage.getAlgorithm(np);
	 /*
	 cout << "path " << flush << np << " yields algorithm named \"";
	 try
	 {
	    cout << (string)(retv->getName()) << flush;
	 }
	 catch(exception e)
	 {
	    cout << "SEVERE_ERROR";
	 }
	 cout << "\".\n" << flush;
	 assert((np.size() - this->path.size()) == 1);
	 */
	 retv->setPath(np);
	 return retv;
   }
   
   void ALGORITHM::setReusable(bool val)
   {
    reusable =val;
   }
   
   bool ALGORITHM::getReusable()
   {
    return reusable;
   }
   
   void ALGORITHM::setAlgorithm(ALGORITHM * p_algorithm)
   {
      cerr << "warning: setAlgorithm is not implemented for the ALGORITHM: ";
      cerr << " ID " << ID << ", name " << name << "\n";
	exit(1); 
   }

   BINDING ALGORITHM::abstractBinding(BINDING b)
   {
	BINDING res;
	cerr << "warning: abstractBinding is not implemented for the ALGORITHM: ";
	cerr << " ID " << ID << ", name " << name << "\n";
	exit(1);
	return res;
   }

   bool ALGORITHM::smallereq(list<EXPRESSION> l1, list<EXPRESSION> l2)
   {
	cerr << "error: smallereq is not implemented for the ALGORITHM: ";
	cerr << " ID " << ID << ", name " << name << "\n";
	exit(1);
   }

   bool ALGORITHM::smallereq(EXPRESSION e1, EXPRESSION e2)
   {
	cerr << "error: smallereq is not implemented for the ALGORITHM: ";
	cerr << " ID " << ID << ", name " << name << "\n";
	exit(1);
   }

   bool ALGORITHM::smallereq(ExpressionElement ee1, ExpressionElement ee2)
   {
	cerr << "error: smallereq is not implemented for the ALGORITHM: ";
	cerr << " ID " << ID << ", name " << name << "\n";
	exit(1);
   }

   ostream& operator<<(ostream& ost, PATH_DB& th)
   {
      PATH_DB::iterator thi;
      for(thi = th.begin(); thi != th.end(); thi++)
      {
         try
	 {
	    ost << '<' << (string)thi->first << flush << ", " << (string)thi->second << '>' << flush;
	 }
	 catch(exception e){ ost << "<SEVERE_ERROR>" << flush; }
      }
      return ost;
   }
   
   ostream& operator<<(ostream& ost, ALGORITHM& th)
   {
      ost << "algorithm '" << th.name << "' (ID " << th.ID << ")";
      return ost;
   }


};

