/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef APPLY_RULE_H
#define APPLY_RULE_H

#include "globals.h"
#include "hypergraph.h"
#include "rule.h"
#include "binding.h"
#include "algorithm.h"

namespace algorithms
{

namespace hypergraph
{
   
class APPLY_RULE
{
public:

    APPLY_RULE();

    ~APPLY_RULE();

    virtual void initialize(HYPERGRAPH * hg, ALGORITHM * p_engine);
    virtual void initialize(HYPERGRAPH * hg);
    virtual HYPERGRAPH run(RULE * r, MATCH & m);
    virtual HYPERGRAPH run(RULE * r, MATCH & m, BINDING & b);
    virtual bool IsAppliable(RULE * r,  BINDING * b);

private:

    HYPERGRAPH * hg;

    ALGORITHM * p_engine;

};

};

};

using namespace algorithms;
using namespace hypergraph;

#endif
