/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ATTR_EXAMPLE_CHECKER_H
#define ATTR_EXAMPLE_CHECKER_H

#include "petrigraph.h"
#include "counter_example.h"
#include "algorithm.h"

namespace attributes {

// This is a help structure
// Here we hold together rule, match, binding and hypergraph
// It is needed for example if we want to have a list of such a complex information
struct BINDING_MATCH
{
	BINDING_MATCH()
	{
	}
	
	BINDING_MATCH(RULE rule, MATCH match, BINDING binding)
	{
		this->rule = rule;
		this->match = match;
		this->binding = binding;
	}

	BINDING_MATCH(RULE rule, MATCH match, BINDING binding, HYPERGRAPH hg)
	{
		this->rule = rule;
		this->match = match;
		this->binding = binding;
		this->hg = hg;
	}

	RULE rule;
	MATCH match;
	BINDING binding;
	HYPERGRAPH hg;
};

class ATTR_EXAMPLE_CHECKER
{
public:
    ATTR_EXAMPLE_CHECKER();

    ~ATTR_EXAMPLE_CHECKER();

    void initialize(PETRIGRAPH * pg, COUNTER_EXAMPLE & ce);

    // run counter-example with the real or current engine to see
    // if it is possible to go through it
    // in the real case we check if the given counter-example is spurious
    // with respect to attributes
    bool run(bool real_engine);

private:

	bool checkBinding(BINDING b, list<EXPRESSION> guards);

	PTNET * pn;
	COUNTER_EXAMPLE ce;

	ALGORITHM * engine;

};

};
#endif
