/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef BINDER_H
#define BINDER_H

#include "hypergraph.h"
#include "rule.h"
#include "match.h"
#include "binding.h"
#include "ptnet.h"
#include "marking.h"

namespace attributes {

class BINDER
{
public:
	BINDER();
	
	~BINDER();

	// hypergraph
	virtual void initialize(HYPERGRAPH * hg);
	virtual list<BINDING> run(HYPERGRAPH * left, MATCH * m);

	// petri net
	virtual void initialize(PTNET * pn);
	virtual list<BINDING> run(MARKING * marking, IDTYPE idtrans);

protected:

	HYPERGRAPH * hg;
	PTNET * pn;

	list<BINDING> mergeLists(list<BINDING> & l1, list<BINDING> & l2);
	BINDING unifyList(list<BINDING> l);
};

};

#endif
