/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ATTRIBUTESBINDING_H
#define ATTRIBUTESBINDING_H

#include "expression.h"

namespace attributes {

class BINDING
{
public:
    BINDING();

    ~BINDING();

// clear binding
void clear();

// add binding
void addBinding(EXPRESSION e1, EXPRESSION e2);

// get variable
ExpressionElement getVariable(string name);

// set variable
void setVariable(string name, ExpressionElement value);

// get variable names
list<string> getVariableNames();

// has variable ?
bool hasVariable(string name);

int getSize();

static bool compareBindingsAbs(BINDING b1, BINDING b2);

static bool compareBindings(BINDING b1, BINDING b2);


friend ostream &operator<<(ostream &ost, BINDING &b);

private:

map<string, ExpressionElement> variables;

};

};

#endif
