/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "bwra.h"

#include "bwra/InputCvs.h"
#include "bwra/Cvs.h"

#include "bwra_col/InputCvs_Col.h"
#include "bwra_col/Cvs_Col.h"

namespace algorithms
{
namespace ptnet
{

BWRA::BWRA()
{
}


BWRA::~BWRA()
{
}

void BWRA::initialize(PTNET * i_ptnet)
{
	m_p_ptnet = i_ptnet;
}

bool BWRA::run(list<MARKING> m, char * tracefile)
{
  if(coloured)
  {
	InputCvs_Col* in = new InputCvs_Col;
	
	if (in->run(m_p_ptnet,m)) {
	Cvs_Col* cvs = new Cvs_Col(in->getPredicateTransformerSet(),
			in->getInitialConstraintSet(),
			in->getFinalConstraintSet());
  
  	return cvs->run(tracefile);
  	}
  }
  else
  {
	InputCvs* in = new InputCvs;
	
	if (in->run(m_p_ptnet,m)) {
	Cvs* cvs = new Cvs(in->getPredicateTransformerSet(),
			in->getInitialConstraintSet(),
			in->getFinalConstraintSet(),
			in->getPlaceNames(),
			in->getTransformerNames());
	
	return cvs->run(tracefile);
  	}
  }

  return false;
}

bool BWRA::run(MARKING m, long * psize)
{
	if(psize!=NULL)
		*psize = 0;

	list<MARKING> lm;
	lm.push_back(m);

	string transpath("transpath");

	return run(lm, (char*)transpath.c_str());
}

// namespaces

}
}
