#include "Constraint.h"

Constraint::Constraint() { }; // constructor

// is this constraint empty?
bool Constraint::empty()
{
 return ct.empty(); 
}


// set the marks at place specified by key to given value
void Constraint::set(int key,int value)
{
  if (value > 0) {
    ct[key] = value; 
  } else {
    this->del(key); // setting to 0 is same as deleting key
  }
}

// get the number of marks at given place
int Constraint::get(int key)
{
 return ct[key];
}

// delete all marks at given place
void Constraint::del(int key)
{
 ct.erase(key);
}

// is this constraint smaller as given constraint at place given by index?
bool Constraint::smallerAs(Constraint* in, int index) 
{
  if (this->get(index) < in->get(index)) {
    return true; 
  } else { 
    return false;
  }
}

// is this constraint smaller equal as given constraint?
bool Constraint::smallerEqualAs(Constraint* in) 
{
  for (i=ct.begin(); i!=ct.end(); ++i) {
    if (i->second > in->get(i->first)) { return false; }
  }
  
  return true;
}

// return a new copy of this constraint
Constraint* Constraint::copy() 
{
  Constraint* c = new Constraint;
  for (i=ct.begin(); i!=ct.end(); ++i) {
    c->set(i->first,i->second);
  }
  int j;
  for(j=0; j<ltr.size();j++)
    c->addTransition(ltr[j]);
  return c;
}

// return string-representation of this constraint, given the place names
string Constraint::asString(stringMap* placeNames)
{
  ostringstream os;
  if (this->empty()) {
    os << "()\n";
  } else {
    for (i=ct.begin(); i!=ct.end(); ++i) {
      if (i->second != 0) {
	os << '(' << placeNames->getString(i->first) << ',' << i->second << ") ";
      }
    }
    os << endl;
  }
  return os.str();
}

void Constraint::addTransition(TRANSITION_INFO trans)
{
    ltr.push_back(trans);
}

int Constraint::getTransCount()
{
    return ltr.size();
}

TRANSITION_INFO Constraint::getTransition(int number)
{
    TRANSITION_INFO ti;
    if(ltr.size()<number+1)
	return ti;
	
    return ltr[number];
}

