#include "intSet.h"

// iterator-methods for pointing iterator to beginning/end of this set
intSet::iterator intSet::begin() { return ids.begin(); }
intSet::iterator intSet::end() { return ids.end(); }

// is this set empty?
bool intSet::isEmpty() { return ids.empty(); }

// do we have given integer?
bool intSet::has(int in) { 
  for (i = ids.begin(); i != ids.end(); i++) {
    if ((*i) == in) { 
      return true; 
    }
  }
  return false;
}

// get the element where iterator is pointing to
int intSet::get(iterator& iter) { return (*iter); }

// delete element with given integer number
void intSet::del(int in) { ids.remove(in); }

// add given integer to this set
void intSet::add(int in) { 
  if (! this->has(in)) { 
    ids.push_back(in); 
  }
}

// add given integers to this set
void intSet::add(intSet* in) { 
  for (intSet::iterator ii = in->begin(); ii != in->end(); ii++) {
    this->add(in->get(ii));
  }
}

// select, remove and return any of the elements in this set
int intSet::pop() {  
  int e = ids.front();
  this->del(e); 
  return e; 
}

