#include <set>
#include <list>
#include <stack>
#include <iostream>
using namespace std;

#ifndef INTSET_H
#define INTSET_H

// this class provides a container for integers.
class intSet {
 private:
  list<int> ids; // internal container for integer numbers
  list<int>::iterator i; // internal used iterator
 public:
  intSet() {}; // Constructor
  
  // provide iterator for simple access to elements
  typedef list<int>::iterator iterator;
  iterator begin();
  iterator end();
  
  bool isEmpty(); // is this set empty?
  
  // get the element where iterator is pointing to
  int get(iterator& iter);
  
  int pop(); // select, remove and return first element

  void del(int in); // delete element with given integer number

  void add(intSet* in); // insert given integers at the end 
  
  void add(int in); // insert given integer at the end

  bool has(int in); // do we have given integer?
};

#endif
