#include "stringMap.h"
#include <sstream>

stringMap::stringMap() { count = 0;} // Constructor

// get the integer-value of given string
int stringMap::getInt(const string in) { return strMap[in]; }

// get the string with given integer-value
string stringMap::getString(const int in) { return intMap[in]; }

// do we have given string?
// returns 0, if string is not available, else the integer-value
int stringMap::has(string in) { return strMap[in]; }

// return a string-representation of all strings
string stringMap::asString() {
  bool flag = true;
  ostringstream os;
  os << "{ ";
    
  for(theMapIT = strMap.begin(); theMapIT != strMap.end(); theMapIT++){
    if(flag) {
      os << theMapIT->first;
      flag = false;
    } else {
      os << ", " << theMapIT->first;
    }
  }
  os << " }\n";
  return os.str();
}


// add a string-integer-pair to this container, and return the integer-value
int stringMap::add(const string in) {
  int temp = 0;
  temp = this->has(in);

  if (this->has(in) == 0) {
    count++;
    strMap[in] = count;
    intMap[count] = in;
    return count;
  } else {
    return temp;
  }
}

// set a string-to-integer mapping
void stringMap::set(const string in, const int id) { 
  strMap[in] = id; 
  intMap[id] = in;
}

// delete string-integer-pair given the integer
void stringMap::del(const int id) { 
  strMap.erase(this->getString(id));
  intMap.erase(id);
}

// delete string-integer-pair given the string
void stringMap::del(const string in) { 
  strMap.erase(in);
  intMap.erase(this->getInt(in));
}
