#include <map>
#include <string>
using namespace std;

#ifndef STRINGMAP_H
#define STRINGMAP_H

/* this container provides a one-to-one-mapping
   from strings to integers.
*/
class stringMap {
 private:
  map<string,int> strMap; // internal container
  map<int,string> intMap; // internal container
  map<string,int>::iterator theMapIT; // internal used iterator
  int count; // used to assign unique integers to the strings
 public:
  stringMap(); // Constructor

  // get the integer-value of given string
  int getInt(string in);

  // get the string with given integer-value
  string getString(int in);

  // set a string-to-integer mapping
  void set(string in, const int id);

  // do we have given string?
  int has(string in);
  
  // add a string to this container, and return its integer-value
  int add(const string in);
  
  // return a string-representation of all strings
  string asString();
  
  // delete string-integer-pair given the string
  void del(const string in);
  
  // delete string-integer-pair given the integer
  void del(const int id); 
};

#endif
