#include <sstream>
#include <time.h>

// #include "../bwra/stringMap.h"
#include "../bwra/intSet.h"
#include "Constraint_Col.h"
#include "ConstraintSet_Col.h"
#include "PredicateTransformer_Col.h"
#include "PredicateTransformerSet_Col.h"

#ifndef CVS_COL_H
#define CVS_COL_H

// extern long timeout;

/* Class Cvs, which is implementing a Constraint Verification
   System, in this case the Backward Reachability Algorithm.
 */
class Cvs_Col {
  ConstraintSet_Col* V; // List of visited Constraints
  ConstraintSet_Col* W; // Working List of Constraints
  ConstraintSet_Col* initial; // set of initial Constraints
  PredicateTransformerSet_Col* T; // set of Transitions / Predicate Transformers
  // stringMap* placeNames; // available place names, and their Integer-IDs
  // stringMap* transformerNames; // available transition names, and their Integer-IDs
 public:
  Cvs_Col(PredicateTransformerSet_Col* T,ConstraintSet_Col* initial_in,ConstraintSet_Col* final_in);

  /* run the Backward Rechability Algorithm, and return the Result,
     "true", if final marking(s) is coverable,
     "false", if final marking(s) is not coverable,
  */
  bool run(char * tracefile);

  intSet* select(PredicateTransformerSet_Col* ps,Constraint_Col* c);
  intSet* selectAll(PredicateTransformerSet_Col* ps,Constraint_Col* c);
};

#endif
