#include "InputCvs_Col.h"
#include <fstream>
#include <sstream>
#include <stdio.h>

#include "algorithm_storage.h"

InputCvs_Col::InputCvs_Col() { // constructor
  final = new ConstraintSet_Col;
  initial = new ConstraintSet_Col;
  ptSet = new PredicateTransformerSet_Col;
  // placeNames = new stringMap;
  // transformerNames = new stringMap;
}

// methods, for obtaining infos
PredicateTransformerSet_Col* InputCvs_Col::getPredicateTransformerSet() { return ptSet; }
ConstraintSet_Col* InputCvs_Col::getFinalConstraintSet() { return final; }  
ConstraintSet_Col* InputCvs_Col::getInitialConstraintSet() { return initial; }  
// stringMap* InputCvs_Col::getTransformerNames() { return transformerNames; }  
// stringMap* InputCvs_Col::getPlaceNames() { return placeNames; }  

bool InputCvs_Col::run(PTNET * pn, list<MARKING> m)
{ 
  if(!coloured)
  {
   cout << "\ncoloured bwra is called with non-coloured parameters\n";
   exit(1);
  }

/*
  // places
  set<IDTYPE> places = pn->getPlaces();
  for(set<IDTYPE>::iterator its = places.begin(); its != places.end(); its++)
  {
    char buffer[16];
    sprintf(buffer, "%u", *its);

    placeNames->add(string(buffer));
  }
*/

  // get engine
  ALGORITHM * engine = storage.getEngine();

  // initial marking
  MARKING marking = pn->getInitialMarking();
  map<IDTYPE, vector<TOKEN> > init_map = marking.getMarkings();

  Constraint_Col * newCI = new Constraint_Col;

  for(map<IDTYPE, vector<TOKEN> >::iterator it = init_map.begin(); it != init_map.end(); it++)
  {
/*
   // is the place name known?
   char buffer[16];
   sprintf(buffer, "%u", it->first);
   
   int place_int = placeNames->has(string(buffer));
   if (place_int == 0)
   {
    cout << "\nBWRA: No such PLACE: " << buffer << "\n";
    exit(1);
   }
*/
    // evaluate expressions
   vector<TOKEN> vt;
   for(vector<TOKEN>::iterator itt  = it->second.begin(); itt != it->second.end(); itt++)	
   {
	TOKEN t;
	t.setCount(itt->getCount());
	list<EXPRESSION> le = itt->getAttributes();
	list<EXPRESSION> le_evaluated;
	for(list<EXPRESSION>::iterator ite = le.begin(); ite != le.end(); ite++)
	{
		EXPRESSION e = engine->run(*ite);
		le_evaluated.push_back(e);
	}

	t.setAttributes(le_evaluated);
	vt.push_back(t);
   }

    newCI->set(it->first,vt);
  }

  initial->add(newCI);

  // end marking
  for(list<MARKING>::iterator itlm = m.begin(); itlm != m.end(); itlm++)
  {	
	map<IDTYPE, vector<TOKEN> > end_map;
        end_map = itlm->getMarkings();
	
	Constraint_Col * newCF = new Constraint_Col;
	
	for(map<IDTYPE, vector<TOKEN> >::iterator it = end_map.begin(); it != end_map.end(); it++)
	{
/*
		// is the place name known?
		char buffer[16];
		sprintf(buffer, "%u", it->first);
		
		int place_int = placeNames->has(string(buffer));
		if (place_int == 0)
		{
			cout << "\nBWRA: no such PLACE: " << buffer << "\n";
			exit(1);
		}
*/
		// evaluate expressions
		vector<TOKEN> vt;
		for(vector<TOKEN>::iterator itt  = it->second.begin(); itt != it->second.end(); itt++)	
		{
			TOKEN t;
			t.setCount(itt->getCount());
			list<EXPRESSION> le = itt->getAttributes();
			list<EXPRESSION> le_evaluated;
			for(list<EXPRESSION>::iterator ite = le.begin(); ite != le.end(); ite++)
			{
				EXPRESSION e = engine->run(*ite);
				le_evaluated.push_back(e);
			}
			
			t.setAttributes(le_evaluated);
			vt.push_back(t);
		}

		newCF->set(it->first,vt);
	}
	
	final->add(newCF);
  }

  // set Petri Net
  engine->initialize(pn);

  // transitions

  map<IDTYPE, TRANSITION> transitions = pn->getTransitions();
  for(map<IDTYPE, TRANSITION>::iterator it = transitions.begin(); it != transitions.end(); it++)
  {
   PredicateTransformer_Col* newPT = new PredicateTransformer_Col;

   newPT->setTransition(it->second.getID());
   newPT->setPetriNet(pn);
   newPT->setEngine(engine);

   ptSet->add(newPT);

   // set name
   // transformerNames->set(it->second.getLabel(),ptSet->add(newPT));

  }

  return true; 
}

// return parsed informations as string
/*
string InputCvs_Col::asString() {
  ostringstream os;
  os << "Initial Markings:\n"
     << this->getInitialConstraintSet()->asString(placeNames)
     << "Test Markings:\n"
     << this->getFinalConstraintSet()->asString(placeNames)
     << "Net:\n"
     << this->getPredicateTransformerSet()->asString(placeNames,transformerNames); 
  return os.str();
}
*/
