#include "Constraint_Col.h"
#include "ConstraintSet_Col.h"
#include "PredicateTransformer_Col.h"
#include "PredicateTransformerSet_Col.h"
// #include "../bwra/stringMap.h"

#include "../ptnet.h"
#include "../marking.h"

#ifndef InputCvs_COL_H
#define InputCvs_COL_H

/* class InputCvs: read Petri-Net description 
   and provide Final-Set of Constraints,
   Initial-Set of Constraints and PredicateTransformerSet.
*/
class InputCvs_Col {
  // variables, to store information:
  // places, markings, transitions, place and transition names.
  ConstraintSet_Col* final;
  ConstraintSet_Col* initial;
  PredicateTransformerSet_Col* ptSet;
  // stringMap* placeNames;
  // stringMap* transformerNames;

 public:
  InputCvs_Col();

  // initiate parsing on files
  bool run(PTNET * pn, list<MARKING> m);
  
  // provide markings and transitions
  PredicateTransformerSet_Col* getPredicateTransformerSet();
  ConstraintSet_Col* getFinalConstraintSet();
  ConstraintSet_Col* getInitialConstraintSet();
  // stringMap* getTransformerNames();
  // stringMap* getPlaceNames();

};
#endif
