#include <sstream>
#include <map>

#include "../bwra/intSet.h"
// #include "../bwra/stringMap.h"
#include "Constraint_Col.h"
#include "ConstraintSet_Col.h"
#include "PredicateTransformer_Col.h"

using namespace std;

#ifndef PREDICATETRANSFORMERSET_COL_H
#define PREDICATETRANSFORMERSET_COL_H

/* class provides containter for 
   Constraint-Modifiers/Predicate Transformers (PT)/Transitions
*/
class PredicateTransformerSet_Col {
protected:
  int count; // used for assigning unique ID to transitions
  map<int,PredicateTransformer_Col*> pts; // map: id -> Predicate Transformer

  // iterator used to iterate over this set of transitions
  map<int,PredicateTransformer_Col*>::iterator i; 
 public:
  PredicateTransformerSet_Col(); // constructor
  bool isEmpty(); // is this set empty?

  // methods for updating/accessing elements of this set
  int add(PredicateTransformer_Col* in); // add new PT and return its ID
  PredicateTransformer_Col* get(int id); // return specified PT
  
  PredicateTransformerSet_Col* copy(); // create a new copy of this set
  
  // applying this set of PT to input-Constraint
  ConstraintSet_Col* apply(Constraint_Col* in);
  
  // applying PTs which are specified in input-set of IDs to input-Constraint
  ConstraintSet_Col* apply(intSet* ids, Constraint_Col* in);

  // iterator: type and methods,
  // for easily iterating over this set
  typedef map<int,PredicateTransformer_Col*>::iterator iterator;
  iterator begin();
  iterator end();

  // access to PT or its ID via iterator
  int getID(PredicateTransformerSet_Col::iterator iter);
  PredicateTransformer_Col* getPredicateTransformer(PredicateTransformerSet_Col::iterator iter);
  
  // return all PTs as string
  string asString(stringMap* placeNames,stringMap* transNames);
};

#endif
