/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include "causality_relation.h"

namespace algorithms
{
   namespace ptnet
   {
      CAUSALITY_RELATION::CAUSALITY_RELATION()
      {
         this->ID = ALGORITHM_CAUSALITY_RELATION;
	 this->name = "causality_relation";
      }
      CAUSALITY_RELATION::~CAUSALITY_RELATION() {}
      
      void CAUSALITY_RELATION::initialize(PTNET* i_ptnet)
      {
         this->ptnet = i_ptnet;
      }
      
      bool CAUSALITY_RELATION::run(IDTYPE elem1, IDTYPE elem2)
      {
         /*
	  * set of visited elements in DFS
	  */
         set<IDTYPE> visited;
	 
	 return this->in_causality_relation(elem1, elem2, &visited);
      }
      
      bool CAUSALITY_RELATION::in_causality_relation( IDTYPE elem1,
                                                      IDTYPE elem2, set<IDTYPE>* visited )
      {
         if(visited->count(elem1) > 0) return false;
	 visited->insert(elem1);
	 
	 vector<TCONNECTION> postset = this->ptnet->getPostset(elem1);
	 vector<TCONNECTION>::iterator postit;
	 for(postit = postset.begin(); postit != postset.end(); postit++)
	 {
	    if(postit->weight > 0)
	    {
	       if(postit->ID == elem2) return true;
	       if(this->in_causality_relation(postit->ID, elem2, visited)) return true;
	    }
	 }
	 return false;
      }
   };
};
