/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "check_coverability.h"

#include "cov_graph.h"

namespace tool_testing
{

CHECK_COVERABILITY::CHECK_COVERABILITY()
{
	c1 = c2 = NULL;
}


CHECK_COVERABILITY::~CHECK_COVERABILITY()
{
}

void CHECK_COVERABILITY::initialize(ALGORITHM * c1, ALGORITHM * c2)
{
	this->c1 = (COVERABILITY *)c1;
	this->c2 = (COVERABILITY *)c2;

	if(c1==NULL || c2==NULL)
	{
		cout << "internal pointer error" << endl;
		exit(1);
	}
}

bool CHECK_COVERABILITY::run()
{
	COV_GRAPH * covGraph1 = c1->getCovGraph();
	COV_GRAPH * covGraph2 = c2->getCovGraph();

	IDTYPE node_id;

	// first
	cout << "checking first coverability graph \n";
	for(map<Marking,IDTYPE>::iterator it1 = (covGraph1->m_nodeMapping).begin(); 
		it1!=(covGraph1->m_nodeMapping).end(); it1++)
	{		
		if(!(covGraph2->coverNode((Marking&)(it1->first), &node_id)))
		{
			cout << "different coverability graphs" <<endl;
			return false;
		}
	}

	// second
	cout << "checking second coverability graph \n";
	for(map<Marking,IDTYPE>::iterator it2 = (covGraph2->m_nodeMapping).begin(); 
		it2!=(covGraph2->m_nodeMapping).end(); it2++)
	{
		if(!(covGraph1->coverNode((Marking&)(it2->first), &node_id)))
		{
			cout << "different coverability graphs" <<endl;
			return false;
		}
	}

	cout << "checked\n";

	return true;
}

}


