/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "check_pg_structure.h"

namespace tool_testing
{

CHECK_PG_STRUCTURE::CHECK_PG_STRUCTURE()
{
}


CHECK_PG_STRUCTURE::~CHECK_PG_STRUCTURE()
{
}

void CHECK_PG_STRUCTURE::initialize(PETRIGRAPH * pg)
{
	this->petrigraph = pg;
}

bool CHECK_PG_STRUCTURE::run()
{
	bool result = true;
	
	// check nodes
	if(petrigraph->getVertices().size() == 0)
	{
		cout << endl << "WARNING: No nodes in PETRIGRAPH !" << endl;
		result = false;
	}

	// check edges 
	if(petrigraph->getEdges().size() == 0)
	{
		cout << endl << "WARNING: No edges in PETRIGRAPH !" << endl;
		result = false;
	}

	// check transitions
	if(petrigraph->getTransitions().size() == 0)
	{
		cout << endl << "WARNING: No transitions in PETRIGRAPH !" << endl;
		result = false;
	}
	
	// check connected edges
	if(petrigraph->getConnectedEdges().size() == 0)
	{
		cout << endl << "WARNING: No Connected Edges in PETRIGRAPH !" << endl;
		result = false;
	}

	// check connected nodes
	if(petrigraph->getConnectedVertices().size() == 0)
	{
		cout << endl << "WARNING: No Connected Nodes in PETRIGRAPH !" << endl;
		result = false;
	}

	// to do - other checks

	return result;
}

}
