/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMS_SEARCHPLANCOSTGRAPH_H
#define ALGORITHMS_SEARCHPLANCOSTGRAPH_H

#include <graph.h>
#include <costmatrix.h>

namespace algorithms {


namespace matchings
{
namespace data_str_searchplan
{

/**
	@author Maxim Zaks
*/
class COSTGRAPH : public GRAPH
{
public:
    COSTGRAPH();

    ~COSTGRAPH();

    void addVertex(VERTEX v );
    void addEdge(EDGE e, IDTYPE v1, IDTYPE v2, float cost);
    void clean();
    
    IDTYPE getSource(IDTYPE i);
    IDTYPE getTarget(IDTYPE i);
    list<IDTYPE> getIncoming(IDTYPE i);
    list<IDTYPE> getOutgoing(IDTYPE i);
    list<IDTYPE> getOrderedOutgoing(IDTYPE i);
    
//     void setCost(IDTYPE element, float cost);
    float getCost(IDTYPE element);

protected:

    map< IDTYPE, list<IDTYPE> > incomingEdges;
    map< IDTYPE, list<IDTYPE> > outgoingEdges;
    map< IDTYPE, IDTYPE > sourceVertex;
    map< IDTYPE, IDTYPE > targetVertex;
    map< IDTYPE, float > cost;
};

}

}

}

using namespace algorithms::matchings::data_str_searchplan;


#endif
