/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "costmatrix.h"

namespace algorithms {

namespace matchings
{
namespace data_str_searchplan
{

	COSTMATRIX::COSTMATRIX()
	{
	}


	COSTMATRIX::~COSTMATRIX()
	{
	}


	void COSTMATRIX::intitialize( HYPERGRAPH* g){
		
		assert(g != NULL);
	 
	 	this->hyperGraph = g;

		map <IDTYPE,VERTEX> v_list = hyperGraph->getVertices();
		for(map <IDTYPE,VERTEX>::iterator v_iter = v_list.begin(); v_iter != v_list.end(); v_iter++){
			
			multiset <IDTYPE> e_list = hyperGraph->getConnectedEdges( v_iter->first );
			
			for(multiset<IDTYPE>::iterator e_iter = e_list.begin(); e_iter != e_list.end(); e_iter++){
				
				int index = 0;
				bool found = false;	
				list <IDTYPE> vb_list = hyperGraph->getConnectedVertices( *e_iter );
				for(list<IDTYPE>::iterator vb_iter = vb_list.begin(); vb_iter != vb_list.end() || !found; vb_iter++){
					if(*vb_iter == v_iter->first ) {
						char nodeID[255+1]; char connectionIndex[255+1];
	    					sprintf( nodeID, "%i", *vb_iter );
						sprintf( connectionIndex, "%i", index );
						string label = "";
						label = label + nodeID + "-" + connectionIndex + "-" + hyperGraph->getEdge( *e_iter ).getLabel();
// 						cout << label << endl;
						nodeConnection[label].push_back( *e_iter );
						found = true;
					}
					index++;
				}
			}
		}
		setTheCost();
// 		getTheCost();
		
	}

	void COSTMATRIX::run(){
		
		
		
	}

	void COSTMATRIX::setTheCost(){
		
		map<IDTYPE, EDGE> edges = hyperGraph->getEdges();
         	for(map<IDTYPE, EDGE>::iterator i = edges.begin(); i != edges.end(); i++)
	 	{
	     
	    		/////////////////////////
			//directMatch berechnen
			/////////////////////////
	    		

			directMatch[i->second.getLabel()] ++;
			edgeLookUp[i->second.getLabel()].push_back( i->first );

			
	 	}
		

		/////////////////////////
		//matchOverNode berechnen
		/////////////////////////

		
         	for(map<IDTYPE, EDGE>::iterator i = edges.begin(); i != edges.end(); i++)
	 	{

			list<IDTYPE> connVers = hyperGraph->getConnectedVertices(i->second.getID());
			int n1=0;
			for(list<IDTYPE>::iterator connVer_i = connVers.begin(); connVer_i != connVers.end(); connVer_i++){
				
				multiset<IDTYPE> connEs = hyperGraph->getConnectedEdges( *connVer_i );
				for(multiset<IDTYPE>::iterator connE_i = connEs.begin(); connE_i != connEs.end(); connE_i++){
					
					list<IDTYPE> connVers1 = hyperGraph->getConnectedVertices( *connE_i );
					int n2=0;
					for(list<IDTYPE>::iterator connVer1_i = connVers1.begin(); connVer1_i != connVers1.end(); connVer1_i++){
						if(*connVer1_i==*connVer_i){
// 							if(*connE_i==i->first && n1 == n2)continue;
							char firstIndex[255+1]; char secondIndex[255+1];
	    						sprintf( firstIndex, "%i", n1 );
							sprintf( secondIndex, "%i", n2 );
							string label; 
							label = i->second.getLabel() + "-" + firstIndex + "-" + secondIndex + "-" + hyperGraph->getEdge( *connE_i ).getLabel();
							matchOverNode[label] ++;
						}
						n2++;
					}
				}
				n1++;
			}
		}
		
		/////////////////////////////////
		//Arithmetisches Mittel
		//für matchOverNode berechnen
		/////////////////////////////////
		for(map<string, float>::iterator i = matchOverNode.begin(); i != matchOverNode.end(); i++)
	 	{
			
			float d = directMatch[i->first.substr(0,i->first.find("-",0))];
			matchOverNode[i->first] = i->second/d;
		}
		
		for(map<string, list<IDTYPE> >::iterator i = nodeConnection.begin(); i != nodeConnection.end(); i++)
	 	{
			
			i->second.unique();
		}
	}

	void COSTMATRIX::getTheCost(){
		
		for(map<string, float>::iterator i = directMatch.begin(); i != directMatch.end(); i++)
	 	{
			cout << "Hyperkante mit Label: " << i->first << " gibt es: "<<i->second << " mal" << endl; 
		}
		
		for(map<string, float>::iterator i = matchOverNode.begin(); i != matchOverNode.end(); i++)
	 	{
			cout << "Den Übergang: " << i->first << " gibt es: "<<i->second << " mal" << endl; 
		}

	}

	float COSTMATRIX::getCostOver(string i){
		
		return log(matchOverNode[i]);
		//return matchOverNode[i];
	}
	
	float COSTMATRIX::getDirectCost(string i){
		
		return log(directMatch[i]);
		//return directMatch[i];
	}
	
	list<IDTYPE> COSTMATRIX::getLookUp( string label ){

		return edgeLookUp[label];
	}
	
	list<IDTYPE> COSTMATRIX::getNodeConnection( string label ){

		return nodeConnection[label];
	}
}

}

}
