/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMS_SEARCHPLANCOSTMATRIX_H
#define ALGORITHMS_SEARCHPLANCOSTMATRIX_H

#include "algorithm.h"
#include "hypergraph.h"

#include <math.h>

namespace algorithms {

namespace matchings
{
namespace data_str_searchplan
{

/**
	@author Maxim Zaks
*/
class COSTMATRIX{
public:

    void intitialize(HYPERGRAPH* g);
    void run();
    void update();
    void getTheCost();
    float getDirectCost(string i);
    float getCostOver(string i);
    list<IDTYPE> getLookUp(string label);
    list<IDTYPE> getNodeConnection( string label );
    COSTMATRIX();

    ~COSTMATRIX();
    HYPERGRAPH* hyperGraph;
protected:
    
    
    map<string,float> directMatch;
    map<string,float> matchOverNode;
    map<string, list<IDTYPE> > nodeConnection;
    map<string, list<IDTYPE> > edgeLookUp;
    void setTheCost();
};

};

};

};

using namespace algorithms::matchings::data_str_searchplan;


#endif
