/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "costtree.h"

namespace algorithms {

namespace matchings {

namespace data_str_searchplan {

COSTTREE::COSTTREE()
 : COSTGRAPH()
	{
	}


	COSTTREE::~COSTTREE()
	{
	}

	void COSTTREE::delEdge(IDTYPE eID){
	
	  if(this->edges.count(eID) > 0)
      		{
		
		EDGE e = this->getEdge(eID);
		
		IDTYPE v1 = this->sourceVertex[eID];
		IDTYPE v2 = this->targetVertex[eID];

		list<IDTYPE>incomingE = this->incomingEdges[v2];
		
		for(list<IDTYPE>::iterator iter = incomingE.begin(); iter != incomingE.end(); iter++){

			if(*iter==eID){
				
				this->incomingEdges[v2].remove(*iter);
				break;
			}
		}

		list<IDTYPE>outgoingE = this->outgoingEdges[v1];
		
		for(list<IDTYPE>::iterator iter = outgoingE.begin(); iter != outgoingE.end(); iter++){

			if(*iter==eID){
				
				this->outgoingEdges[v1].remove(*iter);
				break;
			}
		}
		
		this->targetVertex.erase(eID);
		this->sourceVertex.erase(eID);
		this->edges.erase(eID);
		this->cost.erase(eID);
		
		}
	}

	list<IDTYPE> COSTTREE::getFirstCircle(){

		list<IDTYPE> result;
		for(map<IDTYPE,VERTEX>::iterator v_it=this->vertices.begin(); v_it!=this->vertices.end(); v_it++){
			
			list<IDTYPE> pfad; map <IDTYPE, int> index;
			pfad.push_back(v_it->first); index[v_it->first] = 1;

			result = getCircle( v_it->first, pfad, index );
				
// 			cout << "Kreis von " << v_it->first << endl;
// 			for(list<IDTYPE>::iterator iter = result.begin(); iter != result.end(); iter++){
// 				
// 				cout << *iter << endl;
// 			}

			if (!result.empty()) return result;	
		}
		return result;
	}

	list<IDTYPE> COSTTREE::getCircle( IDTYPE vID, list<IDTYPE> pfad, map<IDTYPE,int> index ){
		
		list<IDTYPE> result;

		list<IDTYPE> outEs = this->getOutgoing( vID );
		for(list<IDTYPE>::iterator e_it = outEs.begin(); e_it != outEs.end(); e_it++){

			IDTYPE v = this->targetVertex[*e_it];
			pfad.push_back(v);
			if(index[v]==0){

				index[v]=1;
				result = getCircle( v, pfad,index );
			}
			else{
				
				for(list<IDTYPE>::iterator iter = pfad.begin(); iter != pfad.end(); iter++){
					
					if(*iter==v){
						
						pfad.erase(pfad.begin(),iter);
						pfad.pop_back();
						break;
					}
				}
				return pfad;
			}
			
			if(result.empty()){

				index[v]=0;
				pfad.pop_back();
			}
			else break;
		}
		return result;
	}

}

}

}
