/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef EQUIVALENCE_CONSTRUCTOR_COL_H
#define EQUIVALENCE_CONSTRUCTOR_COL_H

#include "globals.h"
#include "petrigraph.h"
#include "sample.h"

namespace algorithms {

namespace refinement {

class EQUIVALENCE_CONSTRUCTOR_COL
{

public:

  EQUIVALENCE_CONSTRUCTOR_COL();

  ~EQUIVALENCE_CONSTRUCTOR_COL();

  void initialize(PETRIGRAPH * pg, vector<IDTYPE> trans, SAMPLE * s);

  void run();

private:

  /** find first appearing of each node in equivalence classes in [M_0] ... [M_n] */
  void findAppearing();

  /** optimize sample list by deleting the hypergraphs
		where no labels are marked
		and no labels will be marked at the next levels */
  void optimize();
  
  /** find in the level link of the graph with id */
  unsigned int findLink(unsigned int id, unsigned int level);

  /** find hypergraph with id at the level */
  HYPERGRAPH_INFO * findHypergraph(unsigned int id, unsigned int level);

  /** is the graph with id at the level linked from some graph at the level + 1 */
  bool isLinked(unsigned int id, unsigned int level);

  // petri graph
  PETRIGRAPH * pg;

  // list of transition's ids
  vector<IDTYPE> trans;

  // [M_0] ... [M_n]
  vector<list<HYPERGRAPH_INFO> > * m_list;

  // equivalences and it's classes for each graph in [M_k]
  list<set<NODE_INFO> > equivalences;

  // sample
  SAMPLE * sample;
};

};

};

#endif
