/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef EXAMPLE_CHECKER_H
#define EXAMPLE_CHECKER_H

#include "globals.h"
#include "sample.h"
#include "petrigraph.h"
#include "fire_transition.h"
#include "algorithm.h"

namespace algorithms {

namespace refinement {

class EXAMPLE_CHECKER : public ALGORITHM
{

public:
    
    EXAMPLE_CHECKER();

    ~EXAMPLE_CHECKER();
    
    virtual void initialize(PETRIGRAPH * pg, vector<IDTYPE> & trans);

    SAMPLE run(int * trans_num, bool * result);

private:   
    
        bool checkCommuting(map<IDTYPE, IDTYPE> ab, map<IDTYPE, IDTYPE> bc, map<IDTYPE, IDTYPE> ac,
  			map<IDTYPE, IDTYPE> mergedEdges);
	
	void checkLevel(int level, Marking m, vector<list<HYPERGRAPH_INFO> > * m_list);

	PETRIGRAPH * pg;

	// transitions
	vector<IDTYPE> trans;

	// counter
	unsigned int counter;
		
	FIRE_TRANSITION ft;
};

};

};

#endif
