/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef EXAMPLE_CHECKER_COL_H
#define EXAMPLE_CHECKER_COL_H

#include "globals.h"
#include "sample.h"
#include "petrigraph.h"
#include "fire_transition.h"
#include "algorithm.h"

namespace algorithms {

namespace refinement {

class EXAMPLE_CHECKER_COL: public ALGORITHM
{

public:

    EXAMPLE_CHECKER_COL();

    ~EXAMPLE_CHECKER_COL();

    virtual void initialize(PETRIGRAPH * pg, vector<IDTYPE> & trans, vector<BINDING> & bindings);

    SAMPLE run(int * trans_num, bool * result);

private:

        bool checkCommuting(map<IDTYPE, IDTYPE> ab, map<IDTYPE, IDTYPE> bc, map<IDTYPE, IDTYPE> ac,
  			map<IDTYPE, IDTYPE> mergedEdges);
	
	void checkLevel(int level, list<MARKING> lm, vector<list<HYPERGRAPH_INFO> > * m_list);

	PETRIGRAPH pg;

	// transitions
	vector<IDTYPE> trans;

	// bindings
	vector<BINDING> bindings;

	// counter
	unsigned int counter;
		
	FIRE_TRANSITION ft;

	ALGORITHM * std_engine;
  	ALGORITHM * abs_engine;
};

};

};

#endif
