 #ifndef EXPR_H
 #define EXPR_H

 #include <string>
 #include <vector>
 #include <exception>
 #include <iostream>

 // #include "../globals.h"
 
 using namespace std;

 typedef enum { NONE_ = 0,
		OP_NUM_PLUS, // 1
		OP_NUM_MINUS, // 2
		OP_NUM_MULT, // 3
		OP_NUM_DIV, // 4
		OP_NUM_MOD, // 5
		OP_BOOL_AND, // 6
		OP_BOOL_OR, // 7
		OP_BOOL_NOT, // 8
		OP_NUM_BOOL_EQ, // 9
		OP_NUM_BOOL_LE, // 10
		OP_NUM_BOOL_GE, // 11
		OP_NUM_BOOL_NE, // 12
		OP_NUM_BOOL_L, // 13
		OP_NUM_BOOL_G, // 14
		NUMBER, // 15
		_STR_, // 16
		BOOLEAN, // 17
		VAR_NUM, // 18
		VAR_STR, // 19
		OP_STR_CONC, // 20
		OP_STR_LEN, // 21
		OP_STR_BOOL_EQ, // 22
		OP_NUM_UMINUS, // 23
		VAR_UNKNOWN // 24
	} ELEMENT_TYPE;

typedef enum {
	FALSE_VAL = 0,
	TRUE_VAL,
	DN_VAL
} BOOLEAN_3;

 class ExpressionElement
 {
  public:
	
	ExpressionElement();

	~ExpressionElement();

	ELEMENT_TYPE type;

	string str_val;
	int int_val;
	BOOLEAN_3 bool_val;

	string variable_name;
	
	vector<ExpressionElement> elements;

	// evaluation
	string str_evaluated;
	int int_evaluated;

	// is abstract
	bool is_abstract;

	static BOOLEAN_3 logic_3(BOOLEAN_3 v1, BOOLEAN_3 v2, ELEMENT_TYPE operation)
	{
		BOOLEAN_3 bresult;
	
		switch(operation)
		{
			case OP_BOOL_AND:
			{
				if(v1==TRUE_VAL && v2==TRUE_VAL)
					bresult = TRUE_VAL;
				else if(v1==FALSE_VAL || v2==FALSE_VAL)
					bresult = FALSE_VAL;
				else
					bresult = DN_VAL;
				break;
			}
			case OP_BOOL_OR:
			{
				if(v1==TRUE_VAL || v2==TRUE_VAL)
					bresult = TRUE_VAL;
				else if(v1==FALSE_VAL && v2==FALSE_VAL)
					bresult = FALSE_VAL;
				else
					bresult = DN_VAL;
				break;
	
			}
			case OP_BOOL_NOT:
			{
				if(v1==TRUE_VAL)
					bresult = FALSE_VAL;
				else if(v1==FALSE_VAL)
					bresult = TRUE_VAL;
				else
					bresult = DN_VAL;
				break;
			}
			default:
			{
				std::cout << "\ninternal error: in function logic_3() is a not logical operation\n";
				throw std::exception();
			}
		}
	
		return bresult;
	}
 };

#endif
