/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <iostream>
#include <cstdlib>

#include "expr.h"

using namespace std;

extern "C"
{
  extern int yyparse();
  extern char *yystrin;
}

extern vector<ExpressionElement> abstree;

void write(ExpressionElement * el)
{
	cout << "Type: " << el->type << endl;
	cout << "Int_Value: " << el->int_val << endl;
	cout << "Str_Value: " << el->str_val << endl;
	cout << "---------------" << endl;

	for(vector<ExpressionElement>::iterator it = el->elements.begin();
		it != el->elements.end(); it++)
	{
			write((ExpressionElement*)(&(*it)));
	}
}

int main(int argc, char *argv[])
{
	string to_parse = "TRUE & (x = 3 | 3 == x),3+2222";

	cout << to_parse << endl;
	
	yystrin = (char*)to_parse.c_str();

	yyparse();

	for(vector<ExpressionElement>::iterator it = abstree.begin(); it != abstree.end(); it++)
		write((ExpressionElement*)&(*it));

	int x;
	cin >> x;

	cout << "ready" << endl; 

  return EXIT_SUCCESS;
}
