
%{
#include "expr.h"
// #include "../globals.h"
#include "exprpars.tab.hh"

#include <stdio.h>
#include <string.h>
#include <algorithm>

using namespace std;

#undef YY_INPUT
char *ttstrin;		/* current pointer on input string */

#define YY_INPUT(buf, result, max_size) \
	strncpy(buf, ttstrin, max_size-1);\
	ttstrin += result = strlen(buf);

%}

%%

"+"	{return PLUS;}
"-"	{return MINUS;}
"*"	{return MULT;}
"/"	{return DIV;}
"%"	{return MOD;}

"("	{return LEFT;}
")"	{return RIGHT;}
","	{return COMMA;}

"."	{return CONC;}

"="	{return EQ;}
"<"	{return LT;}
">"	{return GT;}

TRUE	{return TRUE;}
FALSE	{return FALSE;}

LEN	{return LEN;}

NOT	{return NOT;}
AND	{return AND;}
OR	{return OR;}

"~"	{return NOT;}
"&"	{return AND;}
"|"	{return OR;}


"=="  {return EQ;}
"<=" {return LE;}
">=" {return GE;}
"!=" {return NE;}

"LT" {return LT;}
"GT" {return GT;}
"LE" {return LE;}
"GE" {return GE;}
"NE" {return NE;}

"equals" {return EQUALS;}

"[" {return ECKIG_L;}
"]" {return ECKIG_R;}

[0-9]+ {
sscanf(tttext, "%d", &ttlval.integer);
return INT_VALUE;
}

[A-Za-z]+[0-9]* {
string* s = new string (tttext);
transform(s->begin(), s->end(), s->begin(), static_cast<int (*)(int)>(tolower));
ttlval.pstr = s;
return VARIABLE;
}

\'.*\' {
string s1 (tttext);
string *s = new string(s1, 1, ttleng - 2);
ttlval.pstr = s;
return STR_VALUE;
}

\".*\" {
string s1 (tttext);
string *s = new string(s1, 1, ttleng - 2);
ttlval.pstr = s;
return STR_VALUE;
}

[\t\ \r]  ; {/* ignore these as spaces*/}

\/\/.* {/* ignore as comment */}

. {printf("lexical error in expression\n"); exit(1); }

%%

