/***************************************************************************
 *   Copyright (C) 2007 by Salil Joshi   *
 *   hellfeuer@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMSEXPR_READER_H
#define ALGORITHMSEXPR_READER_H

#include <iostream>
#include <cstdlib>
#include <string>
#include "semilin/cfexpression.h"
using semilin::CFEXPRESSION;

namespace algorithms {
	namespace readers {
/**
		@author hellfeuer <hellfeuer@gmail.com>
		Parses contents of 'filename' and generates an expression
		Format of input:
		For power, the format is: (a)2 represent a^2 (a squared)
		For *, explicitly specify brackets for more than one character. i.e. ab* will give a(b)* and not (ab)*.
 */
		class EXPR_READER{
			public:
				EXPR_READER();
    
				void run(CFEXPRESSION** exp);
				void initialize(const char* filename);
    
				~EXPR_READER();
			private:
				std::string expr;
		};

	};
};

#endif
