/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                             * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ATTRIBUTESEXPRESSION_H
#define ATTRIBUTESEXPRESSION_H

#include <string>
#include "globals.h"
#include "expr_lex_yacc/expr.h"
// #include "expr_lex_yacc/exprpars.tab.hh"


extern "C"
{
  extern int ttparse();
  extern char *ttstrin;
}

extern vector<ExpressionElement> exprtree;


namespace attributes
{
   class EXPRESSION
   {
      public:
         EXPRESSION();
         EXPRESSION(TYPES type, string expr, string name);
         ~EXPRESSION();
         EXPRESSION clone();
         void addType(TYPES type);
         void addExpr(string expr);
         void addName(string name);
         TYPES getTYPES();
         string getExpr();
         string getName();
	 
	 string getTypesString();

	 vector<ExpressionElement> & getExprParsed();
	 void addExprParsed(vector<ExpressionElement> vee);

	 void writeParsed();

         friend ostream &operator<<(ostream &ost, EXPRESSION &expr);

	 static bool equal(list<EXPRESSION> l1, list<EXPRESSION> l2);
	 static bool equal(EXPRESSION e1, EXPRESSION e2);
	 static bool equal(ExpressionElement ee1, ExpressionElement ee2);

      protected:
         TYPES type;
         string expr;
         //Name of Attribute
         string name;
	 // parsed attribute
	 vector<ExpressionElement> expr_parsed;

      private:
	
	 void write(ExpressionElement * el);
   };
};
using namespace attributes;

#endif
