/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "expression_engine_mp.h"

namespace attributes {

EXPRESSION_ENGINE_MP::EXPRESSION_ENGINE_MP()
{	
}


EXPRESSION_ENGINE_MP::~EXPRESSION_ENGINE_MP()
{
}

void EXPRESSION_ENGINE_MP::evaluate(ExpressionElement & e)
{
	if(e.is_abstract==true)
	 return;

	switch(e.type)
	{
		case OP_NUM_PLUS:
		{
			checkArgumentNumber(e.elements, 2);
			evaluate(e.elements[0]);
			evaluate(e.elements[1]);

			if(e.elements[0].int_evaluated == POSITIV &&
				e.elements[1].int_evaluated == POSITIV)
			 e.int_evaluated = POSITIV;
			else if(e.elements[0].int_evaluated == NEGATIV &&
				e.elements[1].int_evaluated == NEGATIV)
			 e.int_evaluated = NEGATIV;
			else
			 e.int_evaluated = ALL;

			e.is_abstract = true;

			break;
		}
		case OP_NUM_MINUS:
		{
			checkArgumentNumber(e.elements, 2);
			evaluate(e.elements[0]);
			evaluate(e.elements[1]);

			if(e.elements[0].int_evaluated == POSITIV &&
				e.elements[1].int_evaluated == NEGATIV)
			 e.int_evaluated = POSITIV;
			else if(e.elements[0].int_evaluated == NEGATIV &&
				e.elements[1].int_evaluated == POSITIV)
			 e.int_evaluated = NEGATIV;
			else
			 e.int_evaluated = ALL;

			e.is_abstract = true;

			break;
		}
		case OP_NUM_MULT:
		{
			checkArgumentNumber(e.elements, 2);
			evaluate(e.elements[0]);
			evaluate(e.elements[1]);

			if(e.elements[0].int_evaluated == POSITIV &&
				e.elements[1].int_evaluated == NEGATIV)
			 e.int_evaluated = NEGATIV;
			else if(e.elements[0].int_evaluated == NEGATIV &&
				e.elements[1].int_evaluated == POSITIV)
			 e.int_evaluated = NEGATIV;
			else if(e.elements[0].int_evaluated == POSITIV &&
				e.elements[1].int_evaluated == POSITIV)
			 e.int_evaluated = POSITIV;
			else if(e.elements[0].int_evaluated == NEGATIV &&
				e.elements[1].int_evaluated == NEGATIV)
			 e.int_evaluated = POSITIV;
			else
			 e.int_evaluated = ALL;

			e.is_abstract = true;

			break;
		}
		case OP_NUM_DIV:
		{
			checkArgumentNumber(e.elements, 2);
			evaluate(e.elements[0]);
			evaluate(e.elements[1]);

			if(e.elements[0].int_evaluated == POSITIV &&
				e.elements[1].int_evaluated == NEGATIV)
			 e.int_evaluated = NEGATIV;
			else if(e.elements[0].int_evaluated == NEGATIV &&
				e.elements[1].int_evaluated == POSITIV)
			 e.int_evaluated = NEGATIV;
			else if(e.elements[0].int_evaluated == POSITIV &&
				e.elements[1].int_evaluated == POSITIV)
			 e.int_evaluated = POSITIV;
			else if(e.elements[0].int_evaluated == NEGATIV &&
				e.elements[1].int_evaluated == NEGATIV)
			 e.int_evaluated = POSITIV;
			else
			 e.int_evaluated = ALL;

			e.is_abstract = true;

			break;
		}
		case OP_NUM_MOD:
		{
			checkArgumentNumber(e.elements, 2);
			evaluate(e.elements[0]);
			evaluate(e.elements[1]);

			if(e.elements[0].int_evaluated == POSITIV &&
				e.elements[1].int_evaluated == NEGATIV)
			 e.int_evaluated = NEGATIV;
			else if(e.elements[0].int_evaluated == NEGATIV &&
				e.elements[1].int_evaluated == POSITIV)
			 e.int_evaluated = NEGATIV;
			else if(e.elements[0].int_evaluated == POSITIV &&
				e.elements[1].int_evaluated == POSITIV)
			 e.int_evaluated = POSITIV;
			else if(e.elements[0].int_evaluated == NEGATIV &&
				e.elements[1].int_evaluated == NEGATIV)
			 e.int_evaluated = POSITIV;
			else
			 e.int_evaluated = ALL;

			e.is_abstract = true;
			break;
		}
		case NUMBER:
		{
			checkArgumentNumber(e.elements, 0);
			
			if(! e.is_abstract)
			{
				if(e.int_val < 0)
				 e.int_evaluated = NEGATIV;
				if(e.int_val >= 0)
				 e.int_evaluated = POSITIV;
			}
			
			break;
		}
		case VAR_NUM:
		{
			checkArgumentNumber(e.elements, 0);
			ExpressionElement ee = pb.getVariable(e.str_val);
			e.int_evaluated = ee.int_evaluated;
			e.is_abstract = true;
			break;
		}
		case OP_STR_LEN:
		{
			checkArgumentNumber(e.elements, 1);
			e.int_evaluated = 0;
			break;
		}
		case OP_NUM_UMINUS:
		{
			checkArgumentNumber(e.elements, 1);
			evaluate(e.elements[0]);
			if(e.elements[0].int_evaluated == POSITIV)
			 e.int_evaluated = NEGATIV;
			else if(e.elements[0].int_evaluated == NEGATIV)
			 e.int_evaluated = POSITIV;
			else
			 e.int_evaluated = ALL;
			
			break;
		}
		case OP_NUM_BOOL_EQ:
		{
			checkArgumentNumber(e.elements, 2);
			evaluate(e.elements[0]);
			evaluate(e.elements[1]);
			if(e.elements[0].int_evaluated == POSITIV && e.elements[1].int_evaluated == NEGATIV)
				e.bool_val = FALSE_VAL;
			else if(e.elements[0].int_evaluated == NEGATIV && e.elements[1].int_evaluated == POSITIV)
				e.bool_val = FALSE_VAL;
			else
				e.bool_val = DN_VAL;
			break;
		}
		case OP_NUM_BOOL_LE:
		{
			checkArgumentNumber(e.elements, 2);
			evaluate(e.elements[0]);
			evaluate(e.elements[1]);
			if(e.elements[0].int_evaluated == NEGATIV && e.elements[1].int_evaluated == POSITIV)
				e.bool_val = TRUE_VAL;
			else if(e.elements[0].int_evaluated == POSITIV && e.elements[1].int_evaluated == NEGATIV)
				e.bool_val = FALSE_VAL;
			else
				e.bool_val = DN_VAL;
			break;
		}
		case OP_NUM_BOOL_GE:
		{
			checkArgumentNumber(e.elements, 2);
			evaluate(e.elements[0]);
			evaluate(e.elements[1]);
			if(e.elements[0].int_evaluated == POSITIV && e.elements[1].int_evaluated == NEGATIV)
				e.bool_val = TRUE_VAL;
			else if(e.elements[0].int_evaluated == NEGATIV && e.elements[1].int_evaluated == POSITIV)
				e.bool_val = FALSE_VAL;
			else
				e.bool_val = DN_VAL;
			break;
		}
		case OP_NUM_BOOL_NE:
		{
			checkArgumentNumber(e.elements, 2);
			evaluate(e.elements[0]);
			evaluate(e.elements[1]);
			if(e.elements[0].int_evaluated == POSITIV && e.elements[1].int_evaluated == NEGATIV)
				e.bool_val = TRUE_VAL;
			else if(e.elements[0].int_evaluated == NEGATIV && e.elements[1].int_evaluated == POSITIV)
				e.bool_val = TRUE_VAL;
			else
				e.bool_val = DN_VAL;
			break;
		}
		case OP_NUM_BOOL_L:
		{
			checkArgumentNumber(e.elements, 2);
			evaluate(e.elements[0]);
			evaluate(e.elements[1]);
			if(e.elements[0].int_evaluated == NEGATIV && e.elements[1].int_evaluated == POSITIV)
				e.bool_val = TRUE_VAL;
			else if(e.elements[0].int_evaluated == POSITIV && e.elements[1].int_evaluated == NEGATIV)
				e.bool_val = FALSE_VAL;
			else
				e.bool_val = DN_VAL;
			break;
		}
		case OP_NUM_BOOL_G:
		{
			checkArgumentNumber(e.elements, 2);
			evaluate(e.elements[0]);
			evaluate(e.elements[1]);
			if(e.elements[0].int_evaluated == NEGATIV && e.elements[1].int_evaluated == POSITIV)
				e.bool_val = FALSE_VAL;
			else if(e.elements[0].int_evaluated == POSITIV && e.elements[1].int_evaluated == NEGATIV)
				e.bool_val = TRUE_VAL;
			else
				e.bool_val = DN_VAL;
			break;
		}
		case OP_STR_BOOL_EQ:
		{
			checkArgumentNumber(e.elements, 2);
			evaluate(e.elements[0]);
			evaluate(e.elements[1]);
			e.bool_val = DN_VAL;
			break;
		}
		case BOOLEAN:
		{
			checkArgumentNumber(e.elements, 0);
			break;
		}
		
		case _STR_:
		{
			checkArgumentNumber(e.elements, 0);
			e.str_evaluated = string("");
			break;
		}
		case VAR_STR:
		{
			checkArgumentNumber(e.elements, 0);
			// ExpressionElement ee = pb->getVariable(e.str_val);
			e.str_evaluated = string("");
			break;
		}
		case OP_STR_CONC:
		{
			checkArgumentNumber(e.elements, 2);
			// evaluate(e.elements[0]);
			// evaluate(e.elements[1]);
			e.str_evaluated = string("");
			break;
		}
		case VAR_UNKNOWN:
		{
			checkArgumentNumber(e.elements, 0);
			ExpressionElement ee = pb.getVariable(e.str_val);
			e.str_evaluated = ee.str_evaluated;
			e.int_evaluated = ee.int_evaluated;
			e.bool_val = ee.bool_val;
			break;
		}
		default:
		{
			EXPRESSION_ENGINE::evaluate(e);
		}
	}
}

string EXPRESSION_ENGINE_MP::run(ExpressionElement &e, PRINT_TYPE type)
{
	switch(e.type)
	{
		case OP_NUM_PLUS:
		case OP_NUM_MINUS:
		case OP_NUM_MULT:
		case OP_NUM_DIV:
		case OP_NUM_MOD:
		case VAR_NUM:
		case OP_STR_LEN:
		case OP_NUM_UMINUS:
		case NUMBER:
		{
			string res;
			if(e.int_evaluated == POSITIV) 
	       		 res = "PLUS";
			else if(e.int_evaluated == NEGATIV)
			 res = "MINUS";
			else
			 res = "ALL";
			
			if(e.type != NUMBER)
			 e.is_abstract = true;
			return res;
		}
		
		case OP_BOOL_AND:
		case OP_BOOL_OR:
		case OP_NUM_BOOL_EQ:
		case OP_NUM_BOOL_LE:
		case OP_NUM_BOOL_GE:
		case OP_NUM_BOOL_NE:
		case OP_NUM_BOOL_L:
		case OP_NUM_BOOL_G:
		case OP_STR_BOOL_EQ:
		case BOOLEAN:
		{
			string bresult;

			if(e.bool_val == TRUE_VAL)
				bresult = "TRUE";
			else if(e.bool_val == FALSE_VAL)
				bresult = "FALSE";
			else
				bresult = "1/2";

			return bresult;
		}
		
		case _STR_:
		case VAR_STR:
		case OP_STR_CONC:
		{
			return string("STRING");
		}

		case VAR_UNKNOWN:
		{
			checkArgumentNumber(e.elements, 0);
			ExpressionElement ee = pb.getVariable(e.str_val);
			return run(ee, type);
		}
		default:
		{
			cout << "\ninternal error in EXPRESSION_ENGINE: Unknown EXPRESSION\n";
			exit(1);
		}
	}

	return "";
}

vector<ExpressionElement> EXPRESSION_ENGINE_MP::GetPossibleValues(T type)
{
	vector<ExpressionElement> result;

	// integer
	if(type == INTEGER)
	{		
		// plus
		ExpressionElement ee_plus;
		ee_plus.type = NUMBER;
		ee_plus.int_evaluated = POSITIV;
		ee_plus.is_abstract = true;
		result.push_back(ee_plus);
	
		// minus
		ExpressionElement ee_minus;
		ee_minus.type = NUMBER;
		ee_minus.int_evaluated = NEGATIV;
		ee_minus.is_abstract = true;
		result.push_back(ee_minus);

		// all
		ExpressionElement ee_all;
		ee_all.type = NUMBER;
		ee_all.int_evaluated = ALL;
		ee_all.is_abstract = true;
		result.push_back(ee_all);
	}
	// string
	else if(type == STRING)
	{
		// string
		ExpressionElement ee_string;
		ee_string.type = _STR_;
		ee_string.is_abstract = true;
		result.push_back(ee_string);
	}
	// boolean
	else
	{
		// plus
		ExpressionElement ee_true;
		ee_true.type = BOOLEAN;
		ee_true.bool_val = TRUE_VAL;
		ee_true.is_abstract = true;
		result.push_back(ee_true);
	
		// minus
		ExpressionElement ee_false;
		ee_false.type = BOOLEAN;
		ee_false.bool_val = FALSE_VAL;
		ee_false.is_abstract = true;
		result.push_back(ee_false);

		// all
		ExpressionElement ee_dn;
		ee_dn.type = BOOLEAN;
		ee_dn.bool_val = DN_VAL;
		ee_dn.is_abstract = true;
		result.push_back(ee_dn);
	}

	return result;
}

bool EXPRESSION_ENGINE_MP::smallereq(ExpressionElement ee1, ExpressionElement ee2)
{
	if( (ee1.type != ee2.type) ||
		(ee1.bool_val != ee2.bool_val) ||
		(ee1.str_evaluated != ee2.str_evaluated)
	  )

	if(ee1.int_evaluated != ee2.int_evaluated && ee2.int_evaluated != ALL)	
		return false;

	return true;
}

}

