/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "ffreader.h"

#include <fstream>
#include <string.h>
using namespace std;

namespace algorithms {

namespace readers {

FFREADER::FFREADER()
{
}

FFREADER::~FFREADER()
{
}

void FFREADER::initialize(char *filename)
{
	this->filename = filename;
}

COUNTER_EXAMPLE * FFREADER::run(PTNET * pn, bool * cov)
{
	COUNTER_EXAMPLE * ce = new COUNTER_EXAMPLE();

	if(cov==NULL)
	{
		cout << "Bad Pointer" << endl;
		exit(1);
	} 

	ifstream ifs(filename);

	char ch[512];

	ifs.getline(ch, 512);

	// possibilities
	string result1 = "best first search space empty! problem proven unsolvable.";
	string result2 = "ff: found legal plan as follows";

	// look for result
	while(string(ch) != result1 && string(ch) != result2)
	{
	 ifs.getline(ch, 512);

	 if(ifs.eof())
	 {
		cout << "FFREADER: incomplete format of Metric FF output file" << endl;
		exit(1);
	 }
	}

	// not coverable
	if(string(ch) == result1)
	{
		*cov = false;
		return ce;
	}

	*cov = true;

	// read empty line and first line
	ifs.getline(ch, 512);
	
	if(strlen(ch) == 0)
	 ifs.getline(ch, 512);

	// read counter-example
	list<string> s_counter_example;
	while(strlen(ch) != 0)
	{
		s_counter_example.push_back(string(ch));
		ifs.getline(ch, 512);

		if(ifs.eof())
	 	{
			cout << "FFREADER: incomplete format of Metric FF output file" << endl;
			exit(1);
	 	}
	}

	//step    0: FIRE-TRANSITION T678
	//        1: FIRE-TRANSITION T686

	for(list<string>::iterator it = s_counter_example.begin(); it != s_counter_example.end(); it++)
	{
		if(it->size() < 28)
		 continue;

		IDTYPE tid = atoi((it->substr(28, it->size()-28)).c_str());
		
		ce->trans_ids.push_back(tid);
		ce->trans_strings.push_back(pn->getTransition(tid).getLabel());
	}

	return ce;
}

}

}
