/***************************************************************************
 *   Copyright (C) 2006 by Maxim Zaks   *
 *   mzaks@neckar   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMS_MATCHINGS_FIND_ALL_MATCHES_BY_SP_H
#define ALGORITHMS_MATCHINGS_FIND_ALL_MATCHES_BY_SP_H

#include "algorithm.h"
#include "hypergraph.h"
#include "matchhandler.h"
#include "costmatrix.h"
#include "searchplan.h"

namespace algorithms
{
   namespace matchings
   {
      class FIND_ALL_MATCHES_BY_SP: public ALGORITHM
      {
       public:
	 FIND_ALL_MATCHES_BY_SP();
	 virtual ~FIND_ALL_MATCHES_BY_SP();

	 virtual void initialize(HYPERGRAPH* i_t);
	 virtual list<MATCH> run( HYPERGRAPH* hgraph, ALGORITHM* i_matchhandler, 
	                          bool surjective );
	 
       protected:
         HYPERGRAPH* ggraph;
	 SEARCHPLAN searchPlan;
	 COSTMATRIX costMatrix;
	 
	 void next( HYPERGRAPH* hgraph, stack< map<IDTYPE, EDGE>::iterator >* mappings,
	            stack< pair<IDTYPE, EDGE> >* unmapped_edges, MATCH* phi_v,
		    MATCH* phi_e, list<MATCH>* found_matches, ALGORITHM* i_matchhandler,
		    bool surjective );
      };
   };
};
using namespace algorithms;
using namespace matchings;

#endif
