/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMSFINDMATCH_H
#define ALGORITHMSFINDMATCH_H

#include "algorithm.h"
#include "hypergraph.h"
#include "matchhandler.h"

namespace algorithms
{
   namespace matchings
   {
      class FINDMATCH: public ALGORITHM
      {
         public:
            FINDMATCH();
            virtual ~FINDMATCH();

	    virtual void initialize( HYPERGRAPH* i_t, MATCH* im1,
	                             MATCH* im2, bool* icf, bool* icu, PETRIGRAPH* pg );
	    virtual void initialize(HYPERGRAPH* i_t);
	    virtual MATCH* run(HYPERGRAPH* hgraph, bool* found, IDTYPE ruleid, MARKING* phi_E_L);
	    virtual MATCH* run(HYPERGRAPH* hgraph, bool* found, IDTYPE ruleid);
	    virtual MATCH* run(HYPERGRAPH* hgraph, IDTYPE ruleid);

         protected:
	    HYPERGRAPH* ggraph;
	    MATCH* m1;
	    MATCH* m2;
	    bool* canFold;
	    bool* canUnfold;
	    ALGORITHM* matchhandler;
	    PETRIGRAPH* petrigraph;	
// 	    map<string, list<IDTYPE> > edgeLookUp;
	    
	    bool findNextMatching( HYPERGRAPH* hgraph,
	                           stack<map<IDTYPE, EDGE>::iterator>* mappings,
	                           stack< pair<IDTYPE, EDGE> >* unmapped_edges, MATCH* phi_v,
				   MATCH* phi_e, ALGORITHM* matchhandler );
      };
   };    
};
using namespace algorithms;
using namespace algorithms::matchings;

#endif
