/***************************************************************************
 *   Copyright (C) 2006 by Maxim Zaks   *
 *   mzaks@neckar   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMS_MATCHINGSFINDMATCH_BY_SP_H
#define ALGORITHMS_MATCHINGSFINDMATCH_BY_SP_H

#include "algorithm.h"
#include "hypergraph.h"
#include "matchhandler.h"
#include "costmatrix.h"
#include "searchplan.h"

namespace algorithms {

namespace matchings {

/**
	@author Maxim Zaks <mzaks@neckar>
*/
class FINDMATCH_BY_SP: public ALGORITHM{
public:
    	FINDMATCH_BY_SP();

    	~FINDMATCH_BY_SP();

	virtual void initialize( HYPERGRAPH* i_t, MATCH* im1, MATCH* im2, bool* icf, bool* icu, PETRIGRAPH* pg );
	    virtual void initialize(HYPERGRAPH* i_t);
	    virtual MATCH* run(HYPERGRAPH* hgraph, bool* found, IDTYPE ruleid, MARKING* phi_E_L);
	    virtual MATCH* run(HYPERGRAPH* hgraph, bool* found, IDTYPE ruleid);
	    virtual MATCH* run(HYPERGRAPH* hgraph, IDTYPE ruleid);

protected:
	    HYPERGRAPH* ggraph;
	    MATCH* m1;
	    MATCH* m2;
	    bool* canFold;
	    bool* canUnfold;
	    ALGORITHM* matchhandler;
	    PETRIGRAPH* petrigraph;
	    SEARCHPLAN searchPlan;
	    COSTMATRIX costMatrix;
	    bool loaded;
};

}

}

using namespace algorithms;
using namespace matchings;

#endif
