/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FIRE_TRANSITION_H
#define FIRE_TRANSITION_H

#include "algorithm.h"
#include "ptnet.h"

namespace algorithms
{
namespace ptnet
{

class FIRE_TRANSITION : public ALGORITHM
{

public:
    FIRE_TRANSITION();

    ~FIRE_TRANSITION();

    virtual void initialize(PTNET * pn);
    virtual Marking run(TRANSITION t, Marking m);

    // warning: can be called only by unfolding operation
    list<Marking> run_n_times(TRANSITION t, Marking m);

    list<TRANSITION> getEnabledTransitions(Marking m);
    list<TRANSITION> getEnabledTransitions(Marking m, map<IDTYPE, IDTYPE> without_this);
    bool isEnabledBy(Marking marking, IDTYPE transition_id); 

    // coloured
    void initialize(PTNET * pn, ALGORITHM * p_engine);
    MARKING run(TRANSITION t, MARKING m, BINDING b);

    // warning: can be called only by unfolding operation
    list<MARKING> run_n_times(TRANSITION t, MARKING m, BINDING b);

    list<pair<TRANSITION, BINDING> > getEnabledTransitions(MARKING m);
    list<pair<TRANSITION, BINDING> > getEnabledTransitions(MARKING m, map<IDTYPE, IDTYPE> without_this);

    list<BINDING> getEnabledBindings(MARKING marking, IDTYPE transition_id);
    bool isEnabledBy(MARKING marking, IDTYPE transition_id, BINDING b);

private:

    PTNET * pn;

    ALGORITHM * p_engine;

};

};

};

using namespace algorithms;
using namespace ptnet;

#endif
