/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "general_marking_reader.h"

namespace algorithms {

namespace readers {

GENERAL_MARKING_READER::GENERAL_MARKING_READER()
{
	this->filename = NULL;
}


GENERAL_MARKING_READER::~GENERAL_MARKING_READER()
{
}

void GENERAL_MARKING_READER::initialize(char *filename)
{
	this->filename = filename;
}
	
list<MARKING> GENERAL_MARKING_READER::run(int type)
{
	if(checkFileType() == M_R)
	{
		MARKING_READER mr;
		mr.initialize(filename);
		return mr.run(0);
	}

	// else read another format and convert it
	MARKINGSREADER mr;
	mr.initialize(filename);
	Node *formula = NULL;
	mr.run (&formula);

	// list<MARKING> result;
	// parseNode1(&result);
}

void GENERAL_MARKING_READER::parseNode1(Node *formula, list<MARKING> * lm)
{
}

void GENERAL_MARKING_READER::parseNode2(Node *formula, MARKING * m)
{
}

void GENERAL_MARKING_READER::run(Node **formula)
{
	if(checkFileType() == MSR)
	{
		MARKINGSREADER mr;
		mr.initialize(filename);
		mr.run (formula);
		return;
	}

	// else read another format and convert it
	MARKING_READER mr;
	mr.initialize(filename);
	list<MARKING> lm = mr.run(0);

	Operator * result = NULL;

	for(list<MARKING>::iterator it = lm.begin(); it != lm.end(); it++)
	{
		map< IDTYPE, vector<TOKEN> > m = it->getMarkings();

		Operator * n = NULL;

		for(map< IDTYPE, vector<TOKEN> >::iterator itm = m.begin(); itm != m.end(); itm++)
		{
			if(itm->second.size() == 0)
			 continue;

			Variable * v = new Variable(itm->first);
			Constant * c = new Constant(it->getTokenNumber(itm->first));
			Operator * on = new Operator (">=", v, c);

			if(n==NULL)
			{
			 n = on;
			}
			else
			{
			 Operator * ob = new Operator ("&", n, on);
			 n = ob;
			}
		}

		if(n==NULL)
		{
		 cout << "Error in GENERAL_MARKING_READER: empty marking found" << endl;
		 exit(1);
		}

		if(result==NULL)
		{
		 result = n;
		}
		else
		{
		 Operator * ob = new Operator ("|", result, n);
		 result = ob;
		}
	}

	if(result != NULL)
	 *formula = result;
}

GENERAL_MARKING_READER::MFORMAT GENERAL_MARKING_READER::checkFileType()
{
	if(filename == NULL)
	{
	 cout << "Error in GENERAL_MARKING_READER: File name is not initialized" << endl;
	 exit(1);
	}

	ifstream ifs(filename);

	char ch;
	ifs.get(ch);
	while ((ch == ' ') || (ch == '\n'))
	 ifs.get(ch);

	// if the first symbol is 'M' - it is a MARKING_READER's format
	// else it is a MARKINGSREADER's format
	if(ch == 'M')
	 return M_R;
	else
	 return MSR;

	ifs.close();
}

}

}

