/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GENERAL_MARKING_READER_H
#define GENERAL_MARKING_READER_H

#include "algorithm.h"
#include "marking_reader.h"
#include "markingsreader.h"

// This reader will be used instead of both MARKING_READER and MARKINGSREADER.
// It can read from both file formats and 
// produce data structure also in both formats

namespace algorithms {

namespace readers {

class GENERAL_MARKING_READER: public ALGORITHM
{
public:
	GENERAL_MARKING_READER();
	
	~GENERAL_MARKING_READER();
	
	void initialize(char *filename);
	
	list<MARKING> run(int type);

	void run(Node **formula);

private:

	typedef enum {M_R = 0, MSR} MFORMAT;

	char * filename;

	MFORMAT checkFileType();

	void parseNode1(Node *formula, list<MARKING> * lm);
	void parseNode2(Node *formula, MARKING * m);
};

};

};

using namespace algorithms;
using namespace readers;

#endif
