/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DATA_STRUCTGRAPH_H
#define DATA_STRUCTGRAPH_H

#include "edge.h"
#include "vertex.h"


using namespace std;

namespace data_structures
{
   class GRAPH
   {
      public:
         GRAPH();
	 
	 GRAPH(map<IDTYPE, VERTEX> vertices,
                map<IDTYPE, EDGE> edges, 
	        string name,
	        IDTYPE id,
	        IDTYPE lastUsedID);
		
         virtual ~GRAPH();

	 map<IDTYPE, VERTEX> getVertices();
	 map<IDTYPE, EDGE> getEdges();
	 map<IDTYPE, VERTEX> * getVerticesPointer();
	 map<IDTYPE, EDGE> * getEdgesPointer();
	 string getName();
	 IDTYPE getID();
	 void setName(string s);
	 void setID(IDTYPE i);
	 void setID();
	 IDTYPE getLastUsedID();
	 void setLastUsedID(IDTYPE id);
	 
	 VERTEX getVertex(IDTYPE id);
	 VERTEX getVertex(string s);
         bool hasVertex(IDTYPE id);
	 bool hasVertex(string s);
	 
	 EDGE getEdge(IDTYPE id);
	 EDGE getEdge(string s);
         bool hasEdge(IDTYPE id);
	 bool hasEdge(string s);

	void clean();	
	/**
	* Methoden für quickUnfold
	*/
	void setVertices(map<IDTYPE, VERTEX> verts){vertices=verts;}
	void setEdges(map<IDTYPE, EDGE> edgs){edges=edgs;}
	void addVertexQuick(IDTYPE id, VERTEX v){vertices.insert(make_pair(id,v));}
	void addEdgeQuick(IDTYPE id, EDGE e){edges.insert(make_pair(id,e));}

	 
      protected:

         map<IDTYPE, VERTEX> vertices;
         map<IDTYPE, EDGE> edges; 
	 string name;
	 IDTYPE id;
	 IDTYPE lastUsedID;

   };
};
using namespace data_structures;

#endif
