/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "graph_element.h"

namespace data_structures {

GRAPH_ELEMENT::GRAPH_ELEMENT()
{
  ID = 0;
  type = NONE;
}


GRAPH_ELEMENT::~GRAPH_ELEMENT()
{
}


IDTYPE GRAPH_ELEMENT::getID()
{
  return ID; 
}

void GRAPH_ELEMENT::setID(IDTYPE ID)
{
  this->ID = ID;
}

void GRAPH_ELEMENT::setLabel(string s)
{
  this->label = s;
}


string GRAPH_ELEMENT::getLabel()
{
  return this->label;
}

void GRAPH_ELEMENT::setIdLabel(string s)
{
  this->idLabel = s;
}

string GRAPH_ELEMENT::getIdLabel()
{
  return this->idLabel;
}

GRAPH_ELEMENT GRAPH_ELEMENT::clone()
   {
      GRAPH_ELEMENT v = GRAPH_ELEMENT();
      v.ID=ID;
      v.idLabel=idLabel;
      v.label=label;
      v.type=type;
      return v;
   }

//timur
void GRAPH_ELEMENT::addAttributes(EXPRESSION exp)
{
  assert(exp.getTYPES()==this->type);
  this->attributes.push_back(exp);
}
list<EXPRESSION> GRAPH_ELEMENT::getAttributes()
{
  return this->attributes;
}
void GRAPH_ELEMENT::setType(TYPES type)
{
  this->type = type;
}

void GRAPH_ELEMENT::setAttributes(list<EXPRESSION> l_exp)
{
 this->attributes = l_exp;
}

ostream& operator<<(ostream& ost, GRAPH_ELEMENT& th)
{
   if((th.label == "") && (th.idLabel == "") && (th.ID == 0))
   {
      ost << '-';
      return ost;
   }
   ost << '[';
   if(th.label != "") ost << " <" << th.label << ">";
   if(th.idLabel != "") ost << " {" << th.idLabel << "}"; 
   if(th.ID != 0) ost << ' ' << th.ID; 
   ost << " ]";
   return ost;
}

};
