/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DATA_STRUCTURESGRAPH_ELEMENT_H
#define DATA_STRUCTURESGRAPH_ELEMENT_H
#include <string>
#include "expression.h"

using namespace attributes;
using namespace std;

namespace data_structures {

class GRAPH_ELEMENT
{
public:
    GRAPH_ELEMENT();

    ~GRAPH_ELEMENT();
    
    IDTYPE getID();
    
    void setID(IDTYPE ID);
    
    void setLabel(string s);
    
    void setIdLabel(string s);
    
    string getLabel();
        
    string getIdLabel();
    
    GRAPH_ELEMENT clone();

    //timur
    void addAttributes(EXPRESSION exp);
    list <EXPRESSION> getAttributes();
    void setType(TYPES type);

    void setAttributes(list<EXPRESSION> l_exp);

    friend ostream& operator<<(ostream& os, GRAPH_ELEMENT& th);
    
protected:
    // Id of the element
    IDTYPE ID;
    // type of the element
    TYPES type;   
    // list of attributes
    list<EXPRESSION> attributes;
    // label
    string label;
    // label from XML file
    string idLabel;
};

};
using namespace data_structures;

#endif
