/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DATA_STRUCTURESGTS_H
#define DATA_STRUCTURESGTS_H

#include "hypergraph.h"
#include "rule.h"

namespace data_structures
{
   class GTS
   {
      public:
         GTS();
         ~GTS();

         GTS clone();

         map<IDTYPE, RULE>* getRules();
         RULE* getRule(IDTYPE id);
	 RULE* getRule(string s);
         bool hasRule(IDTYPE id);
         void setRules(map<IDTYPE, RULE>* rulemap);
         void addRule(RULE* r);
         void deleteRule(IDTYPE id);

         HYPERGRAPH* getStartgraph();
         void setStartgraph(HYPERGRAPH* g);
         HYPERGRAPH* getTypegraph();
         void setTypegraph(HYPERGRAPH* g);
	 
	 friend ostream& operator<<(ostream& ost, GTS& th);

      protected:
         map<IDTYPE, RULE> rules;
         HYPERGRAPH startgraph;
         HYPERGRAPH typegraph;
   };
};
using namespace data_structures;

#endif
