/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef ALGORITHM_GTXL_NAC_READER_H
#define ALGORITHM_GTXL_NAC_READER_H

#include "algorithm.h"
#include <libxml/tree.h>

namespace algorithms
{
   namespace readers
   {
      class GTXL_NAC_READER: public ALGORITHM
      {
       public:
         GTXL_NAC_READER();
	 virtual ~GTXL_NAC_READER();
	 
         virtual void initialize(char* filename);
	 virtual void run(GTS& GraphGrammar);
       
       protected:
         IDTYPE lastUsedID;
	 string fname;
	  
	 HYPERGRAPH* readHypergraph(xmlNodePtr root, map<string, IDTYPE>* xmlID2ID);
	 RULE* readRule(xmlNodePtr node, bool interpretNAC);
	 HYPERGRAPH* readRuleGraph(xmlNodePtr node, map<string, IDTYPE>* xmlID2ID);
	 string getLabel(xmlNodePtr node);
      };
   };
};
using namespace algorithms;
using namespace algorithms::readers;

#endif
