/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef READERSGXLREADER_H
#define READERSGXLREADER_H

#include "gts.h"
#include "petrigraph.h"

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include "algorithm.h"


namespace algorithms {



namespace readers {

using namespace data_structures;

using namespace algorithm;
/**

*/
class GXLREADER: public ALGORITHM{
public:
    GXLREADER();

    ~GXLREADER();
    
    void initialize(char *filename);
    
    void run(PETRIGRAPH &PtGraph, GTS &GraphGrammar);
    
private:
    xmlDocPtr doc; 
     
    HYPERGRAPH * ReadHypergraph(xmlNodePtr node, set<string> &ids);
    
    xmlNodePtr GetChildrenNode(xmlNodePtr parent, char* child_name);
    
    xmlNodePtr GetNextChild(xmlNodePtr child1, char* child_name);
    
    xmlNodePtr GetAttributeNode(xmlNodePtr node, char* name);

    xmlNodePtr GetRelend(xmlNodePtr rel, int order);
    
    
    
    IDTYPE createNewID();
};

};
};

using namespace algorithms;
using namespace readers;

#endif
