#ifndef WRITERS_GXLWRITER_H
#define WRITERS_GXLWRITER_H

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>

#include "algorithm.h"
#include "gts.h"
#include "petrigraph.h"

namespace algorithms
{

namespace writers
{

class GXLWRITER : public ALGORITHM 
{

public:
    GXLWRITER();

    ~GXLWRITER();
    
    void initialize(char *pfilename);
    
    void run(PETRIGRAPH &PtGraph, const char* id_name);
    
private:

    xmlDocPtr doc; 
    
    char *filename;
    
    void WriteHypergraph(xmlNodePtr node, HYPERGRAPH &hg);
    
   
};
}

}
using namespace algorithms;
using namespace algorithms::writers;

#endif
