/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "hg_converter.h"

#include "gxlreader.h"
#include "vis_hypergraph.h"

namespace converters
{

HG_CONVERTER::HG_CONVERTER()
{
	this->inspec.push_back(pair<string, DATA_FORMAT>("gxl-file", GTXL));
      this->outspec.push_back(pair<string, DATA_FORMAT>("ps_hypergraph", PS));

      this->call_descriptor = "Usage: augur -sc=hg2ps [-size=n] gxl-file ps_hypergraph \n\n\
gxl-file\tpetrigraph in GXL format\n\
ps_hypergraph\thypergraph visualized in PS format\n\n";
}


HG_CONVERTER::~HG_CONVERTER()
{
}

void HG_CONVERTER::run()
{	
	GXLREADER reader;
	reader.initialize((char*)this->filemap["gxl-file"].c_str());
	GTS gts;
	PETRIGRAPH PtGraph;
	reader.run(PtGraph, gts);

	VIS_HYPERGRAPH vh;
	vh.initialize((char*)this->filemap["ps_hypergraph"].c_str());
	vh.run((HYPERGRAPH&)PtGraph, FULL);
}

}
