/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SCENARIOSLOGIC_CONVERTER_H
#define SCENARIOSLOGIC_CONVERTER_H

#include <scenario.h>
#include "logic_lex_yacc/types.h"
#include <partition.h>

namespace converters {

namespace logic_converter {

/**
@author Arwed v. Merkatz
*/
class LOGIC_CONVERTER : public SCENARIO
{
public:
    LOGIC_CONVERTER();

    ~LOGIC_CONVERTER();
    
    void run();

private:
    Node* encode_equals (const Node &F, map<string, IDTYPE> mapping,
                         PARTITION P, const PETRIGRAPH &pg);
    list<Node *> mapToExistingClass (string variable, const Node &F,
                                     map<string, IDTYPE> mapping,
                                     PARTITION P, const PETRIGRAPH &pg);
    void filterBooleans (list<Node *> &nodes, bool filter);
    bool hasBoolean (const list<Node *> &nodes, bool value);
    Node* encode_sub_formula (const string &variable, const IDTYPE edge,
                              const Node &F,
                              const map<string, IDTYPE> &mapping,
                              const PARTITION &P, const PETRIGRAPH &pg);
    Node* encode_quantor (const Node &F, map<string, IDTYPE> mapping,
                          PARTITION P, const PETRIGRAPH &pg);
    Node* encode (const Node &F, map<string, IDTYPE> mapping, PARTITION P,
                  const PETRIGRAPH &pg);

};

};

};

using namespace converters::logic_converter;

#endif
