%option yylineno
%{
 #include <iostream>
 #include <fstream>
 #include "types.h"
 #include "lp.parser.hpp"
 extern "C" void lp_error (char *s);

#ifndef TEST_PARSE
namespace algorithms {
  namespace readers {
    namespace logic_reader {
      extern fstream is;
    }
  }
}

#define YY_INPUT(buf, result, max_size) \
  { \
    algorithms::readers::logic_reader::is.read(buf,1); \
    result = algorithms::readers::logic_reader::is.eof() ? YY_NULL : 1; \
  }
#endif
%}
character [a-zA-Z]
identifier {character}({character}|[0-9])*
whitespace [ \t\n]+
connection c[0-9]+
%%
"~"     { return LP_NOT; }
"&"     { return LP_AND; }
"|"     { return LP_OR; }
"=>"    { return LP_IMPLIES; }
"ex1"   { return LP_EX1; }
"all1"  { return LP_ALL1; }
"="     { return LP_EQUAL; }
"("     { return LP_LPAREN; }
")"     { return LP_RPAREN; }
{connection} { sscanf (lp_text, "c%u\n", &lp_lval.integer);
               return LP_CONNECTION; }
"lab"   { return LP_LABEL; }
\"[^\"\n]*\" { char *result = strdup (lp_text + 1);
               result[lp_leng - 2] = 0;
               lp_lval.string = result;
               return LP_STRING; }
{identifier}  { lp_lval.string = strdup (lp_text);
                return LP_NAME; }
"#".*
{whitespace}
. lp_error ("invalid character");
%%
#ifndef lp_wrap
int lp_wrap() { return 1; }
#endif

