/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DATA_STRUCTURESMARKING_H
#define DATA_STRUCTURESMARKING_H

#include "globals.h"
#include "token.h"

namespace special
{
   const unsigned long OMEGA = 1000000;
};
using namespace special;

namespace data_structures
{
   class MARKING
   {
      public:
         MARKING();
         ~MARKING();

//       void addPlace(IDTYPE p);
         void deletePlace(IDTYPE p);
         vector<TOKEN> getMarking(IDTYPE p);
         void setMarking(IDTYPE p, vector<TOKEN> m);
         void putToken(IDTYPE p, TOKEN tkn);
         void removeTokens(IDTYPE p);
	 map< IDTYPE, vector<TOKEN> > & getMarkings();
	 void setMarkings(map< IDTYPE, vector<TOKEN> > marking);
	 friend ostream& operator<<(ostream& ost, MARKING& th);
	 friend bool operator==(const MARKING & m1, const MARKING & m2);
         unsigned getTokenNumber(unsigned ID);
         bool IsMarked(unsigned ID);
	 map<IDTYPE, unsigned> getUncoloured();
	 bool isColoured();
	 void removeTokens(IDTYPE p, TOKEN tkn);

	 // static methods
	 static bool isEqual(MARKING & m1, MARKING & m2);
	 static bool isLower(MARKING & m1, MARKING & m2);
	 static bool isStrictlyLower(MARKING & m1, MARKING & m2);

	 // is uncoloured lower as coloured
	 // calculated only by the number of tokens
	 static bool isLower_UC(MARKING & m1, MARKING & m2);

	 // on the place
	 static bool isLowerPlace(MARKING & m1, MARKING & m2, IDTYPE place);
	 static bool isStrictlyLowerPlace(MARKING & m1, MARKING & m2, IDTYPE place);
	 static bool ShortagePlace(MARKING & m1, MARKING & m2, IDTYPE place);

      private:
         map< IDTYPE, vector<TOKEN> > marking;
   };
};
using namespace data_structures;

#endif
