%option yylineno
%{
 #include <iostream>
 #include <fstream>
 #include "../logic_lex_yacc/types.h"
 #include "mp.parser.hpp"
 extern "C" void mp_error (char *s);

#ifndef TEST_PARSE
namespace algorithms {
  namespace readers {
    namespace markings_reader {
      extern fstream is;
    }
  }
}

#define YY_INPUT(buf, result, max_size) \
  { \
    algorithms::readers::markings_reader::is.read(buf,1); \
    result = algorithms::readers::markings_reader::is.eof() ? YY_NULL : 1; \
  }
#endif
%}
number [0-9][0-9]*
variable #_[0-9][0-9]*
whitespace [ \t\n]+
%%
"&"     { return MP_AND; }
"|"     { return MP_OR; }
"~"     { return MP_NOT; }
">="    { return MP_GE; }
"<="    { return MP_LE; }
">"     { return MP_GT; }
"<"     { return MP_LT; }
"="     { return MP_EQUAL; }
"("     { return MP_LPAREN; }
")"     { return MP_RPAREN; }
{variable}  { sscanf (mp_text, "#_%u\n", &mp_lval.integer);
                return MP_VARIABLE; }
{number} { sscanf (mp_text, "%u\n", &mp_lval.integer);
           return MP_NUMBER; }
{whitespace}
"\"".*
. mp_error ("invalid character");
%%
#ifndef mp_wrap
int mp_wrap() { return 1; }
#endif

