/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "match.h"

namespace data_structures
{
   MATCH::MATCH()
   {
   }

   MATCH::~MATCH()
   {
   }
   
   MATCH MATCH::clone()
   {
      MATCH m = MATCH();
      m.match = this->match;
      return m;
   }

   void MATCH::deleteKey(IDTYPE key)
   {
      this->match.erase(key);
   }
   
   map<IDTYPE, IDTYPE> MATCH::getMatch()
   {
      return this->match;
   }
   
   IDTYPE MATCH::getMatch(IDTYPE key)
   {
      if(this->match.count(key) == 0)
      {
         cout << "a severe inconsistency was detected in match.cpp\n";
	 cout << *this << "\n";
	 cout << "can't respond to query for key " << key << " ... aborting.\n";
	 exit(-1);
      }
      return this->match[key];
   }
   
   bool MATCH::hasMatch(IDTYPE key)
   {
      return (this->match.count(key) > 0);
   }
   
   void MATCH::setMatch(map<IDTYPE, IDTYPE> m)
   {
      this->match = m;
   }
   
   void MATCH::setMatch(IDTYPE key, IDTYPE val)
   {
      this->match[key] = val;
   }
   
   unsigned long MATCH::count() { return this->match.size(); }
   
   bool operator==(const MATCH & m1, const MATCH & m2)
   {
    return ((MATCH)m1).IsEqual(m2);    
   }
   
   ostream& operator<<(ostream& ost, MATCH& th)
   {
      ost << "match";
      
      map<IDTYPE, IDTYPE>::iterator matchit;
      for(matchit = th.match.begin(); matchit != th.match.end(); matchit++)
      {
         ost << ' ' << matchit->first << '/' << matchit->second;
      }
      
      return ost;
   }
   
   bool MATCH::IsEqual(const MATCH & m)
   {    
    if(match.size()!=m.match.size())
     return false;
    
    for(map<IDTYPE, IDTYPE>::iterator it=match.begin(); it!=match.end(); it++)
    {
     map<IDTYPE, IDTYPE>::const_iterator cit=m.match.find(it->first);
     if(cit==m.match.end())
      return false;
     if(it->second != cit->second)
      return false; 
    } 
    
    return true;
   }
};



