/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "partition.h"

namespace converters {

namespace logic_converter {

namespace data_str_partition {

PARTITION::PARTITION()
{
}

PARTITION::PARTITION(const PARTITION &part) :
  subsets (part.subsets)
{
}

PARTITION::~PARTITION()
{
}

void PARTITION::removeSet(const IdSet &set)
{
	subsets.erase (set);
}
    
void PARTITION::addSet(const IdSet &set)
{
	subsets.insert (set);
}
    
bool PARTITION::isSameClass(const Identifier &id1, const Identifier &id2)
{
	for (std::set<IdSet, ltIdSet>::iterator it = subsets.begin(); it != subsets.end(); ++it)
	{
		if ((*it).count (id1.name) > 0)
			return ((*it).count (id2.name) > 0);
	}
}

unsigned int PARTITION::nPp(const IDTYPE id, map<string, IDTYPE> mapping)
{
	unsigned int count = 0;
	for (std::set<IdSet, ltIdSet>::iterator it = subsets.begin(); it != subsets.end(); ++it)
	{
		IdSet currentSet = *it;
		string representative = *currentSet.begin();
		if (mapping[representative] == id) {
			++count;
		}
	}
	return count;
}

}

}

}
