/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PARTITION_H
#define PARTITION_H

#include "logic_lex_yacc/types.h"

#include <set>
#include <string>

namespace converters {

namespace logic_converter {

namespace data_str_partition {

typedef std::set<std::string> IdSet;
typedef std::set<std::string>::iterator IdSetIterator;

struct ltIdSet {
	bool operator()(const IdSet &set1, const IdSet &set2) const
	{
		if (set1.size() < set2.size())
			return true;
		else if (set1.size() > set2.size())
			return false;
			
		IdSetIterator it1 = set1.begin();
		IdSetIterator it2 = set2.begin();
		while (it1 != set1.end()) {
			if (*it1 < *it2)
				return true;
			else if (*it2 < *it1)
				return false;
			
			++it1; ++it2;
		}
		return false;
	}
};

/**
@author Arwed v. Merkatz
*/
class PARTITION{
public:
    PARTITION();

    ~PARTITION();

    PARTITION(const PARTITION &part);
    
    void removeSet(const IdSet &set);
    
    void addSet(const IdSet &set);
    
    bool isSameClass(const Identifier &id1, const Identifier &id2);
    
    unsigned int nPp(const IDTYPE id, map<string, IDTYPE> mapping);
    
    std::set<IdSet, ltIdSet> subsets;
};

};

};

};

using namespace converters::logic_converter::data_str_partition;

#endif
