/***************************************************************************
 *   Copyright (C) 2006 by Maxim Zaks   *
 *   mzaks@neckar   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PDDLWRITER_H
#define PDDLWRITER_H

#include "ptnet.h"
#include "marking.h"

namespace algorithms {



namespace writers {


/**
	@author Maxim Zaks <mzaks@neckar>
*/
class PDDLWriter
{
public:
    PDDLWriter();

    ~PDDLWriter();

    void initialize(char *pfilename);
    
    void run(PTNET &pn, MARKING m);
    void run(PTNET &pn, list<MARKING> m);

private:

   void writePDDLFile(PTNET & pn, char * pddlFile, list<MARKING> m);
   char *filename;

};

};
};

using namespace algorithms;
using namespace writers;

#endif
