/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DATA_STRUCTURESPETRIGRAPH_H
#define DATA_STRUCTURESPETRIGRAPH_H

#include "gts.h"
#include "ptnet.h"

namespace data_structures
{
   class PETRIGRAPH: public HYPERGRAPH, public PTNET
   {
      public:
         PETRIGRAPH();
	 
         virtual ~PETRIGRAPH();

         PETRIGRAPH clone();

         virtual void addPlace(IDTYPE p, VERTEX v);
         void addPlace(IDTYPE p, EDGE e, list<IDTYPE> cV);
         virtual void addPlace(IDTYPE p, EDGE e);
         virtual void deletePlace(IDTYPE p);

         virtual void addVertex(VERTEX v, IDTYPE id);
         virtual void deleteVertex(IDTYPE id);
         virtual void addEdge(EDGE e, IDTYPE id, list<IDTYPE> cV);
         virtual void deleteEdge(IDTYPE id);

         MATCH getIota();
         void setIota(MATCH j);
         map<IDTYPE, MATCH>* getMu();
         MATCH getMu(IDTYPE id);
         void setMu(map<IDTYPE, MATCH>* m);
         void setMu(IDTYPE id, MATCH m);
         GTS* getGrammar();
         void setGrammar(GTS* gg);
	 
	 void setAssociatedRule(IDTYPE t, IDTYPE r);
	 IDTYPE getAssociatedRuleID(IDTYPE t);
 
	 MARKING match2marking(MATCH m);
	 
	 HYPERGRAPH getMarkedHypergraph(Marking m, map<IDTYPE, IDTYPE> * mergedEdges);
	 HYPERGRAPH getMarkedHypergraph(MARKING m, map<IDTYPE, IDTYPE> * mergedEdges);
	 
	 friend ostream& operator<<(ostream& ost, PETRIGRAPH& th);
 
	 void setAllValues(
		MATCH nIota,
		map<IDTYPE, MATCH> nMu,
		map<IDTYPE, IDTYPE> n_associated_rules,
		map< IDTYPE, list<IDTYPE> > ncV,
         	map< IDTYPE, multiset<IDTYPE> > ncE,
		map<IDTYPE, TRANSITION> nT,
		map< IDTYPE, vector<TCONNECTION> > nPresets,
         	map< IDTYPE, vector<TCONNECTION> > nPostsets,
		MARKING nInitialMarking,
		MARKING nCurrentMarking,
		map<IDTYPE, unsigned> nDepth,
		map<IDTYPE, VERTEX> nV,
         	map<IDTYPE, EDGE> nE,
		IDTYPE nLUI,
		GTS * grammar
	 );

	 bool IsReal;

	protected:

	 MATCH iota;
         map<IDTYPE, MATCH> mu;

   };
};
using namespace data_structures;

#endif
