/***************************************************************************
 *   Copyright (C) 2006                                                    *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "pn_converter.h"

#include "gxlreader.h"
#include "vis_petrinet.h"

namespace converters
{

PN_CONVERTER::PN_CONVERTER()
{
	this->inspec.push_back(pair<string, DATA_FORMAT>("gxl-file", GTXL));
      this->outspec.push_back(pair<string, DATA_FORMAT>("ps_petri_net", PS));

      this->call_descriptor = "Usage: augur -sc=pn2ps [-size=n] gxl-file ps_petri_net \n\n\
gxl-file\tpetrigraph in GXL format\n\
ps_petri_net\tPetri net visualized in PS format\n\n";
}


PN_CONVERTER::~PN_CONVERTER()
{
}

void PN_CONVERTER::run()
{
	GXLREADER reader;
	reader.initialize((char*)this->filemap["gxl-file"].c_str());
	GTS gts;
	PETRIGRAPH PtGraph;
	reader.run(PtGraph, gts);

	VIS_PETRINET vpn;
	vpn.initialize((char*)this->filemap["ps_petri_net"].c_str());
	vpn.run((PTNET&)PtGraph);
}

}
