/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMS_READERSPNMLREADER_H
#define ALGORITHMS_READERSPNMLREADER_H

#include <algorithm.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <map>
#include <string>

namespace algorithms {

namespace readers {

/**
@author Arwed v. Merkatz
*/
class PNMLREADER : public ALGORITHM
{
public:
    PNMLREADER();

    ~PNMLREADER();

    static bool isPNML(char *filename);

    virtual void initialize(char *filename);

    virtual void run(PTNET &PtNet);

private:
    xmlDocPtr doc;
    xmlXPathContextPtr ctx;
    map<string, IDTYPE> pnmlToIDMapping;
    MARKING initialMarking;
    unsigned long num_places;

    void createPlaces (PTNET &PtNet);
    void createTransitions (PTNET &PtNet);
};

};

};

#endif
