#include <iostream>
#include <string.h>
#include "arithmetictree.h"
#include "helpfunction.h"



using namespace std;
using namespace arithmetictree;

/*                    */
/* ---NumConstNode--- */
/*                    */
void NumConstNode::printTree(MODE mode) const
{
   cout <<value;
}

char* NumConstNode::getArithmeticExpression()
{ 
   char *strvalue=new char[15];
   sprintf(strvalue,"%d\0",value);
   return strvalue;
}

void NumConstNode::getNumConstNode(list<int> &list) const {
   list.push_back(value);
}



/*               */
/* ---NumNode--- */
/*               */
void NumNode::getNumNode(list<CHARLIST> &list) const 
{
   list.push_back(path);
}

void NumNode::changeNumNode(list<char*> changenode, list<char*> newnode) 
{
   if (pathcmp(changenode, path) ==0) {
      list<char*>::iterator itr_begin = newnode.begin();
      list<char*>::iterator itr_end=newnode.end();
      path.clear();
      path.assign(newnode.begin(),newnode.end());
   }
}

void NumNode::printTree(MODE mode) const
{
   printcharlist(path);
}

char* NumNode::getArithmeticExpression()
{
   list<char*>::iterator itr = path.begin();
   char *returnstring=new char[strlen(*itr)];
   returnstring=*itr;
   itr++;
   while (itr != path.end())
   {
      returnstring=catstrstr(returnstring,*itr);
      itr++;
   }
   return returnstring;
}



/*               */
/* ---TwoOpNode--- */
/*               */
TwoOpNode::~TwoOpNode()
{
   delete pLeft;
   delete pRight;
}



/*               */
/* ---AddNode--- */
/*               */
void AddNode::getNumNode(list<CHARLIST> &list) const 
{
   pLeft->getNumNode(list);
   pRight->getNumNode(list);
}

void AddNode::getNumConstNode(list<int> &list) const
{
   pLeft->getNumConstNode(list);
   pRight->getNumConstNode(list);
}

void AddNode::printTree(MODE mode) const
{
   switch (mode) {
      case INORDER: {
         cout <<"(";
         pLeft->printTree(mode);
         cout <<" "<<STR_ADD<<" ";
         pRight->printTree(mode);
         cout <<")";
         break;
      }
      case PREORDER: {
         cout <<"(";
         cout <<STR_ADD<<" ";
         pLeft->printTree(mode);
         cout <<" ";
         pRight->printTree(mode);
         cout <<")";
         break;
      }
      case POSTORDER: {
         cout <<"(";
         pLeft->printTree(mode);
         cout <<" ";
         pRight->printTree(mode);
         cout <<" "<<STR_ADD;
         cout <<")";
         break;
      }
   }
}

void AddNode::changeNumNode(list<char*> changenode, list<char*> newnode) {
   pLeft->changeNumNode(changenode, newnode);
   pRight->changeNumNode(changenode, newnode);
}

char* AddNode::getArithmeticExpression() {
  char *str1=catstrstr("(", pLeft->getArithmeticExpression());
  char *str2=catstrstr(str1, STR_ADD);
  char *str3=catstrstr(str2, pRight->getArithmeticExpression());
  return catstrstr(str3, ")");
}



/*               */
/* ---MinNode--- */
/*               */
void MinNode::getNumNode(list<CHARLIST> &list) const 
{
   pLeft->getNumNode(list);
   pRight->getNumNode(list);
}

void MinNode::getNumConstNode(list<int> &list) const
{
   pLeft->getNumConstNode(list);
   pRight->getNumConstNode(list);
}

void MinNode::printTree(MODE mode) const
{
   switch (mode) {
      case INORDER: {
         cout <<"(";
         pLeft->printTree(mode);
         cout <<" "<<STR_MIN<<" ";
         pRight->printTree(mode);
         cout <<")";
         break;
      }
      case PREORDER: {
         cout <<"(";
         cout <<STR_MIN <<" ";
         pLeft->printTree(mode);
         cout <<" ";
         pRight->printTree(mode);
         cout <<")";
         break;
      }
      case POSTORDER: {
         cout <<"(";
         pLeft->printTree(mode);
         cout <<" ";
         pRight->printTree(mode);
         cout <<" "<<STR_MIN;
         cout <<")";
         break;
      }
   }
}

void MinNode::changeNumNode(list<char*> changenode, list<char*> newnode) {
   pLeft->changeNumNode(changenode, newnode);
   pRight->changeNumNode(changenode, newnode);
}

char* MinNode::getArithmeticExpression() {
  char *str1=catstrstr("(", pLeft->getArithmeticExpression());
  char *str2=catstrstr(str1, STR_MIN);
  char *str3=catstrstr(str2, pRight->getArithmeticExpression());
  return catstrstr(str3, ")");
}



/*                */
/* ---MultNode--- */
/*                */
void MultNode::getNumNode(list<CHARLIST> &list) const 
{
   pLeft->getNumNode(list);
   pRight->getNumNode(list);
}

void MultNode::getNumConstNode(list<int> &list) const 
{
   pLeft->getNumConstNode(list);
   pRight->getNumConstNode(list);
}

void MultNode::printTree(MODE mode) const
{
   switch (mode) {
      case INORDER: {
         cout <<"(";
         pLeft->printTree(mode);
         cout <<" "<<STR_MULT<<" ";
         pRight->printTree(mode);
         cout <<")";
         break;
      }
      case PREORDER: {
         cout <<"(";
         cout <<STR_MULT <<" ";
         pLeft->printTree(mode);
         cout <<" ";
         pRight->printTree(mode);
         cout <<")";
         break;
      }
      case POSTORDER: {
         cout <<"(";
         pLeft->printTree(mode);
         cout <<" ";
         pRight->printTree(mode);
         cout <<" "<<STR_MULT;
         cout <<")";
         break;
      }
   }
}

void MultNode::changeNumNode(list<char*> changenode, list<char*> newnode) {
   pLeft->changeNumNode(changenode, newnode);
   pRight->changeNumNode(changenode, newnode);
}

char* MultNode::getArithmeticExpression() {
  char *str1=catstrstr("(", pLeft->getArithmeticExpression());
  char *str2=catstrstr(str1, STR_MULT);
  char *str3=catstrstr(str2, pRight->getArithmeticExpression());
  return catstrstr(str3, ")");
}



/*                */
/* ---DivNode--- */
/*                */
void DivNode::getNumNode(list<CHARLIST> &list) const 
{
   pLeft->getNumNode(list);
   pRight->getNumNode(list);
}

void DivNode::getNumConstNode(list<int> &list) const 
{
   pLeft->getNumConstNode(list);
   pRight->getNumConstNode(list);
}

void DivNode::printTree(MODE mode) const
{
   switch (mode) {
      case INORDER: {
         cout <<"(";
         pLeft->printTree(mode);
         cout <<" "<<STR_DIV<<" ";
         pRight->printTree(mode);
         cout <<")";
         break;
      }
      case PREORDER: {
         cout <<"(";
         cout <<STR_DIV <<" ";
         pLeft->printTree(mode);
         cout <<" ";
         pRight->printTree(mode);
         cout <<")";
         break;
      }
      case POSTORDER: {
         cout <<"(";
         pLeft->printTree(mode);
         cout <<" ";
         pRight->printTree(mode);
         cout <<" " <<STR_DIV;
         cout <<")";
         break;
      }
   }
}

void DivNode::changeNumNode(list<char*> changenode, list<char*> newnode) {
   pLeft->changeNumNode(changenode, newnode);
   pRight->changeNumNode(changenode, newnode);
}

char* DivNode::getArithmeticExpression() {
  char *str1=catstrstr("(", pLeft->getArithmeticExpression());
  char *str2=catstrstr(str1, STR_DIV);
  char *str3=catstrstr(str2, pRight->getArithmeticExpression());
  return catstrstr(str3, ")");
}


/*                */
/* ---ModNode--- */
/*                */
void ModNode::getNumNode(list<CHARLIST> &list) const 
{
   pLeft->getNumNode(list);
   pRight->getNumNode(list);
}

void ModNode::getNumConstNode(list<int> &list) const 
{
   pLeft->getNumConstNode(list);
   pRight->getNumConstNode(list);
}

void ModNode::printTree(MODE mode) const
{
   switch (mode) {
      case INORDER: {
         cout <<"(";
         pLeft->printTree(mode);
         cout <<" "<<STR_MOD<<" ";
         pRight->printTree(mode);
         cout <<")";
         break;
      }
      case PREORDER: {
         cout <<"(";
         cout <<STR_MOD <<" ";
         pLeft->printTree(mode);
         cout <<" ";
         pRight->printTree(mode);
         cout <<")";
         break;
      }
      case POSTORDER: {
         cout <<"(";
         pLeft->printTree(mode);
         cout <<" ";
         pRight->printTree(mode);
         cout <<" " <<STR_MOD;
         cout <<")";
         break;
      }
   }
}

void ModNode::changeNumNode(list<char*> changenode, list<char*> newnode) {
   pLeft->changeNumNode(changenode, newnode);
   pRight->changeNumNode(changenode, newnode);
}

char* ModNode::getArithmeticExpression() {
  char *str1=catstrstr("(", pLeft->getArithmeticExpression());
  char *str2=catstrstr(str1, STR_MOD);
  char *str3=catstrstr(str2, pRight->getArithmeticExpression());
  return catstrstr(str3, ")");
}



