/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef POINTER_LANG_READER_H
#define POINTER_LANG_READER_H

#include "algorithm.h"
#include "pointer_lang/arithmetictree.h"
#include "pointer_lang/booltree.h"
#include "pointer_lang/abstree.h"
#include "pointer_lang/helpfunction.h"
#include "pointer_lang/PLGTS.h"

/**
@author Timur Tsotniashvili
*/

namespace algorithms
{

namespace readers
{

class POINTER_LANG_READER: public ALGORITHM {
public:
    POINTER_LANG_READER();

    ~POINTER_LANG_READER();
    
    void initialize(char *infilename);
    
    void run(GTS &GraphGrammar);

private:

    void produceDeclRules(PLGTS *GraphGrammar, NODE *abstree, int &counter);
    void produceBodyRules(PLGTS *GraphGrammar, NODE *abstree, int counter, bool laststm, int gotocounter);

    int computeSTMLIST(NODE *abstree);
    list <char*> PathToCharList(NODE* tree);
    arithmetictree::Node *ArithmeticExpToArithmetictree(NODE* tree);
    booltree::Node *BoolExpToBooltree(NODE* tree);


    SymbolTable *symboltable;

    string workDir;
};

};

};

#endif

