/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CONFLICTCALCULATOR_H
#define CONFLICTCALCULATOR_H
#include <map>
#include "petrigraph.h"
#include "algorithm.h"

namespace scenarios{
namespace quickUnfolding{
namespace conflictCheck{

class ConflictCalculator : public ALGORITHM{
private:
	set<IDTYPE> getPresetFromTransition(IDTYPE id, PETRIGRAPH pg);
	set<IDTYPE> getPostsetFromTransition(IDTYPE id, PETRIGRAPH pg);
	map<IDTYPE, set<IDTYPE> >* transitionConflicts;
	map<IDTYPE, set<IDTYPE> >* removingEdge;
	map<IDTYPE, IDTYPE>* createdByTransition;
	void insertConflictinBranch(PETRIGRAPH pg, IDTYPE branch, IDTYPE conflict);
public:
	ConflictCalculator(){}
	virtual void initialize(map<IDTYPE, set<IDTYPE> >& removingEdge, map<IDTYPE, IDTYPE>& createdByTransition);
	virtual void run(PETRIGRAPH& pg, list<IDTYPE>& transitions);
	map<IDTYPE, set<IDTYPE> >& getTransitionConflicts(){return *transitionConflicts;}
};

}
}
}
#endif
