/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "DependenciesCalculator.h"
#include "checkEdge.h"
namespace scenarios{
namespace quickUnfolding{

DependenciesCalculator::DependenciesCalculator(GTS* grammar){
	int counter = 0;

    std::map<IDTYPE, RULE>* rules = grammar->getRules();

    for(std::map<IDTYPE, RULE>::iterator rulesIt = rules->begin();
	rulesIt != rules->end();
	rulesIt++)
      {
	std::map<IDTYPE, map<IDTYPE, IDTYPE> > ruleResult;

	for(std::map<IDTYPE, RULE>::iterator leftRulesIt = rules->begin();
	    leftRulesIt != rules->end();
	    leftRulesIt++)
	  {
	    std::map<IDTYPE, IDTYPE> leftRuleResult;
	    std::set<IDTYPE> rightEdges = coverability::getKeys(rulesIt->second.getRight()->getEdges());
	    std::set<IDTYPE> leftEdges = coverability::getKeys(leftRulesIt->second.getLeft()->getEdges());
	    for(std::set<IDTYPE>::iterator rightEdgesIt = rightEdges.begin();
		rightEdgesIt != rightEdges.end();
		rightEdgesIt++)
	      {
		if(coverability::getKeys(rulesIt->second.getLeft()->getEdges()).count(*rightEdgesIt) == 1)
		  {
		    // edge in context
		    continue;
		  }
		for(std::set<IDTYPE>::iterator leftEdgeIt = leftEdges.begin();
		    leftEdgeIt != leftEdges.end();
		    leftEdgeIt++)
		  {
		    std::string leftLabel = leftRulesIt->second.getLeft()->getEdges()[*leftEdgeIt].getLabel();
		    std::string rightLabel = rulesIt->second.getRight()->getEdges()[*rightEdgesIt].getLabel();
		    if(rightLabel == leftLabel)
		      {
			leftRuleResult.insert(pair<IDTYPE, IDTYPE>(*rightEdgesIt, *leftEdgeIt));
			counter++;
		      }
					      
		  }
	      }
	    if(leftRuleResult.size() > 0) 
	      {
		pair<IDTYPE, map<IDTYPE, IDTYPE> > ruleResultpair((*leftRulesIt).first, leftRuleResult);
		ruleResult.insert(ruleResultpair);
	      }
	      
	  }
	if(ruleResult.size() > 0) 
	  {

	    pair<IDTYPE, map<IDTYPE, map<IDTYPE, IDTYPE> > > resultpair((*rulesIt).first, ruleResult);
	    result.insert(resultpair);
	  }
      }
}

}
}
