/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "RedundancyChecker.h"

namespace scenarios{
namespace quickUnfolding{

RedundancyChecker::RedundancyChecker(multimap<IDTYPE, list<pair<map <IDTYPE,IDTYPE>, map<IDTYPE,IDTYPE> > > > result){
	multimap<IDTYPE, list<pair<map <IDTYPE,IDTYPE>, map<IDTYPE,IDTYPE> > > > newResult;

    for(multimap<IDTYPE, list<pair<map <IDTYPE,IDTYPE>, map<IDTYPE,IDTYPE> > > >::iterator resultListIt = result.begin();
	resultListIt != result.end();
	resultListIt++)
      {

	multimap<IDTYPE, list<pair<map<IDTYPE, IDTYPE>, map<IDTYPE, IDTYPE> > > >::iterator newResultIDIT = newResult.find((*resultListIt).first);
	list<pair<map<IDTYPE, IDTYPE>, map<IDTYPE, IDTYPE> > > newMappings;
	list<pair<map<IDTYPE, IDTYPE>, map<IDTYPE, IDTYPE> > > newResultID;
	if(newResultIDIT != newResult.end())
	  {
	    newResultID = (*newResultIDIT).second;
	  }

	for(list<pair<map<IDTYPE, IDTYPE>, map<IDTYPE, IDTYPE> > >::iterator resultIt = (*resultListIt).second.begin();
	    resultIt != (*resultListIt).second.end();
	    resultIt++)
	  {
	    bool equal = false;

	    if(newResultIDIT == newResult.end())
	      {
		list<pair<map<IDTYPE, IDTYPE>, map <IDTYPE, IDTYPE> > > newResultItem;
		newResultItem.push_back(*resultIt);
		newResultIDIT = newResult.insert(pair<IDTYPE, list<pair<map<IDTYPE,IDTYPE>, map<IDTYPE,IDTYPE> > > >((*resultListIt).first, newResultItem));
		newResultID = (*newResultIDIT).second;
		continue;
	      }

	    for(list<pair<map <IDTYPE,IDTYPE>, map<IDTYPE,IDTYPE> > >::iterator copyListIt = newResultID.begin();
		copyListIt != newResultID.end();
		copyListIt++)
	      {
		bool acopy = true;
		map<IDTYPE, IDTYPE>::iterator mappingedgeIt = (*resultIt).first.begin();
		map<IDTYPE, IDTYPE>::iterator copyedgeIt = (*copyListIt).first.begin();
		while(acopy && (mappingedgeIt != (*resultIt).first.end()))
		  {
		    if((*mappingedgeIt).second != (*copyedgeIt).second)
		      {
			//mapping is not equal
			acopy = false;
		      }
		    mappingedgeIt++;
		    copyedgeIt++;
		  }
		if(acopy)
		  {
		    equal = true;
		  }
	      }	      

	    for(list<pair<map <IDTYPE,IDTYPE>, map<IDTYPE,IDTYPE> > >::iterator newMappingsIt = newMappings.begin();
		newMappingsIt != newMappings.end();
		newMappingsIt++)
	      {
		bool acopy = true;
		map<IDTYPE, IDTYPE>::iterator mappingedgeIt = (*resultIt).first.begin();
		map<IDTYPE, IDTYPE>::iterator newMappingEdgeIt = (*newMappingsIt).first.begin();
		while(acopy && (mappingedgeIt != (*resultIt).first.end()))
		  {
		    if((*newMappingEdgeIt).second != (*mappingedgeIt).second)
		      {
			//mapping is not equal
			acopy = false;
		      }
		    newMappingEdgeIt++;
		    mappingedgeIt++;
		  }
		if(acopy)
		  {
		    equal = true;
		  }
	      }	      	  

	    if(!equal) 
	      {
		newMappings.push_back(*resultIt);
	      } else {
	      }
	  }

	(*newResultIDIT).second.insert((*newResultIDIT).second.end(), newMappings.begin(), newMappings.end());
    
      }
}

}
}
