/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "checkNode.h"

namespace scenarios{
namespace quickUnfolding{
namespace coverability{

CheckNode::CheckNode(PETRIGRAPH & pg, RULE rule, IDTYPE ruleV, map<IDTYPE, IDTYPE> phi_e , map<IDTYPE,IDTYPE> phi_v)
{
    matching = true;
    map<IDTYPE, IDTYPE> resultV;
    map<IDTYPE, IDTYPE> resultE;

    list<pair<map<IDTYPE, IDTYPE>, map<IDTYPE,IDTYPE> > > newResultList;
    multiset<IDTYPE> ruleEdges = rule.getLeft()->getConnectedEdges(ruleV);
    multiset<IDTYPE> graphEdges = pg.getConnectedEdges((*phi_v.find(ruleV)).second);
    
    multiset<IDTYPE>::iterator ruleEdgesIt = ruleEdges.begin();
    
    while(matching && ruleEdgesIt != ruleEdges.end()) {
      matching = false;

      if(phi_e.count(*ruleEdgesIt) > 0)
	{
	  // edge already mapped, nothing to do
	  matching = true;
	  ruleEdgesIt++;
	  continue;
	}

      std::string ruleEdgeLabel = rule.getLeft()->getEdge(*ruleEdgesIt).getLabel();

      for(multiset<IDTYPE>::iterator graphEdgesIt = graphEdges.begin();
	  graphEdgesIt != graphEdges.end();
	  graphEdgesIt++) 
	{
	  std::string graphEdgeLabel = pg.getEdge(*graphEdgesIt).getLabel();
	  if(ruleEdgeLabel == graphEdgeLabel) 
	    {
	      if(resultList.size() == 0) {
		CheckEdge checkResult(pg, rule, (*ruleEdgesIt), (*graphEdgesIt), phi_e, phi_v);
		  if(checkResult.isCoverable())
		    {
		      matching = true;
		      newResultList.merge(checkResult.getMapping());
		    } else {
		    }
	      } else {
		//for alle elements of the resultList checkEdge has to be called
		for(list<pair<map<IDTYPE, IDTYPE>, map<IDTYPE,IDTYPE> > >::iterator resultListIt = resultList.begin();
		    resultListIt != resultList.end();
		    resultListIt++)
		  {
		    map<IDTYPE, IDTYPE> phi_e_union(phi_e);
		    phi_e_union.insert((*resultListIt).first.begin(), (*resultListIt).first.end());
		    map<IDTYPE, IDTYPE> phi_v_union(phi_v);
		    phi_v_union.insert((*resultListIt).second.begin(), (*resultListIt).second.end());

		    CheckEdge checkResult(pg, rule, (*ruleEdgesIt), (*graphEdgesIt), phi_e_union, phi_v_union);
		    if(checkResult.isCoverable()) {
		      for(list<pair<map <IDTYPE,IDTYPE>, map<IDTYPE, IDTYPE> > >::iterator testIt = checkResult.getMapping().begin();
			  testIt != checkResult.getMapping().end();
			  testIt++)
			{
			  for(map<IDTYPE, IDTYPE>::iterator secondTestIt = (*testIt).first.begin();
			      secondTestIt != (*testIt).first.end();
			      secondTestIt++)
			    {

			    }
			}
		      matching = true;
		      if(checkResult.getMapping().size() > 0) {
			for(list<pair<map <IDTYPE,IDTYPE>, map<IDTYPE, IDTYPE> > >::iterator checkResultIt = checkResult.getMapping().begin();
			    checkResultIt != checkResult.getMapping().end();
			    checkResultIt++)
			  {
			    pair<map<IDTYPE, IDTYPE>, map<IDTYPE, IDTYPE> > resultUnionList = *checkResultIt;
			    resultUnionList.first.insert((*resultListIt).first.begin(), (*resultListIt).first.end());
			    resultUnionList.second.insert((*resultListIt).second.begin(), (*resultListIt).second.end());

			    newResultList.push_back(resultUnionList);
			  }

			//inserting the results in ResultList 
		      } else {
			newResultList.push_back(*resultListIt);
		      }
		    } else {
		    }
		  }
	      }
	    }
	}
      if(newResultList.size() > 0) 
	{
	  resultList = newResultList;
	} else {
	  //mapping has been already complete
	}
      newResultList.clear();
      ruleEdgesIt++;
    }
}


}//Ende Namespace
}
}
