/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "compareExtendedCertificate.h"
#include "generateExtendedCertificate.h"
#include "mapGraph.h"

namespace scenarios{
namespace quickUnfolding{
namespace certificates{

CompareExtendedCertificate::CompareExtendedCertificate(HYPERGRAPH hg,list<pair<IDTYPE, list<pair<LABELTYPE, int> > > > cutCert,  list<pair<IDTYPE, list<pair<LABELTYPE, int> > > > isoCert, map<LABELTYPE, set<IDTYPE> > cutGraph, map<LABELTYPE, set<IDTYPE> > isoGraph, map<IDTYPE, IDTYPE> mapping){
	if(cutCert.size() == 0)
      equal = (newUnfold::MapGraph(hg, cutGraph, isoGraph, mapping).isEqual());

    list<pair<IDTYPE, list<pair<LABELTYPE, int> > > >::iterator cutVertex = cutCert.begin();
    list<pair<IDTYPE, list<pair<LABELTYPE, int> > > >::iterator isoVertex = isoCert.begin();

    int i = 0;
    while(isoVertex != isoCert.end())
      {

	if(certificatesort((*isoVertex), (*cutVertex)))
	  {
	    map<IDTYPE, IDTYPE> newMapping(mapping);
	    newMapping.insert(pair<IDTYPE, IDTYPE>((*cutVertex).first, (*isoVertex).first));
	    list<pair<IDTYPE, list<pair<LABELTYPE, int> > > > newCutCert(cutCert);
	    newCutCert.erase(newCutCert.begin());
	    list<pair<IDTYPE, list<pair<LABELTYPE, int> > > > newIsoCert(isoCert);
	    list<pair<IDTYPE, list<pair<LABELTYPE, int> > > >::iterator newIsoVertex = newIsoCert.begin();
	    for(int j = 0; j < i; j++)
	      newIsoVertex++;
	    newIsoCert.erase(newIsoVertex);
	    if(CompareExtendedCertificate(hg, newCutCert, newIsoCert, cutGraph, isoGraph, newMapping).isEqual())
	      equal = true;
	  } else {
	    equal = false;
	  }
	isoVertex++;
	i++;
      }
    equal = false;
}

}
}
}
