/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CONCURRENCYCHECKER_CPP
#define CONCURRENCYCHECKER_CPP

#include "concurrencyChecker.h"

namespace scenarios{
namespace quickUnfolding{

void ConcurrencyChecker::initialize(map<IDTYPE, set<IDTYPE> >& concurrentEdges){
	this->concurrentEdges = &concurrentEdges;
}

void ConcurrencyChecker::run(map<IDTYPE, IDTYPE> preset){
    for(map<IDTYPE, IDTYPE>::iterator edge = preset.begin();
	edge != preset.end();
	edge++)
      { 
	for(map<IDTYPE, IDTYPE>::iterator concurrentEdge = preset.begin();
	    concurrentEdge != preset.end();
	    concurrentEdge++)
	  {
	    if((*concurrentEdge).first != (*edge).first)
	      {
		std::map<IDTYPE, set<IDTYPE> >::iterator concurrentIt = concurrentEdges->find((*concurrentEdge).second);
		if(concurrentIt == concurrentEdges->end())
		  {
		    coverable = false;
			return;
		  }
		set<IDTYPE> concurrent = (*concurrentIt).second;
		if(concurrent.find((*edge).second) == concurrent.end())
		  {
		    coverable = false;
			return;
		  }
	      }
	  }
      }
    coverable = true;
  }

}
}

#endif
