/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DIRECTCONFLICTCHECKER_H
#define DIRECTCONFLICTCHECKER_H
#include "petrigraph.h"
#include "algorithm.h"

namespace scenarios{
namespace quickUnfolding{
namespace conflictCheck{

class DirectConflictChecker : public ALGORITHM{
private:
	bool coverable;
	set<IDTYPE> getDirectConflicts(set<IDTYPE> transitions);
	bool cycleChecker(set<IDTYPE> & toCheck, set<IDTYPE> necTransitions, set<IDTYPE> branch, IDTYPE transitionToCheck);
	map<IDTYPE, set<IDTYPE> >* necessaryTransitions;
	map<IDTYPE, set<IDTYPE> >* directConflicts;
public:
	void initialize(map<IDTYPE, set<IDTYPE> >& necessaryTransitions, map<IDTYPE, set<IDTYPE> >& directConflicts);
	void run(PETRIGRAPH pg, map<IDTYPE, IDTYPE> preset);
	DirectConflictChecker(){}
	bool isCoverable(){return coverable;}
};

}
}
}

#endif
