/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FINDMATCHEDGE_H
#define FINDMATCHEDGE_H
#include <list>
#include <map>
#include "globals.h"
#include "rule.h"
#include "petrigraph.h"

using namespace std;
namespace scenarios{
namespace quickUnfolding{

class FindMatchEdge{
public:
	FindMatchEdge(PETRIGRAPH& pg, RULE rule);
	bool isCoverable(){return matching;}
	list<pair<map <IDTYPE,IDTYPE>, map<IDTYPE, IDTYPE> > >& getMapping(){return resultList;}
private:
	bool matching;
	list<pair<map <IDTYPE,IDTYPE>, map<IDTYPE, IDTYPE> > > resultList;
	pair<IDTYPE, int> findMinimumEdge(PETRIGRAPH & pg, RULE rule);
	int countAppearances(PETRIGRAPH & pg, std::string edgelabel);
};

}
}

#endif
