/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FULLCONFLICTCHECKER_CPP
#define FULLCONFLICTCHECKER_CPP

#include "fullConflictChecker.h"

namespace scenarios{
namespace quickUnfolding{
namespace conflictCheck{

void FullConflictChecker::initialize(map<IDTYPE, set<IDTYPE> >& necessaryTransitions, map<IDTYPE, IDTYPE>& createdByTransition, map<IDTYPE, set<IDTYPE> >& transitionConflicts){
	this->necessaryTransitions = &necessaryTransitions;
	this->createdByTransition = &createdByTransition;
	this->transitionConflicts = &transitionConflicts;
}

void FullConflictChecker::run(map<IDTYPE, IDTYPE>& phi_e){
	set<IDTYPE> conflicts;
    for(map<IDTYPE, IDTYPE>::iterator preEdge = phi_e.begin();
	preEdge != phi_e.end();
	preEdge++)
      {
	IDTYPE transID = (*createdByTransition->find((*preEdge).second)).second;

	if(transID == 0)
	  continue;

	//Creating of the Full conflict list and checking for conflicts
	map<IDTYPE, set<IDTYPE> >::iterator necessaryTrans = necessaryTransitions->find((*preEdge).second);
	if(necessaryTrans != necessaryTransitions->end())
	  {
	    for(set<IDTYPE>::iterator necTraIT = (*necessaryTrans).second.begin();
		necTraIT != (*necessaryTrans).second.end();
		necTraIT++)
	      {
		set<IDTYPE>::iterator confFind = conflicts.find(*necTraIT);
		if(confFind != conflicts.end())
		  {
		    coverable = false;
			return;
		  }
	      }
	  }



	set<IDTYPE> confTrans = (*transitionConflicts->find(transID)).second;
	conflicts.insert(confTrans.begin(), confTrans.end());
      }

    coverable = true;
}

}
}
}

#endif
