/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FULLCONFLICTCHECKER_H
#define FULLCONFLICTCHECKER_H
#include <map>
#include "globals.h"
#include "algorithm.h"

namespace scenarios{
namespace quickUnfolding{
namespace conflictCheck{

class FullConflictChecker : public ALGORITHM{
private:
	bool coverable;
	map<IDTYPE, set<IDTYPE> >* necessaryTransitions; 
	map<IDTYPE, IDTYPE>* createdByTransition; 
	map<IDTYPE, set<IDTYPE> >* transitionConflicts;
public:
	FullConflictChecker(){}
	void initialize(map<IDTYPE, set<IDTYPE> >& necessaryTransitions, map<IDTYPE, IDTYPE>& createdByTransition, map<IDTYPE, set<IDTYPE> >& transitionConflicts);
	void run(map<IDTYPE, IDTYPE>& phi_e);
	bool isCoverable(){return coverable;}
};

}
}
}

#endif
