/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "generateExtendedCertificate.h"

namespace scenarios{
namespace quickUnfolding{
namespace certificates{

GenerateExtendedCertificate::GenerateExtendedCertificate(HYPERGRAPH hg, map<LABELTYPE, set<IDTYPE> > graph){
    set<IDTYPE> vertices;
    set<IDTYPE> edges;
    for(map<LABELTYPE, set<IDTYPE> >::iterator label = graph.begin();
	label != graph.end();
	label++)
      {
	for(set<IDTYPE>::iterator edge = (*label).second.begin();
	    edge != (*label).second.end();
	    edge++)
	  {
	    edges.insert(*edge);
	    list<IDTYPE> connectedV = hg.getConnectedVertices(*edge);
	    int i = 0;
	    for(list<IDTYPE>::iterator vertex = connectedV.begin();
		vertex != connectedV.end();
		vertex++)
	      {
		bool foundVertex = false;
		for(list<pair<IDTYPE, list<pair<LABELTYPE, int> > > >::iterator resultIt = certificate.begin();
		    resultIt != certificate.end();
		    resultIt++)
		  {
		    if((*resultIt).first == *vertex)
		      {
			foundVertex = true;
			  (*resultIt).second.push_back(pair<LABELTYPE, int>((*label).first, i));
			  break;
		      }
		  }
		if(!foundVertex)
		  {
		    list<pair<LABELTYPE, int> > newList;
		    newList.push_back(pair<LABELTYPE, int>((*label).first, i));
		    certificate.push_back(pair<IDTYPE, list<pair<LABELTYPE, int> > >((*vertex), newList));
		  }
		i++;
	      }
	    }
      }

    for(list<pair<IDTYPE, list<pair<LABELTYPE, int> > > >::iterator resIT = certificate.begin();
	resIT != certificate.end();
	resIT++)
      {
	(*resIT).second.sort(vertexListSort);
	}
    certificate.sort(certificatesort);
}

bool vertexListSort(pair<LABELTYPE, int> a, pair<LABELTYPE, int> b)
{
    	if(a.first < b.first)
	  return true;
	if(a.first > b.first)
	  return false;
	if(a.second < b.second)
	  return true;
	if(a.second > b.second)
	  return false;

	return true;
}

bool certificatesort(pair<IDTYPE, list<pair<LABELTYPE, int> > > a, pair<IDTYPE, list<pair<LABELTYPE, int> > > b)
  {
    if(a.second.size() > b.second.size())
      {
	return true;
      }
    if(b.second.size() > a.second.size())
      {
	return false;
      }
    list<pair<LABELTYPE, int> >::iterator  aLabel = a.second.begin();
    list<pair<LABELTYPE, int> >::iterator  bLabel = b.second.begin();

    while(aLabel != a.second.end())
      {
	if((*aLabel).first > (*bLabel).first)
	  return true;
	if((*aLabel).first < (*bLabel).first)
	  return false;
	if((*aLabel).second < (*bLabel).second)
	  return true;
	if((*aLabel).second > (*bLabel).second)
	  return false;

	aLabel++;
	bLabel++;
      }
    return true; //equal
}

}
}
}



