/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "mapGraph.h"

namespace scenarios{
namespace quickUnfolding{
namespace newUnfold{

MapGraph::MapGraph(HYPERGRAPH hg, map<LABELTYPE, set<IDTYPE> > cutGraph, map<LABELTYPE, set<IDTYPE> > isoGraph, map<IDTYPE, IDTYPE> mapping){
	 if(cutGraph.size() == 0)
      { 
	equal = true;
      }
    bool mapped = false;


    LABELTYPE label = (*cutGraph.begin()).first;
    set<IDTYPE> edges = (*cutGraph.begin()).second;

    set<IDTYPE> isoEdges = (*isoGraph.find(label)).second;

    set<IDTYPE>::iterator edge = edges.begin();
    for(set<IDTYPE>::iterator isoedge = isoEdges.begin();
	isoedge != isoEdges.end();
	isoedge++)
      {
	if(mapping.find(*isoedge) != mapping.end())
	  {
	    continue;
	  }
	list<IDTYPE> cVertices =  hg.getConnectedVertices(*edge);
	list<IDTYPE> iVertices = hg.getConnectedVertices(*isoedge);
	
	if(cVertices.size() != iVertices.size())
	  {
	    continue;
	  }
	map<IDTYPE, IDTYPE> newMapping(mapping);
	list<IDTYPE>::iterator cVertex = cVertices.begin();
	list<IDTYPE>::iterator iVertex = iVertices.begin();
	bool fits = true;
	while((fits) && (cVertex != cVertices.end()))
	  {

	    if(newMapping.find(*iVertex) != newMapping.end())
	      {
		if(*cVertex != (*newMapping.find(*iVertex)).second)
		  {
		    fits = false;
		  } 
	      } else {
		newMapping.insert(pair<IDTYPE, IDTYPE>(*iVertex, *cVertex));
	      }
	    cVertex++;
	    iVertex++;
	  }
	if(fits)
	  {
	    newMapping.insert(pair<IDTYPE, IDTYPE>(*isoedge, *edge));
	    map<LABELTYPE, set<IDTYPE> > newCutGraph(cutGraph);
	    if((*newCutGraph.begin()).second.size() == 1)
	      {
		newCutGraph.erase(newCutGraph.begin());
	      } else {
		(*newCutGraph.begin()).second.erase(*edge);
	      }
	    if(MapGraph(hg, newCutGraph, isoGraph, newMapping).isEqual())
	      {
		equal = true;
	      }
			
	  }
      }

    equal = false;
}

}
}
}
