/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NEWUNFOLD_H
#define NEWUNFOLD_H
#include "globals.h"
#include "petrigraph.h"
#include "rule.h"
#include "transitionCertificate.h"
#include "extendedTransitionCertificate.h"
#include "hypergraph.h"
#include "checkEdge.h"
#include "transition.h"
#include "cutoffCheck.h"
#include "algorithm.h"
#include <map>

namespace scenarios{
namespace quickUnfolding{
namespace newUnfold{
using namespace certificates;

class NewUnfold : public ALGORITHM{
private:
	IDTYPE transition;
	map<IDTYPE, set<IDTYPE> >* necessaryTransitions;
	map<IDTYPE, set<IDTYPE> >* directConflicts;
	map<IDTYPE, set<IDTYPE> >* edgeContext;
	map<IDTYPE, set<IDTYPE> >* removingEdge;
	map<IDTYPE, map<IDTYPE, IDTYPE> >* possibleRules;
	map<IDTYPE, TransitionCertificate>* transitionCertificates;
	map<IDTYPE, ExtendedTransitionCertificate>* extendedTransitionCertificates;
	map<IDTYPE, map<IDTYPE, map<IDTYPE, IDTYPE> > >* dependencies;
	map<IDTYPE, IDTYPE>* createdByTransition;
	map<IDTYPE, set<IDTYPE> >* concurrentEdges;

	IDTYPE counter;
public:
	NewUnfold(){}
	void initialize(map<IDTYPE, map<IDTYPE, IDTYPE> > &possibleRules, map<IDTYPE, ExtendedTransitionCertificate> &extendedTransitionCertificates, map<IDTYPE, map<IDTYPE, map<IDTYPE, IDTYPE> > > &dependencies, map<IDTYPE, IDTYPE> &createdByTransition, map<IDTYPE, TransitionCertificate> &transitionCertificates, map<IDTYPE, set<IDTYPE> >& concurrentEdges);
	void run(PETRIGRAPH & pg, RULE rule, pair<map<IDTYPE, IDTYPE>, map<IDTYPE, IDTYPE> > phi);
	IDTYPE getTransition(){return transition;}
	map<IDTYPE, set<IDTYPE> >& getNecessaryTransitions(){return *necessaryTransitions;}
	map<IDTYPE, set<IDTYPE> >& getDirectConflicts(){return *directConflicts;}
	map<IDTYPE, set<IDTYPE> >& getEdgeContext(){return *edgeContext;}
	map<IDTYPE, set<IDTYPE> >& getRemovingEdge(){return *removingEdge;}
	map<IDTYPE, map<IDTYPE, map<IDTYPE, IDTYPE> > >& getDependencies(){return *dependencies;}
	map<IDTYPE, map<IDTYPE, IDTYPE> >& getPossibleRules(){return *possibleRules;}
	map<IDTYPE, IDTYPE>& getCreatedByTransition(){return *createdByTransition;}
	map<IDTYPE, TransitionCertificate>& getTransitionCertificates(){return *transitionCertificates;}
	map<IDTYPE, ExtendedTransitionCertificate>& getExtendedTransitionCertificates(){return *extendedTransitionCertificates;}
	IDTYPE	createNewID();
};

}
}
}
#endif
