/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "preConflictCheck.h"
namespace scenarios{
namespace quickUnfolding{
namespace conflictCheck{

void PreConflictCheck::initialize(map<IDTYPE, set<IDTYPE> >& necessaryTransitions, map<IDTYPE, set<IDTYPE> >& removingEdge){
	this->necessaryTransitions = &necessaryTransitions;
	this->removingEdge = &removingEdge;
}

void PreConflictCheck::run(std::map<IDTYPE, IDTYPE> phi_e){
	set<IDTYPE> allNecessary;
    set<IDTYPE> allRemoving;
    set<IDTYPE> allUsedEdges;
    int edgeCounter = 0;
    for(map<IDTYPE, IDTYPE>::iterator phiEIt = phi_e.begin();
	phiEIt != phi_e.end();
	phiEIt++)
      {
	map<IDTYPE, set<IDTYPE> >::iterator necTransIt= necessaryTransitions->find((*phiEIt).second);
	if(necTransIt != necessaryTransitions->end())
	  {
	    set<IDTYPE> necessary = (*necTransIt).second;
	    allNecessary.insert((necessary).begin(), (necessary).end());
	  }

	map<IDTYPE, set<IDTYPE> >::iterator remEdgeIt= removingEdge->find((*phiEIt).second);	 
	if(remEdgeIt != removingEdge->end())
	  {
	    set<IDTYPE> removing = (*remEdgeIt).second;
	    allRemoving.insert((removing).begin(), (removing).end());
	  }

      }

    set<IDTYPE> allUnion(allNecessary);
    allUnion.insert(allRemoving.begin(), allRemoving.end());
 
    if(allUnion.size() < (allRemoving.size() + allNecessary.size())) 
      {
	//not reachable
	reachable = false;
      }


    reachable = true;
}

}
}
}
