/***************************************************************************
 *   Copyright (C) 2006 by Michael Mayer   *
 *   mayer@lippe   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef QUICKUNFOLD_H
#define QUICKUNFOLD_H
#include "globals.h"
#include "scenario.h"
#include "gts.h"
#include "petrigraph.h"
#include "gxlwriter.h"
#include "ptnet.h"
#include "token.h"
#include "marking.h"
#include "InterfaceChecker.h"
#include "generateCertificate.h"
#include "transitionCertificate.h"
#include "extendedTransitionCertificate.h"
#include "generateExtendedCertificate.h"
#include "newUnfold.h"

namespace scenarios{
namespace quickUnfolding{
using namespace certificates;
class QuickUnfold{
private:
	map<IDTYPE, map<IDTYPE, IDTYPE> > possibleRules;
	map<IDTYPE, ExtendedTransitionCertificate> extendedTransitionCertificates;
	map<IDTYPE, map<IDTYPE, map<IDTYPE, IDTYPE> > > dependencies;
	map<IDTYPE, set<IDTYPE> > concurrentEdges;
	map<IDTYPE, IDTYPE> createdByTransition;
	map<IDTYPE, set<IDTYPE> > transitionConflicts;
	map<IDTYPE, set<IDTYPE> > necessaryTransitions;
	map<IDTYPE, set<IDTYPE> > removingEdge;
	map<IDTYPE, set<IDTYPE> > directConflicts;
	map<IDTYPE, TransitionCertificate> transitionCertificates;
	set<IDTYPE> startgraph_edges;
	set<IDTYPE> startgraph_vertices;
	void CreatedByTransitionInit(PETRIGRAPH);
	int countAppearances(PETRIGRAPH& pg, string edgelabel);
	pair<bool, list<pair<map <IDTYPE,IDTYPE>, map<IDTYPE,IDTYPE> > > > findMatchingsForRule(PETRIGRAPH& pg, RULE rule);
	pair<IDTYPE, int> findMinimumEdge(PETRIGRAPH& pg, RULE rule);
	ALGORITHM* writer;
	PETRIGRAPH result;
	GTS* graphgrammar;
public:
	bool initialize(GTS* graphgrammar, ALGORITHM * writer);
	void run(PETRIGRAPH * pg);
};

}

}

#endif
