/***************************************************************************
:A

:A
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef REACHABILITY_ANALYSE_H
#define REACHABILITY_ANALYSE_H

#include <scenario.h>
#include <coverability.h>
#include "logic_lex_yacc/types.h"
#include "reachability_analyse/simplify_formula.h"
#include "reachability_analyse/lpmodel.h"

namespace scenarios {
/**
@author Arwed v. Merkatz
*/
class REACHABILITY_ANALYSE: public SCENARIO {
public:
    REACHABILITY_ANALYSE();

    ~REACHABILITY_ANALYSE();

    void run();

private:
    algorithms::ptnet::coverability::COVERABILITY *cov;

    bool isUnreachable (PTNET pn, const BoundSet &bounds);

    long getMarking (PTNET net, IDTYPE edge);
    LPMODEL makeL0 (PTNET pn, const BoundSet &bounds);
    bool setHasID (const vector<TCONNECTION> &set, const IDTYPE &id);
    LPMODEL makeFLP(PTNET pn);
    void changeFLP (LPMODEL &input, const map<IDTYPE, double> &marking, PTNET pn);
    void printVariables (ostream &os, const map<IDTYPE, double> &variables);
    bool trapCheck (PTNET pn, const BoundSet &bounds);
    bool canUseCoverability (const BoundSet &bounds);
    MARKING convertToMarking (const BoundSet &bounds);
    void removeNot (Node *formula);
    vector<vector<unsigned int> > permutate (vector<unsigned int> bounds);
    Node* convertToDNF (Node *formula);
};

};

#endif
