/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SIMPLIFY_FORMULA_H
#define SIMPLIFY_FORMULA_H
#include <climits>
#include "./logic_lex_yacc/types.h"
//int INT_MIN = -2147483648;
//int INT_MAX = 2147483647;

struct Bounds {
  int lower;
  int upper;

  Bounds (int lower, int upper) : lower(lower), upper(upper) {}
  Bounds () : lower(INT_MIN), upper(INT_MAX) {}

  friend bool operator==(const Bounds &left, const Bounds &right)
  {
    return  ((left.lower == right.lower) && (left.upper == right.upper));
  }

  friend bool operator<(const Bounds &left, const Bounds &right)
  {
    return ((left.lower < right.lower) ||
            ((left.lower == right.lower) && (left.upper < right.upper)));
  }
};

typedef map<IDTYPE, Bounds> BoundSet;

ostream& operator<<(ostream &ostream, const BoundSet &bounds);

void mergeOperators (Node *formula);

vector<BoundSet> simplify (Operator *formula);

#endif
