/***************************************************************************
 *   Copyright (C) 2007 by Salil Joshi   *
 *   hellfeuer@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "regexpreader.h"
#include <fstream>

extern FINITE_AUTOMATON * finalFA;

/*
	Uses the regpars.yy and reglex.ll files
	Parser has prefix re
*/
extern "C"
{
	extern int re_parse();
	extern char *re_strin;
}
namespace algorithms {
namespace readers {
	void REGEXPREADER::initialize (const char* filename)
	{
		std::fstream file;
		file.open(filename);
		char s[1];
		regexp = "";
		
		while (!file.eof()) {
			file.read(s, 1);
			regexp += s[0];
		}
		file.close();
	}
	
	
	void REGEXPREADER::run(FINITE_AUTOMATON** fa)
	{
		re_strin = (char*)regexp.c_str();
		re_parse();
		*fa = finalFA;
	}
	
REGEXPREADER::REGEXPREADER()
{
}


REGEXPREADER::~REGEXPREADER()
{
}

};
};
