/***************************************************************************
 *   Copyright (C) 2007 by Salil Joshi   *
 *   hellfeuer@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMSREGEXPREADER_H
#define ALGORITHMSREGEXPREADER_H

#include <iostream>
#include <cstdlib>
#include <string>
#include "finite_automaton.h"

namespace algorithms {
namespace readers {
/**
	@author hellfeuer <hellfeuer@gmail.com>
	Parses the regular expression in 'filename' and converts it into a finite automaton
	
	The finite automaton data structure can in general represent non-deterministic automatons, but in this case it is used as in a deterministic way
*/
class REGEXPREADER{
public:
    REGEXPREADER();
    
    void run(FINITE_AUTOMATON** fa);
    void initialize(const char* filename);
    
    ~REGEXPREADER();
    std::string regexp;

};

};
};

using namespace algorithms;
using namespace readers;

#endif
