/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "rule.h"

namespace data_structures
{
   RULE::RULE()
   {
   }

   RULE::~RULE()
   {
   }
   
   RULE RULE::clone()
   {
      RULE r = RULE();
      r.ID = this->ID;
      r.name = this->name;
      r.left = this->left;
      r.right = this->right;
      r.interface = this->interface;
      r.guards = this->guards;
      return r;
   }

   IDTYPE RULE::getID()
   {
      return this->ID;
   }
   
   void RULE::setID(IDTYPE ID)
   {
      this->ID = ID;
   }
   
   string RULE::getName()
   {
      return this->name;
   }
   
   void RULE::setName(string name)
   {
      this->name = name;
   }
   
   HYPERGRAPH* RULE::getLeft()
   {
      return &(this->left);
   }
   
   void RULE::setLeft(HYPERGRAPH* h)
   {
      this->left = *h;
   }
   
   HYPERGRAPH* RULE::getRight()
   {
      return &(this->right);
   }
   
   void RULE::setRight(HYPERGRAPH* h)
   {
      this->right = *h;
   }
   
   MATCH RULE::getInterface()
   {
      return this->interface;
   }
   
   void RULE::setInterface(MATCH m)
   {
      this->interface = m;
   }
   
   list<EXPRESSION> RULE::getGuard()
   {
      return this->guards;
   }
   
   void RULE::setGuard(list<EXPRESSION> exp)
   {
      this->guards = exp;
   }

   void RULE::addGuard(EXPRESSION exp)
   {
      this->guards.push_back(exp);
   }
 
   void RULE::setNAC(map<IDTYPE, HYPERGRAPH> i_NAC)
   {
      this->NAC = i_NAC;
   }
   map<IDTYPE, HYPERGRAPH> RULE::getNAC()
   {
      return this->NAC;
   }
   
   ostream& operator<<(ostream& ost, RULE& th)
   {
      ost << "rule \"" << th.name << "\" (ID " << th.ID << "\n";
      ost << "LHS " << th.left << "\nRHS " << th.right << "\n";
      ost << "interface " << th.interface;
      return ost;
   }
};
