/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DATA_STRUCTURESRULE_H
#define DATA_STRUCTURESRULE_H

#include "expression.h"
#include "hypergraph.h"
#include "match.h"

namespace data_structures
{
   class RULE
   {
      public:
         RULE();
         ~RULE();

         RULE clone();

         IDTYPE getID();
         void setID(IDTYPE ID);
         string getName();
         void setName(string name);
         HYPERGRAPH* getLeft();
         void setLeft(HYPERGRAPH* h);
         HYPERGRAPH* getRight();
         void setRight(HYPERGRAPH* h);
         MATCH getInterface();
         void setInterface(MATCH m);
         list<EXPRESSION> getGuard();
         void setGuard(list<EXPRESSION> exp);
	 void addGuard(EXPRESSION exp);
	 friend ostream& operator<<(ostream& ost, RULE& th);
	 void setNAC(map<IDTYPE, HYPERGRAPH> i_NAC);
	 map<IDTYPE, HYPERGRAPH> getNAC();
      
      protected:
         IDTYPE ID;
         string name;
         HYPERGRAPH left;
         HYPERGRAPH right;
         MATCH interface;
         list<EXPRESSION> guards;
	 map<IDTYPE, HYPERGRAPH> NAC;
   };
};
using namespace data_structures;

#endif
