/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SAMPLE_READER_H
#define SAMPLE_READER_H

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>

#include "globals.h"
#include "sample.h"

namespace algorithms {

namespace readers {

class SAMPLE_READER 
{
public:
    SAMPLE_READER();

    ~SAMPLE_READER();
    
    void initialize(char * filename);
    
    SAMPLE_STORAGE run();

private:

	void ReadSample(xmlNodePtr list_sample, SAMPLE &sample);
	
	void Read_m_list(xmlNodePtr m_list_xml, vector<list<HYPERGRAPH_INFO> > &m_list1);
	
	void ReadHypergraphInfo(xmlNodePtr HyperInfo, HYPERGRAPH_INFO &hgInfo);
	
	HYPERGRAPH ReadHypergraph(xmlNodePtr root, set<string> &ids, IDTYPE lastID);
	
	xmlNodePtr GetChildrenNode(xmlNodePtr parent, char* child_name);
	
  	xmlNodePtr GetNextChild(xmlNodePtr child1, char* child_name);        
	
	xmlNodePtr GetRelend(xmlNodePtr rel, int order);
	
	string filename;
};

};

};

using namespace algorithms;
using namespace readers;

#endif
