/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SAMPLE_WRITER_H
#define SAMPLE_WRITER_H

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>

#include "globals.h"
#include "sample.h"

namespace algorithms {

namespace writers {

class SAMPLE_WRITER
{

public:
    SAMPLE_WRITER();

    ~SAMPLE_WRITER();
    
    void initialize(char *filename);
    
    void run(SAMPLE_STORAGE & ss);

private:

    void WriteSample(xmlNodePtr list_sample, SAMPLE &sample);	
    void Write_m_list(xmlNodePtr m_list_xml, vector<list<HYPERGRAPH_INFO> > &m_list1);
    void WriteHypergraphInfo(xmlNodePtr list_el, HYPERGRAPH_INFO &hgInfo);
    void WriteHypergraph(xmlNodePtr node, HYPERGRAPH &hg);
    
    xmlDocPtr doc; 
    char *filename;    
    
};

};

};

using namespace algorithms;
using namespace writers;

#endif
