/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMS_MATCHINGS_DATA_STR_SEARCHPLANSEARCHPLAN_H
#define ALGORITHMS_MATCHINGS_DATA_STR_SEARCHPLANSEARCHPLAN_H

#include "costmatrix.h"
#include "costgraph.h"
#include "costtree.h"
#include "match.h"
#include <math.h>

#include "persistable.h"

namespace algorithms {

namespace matchings
{
namespace data_str_searchplan
{

/**
	@author Maxim Zaks
*/
class SEARCHPLAN: public DATA{
public:
    	SEARCHPLAN();
    	~SEARCHPLAN();

	bool initialize(COSTMATRIX* cm, HYPERGRAPH* hg, ALGORITHM* matchhandler, bool ptg);
	MATCH startMatching();
	list<MATCH> startMatchingForAll();
	void setTestMatch(MATCH test);
	MATCH getTestMatch(MATCH test);
	MATCH runOperation(MATCH* prevMatch, int operationPosition);
   	MATCH runOperationForAll(MATCH* prevMatch, int operationPosition);
	void setMatchHandler(ALGORITHM* matchhandler);

	bool loaded;
	list<MATCH> allMatches; 

protected:
	COSTMATRIX* costMatrix;
	HYPERGRAPH* hyperGraph;
	COSTGRAPH costGraph;
	COSTTREE costTree;
	MATCH testMatch;
	IDTYPE problemNode;
	vector<IDTYPE> searchPlanList;
	
	bool ptg;

	ALGORITHM* matchhandler;
	bool testIsDone;
	bool makeCostGraph();
	void makeCostTree();
	
	MATCH lookUp(IDTYPE eID, MATCH* resBefore);
	MATCH gotoNext(IDTYPE eID, MATCH* m1);
	
	list<MATCH> lookUpForAll(IDTYPE eID);
	list<MATCH> gotoNextForAll(IDTYPE eID, MATCH* m1);
	
	void makeSearchPlanList(IDTYPE id);


	
};

}

}

}

using namespace algorithms;
using namespace matchings;
using namespace data_str_searchplan;

#endif
