/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SECOND_MATCHHANDLER_REFINEMENT_H
#define SECOND_MATCHHANDLER_REFINEMENT_H

#include "algorithm.h"
#include "causality_relation.h"
#include "match.h"
#include "petrigraph.h"
#include "findmatch.h"
#include "sample.h"
#include "algorithm_storage.h"
#include "matchhandler.h"
#include "fire_transition.h"

namespace algorithms
{

namespace matchhandler
{
   
class SECOND_MATCHHANDLER_REFINEMENT: public ALGORITHM
{

public:

	SECOND_MATCHHANDLER_REFINEMENT();

	virtual ~SECOND_MATCHHANDLER_REFINEMENT();
    
	virtual void initialize(PETRIGRAPH * i_petrigraph, IDTYPE i_prule_id,
				 RULE * i_prule, MARKING * i_phi_E_L,
				 MATCH * i_match_first);
	virtual void initialize(PETRIGRAPH * i_petrigraph,
				 IDTYPE i_prule_id, RULE * i_prule,
				 bool * i_canFold,bool * i_canUnfold, 
				 MATCH* m1, MATCH* m2, MARKING* i_phi_E_L ); 
	virtual bool run(MATCH * match);
	 
	virtual void update(vector<EVENT> events);
	
	virtual void initialize();

protected:
	
	 // was already checked ?
	 bool checked(RULE * r, MATCH * match_first, MATCH * match_second);
	 /** check petrigraph */
	 bool checkPetrigraph(PETRIGRAPH * pg, SAMPLE_STORAGE * ss);
	 /** check if some nodes having the same labels are matches in one */
	 bool checkLabels(HYPERGRAPH * hg1, HYPERGRAPH * hg2, MATCH * match, HYPERGRAPH_INFO * hi);

	 PETRIGRAPH * petrigraph;
	 IDTYPE prule_id;
	 RULE *prule;
	 MARKING *phi_E_L;
	 MATCH *match_first;
	 MATCH *match_second;
	 
	 FIRE_TRANSITION ft;
	 
	 list<CHECKED_FOLDINGS> checkedFoldings;

};

};

};

#endif
