/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef AUTOMATION_2_GRAMMAR_H
#define AUTOMATION_2_GRAMMAR_H

/**
	this class converts finite automation into the grammar - CFEXPRESSION
*/

#include "cfexpression.h"
#include "../finite_automaton.h"

namespace semilin {

class AUTOMATON_2_GRAMMAR
{
public:
    AUTOMATON_2_GRAMMAR();

    ~AUTOMATON_2_GRAMMAR();

    vector<CFEXPRESSION*> run(FINITE_AUTOMATON * a);

    map<IDTYPE, string> getVariables();

    map<string, char> getConstants();

private:

	// symbols for variables
	vector<string> variables;
	long counter_var;

	// symbols for constants
	vector<char> constants;
	long counter_con;
 
	string getVariable(long index);
	map<IDTYPE, string> indices_var;

	const char getConstant(string s);
	map<string, char> indices_con;
};

};

using namespace semilin;

#endif
