/***************************************************************************
 *   Copyright (C) 2007 by Salil Joshi   *
 *   hellfeuer@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMS_EXPRESSIONCOMMKLEENE_DIFFERENTIAL_H
#define ALGORITHMS_EXPRESSIONCOMMKLEENE_DIFFERENTIAL_H
#include <string>
#include "cfexpression.h"
using std::string;

namespace semilin {

/**
	@author hellfeuer <hellfeuer@gmail.com>
	Differentiates the given expression with respect to the given variable and returns the result.
	Expression is treated as being from a Commutative Kleene Algebra
	Used by COMMKLEENE_SOLVE
*/
class COMMKLEENE_DIFFERENTIAL{
	private:
		string wrt;
		CFEXPRESSION* simplifyPlus(CFEXPRESSION* left, CFEXPRESSION* right);
		CFEXPRESSION* simplifyConcat(CFEXPRESSION* left, CFEXPRESSION* right);
public:
    COMMKLEENE_DIFFERENTIAL();
    
    void initialize(string wrtVar);	//Differentiates with respect to 'wrtVar'
    CFEXPRESSION * run(CFEXPRESSION* exp);	//Original expression is unchanged
    
    ~COMMKLEENE_DIFFERENTIAL();

};

}

#endif
