/***************************************************************************
 *   Copyright (C) 2007 by Salil Joshi   *
 *   hellfeuer@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMS_EXPRESSIONCOMMKLEENE_EVAL_H
#define ALGORITHMS_EXPRESSIONCOMMKLEENE_EVAL_H

#include <string>
#include "cfexpression.h"

namespace semilin {

/**
	@author hellfeuer <hellfeuer@gmail.com>
	'Evaluates' an expression. i.e. substitutes an expression (value) for a variable in a given expression
	ALTERS original expression
	Used by COMMKLEENE_SOLVE
*/
class COMMKLEENE_EVAL{
	private:
		string variable;
		CFEXPRESSION* value;
public:
	COMMKLEENE_EVAL();

 	void initialize(string var, CFEXPRESSION* val);
	void run(CFEXPRESSION* exp);
	
	~COMMKLEENE_EVAL();

};

}

#endif
