/***************************************************************************
 *   Copyright (C) 2007 by Salil Joshi   *
 *   hellfeuer@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMS_CONVERTERSRE_SEMILIN_CONVERTER_H
#define ALGORITHMS_CONVERTERSRE_SEMILIN_CONVERTER_H
#include "../semilinear.h"
#include "cfexpression.h"
#include "slmarking.h"
#include <map>
using std::map;

using namespace data_structures;

namespace semilin {

/**
	@author hellfeuer <hellfeuer@gmail.com>
	Converts the given expression into a semilinear set.
*/

class RE_SEMILIN_CONVERTER{
	private:
		unsigned int n;
		map<char, unsigned int>* charmap;
public:
    RE_SEMILIN_CONVERTER();
    
    /*Initialize with size of alphabet, and a map which maps each member of the alphabet to an index.
    Here the index is used for the marking.
    */
    void initialize(unsigned int alphabetsize, map <char, unsigned int>*chartoindex);
    SEMILINEAR<slmarking>* run(CFEXPRESSION* re);
    ~RE_SEMILIN_CONVERTER();

};

}

using namespace semilin;


#endif
