/***************************************************************************
 *   Copyright (C) 2007 by Salil Joshi   *
 *   hellfeuer@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "slmarking.h"
#include <iostream>
using std::cout;

namespace semilin {

slmarking::slmarking()
{
}

slmarking::slmarking(unsigned int n)
{
	m = vector<unsigned int>(n, 0);
}

slmarking::slmarking (const slmarking& a)
{
	m = vector<unsigned int>(a.m);
}

unsigned int slmarking::getN()
{
	return m.size();
}

bool slmarking::operator==(slmarking & a)
{
	return (m == a.m);
}

bool slmarking::operator<(const slmarking & a)
{
	return (m < a.m);
}

void slmarking::operator+=(const slmarking & a)
{
	for (int i = 0; i < m.size(); i++)
	{
		m[i] += a.m[i];
	}
}

bool slmarking::isZero()
{
	for (int i = 0; i < m.size(); i++)
	{
		if (m[i] != 0) {
			return false;
		}
	}
	return true;
}

slmarking* slmarking::operator+(const slmarking & a)
{
	slmarking* tmp = new slmarking(m.size());
	for (int i = 0; i < m.size(); i++)
	{
		tmp->m[i] = m[i] + a.m[i];
	}
	return tmp;
}

void slmarking::print()
{
	cout<<"[";
	for(int i = 0; i <m.size(); i++)
	{
		cout<<" "<<m[i]<<" ";
	}
	cout<<"]";
}

unsigned int& slmarking::operator[](unsigned int i)
{
	return m[i];
}

slmarking::~slmarking()
{
}


}
