/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "semilin_caller.h"

#include "semilin/re_semilin_converter.h"
#include "semilinear.h"
#include "semilin/slmarking.h"

using namespace data_structures;

namespace scenarios
{

SEMILIN_CALLER::SEMILIN_CALLER()
{
}


SEMILIN_CALLER::~SEMILIN_CALLER()
{
}

void SEMILIN_CALLER::initialize(char * filename)
{
	this->filename = filename;
}

void SEMILIN_CALLER::run(CFEXPRESSION exp)
{
	RE_SEMILIN_CONVERTER rs;

	rs.initialize(charmap.size(), &charmap);
	SEMILINEAR<slmarking>* semilinear = rs.run(&exp);
	semilinear->print();

	// write marking
	ofstream ofs(filename);
	for(set<LINEARSET<slmarking>* >::iterator i = semilinear->lsets.begin(); i != semilinear->lsets.end(); i++)
	{
		ofs << "MARKING ";
		bool start = true;
	
		for(map<string, char>::iterator it = constants.begin(); it != constants.end(); it++)
		{
			if(!start)
			 ofs << ", ";

			if((*i)->base_point[charmap[it->second]] > 0)
			{
				ofs << it->first << ": " << (*i)->base_point[charmap[it->second]];
				start = false;
			}
		}
	
		ofs << ";" << endl;
	}
}

void SEMILIN_CALLER::setConstants(map<string, char> constants)
{
	long count = 0;
	for(map<string, char>::iterator it = constants.begin(); it != constants.end(); it++)
	{
		charmap[it->second] = count;
		count++;
	}

	this->constants = constants;
}

}
