/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "spl_scenario.h"
#include "pointer_lang_reader.h"
#include "GTXLWriter.h"

using namespace algorithms;

using namespace readers;

namespace converters
{

SPL_CONVERTER::SPL_CONVERTER()
{
      this->inspec.push_back(pair<string, DATA_FORMAT>("spl-file", PLAIN_TEXT));
      this->outspec.push_back(pair<string, DATA_FORMAT>("grammar", GTXL));
      
      this->call_descriptor = "Usage: augur -sc=spl spl-file grammar \n\n\
spl-file\tpointer language file\n\
grammar\tograph grammar in GTXL format\n\n";
}


SPL_CONVERTER::~SPL_CONVERTER()
{
}

void SPL_CONVERTER::run()
{

 POINTER_LANG_READER reader;
 reader.initialize((char*)(this->filemap["spl-file"]).c_str());
 GTS gts;
 reader.run(gts);
 GTXLWRITER writer;
 writer.initialize((char*)(this->filemap["grammar"]).c_str());
 writer.run(gts);

}


};
