/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "sponge_scenario.h"
#include "sponge.h"
#include "gxlreader.h"
#include "marking_reader.h"
#include "textreader.h"
#include <string>
#include <iostream>

using namespace std;

namespace scenarios
{

SPONGE_SCENARIO::SPONGE_SCENARIO()
{
      this->ID = ALGORITHM_SPONGE;
      this->name = "sponge";
      
      this->inspec.push_back(pair<string, DATA_FORMAT>("hypergraph", GXL));
      this->inspec.push_back(pair<string, DATA_FORMAT>("regular_expression", PLAIN_TEXT));	
      this->outspec.push_back(pair<string, DATA_FORMAT>("marking", PLAIN_TEXT));
      
      this->call_descriptor = "Usage: augur -sc=sponge hypergraph regular_expression marking\n\n\
hypergraph\thypergraph in GXL format\n\
regular_expression\ttested property as regular expression\n\
marking\tmarking corresponding to regular expression\n\n";
}


SPONGE_SCENARIO::~SPONGE_SCENARIO()
{
}

void SPONGE_SCENARIO::run()
{
	//read hypergraph
	GXLREADER gxlreader;
	gxlreader.initialize((char*)(this->filemap["hypergraph"]).c_str());
	PETRIGRAPH pg;
	GTS gts;
	gxlreader.run(pg, gts);
	
	//read regular_expressioname
	TEXTREADER tr;
	tr.initialize((char*)(this->filemap["regular_expression"]).c_str());
	string s;
	tr.run(s);//warum muss string überbegen werden???
		
	// read markings
	MARKING_READER mreader;
	ofstream of((char*)(this->filemap["marking"]).c_str());
	
	SPONGE sponge;
 	sponge.initialize(pg,s);//übergabe Petrigraph und dem String s (Regular_Expression)
 	sponge.run(of);//übergabe von ofstream
}

}
