/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "validator.h"

namespace interfaces
{
   VALIDATOR::VALIDATOR()
   {
   }

   VALIDATOR::~VALIDATOR()
   {
   }
   
   VALIDATED::VALIDATED()
   {
   }
   
   VALIDATED::~VALIDATED()
   {
   }
   
   void VALIDATED::update(vector<EVENT> events)
   {
   }
   
   void VALIDATOR::validate(vector<EVENT> events)
   {
    int counter = 0;
    // check all registered validators for the neccesserity of updates
    for(list<VALIDATED*>::iterator it_v = validated.begin(); it_v != validated.end(); it_v++)
    {
        // list for validator
        vector<EVENT> n_e;
	
	// interested ?
	for(vector<EVENT>::iterator it_e = events.begin(); it_e!= events.end(); it_e++)
	{
	  if(IsInterested(counter, it_e->type))
	   n_e.push_back(*it_e);
	}
	
	// send
	if(n_e.size()!=0)
	 (*it_v)->update(n_e);
	 
	counter++; 
    }
   }  
   
   void VALIDATOR::registerValidated(VALIDATED * validated, list<ATYPES> atypes)
   {
     this->validated.push_back(validated);
     atypes_validated.push_back(atypes);
   }
   
   bool VALIDATOR::IsInterested(int counter, ATYPES e)
   {   
    int count = 0;
    
    for(list<list<ATYPES> >::iterator it = atypes_validated.begin(); it!=atypes_validated.end(); it++)
    {
     if(count!=counter)
     {
      count++;
      continue;
     } 
      
     for(list<ATYPES>::iterator it_e = (*it).begin(); it_e != (*it).end(); it_e++)
     {
      // found
      if((*it_e)==e)
       return true;
     } 
     
     break;
    }
    
    return false;    
   }
};
