/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef VIS_HYPERGRAPH_H
#define VIS_HYPERGRAPH_H

#include "algorithm.h"
#include "hypergraph.h"

#include <fstream>
#include <cmath>

namespace algorithms {

namespace writers {

class VIS_HYPERGRAPH: public ALGORITHM
{
public:
    VIS_HYPERGRAPH();

    ~VIS_HYPERGRAPH();

 virtual void initialize(char * filename);
 virtual void initialize(char * filename, ALGORITHM * p_engine);
 virtual void run(HYPERGRAPH & h, PRINT_TYPE pt);
 void setNodeLabel(map<int, int> nL);

private:

void writeDotFile(HYPERGRAPH & hg, char * dotFile, PRINT_TYPE pt);

char * filename;
map<int, int> nodeLabels;

ALGORITHM * engine;
};

};

};

using namespace algorithms;
using namespace algorithms::writers;

#endif
