/*************************************************************************   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "write_hypergraph.h"
#include "petrigraph.h"
#include "gxlwriter.h"

#include <string.h>

namespace algorithms {

namespace writers {

WRITE_HYPERGRAPH::WRITE_HYPERGRAPH()
{
}


WRITE_HYPERGRAPH::~WRITE_HYPERGRAPH()
{
}

void WRITE_HYPERGRAPH::initialize(char *filename)
{
    int n = strlen(filename);

    this->filename = new char[n+1];
    strcpy(this->filename,filename);
}

void WRITE_HYPERGRAPH::run(HYPERGRAPH & hg)
{
	PETRIGRAPH pg;
	pg.setAllValues(
		MATCH(),
		map<IDTYPE, MATCH>(),
		map<IDTYPE, IDTYPE>(),
		hg.getConnectedVertices(),
        	hg.getConnectedEdges(),
		map<IDTYPE, TRANSITION>(),
		map< IDTYPE, vector<TCONNECTION> >(),
        	map< IDTYPE, vector<TCONNECTION> >(),
		MARKING(),
		MARKING(),
		map<IDTYPE, unsigned>(),
		hg.getVertices(),
        	hg.getEdges(),
		0,
		NULL
   	);

	GXLWRITER writer;
	writer.initialize(filename);
	writer.run(pg, "test");
}

}

}
