/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef ALGORITHM_WRITE_LLNET_H
#define ALGORITHM_WRITE_LLNET_H

#include "algorithm.h"

namespace algorithms
{
   namespace writers
   {
      class WRITE_LLNET: public ALGORITHM
      {
       public:
         WRITE_LLNET();
	 virtual ~WRITE_LLNET();
	 
	 virtual void initialize(PTNET* i_ptnet);
	 virtual void initialize( PTNET* i_ptnet,
	                          map<IDTYPE, unsigned>* pp2l, map<unsigned, IDTYPE>* pl2p,
				  map<IDTYPE, unsigned>* tp2l, map<unsigned, IDTYPE>* tl2p  );
	 virtual void run(char* filename);
       
       protected:
         PTNET* ptnet;
	 map<IDTYPE, unsigned>* p_ptnet_to_llnet;
	 map<unsigned, IDTYPE>* p_llnet_to_ptnet;
	 map<IDTYPE, unsigned>* t_ptnet_to_llnet;
	 map<unsigned, IDTYPE>* t_llnet_to_ptnet;
      };
   };
};
using namespace algorithms;
using namespace algorithms::writers;

#endif
