


#include <string.h>

#include "PLGTS.h"
#include "GTXLWriter.h"
#include "symboltable.h"
#include "helpfunction.h"
#include "HashTable.h"

//extern SymbolTable* symboltable;
list <IDTYPE>lnull;

#define MAX_COUNTER 15


/*
PLGTS::PLGTS()
*/
PLGTS::PLGTS(SymbolTable* symboltable)
{  
   rule_counter=1;
   rule_id=1;
   peqp_2rule=false;
   int counter=1;
   this->symboltable=symboltable;

   char strcounter[MAX_COUNTER];
   sprintf(strcounter,"%d\0",counter);

   //Init Graph
   HYPERGRAPH *hg=new(HYPERGRAPH);
   hg->setName("Start graph");

   EDGE *start = new(EDGE);
   start->setLabel(strcounter);
   start->setID(1);
   hg->addEdge(*start,start->getID(), lnull);

   GraphGrammar.setStartgraph(hg);
   delete hg, start;
}


/*
PLGTS::PLGTS(int counter)
*/
PLGTS::PLGTS(SymbolTable* symboltable, int counter)
{
   this->symboltable=symboltable;
   peqp_2rule=false;
   rule_id=1;

   char strcounter[MAX_COUNTER];
   sprintf(strcounter,"%d\0",counter);

   //Init Graph
   HYPERGRAPH *hg=new(HYPERGRAPH);
   hg->setName("Start graph");

   EDGE *start = new(EDGE);
   start->setLabel(strcounter);
   start->setID(1);
   hg->addEdge(*start,start->getID(), lnull);

   GraphGrammar.setStartgraph(hg); 
   delete hg, start;
}


/*
PLGTS::PLGTS(char *strcounter)
*/
PLGTS::PLGTS(SymbolTable* symboltable, char *strcounter)
{
   this->symboltable=symboltable;
   peqp_2rule=false;
   rule_id=1;

   //Init Graph
   HYPERGRAPH *hg=new(HYPERGRAPH);
   hg->setName("Start graph");

   EDGE *estart = new(EDGE);
   estart->setLabel(strcounter);
   estart->setID(1);
   hg->addEdge(*estart,estart->getID(), lnull);

   GraphGrammar.setStartgraph(hg); 
   delete hg, estart;
}




/*
PLGTS::~PLGTS()
*/
PLGTS::~PLGTS()
{
}




/*
void PLGTS::WriteXML(char *filename)
*/
void PLGTS::WriteXML(char *filename)
{
   //cout << "XML Datei "<<filename <<" schreiben" << endl;
   cout <<"write XML File "<<filename <<endl;
   algorithms::writers::GTXLWRITER wr;
   wr.initialize(filename);
   wr.run(GraphGrammar);
}




/*
void setPeqPOption(bool peqp_2rule_)
*/
void PLGTS::setPeqPOption(bool peqp_2rule_)
{
   peqp_2rule=peqp_2rule_;
}

/*-----------  Vereinbarungen  ------------*/

/*
void produceIntDeclRule(int counter, char *varname, char *rulename)
*/
void PLGTS::produceIntDeclRule(int counter, char *varname, char *rulename) 
{

   produceIntDeclRule(counter, counter+1, varname, rulename);

}


/*
void produceIntDeclRule(int counterleft, int counterright, char *varname, char *rulename)
*/
void PLGTS::produceIntDeclRule(int counterleft, int counterright, char *varname, char *rulename) {

   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];
   sprintf(strcounter_l,"%d\0",counterleft);
   sprintf(strcounter_r,"%d\0",counterright);

   RULE *ruleIntDecl=new(RULE);
   ruleIntDecl->setName(addRuleID(rulename));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id;

   //linke Seite
   id=1;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   //rechte Seite

   VERTEX *ve=new (VERTEX);
   ve->setIdLabel(catstrint("ger",id));
   ve->setID(id);
   hright->addVertex(*ve,ve->getID());
   id++;

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   list <IDTYPE> list;
   EDGE *evar = new(EDGE);
   evar->setLabel(varname);
   evar->setIdLabel(catstrint("ger",id));
   evar->setID(id);
   list.push_back(ve->getID());
   hright->addEdge(*evar,evar->getID(),list);
   id++;

   EDGE *evartype = new(EDGE);
   evartype->setLabel("integer");
   evartype->setIdLabel(catstrint("ger",id));
   evartype->setID(id);
   TYPES types;
   types.push_back(INTEGER);
   evartype->setType(types);
   EXPRESSION *exp=new EXPRESSION(types, "0", "value");
   evartype->addAttributes(*exp);
   hright->addEdge(*evartype,evartype->getID(),list);
   id++;

   ruleIntDecl->setLeft(hleft);
   ruleIntDecl->setRight(hright);
   ruleIntDecl->setID(rule_counter++);
   GraphGrammar.addRule(ruleIntDecl);

   delete ecounter_left, ecounter_right, evar, evartype, exp, ve;
   delete hleft, hright, ruleIntDecl;
}




/*
void produceStrDeclRule(int counter, char *varname, char *rulename)
*/
void PLGTS::produceStrDeclRule(int counter, char *varname, char *rulename) 
{

   produceStrDeclRule(counter, counter+1, varname, rulename);

}


/*
void produceStrDeclRule(int counterleft, int counterright, char *varname, char *rulename )
*/
void PLGTS::produceStrDeclRule(int counterleft, int counterright, char *varname, char *rulename) {

   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];
   sprintf(strcounter_l,"%d\0",counterleft);
   sprintf(strcounter_r,"%d\0",counterright);

   RULE *ruleStrDecl=new(RULE);
   ruleStrDecl->setName(addRuleID(rulename));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id;

   //linke Seite
   id=1;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   //rechte Seite

   VERTEX *ve=new (VERTEX);
   ve->setIdLabel(catstrint("ger",id));
   ve->setID(id);
   hright->addVertex(*ve,ve->getID());
   id++;

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   list <IDTYPE> list;
   EDGE *evar = new(EDGE);
   evar->setLabel(varname);
   evar->setIdLabel(catstrint("ger",id));
   evar->setID(id);
   list.push_back(ve->getID());
   hright->addEdge(*evar,evar->getID(),list);
   id++;

   EDGE *evartype = new(EDGE);
   evartype->setLabel("string");
   evartype->setIdLabel(catstrint("ger",id));
   evartype->setID(id);
   TYPES types;
   types.push_back(STRING);
   evartype->setType(types);
   //EXPRESSION *exp=new EXPRESSION(types, "\"\"", "value");
   EXPRESSION *exp=new EXPRESSION(types, "''", "value");
   evartype->addAttributes(*exp);
   hright->addEdge(*evartype,evartype->getID(),list);
   id++;

   ruleStrDecl->setLeft(hleft);
   ruleStrDecl->setRight(hright);
   ruleStrDecl->setID(rule_counter++);
   GraphGrammar.addRule(ruleStrDecl);

   delete ecounter_left, ecounter_right, evar, evartype, exp, ve;
   delete hleft, hright, ruleStrDecl;
}




/*
void producePtoRecDeclRule(int counter, char *varname, char *rulename)
*/
void PLGTS::producePtoRecDeclRule(int counter, char *varname, char *rulename) 
{

   producePtoRecDeclRule(counter, counter+1, varname, rulename);

}


/*
void producePtoRecDeclRule(int counterleft, int counterright, char *varname, char *rulename)
*/
void PLGTS::producePtoRecDeclRule(int counterleft, int counterright, char *varname, char *rulename) {

   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];
   sprintf(strcounter_l,"%d\0",counterleft);
   sprintf(strcounter_r,"%d\0",counterright);

   RULE *rulePToRecDecl=new(RULE);
   rulePToRecDecl->setName(addRuleID(rulename));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id;

   //linke Seite
   id=1;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   //rechte Seite

   VERTEX *ve=new (VERTEX);
   ve->setIdLabel(catstrint("ger",id));
   ve->setID(id);
   hright->addVertex(*ve,ve->getID());
   id++;

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   list <IDTYPE> list;
   EDGE *evar = new(EDGE);
   evar->setLabel(varname);
   evar->setIdLabel(catstrint("ger",id));
   evar->setID(id);
   list.push_back(ve->getID());
   hright->addEdge(*evar,evar->getID(),list);
   id++;

   EDGE *evartype = new(EDGE);
   evartype->setLabel("null");
   evartype->setIdLabel(catstrint("ger",id));
   evartype->setID(id);
   hright->addEdge(*evartype,evartype->getID(),list);
   id++;

   rulePToRecDecl->setLeft(hleft);
   rulePToRecDecl->setRight(hright);
   rulePToRecDecl->setID(rule_counter++);
   GraphGrammar.addRule(rulePToRecDecl);

   delete ecounter_left, ecounter_right, evar, evartype, ve;
   delete hleft, hright, rulePToRecDecl;
}




/*
void produceTypeDeclRule(int counter, char *rulename)
*/
void PLGTS::produceTypeDeclRule(int counter, char *rulename) {

   produceDummyRule(counter, rulename);

}


/*
void produceTypeDeclRule(int counter, char *rulename)
*/
void PLGTS::produceTypeDeclRule(int counterleft, int counterright, char *rulename) {

   produceDummyRule(counterleft, counterright, rulename);

}




/*-----------  ANWEISUNGEN  ------------*/

/*
void produceSKIPRule(char *strcounter_l, char *strcounter_r, char *rulename)
*/
void PLGTS::produceSKIPRule(int counterleft, int counterright, char *rulename)
{
   produceDummyRule(counterleft, counterright, rulename);
}




/*
void PLGTS::produceNEWRule(int counterleft, int counterright, list<char*> path, char *rulename)
*/
void PLGTS::produceNEWRule(int counterleft, int counterright, list<char*> path, char *rulename)
{
   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];
   sprintf(strcounter_l,"%d\0",counterleft);
   sprintf(strcounter_r,"%d\0",counterright);

   int size=path.size();
   list <RULE*> rulelist;
   assert(size>0);

   list<char*>::iterator itr_path=path.begin();

   if (size==1) {

      list<char*>::iterator itr_path=path.begin();
      char *recordname=getRecordName(symboltable, *itr_path);
      char varname[strlen(*itr_path)+1];
      strcpy(varname, *itr_path);
      RULE *rule=new(RULE);
      char *rulename_=catstrstr(rulename, " (NEW(p))");
      rule->setName(addRuleID(rulename_));
 
      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName("producelefthandGraph");
      hright->setName("producerighthandGraph");

 
      int id=1;

      //linke Seite
      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id));
      ecounter_left->setID(id);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id++;

      VERTEX *ve_left=new (VERTEX);
      ve_left->setIdLabel(catstrint("gel",id));
      ve_left->setID(id);
      hleft->addVertex(*ve_left,ve_left->getID());
      id++;

      EDGE *evar_left = new(EDGE);
      evar_left->setLabel(varname);
      evar_left->setIdLabel(catstrint("gel",id));
      evar_left->setID(id);
      list <IDTYPE> list_left;
      list_left.push_back(ve_left->getID());
      hleft->addEdge(*evar_left,evar_left->getID(),list_left);
      id++;

      //rechte Seite
      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id));
      ecounter_right->setID(id);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id++;

      VERTEX *ve_right=new (VERTEX);
      ve_right->setIdLabel(catstrint("ger",id));
      ve_right->setID(id);
      hright->addVertex(*ve_right,ve_right->getID());
      id++;

      EDGE *evar_right = new(EDGE);
      evar_right->setLabel(varname);
      evar_right->setIdLabel(catstrint("ger",id));
      evar_right->setID(id);
      list <IDTYPE> list_right;
      list_right.push_back(ve_right->getID());
      hright->addEdge(*evar_right,evar_right->getID(),list_right);
      id++;

      VERTEX *ve_new=new (VERTEX);
      ve_new->setIdLabel(catstrint("ger",id));
      ve_new->setID(id);
      hright->addVertex(*ve_new,ve_new->getID());
      id++;

      produceRecordInit(hright, RIGHTHAND, id, recordname, ve_right->getID());

      //Match
      MATCH *match=new MATCH();
      match->setMatch(ve_left->getID(),ve_new->getID());
      rule->setInterface(*match);

      rule->setLeft(hleft);
      rule->setRight(hright);
      rulelist.push_back(rule);

      delete ve_left, ve_right, ve_new, ecounter_left, ecounter_right, evar_left, evar_right;
      delete hleft, hright, match;

   }

   else if (size==2) {

      char varname[strlen(*itr_path)+1];
      strcpy(varname, *itr_path);
      char recordcomp[strlen(*(++itr_path))+1];
      strcpy(recordcomp, *itr_path);
      char *recordname=getRecordName(symboltable, varname);

      RULE *rule=produceNEWPcompRule(strcounter_l, strcounter_r, varname, recordcomp, recordname, catstrstr(rulename, " (NEW(p.comp))") ,false);
      rulelist.push_back(rule);
      RULE *ruleerror=produceError(strcounter_l, varname,catstrstr(rulename , " (produce Error Rule)"));
      rulelist.push_back(ruleerror);

   }
   else {
      char *returnrecordname;
      list<char*>::iterator itr_end=path.end();
      char lastpathcomp[strlen(*(--itr_end))+1];
      strcpy(lastpathcomp, *itr_end);

      int returncounter;
      rulelist=gotoSecondLastPathRule(counterleft, 1,path, "#h", rulename, 0, returncounter, &returnrecordname);

      RULE *rule=produceNEWPcompRule(catstrstr(strcounter_l,"_e"),strcounter_r, "#h", lastpathcomp, returnrecordname, catstrstr(rulename , " (NEW(p.comp))"),true);
      rulelist.push_back(rule);
      RULE *ruleerror=produceError(catstrstr(strcounter_l,"_e"), "#h",catstrstr(rulename , " (produce Error Rule)"));
      rulelist.push_back(ruleerror);

   }
   for (list<RULE*>::iterator itr=rulelist.begin(); itr != rulelist.end(); itr++) {
      (*itr)->setID(rule_counter++);
      GraphGrammar.addRule(*itr);
      delete *itr;
   }
}




/*
   void PLGTS::produceDELETERule(int counterleft, int counterright, list<char*> path, char *rulename)
*/
void PLGTS::produceDELETERule(int counterleft, int counterright, list<char*> path, char *rulename)
{

   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];
   sprintf(strcounter_l,"%d\0",counterleft);
   sprintf(strcounter_r,"%d\0",counterright);

   int size=path.size();
   list <RULE*> rulelist;
   assert(size>0);

   list<char*>::iterator itr_path=path.begin();
   char *recordname=getRecordName(symboltable, *itr_path);
   assert(recordname!=NULL);
   
   if (size==1) {
      rulelist=produceDELETE_P_Rule(strcounter_l, strcounter_r, *itr_path, recordname, rulename);
   }
   else {
      int returnhelpcounter=1;
      list<char*>::iterator itr_path_last=path.end();
      char recordcomp[strlen(*(--itr_path_last))+1];
      strcpy(recordcomp, *itr_path_last);
      char *recordname;
      rulelist=gotoLastPathRule(counterleft, 1, path, "#h", rulename, 0, returnhelpcounter, &recordname);
      list <RULE*> rulelist_=produceDELETE_P_Rule(catstrstr(strcounter_l, "_e"), strcounter_r, "#h", recordname, rulename, true);

      rulelist.merge(rulelist_);
   } 

   /*
   else if (size==2) {

      char varname[strlen(*itr_path)+1];
      strcpy(varname, *itr_path);
      char recordcomp[strlen(*(++itr_path))+1];
      strcpy(recordcomp, *itr_path);
      char *recordname=getRecordName(symboltable, varname);

      rulelist=produceDELETE_PComp_Rule(strcounter_l, strcounter_r, varname, recordcomp, recordname, rulename);
   }
   else {

      int returnhelpcounter=1;
      list<char*>::iterator itr_path_last=path.end();
      char recordcomp[strlen(*(--itr_path_last))+1];
      strcpy(recordcomp, *itr_path_last);
      char *recordname;
      path.pop_back();

      rulelist=gotoLastPathRule(counterleft, 1, path, "#h", rulename, 0, returnhelpcounter, &recordname);

      list <RULE*> rulelist_=produceDELETE_PComp_Rule(catstrstr(strcounter_l, "_e"), strcounter_r, "#h", recordcomp, recordname, rulename, true);

      rulelist.merge(rulelist_);
   }*/

   for (list<RULE*>::iterator itr=rulelist.begin(); itr != rulelist.end(); itr++) {
      (*itr)->setID(rule_counter++);
      GraphGrammar.addRule(*itr);
      delete *itr;
   }
}




/*
void producePointerAssignerRule(int leftcounter, int rightcounter, list <char*> left, list <char*> right, char *rulename)
*/
void PLGTS::producePointerAssignerRule(int counterleft, int counterright, list <char*> left, list <char*> right, char *rulename)
{

   int lengthleft=left.size();
   int lengthright=right.size();
   assert (lengthleft >0 && lengthright >0);

   list <RULE*> rulelist;
   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];
   sprintf(strcounter_l,"%d\0",counterleft);
   sprintf(strcounter_r,"%d\0",counterright);

   list<char*>::iterator itr_left=left.begin();
   list<char*>::iterator itr_right=right.begin();

   //lengthleft=1
   if (lengthleft==1) {
      if (lengthright == 1) {
         RULE *rule=producePToPRule(strcounter_l, strcounter_r, *itr_left, *itr_right, catstrstr(rulename," (p:=p)"));
         rulelist.push_back(rule);
      }
      if (lengthright == 2) {
         if (strcmp(*itr_left, *itr_right)==0) {
            char *recordname= getRecordName(symboltable, *itr_left);
            char *rulename_=catstrstr(rulename, " (p:=p.comp)");
            assert(recordname != NULL);
            RULE *rule = producePToPcompRule(strcounter_l,strcounter_r,*itr_left,*(++itr_right),recordname,rulename_);
            rulelist.push_back(rule);
            RULE *ruleerror=produceError(strcounter_l, *itr_left, catstrstr(rulename, " (produce Error Rule)"));
            rulelist.push_back(ruleerror);
         }
         else {
            char varleft[strlen(*itr_left)+1];
            strcpy(varleft, *itr_left);
            char varright[strlen(*itr_right)+1];
            strcpy(varright, *itr_right);
            char *recordname=getRecordName(symboltable, *itr_right);
            assert(recordname != NULL);
            char recordcomp[strlen(*(++itr_right))+1];
            strcpy(recordcomp, *itr_right);
            char *rulename_=catstrstr(rulename, " (p:=p.comp)");

            RULE *rule=producePiToPjcompRule(strcounter_l, strcounter_r, varleft, varright, recordcomp, recordname, rulename_);
            rulelist.push_back(rule);
            RULE *ruleerror=produceError(strcounter_l, varright, catstrstr(rulename, " (produce Error Rule)"));
            rulelist.push_back(ruleerror);
         }
      }
      else if (lengthright > 2) {
         int returncounter;
         list <RULE*> rule_=gotoLastPathRule(counterleft, 1, right, "#h", rulename, 0, returncounter);
         rulelist.merge(rule_);
         RULE *rule=producePToPRule(catstrstr(strcounter_l,"_e"),strcounter_r,*itr_left, "#h", catstrstr(rulename, " (p:=p)"), false, true);
         rulelist.push_back(rule);
      }
   }
   //lengthright=1
   else if (lengthright == 1) {
      if (lengthleft == 2) {
        if (strcmp(*itr_left, *itr_right)==0) {
            char *recordname= getRecordName(symboltable, *itr_right);
            assert(recordname != NULL);
            char *rulename_=catstrstr(rulename, " (p.comp:=p)");
            RULE *rule = producePcompToPRule(strcounter_l, strcounter_r, *itr_right,*(++itr_left),recordname,rulename_);
            rulelist.push_back(rule);
            RULE *ruleerror=produceError(strcounter_l, *itr_right, catstrstr(rulename, " (produce Error Rule)"));
            rulelist.push_back(ruleerror);
         }
         else {
            char varnameleft[strlen(*itr_left)+1];
            strcpy(varnameleft, *itr_left);
            char varnameright[strlen(*itr_right)+1];
            strcpy(varnameright, *itr_right);
            char *recordname=getRecordName(symboltable, *itr_left);
            assert(recordname != NULL);
            char recordcomp[strlen(*(++itr_left))+1];
            strcpy(recordcomp, *itr_left);

            RULE *rule=producePicompToPjRule(strcounter_l, strcounter_r, varnameleft, recordcomp, recordname, varnameright, catstrstr(rulename, " (p.comp:=p)"));
            rulelist.push_back(rule);
            RULE *ruleerror=produceError(strcounter_l, varnameleft,  catstrstr(rulename, " (produce Error Rule)"));
            rulelist.push_back(ruleerror);
         }
      }
      // lengthleft > 2
      else {
         char *recordname;
         int returncounter;
         list <RULE*>rule_=gotoSecondLastPathRule(counterleft, 1, left, "#h", rulename, 0, returncounter, &recordname);
         list<char*>::iterator itr_last=left.end();
         char *lastcomp=*(--itr_last);
         rulelist.merge(rule_);
         RULE *rule=producePicompToPjRule(catstrstr(strcounter_l,"_e"),strcounter_r, "#h", lastcomp, recordname, *itr_right, catstrstr(rulename," (p.comp:=p)"),true, false);
         rulelist.push_back(rule);
         RULE *ruleerror=produceError(catstrstr(strcounter_l,"_e"), "#h", catstrstr(rulename, " (produce Error Rule)"));
         rulelist.push_back(ruleerror);
      }
   }
   //lengthleft>2 && length>=2
   else if (lengthleft > 2 && lengthright >= 2) {
      char *recordname;
      list<char*>::iterator itr_last=left.end();
      char *lastcomp=*(--itr_last);
      int returnhelpcounter=1;

      list <RULE*> ruleleft=gotoSecondLastPathRule(counterleft, 1, left, "#h1", rulename, 1, returnhelpcounter, &recordname);
      int returnhelpcounter_2=1;
      list <RULE*> ruleright=gotoLastPathRule(counterleft, returnhelpcounter, right, "#h2", rulename, 2,  returnhelpcounter_2);

      ruleright.merge(ruleleft);
      rulelist = ruleright;

      RULE *rulepctop=producePicompToPjRule(catstrstr(strcounter_l,"_e"), strcounter_r, "#h1", lastcomp, recordname, "#h2", catstrstr(rulename, " (p.comp:=p)"), true, true);
      rulelist.push_back(rulepctop);
      RULE *ruleerror=produceError(catstrstr(strcounter_l,"_e"), "#h1", catstrstr(rulename, " (produce Error Rule)"));
      rulelist.push_back(ruleerror);

   }
   //lengthleft=2 && legthright>=2
   else if (lengthleft == 2 && lengthright >= 2) {
      
      char varleft[strlen(*itr_left)+1];;
      strcpy(varleft, *itr_left);
      char *recordname=getRecordName(symboltable, *itr_left);
      char *recordcomp=*(++itr_left);

      int returnhelpcounter=1;
      rulelist=gotoLastPathRule(counterleft, returnhelpcounter, right, "#h", rulename, 0,  returnhelpcounter);
      RULE *rulepctop=producePicompToPjRule(catstrstr(strcounter_l,"_e"), strcounter_r, varleft, recordcomp, recordname, "#h", catstrstr(rulename, " (p.comp:=p)"),false, true);
      rulelist.push_back(rulepctop);

      RULE *ruleerror=produceError(catstrstr(strcounter_l,"_e"), "#h", catstrstr(rulename, " (produce Error Rule)"));
      rulelist.push_back(ruleerror);

   }
   else
      assert(false);

   for (list<RULE*>::iterator itr=rulelist.begin(); itr != rulelist.end(); itr++) {
      (*itr)->setID(rule_counter++);
      GraphGrammar.addRule(*itr);
      delete *itr;
   }
}




/*
void producePointerAssignerNULLRule(int counterleft, int counterright, list<char*> path, char *rulename)
*/
void PLGTS::producePointerAssignerNULLRule(int counterleft, int counterright, list<char*> path, char *rulename)
{
   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];
   sprintf(strcounter_l,"%d\0",counterleft);
   sprintf(strcounter_r,"%d\0",counterright);

   int size=path.size();
   list <RULE*> rulelist;
   assert(size>0);

   list<char*>::iterator itr_path=path.begin();

   if (size==1) {

      list<char*>::iterator itr_path=path.begin();
      char *recordname=getRecordName(symboltable, *itr_path);
      char varname[strlen(*itr_path)+1];
      strcpy(varname, *itr_path);
      RULE *rule=new(RULE);
      char *rulename_=catstrstr(rulename, " (P := NULL)");
      rule->setName(addRuleID(rulename_));
 
      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName("producelefthandGraph");
      hright->setName("producerighthandGraph");

      int id=1;

      //linke Seite
      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id));
      ecounter_left->setID(id);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id++;

      VERTEX *ve_left=new (VERTEX);
      ve_left->setIdLabel(catstrint("gel",id));
      ve_left->setID(id);
      hleft->addVertex(*ve_left,ve_left->getID());
      id++;

      EDGE *evar_left = new(EDGE);
      evar_left->setLabel(varname);
      evar_left->setIdLabel(catstrint("gel",id));
      evar_left->setID(id);
      list <IDTYPE> list_left;
      list_left.push_back(ve_left->getID());
      hleft->addEdge(*evar_left,evar_left->getID(),list_left);
      id++;

      //rechte Seite
      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id));
      ecounter_right->setID(id);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id++;

      VERTEX *ve_right=new (VERTEX);
      ve_right->setIdLabel(catstrint("ger",id));
      ve_right->setID(id);
      hright->addVertex(*ve_right,ve_right->getID());
      id++;

      EDGE *evar_right = new(EDGE);
      evar_right->setLabel(varname);
      evar_right->setIdLabel(catstrint("ger",id));
      evar_right->setID(id);
      list <IDTYPE> list_right;
      list_right.push_back(ve_right->getID());
      hright->addEdge(*evar_right,evar_right->getID(),list_right);
      id++;

      EDGE *enull = new(EDGE);
      enull->setLabel("null");
      enull->setIdLabel(catstrint("ger",id));
      enull->setID(id);
      list <IDTYPE> list_null;
      list_null.push_back(ve_right->getID());
      hright->addEdge(*enull,enull->getID(),list_null);
      id++;

      VERTEX *ve_new=new (VERTEX);
      ve_new->setIdLabel(catstrint("ger",id));
      ve_new->setID(id);
      hright->addVertex(*ve_new,ve_new->getID());
      id++;

      //Match

      MATCH *match=new MATCH();
      match->setMatch(ve_left->getID(),ve_new->getID());
      rule->setInterface(*match);

      rule->setLeft(hleft);
      rule->setRight(hright);
      rulelist.push_back(rule);

      delete ve_left, ve_right, ve_new, ecounter_left, ecounter_right, evar_left, evar_right, enull;
      delete hleft, hright, match;

   }
   else if (size==2) {

      char varname[strlen(*itr_path)+1];
      strcpy(varname, *itr_path);
      char recordcomp[strlen(*(++itr_path))+1];
      strcpy(recordcomp, *itr_path);
      char *recordname=getRecordName(symboltable, varname);
      assert(recordname != NULL);

      RULE *rule=produceNULLPcompRule(strcounter_l, strcounter_r,varname, recordcomp, recordname, catstrstr(rulename, " (P.comp := NULL)"));
      rulelist.push_back(rule);
      RULE *ruleerror=produceError(strcounter_l, varname, catstrstr(rulename, " (produce Error Rule)"));
      rulelist.push_back(ruleerror);

   }
   else {

      char *returnrecordname;

      list<char*>::iterator itr_end=path.end();
      char lastpathcomp[strlen(*(--itr_end))+1];
      strcpy(lastpathcomp, *itr_end);
      int returnhelpcounter=1;

      rulelist=gotoSecondLastPathRule(counterleft, 1, path, "#h", rulename,0 , returnhelpcounter, &returnrecordname);
      RULE *rule=produceNULLPcompRule(catstrstr(strcounter_l,"_e"), strcounter_r,"#h", lastpathcomp, returnrecordname, catstrstr(rulename," (P.comp := NULL)"), true);
      rulelist.push_back(rule);
      RULE *ruleerror=produceError(catstrstr(strcounter_l,"_e"), "#h", catstrstr(rulename, " (produce Error Rule)"));
      rulelist.push_back(ruleerror);

   }

   for (list<RULE*>::iterator itr=rulelist.begin(); itr != rulelist.end(); itr++) {
      (*itr)->setID(rule_counter++);
      GraphGrammar.addRule(*itr);
      delete *itr;
   }
}




/*
void PLGTS::produceStringAssignerConstRule(int counterleft, int counterright, list<char*> left, char *strconst, char *rulename)
*/
void PLGTS::produceStringAssignerConstRule(int counterleft, int counterright, list<char*> left, char *strconst, char *rulename) {

   list <RULE*> rulelist;
   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;

   int id_left=1;
   int id_right=1;

   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];

   sprintf(strcounter_l,"%d\0",counterleft);
   sprintf(strcounter_r,"%d\0",counterright);

   RULE *rule=new(RULE);
   rule->setName(addRuleID(rulename));

   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");


   list<char*>::iterator itr = left.begin();
   if (left.size()==1) {

      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      MATCH *match=new MATCH();
      match->setMatch(id_left, id_right);
      produceVar(hleft, LEFTHAND, id_left, *itr, "x", "string");
      produceVar(hright, RIGHTHAND, id_right, *itr, strconst, "string");

      rule->setInterface(*match);
      rule->setLeft(hleft);
      rule->setRight(hright);
      rulelist.push_back(rule);

      delete ecounter_left, ecounter_right;
      delete match;
   }
   else if (left.size()==2) {

      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      char varname[strlen(*itr)+1];
      strcpy(varname, *itr++);
      char recordcomp[strlen(*itr)+1];
      strcpy(recordcomp, *itr);
      char *recordname=getRecordName(symboltable, varname);

      int edge_id=producePVar(hleft, LEFTHAND, id_left, varname, recordcomp, recordname, "x", "string");
      rulelist.push_back(produceError(strcounter_l, varname, catstrstr(rulename, " (produce Error Rule)")));
      list<IDTYPE> vertexlist = hleft->getConnectedVertices(edge_id);
      list<IDTYPE>::iterator itredgelist = vertexlist.begin();
      while(itredgelist != vertexlist.end()){
         leftmap.push_back(*itredgelist);
         itredgelist++;
      }

      edge_id=producePVar(hright, RIGHTHAND, id_right, varname, recordcomp, recordname, strconst, "string");
      vertexlist = hright->getConnectedVertices(edge_id);
      itredgelist = vertexlist.begin();
      while(itredgelist != vertexlist.end()){ 
         rightmap.push_back(*itredgelist);
         itredgelist++;
      }

      MATCH *match=new MATCH();
      list<IDTYPE>::iterator itr_right = rightmap.begin();
      for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
      {
         match->setMatch(*itr_left,*itr_right);
         itr_right++;
      }
      rule->setInterface(*match);
      rule->setLeft(hleft);
      rule->setRight(hright);
      rulelist.push_front(rule);

      delete ecounter_left, ecounter_right;
      delete match;

   }

   else {
      char *rulename_=catstrstr(rulename, " (Assigner with help var)");
      rule->setName(addRuleID(rulename_));
      int returnhelpcounter;
      list <RULE*> lr=gotoLastPathRule(counterleft, 1, left, "#h", rulename, 0, returnhelpcounter);

      rulelist.merge(lr);

      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(catstrstr(strcounter_l,"_e"));
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      MATCH *match=new MATCH();
      match->setMatch(id_left,id_right);

      produceVar(hleft, LEFTHAND, id_left, "#h","x", "string");
      produceVar(hright, RIGHTHAND, id_right, "#h", strconst, "string");

      rule->setInterface(*match);
      rule->setLeft(hleft);
      rule->setRight(hright);
      rulelist.push_back(rule);

      delete ecounter_left, ecounter_right;
      delete match;
   }

   for (list<RULE*>::iterator itr=rulelist.begin(); itr != rulelist.end(); itr++) {
      (*itr)->setID(rule_counter++);
      GraphGrammar.addRule(*itr);
      delete (*itr);
   }
}




/*
void PLGTS::produceStringAssignerRule(int counterleft, int counterright, list<char*> left, list<char*> right, char *rulename)
*/
void PLGTS::produceStringAssignerRule(int counterleft, int counterright, list<char*> left, list<char*> right, char *rulename) {

   list <RULE*> rulelist;
   list <char*>::iterator itr_left=left.begin();
   list <char*>::iterator itr_right=right.begin();

   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;

   int id_left=1;
   int id_right=1;

   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];

   sprintf(strcounter_l,"%d\0",counterleft);
   sprintf(strcounter_r,"%d\0",counterright);

   if (left.size()==1) {

      if (right.size()==1) {

         RULE *rule=new(RULE);
         rule->setName(addRuleID(rulename));
 
         HYPERGRAPH *hleft=new(HYPERGRAPH);
         HYPERGRAPH *hright=new(HYPERGRAPH);
         hleft->setName("producelefthandGraph");
         hright->setName("producerighthandGraph");

         EDGE *ecounter_left=new(EDGE);
         ecounter_left->setLabel(strcounter_l);
         ecounter_left->setIdLabel(catstrint("gel",id_left));
         ecounter_left->setID(id_left);
         hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
         id_left++;

         EDGE *ecounter_right=new(EDGE);
         ecounter_right->setLabel(strcounter_r);
         ecounter_right->setIdLabel(catstrint("ger",id_right));
         ecounter_right->setID(id_right);
         hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
         id_right++;

         int i=1;
         leftmap.push_back(id_left);
         produceVar(hleft, LEFTHAND, id_left, *itr_left, "x1", "string");
         leftmap.push_back(id_left);
         produceVar(hleft, LEFTHAND, id_left, *itr_right, "x2", "string");
         rightmap.push_back(id_right);
         produceVar(hright, RIGHTHAND, id_right, *itr_left, "x2", "string");
         rightmap.push_back(id_right);
         produceVar(hright, RIGHTHAND, id_right, *itr_right, "x2", "string");

         MATCH *match=new MATCH();
         list<IDTYPE>::iterator itr_right = rightmap.begin();
         for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left !=   leftmap.end(); itr_left++)
         {
            match->setMatch(*itr_left,*itr_right);
            itr_right++;
         }
         rule->setInterface(*match);
         rule->setLeft(hleft);
         rule->setRight(hright);
         rulelist.push_back(rule);

         delete ecounter_left, ecounter_right;
         delete hleft, hright, match;
      }
      else if (right.size()==2) {

         RULE *rule=new(RULE);
         rule->setName(addRuleID(rulename));
 
         HYPERGRAPH *hleft=new(HYPERGRAPH);
         HYPERGRAPH *hright=new(HYPERGRAPH);
         hleft->setName("producelefthandGraph");
         hright->setName("producerighthandGraph");

         EDGE *ecounter_left=new(EDGE);
         ecounter_left->setLabel(strcounter_l);
         ecounter_left->setIdLabel(catstrint("gel",id_left));
         ecounter_left->setID(id_left);
         hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
         id_left++;

         EDGE *ecounter_right=new(EDGE);
         ecounter_right->setLabel(strcounter_r);
         ecounter_right->setIdLabel(catstrint("ger",id_right));
         ecounter_right->setID(id_right);
         hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
         id_right++;

         char varname[strlen(*itr_right)+1];
         strcpy(varname, *itr_right++);
         char recordcomp[strlen(*itr_right)+1];
         strcpy(recordcomp, *itr_right);
         char *recordname=getRecordName(symboltable, varname);

         //linke Seite
         leftmap.push_back(id_left);
         produceVar(hleft, LEFTHAND, id_left, *itr_left, "x1" ,"string");
         int edge_id=producePVar(hleft, LEFTHAND, id_left, varname, recordcomp, recordname, "x2", "string");
         rulelist.push_back(produceError(counterleft, varname, catstrstr(rulename, " (produce Error Rule)")));
         list<IDTYPE> vertexlist = hleft->getConnectedVertices(edge_id);
         list<IDTYPE>::iterator itredgelist = vertexlist.begin();
         while(itredgelist != vertexlist.end()){
            leftmap.push_back(*itredgelist);
            itredgelist++;
         }

         //rechte Seite
         rightmap.push_back(id_right);
         produceVar(hright, RIGHTHAND, id_right, *itr_left, "x2" ,"string");
         edge_id=producePVar(hright, RIGHTHAND, id_right, varname, recordcomp, recordname, "x2", "string");
         vertexlist = hright->getConnectedVertices(edge_id);
         itredgelist = vertexlist.begin();
         while(itredgelist != vertexlist.end()){
            rightmap.push_back(*itredgelist);
            itredgelist++;
         }
         MATCH *match=new MATCH();
         list<IDTYPE>::iterator itr_right = rightmap.begin();
         for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
         {
            match->setMatch(*itr_left,*itr_right);
            itr_right++;
         }
         rule->setInterface(*match);
         rule->setLeft(hleft);
         rule->setRight(hright);
         rulelist.push_front(rule);

         delete ecounter_left, ecounter_right;
         delete hleft, hright, match;

      }
      else {

         int returnhelpcounter=1;
         list <RULE*> rr=gotoLastPathRule(counterleft, 1, right, "#h", rulename, 0, returnhelpcounter);

         rulelist.merge(rr);

         id_left=id_right=1;
         RULE *rule=new(RULE);
         char *rulename_=catstrstr(rulename, " (Assigner with help var)");
         rule->setName(addRuleID(rulename_));

         HYPERGRAPH *hleft=new(HYPERGRAPH);
         HYPERGRAPH *hright=new(HYPERGRAPH);
         hleft->setName("producelefthandGraph");
         hright->setName("producerighthandGraph");

         EDGE *ecounter_left=new(EDGE);
         ecounter_left->setLabel(catstrstr(strcounter_l, "_e"));
         ecounter_left->setIdLabel(catstrint("gel",id_left));
         ecounter_left->setID(id_left);
         hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
         id_left++;

         EDGE *ecounter_right=new(EDGE);
         ecounter_right->setLabel(strcounter_r);
         ecounter_right->setIdLabel(catstrint("ger",id_right));
         ecounter_right->setID(id_right);
         hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
         id_right++;

         int id_vertex_1_left=id_left;
         produceVar(hleft, LEFTHAND, id_left, *itr_left, "x1", "string");
         int id_vertex_2_left=id_left;
         produceVar(hleft, LEFTHAND, id_left, "#h", "x2", "string");
         
         int id_vertex_1_right=id_right;
         produceVar(hright, RIGHTHAND, id_right, *itr_left, "x2", "string");

         int id_vertex_2_right=id_right;
         VERTEX *ve=new (VERTEX);
         ve->setIdLabel(catstrint("ger",id_right));
         ve->setID(id_right);
         hright->addVertex(*ve,ve->getID());
         id_right++;

         list <IDTYPE> vlist; 
         vlist.push_back(ve->getID());

         EDGE *evartype = new(EDGE);
         evartype->setLabel("string");
         evartype->setIdLabel(catstrint("ger",id_right));
         evartype->setID(id_right);
         TYPES types;
         types.push_back(STRING);
         evartype->setType(types);
         EXPRESSION *exp=new EXPRESSION(types, "x2", "value");
         evartype->addAttributes(*exp);

         hright->addEdge(*evartype,evartype->getID(),vlist);
         id_right++;
         
         MATCH *match=new MATCH();
         match->setMatch(id_vertex_1_left,id_vertex_1_right);
         match->setMatch(id_vertex_2_left,id_vertex_2_right);

         rule->setInterface(*match);
         rule->setLeft(hleft);
         rule->setRight(hright);
         rulelist.push_back(rule);

         delete ve, ecounter_left, ecounter_right, evartype, exp;
         delete hleft, hright, match;

      }

   }
   else if (right.size()==1) {
      if (left.size()==2) {

         RULE *rule=new(RULE);
         rule->setName(addRuleID(rulename));
 
         HYPERGRAPH *hleft=new(HYPERGRAPH);
         HYPERGRAPH *hright=new(HYPERGRAPH);
         hleft->setName("producelefthandGraph");
         hright->setName("producerighthandGraph");

         EDGE *ecounter_left=new(EDGE);
         ecounter_left->setLabel(strcounter_l);
         ecounter_left->setIdLabel(catstrint("gel",id_left));
         ecounter_left->setID(id_left);
         hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
         id_left++;

         EDGE *ecounter_right=new(EDGE);
         ecounter_right->setLabel(strcounter_r);
         ecounter_right->setIdLabel(catstrint("ger",id_right));
         ecounter_right->setID(id_right);
         hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
         id_right++;

         char varname[strlen(*itr_left)+1];
         strcpy(varname, *itr_left++);
         char recordcomp[strlen(*itr_left)+1];
         strcpy(recordcomp, *itr_left);
         char *recordname=getRecordName(symboltable, varname);

         //linke Seite

         int edge_id=producePVar(hleft, LEFTHAND, id_left, varname, recordcomp, recordname, "x1", "string");
         rulelist.push_back(produceError(counterleft, varname, catstrstr(rulename, " (produce Error Rule)")));
         list<IDTYPE> vertexlist = hleft->getConnectedVertices(edge_id);
         list<IDTYPE>::iterator itredgelist = vertexlist.begin();
         while(itredgelist != vertexlist.end()){
            leftmap.push_back(*itredgelist);
            itredgelist++;
         }

         leftmap.push_back(id_left);
         produceVar(hleft, LEFTHAND, id_left, *itr_right, "x2" ,"string");



         //rechte Seite
         edge_id=producePVar(hright, RIGHTHAND, id_right, varname, recordcomp, recordname, "x2", "string");
         vertexlist = hright->getConnectedVertices(edge_id);
         itredgelist = vertexlist.begin();
         while(itredgelist != vertexlist.end()){
            rightmap.push_back(*itredgelist);
            itredgelist++;
         }

         rightmap.push_back(id_right);
         produceVar(hright, RIGHTHAND, id_right, *itr_right, "x2" ,"string");

         MATCH *match=new MATCH();
         list<IDTYPE>::iterator itr_right = rightmap.begin();
         for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
         {
            match->setMatch(*itr_left,*itr_right);
            itr_right++;
         }
         rule->setInterface(*match);
         rule->setLeft(hleft);
         rule->setRight(hright);
         rulelist.push_front(rule);

         delete ecounter_left, ecounter_right;
         delete hleft, hright, match;

      }
      else {

         int returnhelpcounter=1;
         list <RULE*> lr=gotoLastPathRule(counterleft, 1, left, "#h", rulename, 0, returnhelpcounter);

         rulelist.merge(lr);

         id_left=id_right=1;
         RULE *rule=new(RULE);
         char *rulename_=catstrstr(rulename, " (Assigner with help var)");
         rule->setName(addRuleID(rulename_));

         HYPERGRAPH *hleft=new(HYPERGRAPH);
         HYPERGRAPH *hright=new(HYPERGRAPH);
         hleft->setName("producelefthandGraph");
         hright->setName("producerighthandGraph");

         EDGE *ecounter_left=new(EDGE);
         ecounter_left->setLabel(catstrstr(strcounter_l, "_e"));
         ecounter_left->setIdLabel(catstrint("gel",id_left));
         ecounter_left->setID(id_left);
         hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
         id_left++;

         EDGE *ecounter_right=new(EDGE);
         ecounter_right->setLabel(strcounter_r);
         ecounter_right->setIdLabel(catstrint("ger",id_right));
         ecounter_right->setID(id_right);
         hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
         id_right++;

         int id_vertex_1_left=id_left;
         produceVar(hleft, LEFTHAND, id_left, "#h", "x1", "string");
         int id_vertex_2_left=id_left;
         produceVar(hleft, LEFTHAND, id_left, *itr_right, "x2", "string");

         int id_vertex_1_right=id_right;
         VERTEX *ve=new (VERTEX);
         ve->setIdLabel(catstrint("ger",id_right));
         ve->setID(id_right);
         hright->addVertex(*ve,ve->getID());
         id_right++;

         list <IDTYPE> vlist; 
         vlist.push_back(ve->getID());

         EDGE *evartype = new(EDGE);
         evartype->setLabel("string");
         evartype->setIdLabel(catstrint("ger",id_right));
         evartype->setID(id_right);
         TYPES types;
         types.push_back(STRING);
         evartype->setType(types);
         EXPRESSION *exp=new EXPRESSION(types, "x2", "value");
         evartype->addAttributes(*exp);
         hright->addEdge(*evartype,evartype->getID(),vlist);
         id_right++;

         int id_vertex_2_right=id_right;
         produceVar(hright, RIGHTHAND, id_right, *itr_right, "x2", "string");


         MATCH *match=new MATCH();
         match->setMatch(id_vertex_1_left,id_vertex_1_right);
         match->setMatch(id_vertex_2_left,id_vertex_2_right);

         rule->setInterface(*match);
         rule->setLeft(hleft);
         rule->setRight(hright);
         rulelist.push_back(rule);

         delete ve, ecounter_left, ecounter_right, evartype, exp;
         delete hleft, hright, match;



      }
   }
   else {

      int returnhelpcounter=1;
      list <RULE*> lr=gotoLastPathRule(counterleft, 1, left, "#h1", rulename, 1, returnhelpcounter);
      rulelist.merge(lr);

      int returnhelpcounter2=1;
      list <RULE*> rr=gotoLastPathRule(counterleft, returnhelpcounter, right, "#h2", rulename, 2, returnhelpcounter2);
      rulelist.merge(rr);

      id_left=id_right=1; 
      RULE *rule=new(RULE);
      char *rulename_=catstrstr(rulename, " (help var to new edge)");
      rule->setName(addRuleID(rulename_));

      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName("producelefthandGraph");
      hright->setName("producerighthandGraph");

      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      int id_vertex=id_left;
      produceVar(hleft, LEFTHAND, id_left, "#h2", "x", "string");
      produceVar(hright, RIGHTHAND, id_right, "#h2", "x", "string");

      VERTEX *ve=new (VERTEX);
      ve->setIdLabel(catstrint("ger",id_right));
      ve->setID(id_right);
      hright->addVertex(*ve,ve->getID());
      id_right++;

      list <IDTYPE> vlist; 
      vlist.push_back(ve->getID());

      EDGE *evartype = new(EDGE);
      evartype->setLabel("string");
      evartype->setIdLabel(catstrint("ger",id_right));
      evartype->setID(id_right);
      TYPES types;
      types.push_back(STRING);
      evartype->setType(types);
      EXPRESSION *exp=new EXPRESSION(types, "x", "value");
      evartype->addAttributes(*exp);
      hright->addEdge(*evartype,evartype->getID(),vlist);
      id_right++;

      MATCH *match=new MATCH();
      match->setMatch(id_vertex,ve->getID());
      rule->setInterface(*match);
      rule->setLeft(hleft);
      rule->setRight(hright);

      list<RULE*> onerule;
      onerule.push_back(rule);
      rulelist.merge(onerule);

      //jetzt kommt die große Regel
      {

      id_left=id_right=1; 
      RULE *rule=new(RULE);
      char *rulename_=catstrstr(rulename, " (Assigner with help var)");
      rule->setName(addRuleID(rulename_));

      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName("producelefthandGraph");
      hright->setName("producerighthandGraph");

      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      int vleft1_id, vleft2_id;
      vleft1_id=id_left;
      produceVar(hleft, LEFTHAND, id_left, "#h1", "x1", "string");
      vleft2_id=id_left;
      produceVar(hleft, LEFTHAND, id_left, "#h2", "x2", "string");

      VERTEX *ve1=new (VERTEX);
      ve1->setIdLabel(catstrint("ger",id_right));
      ve1->setID(id_right);
      hright->addVertex(*ve1,ve1->getID());
      id_right++;
      list <IDTYPE> vlist;
      vlist.push_back(ve1->getID());

      VERTEX *ve2=new (VERTEX);
      ve2->setIdLabel(catstrint("ger",id_right));
      ve2->setID(id_right);
      hright->addVertex(*ve2,ve2->getID());
      id_right++;

      EDGE *evartype = new(EDGE);
      evartype->setLabel("string");
      evartype->setIdLabel(catstrint("ger",id_right));
      evartype->setID(id_right);
      TYPES types;
      types.push_back(STRING);
      evartype->setType(types);
      EXPRESSION *exp=new EXPRESSION(types, "x2", "value");
      evartype->addAttributes(*exp);
      //evartype->addAttribute(ATTRSTR,"x2","value");
      hright->addEdge(*evartype,evartype->getID(),vlist);
      id_right++;

      MATCH *match=new MATCH();
      match->setMatch(vleft1_id,ve1->getID());
      match->setMatch(vleft2_id,ve2->getID());

      rule->setInterface(*match);
      rule->setLeft(hleft);
      rule->setRight(hright);

      list<RULE*> onerule;
      onerule.push_back(rule);
      rulelist.merge(onerule);

      delete ve1, ve2, ecounter_left, ecounter_right, evartype, exp;
      delete hleft, hright, match;
      }

      delete ve, ecounter_left, ecounter_right, evartype, exp;
      delete hleft, hright, match;


   }
   for (list<RULE*>::iterator itr=rulelist.begin(); itr != rulelist.end(); itr++) {
      (*itr)->setID(rule_counter++);
      GraphGrammar.addRule(*itr);
      delete *itr;
   }
}




/*
void PLGTS::produceIntegerAssignerRule(int counterleft, int counterright, list<char*> path, arithmetictree::Node *arithmetictree , char *rulename)
*/
void PLGTS::produceIntegerAssignerRule(int counterleft, int counterright, list<char*> path, arithmetictree::Node *arithmetictree , char *rulename)
{
   assert (arithmetictree != NULL);

   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];
   sprintf(strcounter_l,"%d\0",counterleft);
   sprintf(strcounter_r,"%d\0",counterright);

   list <RULE*> rulelist;
   using namespace arithmetictree;

   list <CHARLIST> varlist;
   list <CHARLIST> uniquevarlist;
   list <CHARLIST> uniquepathlist;

   list <int> intlist;

   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;

   int id_left=1;
   int id_right=1;

   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   arithmetictree->getNumConstNode(intlist);
   arithmetictree->getNumNode(varlist);

   HashTable <string>hashtable;
   char *pathname=charlisttochar(path);
   hashtable.insert(pathname);
   if (path.size() == 1)
      uniquevarlist.push_back(path);
   else
      uniquepathlist.push_back(path);
   for(list<CHARLIST>::iterator itr = varlist.begin(); itr != varlist.end(); itr++) {
      pathname=charlisttochar(*itr);
      if (hashtable.insert(pathname)==1)
         if ((*itr).size() == 1)
            uniquevarlist.push_back(*itr);
         else
            uniquepathlist.push_back(*itr);
   }
   //uniquevarlist: Integervariable
   //uniquepathlist: Pfade
   //pathnumber: Anzahl der Pfade
   list<CHARLIST>::iterator path_itr = uniquepathlist.begin();
   int pathnumber=uniquepathlist.size();



   //keine Pfade, nur Integervariablen
   if (pathnumber == 0) {

      RULE *rule=new(RULE);
      rule->setName(addRuleID(rulename));

      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName("producelefthandGraph");
      hright->setName("producerighthandGraph");

      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      int i=1;
      list <IDTYPE> vlist; 

      for(list<CHARLIST>::iterator itr = uniquevarlist.begin(); itr != uniquevarlist.end(); itr++) {
         list <char*>::iterator itr_=(*itr).begin();
         list <char*> newnode;
         newnode.push_back(catstrint("x",i));
         arithmetictree->changeNumNode(*itr,newnode);
         //linke Seite
         leftmap.push_back(id_left);
         produceVar(hleft, LEFTHAND, id_left, *itr_, catstrint("x",i), "integer");

         //recte Seite
         if (pathcmp(*itr, path)!=0) {
            rightmap.push_back(id_right);
            produceVar(hright, RIGHTHAND, id_right, *itr_, catstrint("x",i), "integer");
         }
         else {

            VERTEX *ve=new (VERTEX);
            ve->setIdLabel(catstrint("ger",id_right));
            ve->setID(id_right);
            hright->addVertex(*ve,ve->getID());
            id_right++;
            vlist.push_back(ve->getID());

            EDGE *evar = new(EDGE);
            evar->setLabel(*itr_);
            evar->setIdLabel(catstrint("x",i));
            evar->setID(id_right);
            hright->addEdge(*evar,evar->getID(),vlist);
            id_right++;

            rightmap.push_back(ve->getID());
            delete ve, evar;
         }
         i++;
      }

      //rechte Seite
      EDGE *evartype = new(EDGE);
      evartype->setLabel("integer");
      evartype->setIdLabel(catstrint("ger",id_right));
      evartype->setID(id_right);
      TYPES types;
      types.push_back(INTEGER);
      evartype->setType(types);
      EXPRESSION *exp=new EXPRESSION(types, arithmetictree->getArithmeticExpression(), "value");
      evartype->addAttributes(*exp);
      hright->addEdge(*evartype,evartype->getID(),vlist);
      id_right++;

      MATCH *match=new MATCH();
      list<IDTYPE>::iterator itr_right = rightmap.begin();
      for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
      {
         match->setMatch(*itr_left,*itr_right);
         itr_right++;
      }
      rule->setInterface(*match);
      rule->setLeft(hleft);
      rule->setRight(hright);
      rulelist.push_back(rule);

      delete ecounter_left, ecounter_right, evartype, exp;
      delete hleft, hright, match;
   }

   //ein Pfad der Groesse 2
   else if ((pathnumber==1) && ((*path_itr).size() == 2)) {

      RULE *rule=new(RULE);
      rule->setName(addRuleID(rulename));
 
      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName("producelefthandGraph");
      hright->setName("producerighthandGraph");

      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      int i=1;
      //Pfad
      list<CHARLIST>::iterator itr = uniquepathlist.begin();
      list<char*>::iterator itr_=(*itr).begin();

      char varname[strlen(*itr_)+1];
      strcpy(varname, *itr_++);
      char recordcomp[strlen(*itr_)+1];
      strcpy(recordcomp, *itr_);
      char *recordname=getRecordName(symboltable, varname);

      list <char*> newnode;
      newnode.push_back(catstrint("x",i));
      arithmetictree->changeNumNode(*itr,newnode);


       //linke Seite
      int edge_id=producePVar(hleft, LEFTHAND, id_left, varname, recordcomp, recordname, catstrint("x", i), "integer");
      rulelist.push_back(produceError(strcounter_l, varname, catstrstr(rulename, " (produce Error Rule)")));
      list<IDTYPE> vertexlist = hleft->getConnectedVertices(edge_id);
      list<IDTYPE>::iterator itredgelist = vertexlist.begin();
      while(itredgelist != vertexlist.end()){
         leftmap.push_back(*itredgelist);
         itredgelist++;
      }
      i++;

        //Variablen
      itr = uniquevarlist.begin();
      while (itr != uniquevarlist.end()) {
         list <char*>::iterator itr_=(*itr).begin();
         list <char*> newnode;
         newnode.push_back(catstrint("x",i));
         arithmetictree->changeNumNode(*itr,newnode);
         //linke Seite
         leftmap.push_back(id_left);
         produceVar(hleft, LEFTHAND, id_left, *itr_, catstrint("x",i), "integer");
         i++;
         itr++;
      }



      //rechte Seite
      itr = uniquevarlist.begin();
      // i=1;
       //links integer-variable
      if (path.size()==1) {
         int edge_id=producePVar(hright, RIGHTHAND, id_right, varname, recordcomp, recordname, catstrint("x",i), "integer");
         list<IDTYPE> vertexlist = hright->getConnectedVertices(edge_id);
         list<IDTYPE>::iterator itredgelist = vertexlist.begin();
         while(itredgelist != vertexlist.end())
         { 
            rightmap.push_back(*itredgelist);
            itredgelist++;
         }
         i++;

         while (itr != uniquevarlist.end()) {
            list <char*>::iterator itr_=(*itr).begin();
            list <char*> newnode;
            newnode.push_back(catstrint("x",i));
            rightmap.push_back(id_right);
            if (pathcmp(*itr,path)==0)
               produceVar(hright, RIGHTHAND, id_right, *itr_, arithmetictree->getArithmeticExpression(), "integer");
            else
               produceVar(hright, RIGHTHAND, id_right, *itr_, catstrint("x",i), "integer");
            i++;
            itr++;
         }
      }
        //links pfad
      else {
         int edge_id=producePVar(hright, RIGHTHAND, id_right, varname, recordcomp, recordname, arithmetictree->getArithmeticExpression(), "integer");
         list<IDTYPE> vertexlist = hright->getConnectedVertices(edge_id);
         list<IDTYPE>::iterator itredgelist = vertexlist.begin();
         while(itredgelist != vertexlist.end())
         { 
            rightmap.push_back(*itredgelist);
            itredgelist++;
         }
         i++;

         while (itr != uniquevarlist.end()) {

            list <char*>::iterator itr_=(*itr).begin();
            list <char*> newnode;
            newnode.push_back(catstrint("x",i));
            rightmap.push_back(id_right);
            produceVar(hright, RIGHTHAND, id_right, *itr_, catstrint("x",i), "integer");
            i++;
            itr++;
         }

      }

      //Match
      MATCH *match=new MATCH();
      list<IDTYPE>::iterator itr_right = rightmap.begin();
      for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
      {
         match->setMatch(*itr_left,*itr_right);
         itr_right++;
      }
      rule->setInterface(*match);

      rule->setLeft(hleft);
      rule->setRight(hright);
      rulelist.push_front(rule);

      delete ecounter_left, ecounter_right;
      delete hleft, hright, match;
   }



   //sonst
   //mehrere Pfade oder ein Pfad mit mehr als zwei Komponenten
   else {

      list<CHARLIST>::iterator itr = uniquepathlist.begin();

      int helpcounter=1;
      int i=1;
      int returnhelpcounter=1;
      list <RULE*> lr;

      if (pathnumber==1)
         lr=gotoLastPathRule(counterleft, helpcounter, *itr, "#h", rulename, 0, returnhelpcounter);
      else
         lr=gotoLastPathRule(counterleft, helpcounter, *itr, catstrint("#h",i), rulename, 1, returnhelpcounter);
      helpcounter=returnhelpcounter;
      i++;

      rulelist.merge(lr);
      itr++;

      //Hilfsvariable zur neuen Hyperkante
      while (itr != uniquepathlist.end()) {

         list <RULE*> lr=gotoLastPathRule(counterleft, helpcounter, *itr, catstrint("#h",i), rulename, 3, returnhelpcounter);
         helpcounter=returnhelpcounter;
         rulelist.merge(lr);

         itr++;

         RULE *rule=new(RULE);
         char *rulename_=catstrstr(rulename, " (help var to new edge)");
         rule->setName(addRuleID(rulename_));

         HYPERGRAPH *hleft=new(HYPERGRAPH);
         HYPERGRAPH *hright=new(HYPERGRAPH);
         hleft->setName(hleftname);
         hright->setName(hrightname);

         int id=1;

         //linke Seite
         EDGE *ecounter_left=new(EDGE);
         ecounter_left->setLabel(catstrint(catstrstr(strcounter_l,"#"), helpcounter));
         ecounter_left->setIdLabel(catstrint("gel",id_left));
         ecounter_left->setID(id_left);
         hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
         id_left++;

         if (itr == uniquepathlist.end())
         {
            EDGE *ehelpcounter=new(EDGE);
            ehelpcounter->setLabel(catstrstr(strcounter_l,"_"));
            ehelpcounter->setIdLabel(catstrint("gel",id_left));
            ehelpcounter->setID(id_left);
            hleft->addEdge(*ehelpcounter,ehelpcounter->getID(),lnull);
            id_left++;

            EDGE *ecounter_right=new(EDGE);
            ecounter_right->setLabel(catstrstr(strcounter_l,"_e"));
            ecounter_right->setIdLabel(catstrint("ger",id_right));
            ecounter_right->setID(id_right);
            hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
            id_right++;

            delete ehelpcounter, ecounter_right;
         }

         else 
         {
            EDGE *ecounter_right=new(EDGE);
            ecounter_right->setLabel(catstrint(catstrstr(strcounter_l,"#"), ++helpcounter));
            ecounter_right->setIdLabel(catstrint("ger",id_right));
            ecounter_right->setID(id_right);
            hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
            id_right++;

            delete ecounter_right;
         }

         int id_vertex=id_left;
         produceVar(hleft, LEFTHAND, id_left, catstrint("#h",i), catstrint("x",i), "integer");
         produceVar(hright, RIGHTHAND, id_right, catstrint("#h",i), catstrint("x",i), "integer");

         VERTEX *ve=new (VERTEX);
         ve->setIdLabel(catstrint("ger",id_right));
         ve->setID(id_right);
         hright->addVertex(*ve,ve->getID());
         id_right++;

         list <IDTYPE> vlist; 
         vlist.push_back(ve->getID());

         EDGE *evartype = new(EDGE);
         evartype->setLabel("integer");
         evartype->setIdLabel(catstrint("ger",id_right));
         evartype->setID(id_right);
         TYPES types;
         types.push_back(INTEGER);
         evartype->setType(types);
         EXPRESSION *exp=new EXPRESSION(types, catstrint("x",i), "value");
         evartype->addAttributes(*exp);
         hright->addEdge(*evartype,evartype->getID(),vlist);
         id_right++;

         MATCH *match=new MATCH();
         match->setMatch(id_vertex,ve->getID());
         rule->setInterface(*match);
         rule->setLeft(hleft);
         rule->setRight(hright);

         rulelist.push_back(rule);

         i++;

         delete ve, ecounter_left, evartype, exp;
         delete hleft, hright, match;

      }


      //jetzt kommt die "grosse" Regel mit Hilfsvariablen #h1, #h2,...
      id_left=id_right=1;

      RULE *rule=new(RULE);
      char *rulename_=catstrstr(rulename, " (Assigner with help var)");
      rule->setName(addRuleID(rulename_));

      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName(hleftname);
      hright->setName(hrightname);

      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(catstrstr(strcounter_l, "_e"));
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      i=1;

      //Pfade
      itr = uniquepathlist.begin();
      IDTYPE ve_exp;
      //erster Pfad

      //linke Seite
      list <char*> newnode;
      newnode.push_back(catstrint("x",i));
      arithmetictree->changeNumNode(*itr,newnode);
      leftmap.push_back(id_left);
      if (pathnumber==1)
         produceVar(hleft, LEFTHAND, id_left, "#h", catstrint("x",i),"integer"); 
      else
         produceVar(hleft, LEFTHAND, id_left, catstrint("#h",i), catstrint("x",i),"integer"); 
      //rechte Seite
      VERTEX *ve=new (VERTEX);
      ve->setIdLabel(catstrint("ger",id_right));
      ve->setID(id_right);
      hright->addVertex(*ve,ve->getID());
      id_right++;
      rightmap.push_back(ve->getID());
      int verID_firstpath=ve->getID();
      if (pathcmp(*itr, path)==0) 
         ve_exp=ve->getID();
      i++;
      itr++;

      //weiter Pfade
      while (itr != uniquepathlist.end()) {

         //linke Seite
         list <char*> newnode;
         newnode.push_back(catstrint("x",i));
         arithmetictree->changeNumNode(*itr,newnode);
         leftmap.push_back(id_left);
         produceVar(hleft, LEFTHAND, id_left, catstrint("#h",i), catstrint("x",i),"integer"); 

         //rechte Seite
         VERTEX *ve=new (VERTEX);
         ve->setIdLabel(catstrint("ger",id_right));
         ve->setID(id_right);
         hright->addVertex(*ve,ve->getID());
         id_right++;
         rightmap.push_back(ve->getID());
         if (pathcmp(*itr, path)==0) 
            ve_exp=ve->getID();
         i++;
         itr++;
         delete ve;
      }

      //Variablen
      itr = uniquevarlist.begin();

      while (itr != uniquevarlist.end()) {

         list <char*>::iterator itr_=(*itr).begin();
         list <char*> newnode;
         newnode.push_back(catstrint("x",i));
         arithmetictree->changeNumNode(*itr,newnode);
         //linke Seite
         leftmap.push_back(id_left);
         produceVar(hleft, LEFTHAND, id_left, *itr_, catstrint("x",i), "integer");
         //recte Seite
         rightmap.push_back(id_right);
         if (pathcmp(*itr, path)!=0) {
            produceVar(hright, RIGHTHAND, id_right, *itr_, catstrint("x",i), "integer");
         }
         else {

            VERTEX *ve=new (VERTEX);
            ve->setIdLabel(catstrint("ger",id_right));
            ve->setID(id_right);
            hright->addVertex(*ve,ve->getID());
            id_right++;

            ve_exp = ve->getID();

            list <IDTYPE> list;
            list.push_back(ve->getID());

            EDGE *evar = new(EDGE);
            evar->setLabel(*itr_);
            evar->setIdLabel(catstrint("x",i));
            evar->setID(id_right);
            hright->addEdge(*evar,evar->getID(),list);
            id_right++;

            delete ve, evar;

         }
         i++;
         itr++;
      }

      //rechte Seite
      //Variable
      list <char*>::iterator path_itr=path.begin();
      if (path.size()==1) {

         EDGE *evartype_ = new(EDGE);
         evartype_->setLabel("integer");
         evartype_->setIdLabel(catstrint("ger",id_right));
         evartype_->setID(id_right);
         TYPES types_;
         types_.push_back(INTEGER);
         evartype_->setType(types_);
         EXPRESSION *exp_=new EXPRESSION(types_, "x1", "value");
         evartype_->addAttributes(*exp_);
         list <IDTYPE> vlist_;
         vlist_.push_back(verID_firstpath);
         hright->addEdge(*evartype_,evartype_->getID(),vlist_);
         id_right++;

         EDGE *evartype = new(EDGE);
         evartype->setLabel("integer");
         evartype->setIdLabel(catstrint("ger",id_right));
         evartype->setID(id_right);
         TYPES types;
         types.push_back(INTEGER);
         evartype->setType(types);
         EXPRESSION *exp=new EXPRESSION(types, arithmetictree->getArithmeticExpression(), "value");
         evartype->addAttributes(*exp);
         list <IDTYPE> vlist;
         vlist.push_back(ve_exp);
         hright->addEdge(*evartype,evartype->getID(),vlist);
         id_right++;

         delete evartype, evartype_, exp, exp_;
      }
      //Pfad
      else {

         rightmap.push_back(ve_exp); 
         list <IDTYPE> vlist;
         vlist.push_back(ve_exp);

         EDGE *evartype = new(EDGE);
         evartype->setLabel("integer");
         evartype->setIdLabel(catstrint("ger",id_right));
         evartype->setID(id_right);
         TYPES types;
         types.push_back(INTEGER);
         evartype->setType(types);
         EXPRESSION *exp=new EXPRESSION(types, arithmetictree->getArithmeticExpression(), "value");
         evartype->addAttributes(*exp);
         hright->addEdge(*evartype,evartype->getID(),vlist);
         id_right++;

         delete evartype, exp;
      }


      MATCH *match=new MATCH();
      list<IDTYPE>::iterator itr_right = rightmap.begin();
      for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
      {
         match->setMatch(*itr_left,*itr_right);
         itr_right++;
      }
      rule->setInterface(*match);
      rule->setLeft(hleft);
      rule->setRight(hright);

      rulelist.push_back(rule);

      delete ve, ecounter_left, ecounter_right;
      delete hleft, hright, match;

   }


   for (list<RULE*>::iterator itr=rulelist.begin(); itr != rulelist.end(); itr++) {
      (*itr)->setID(rule_counter++);
      GraphGrammar.addRule(*itr);
      delete *itr;
   }

}




/*
void PLGTS::produceIFRule(int counterIF, int counterELSE, booltree::Node *booltree , char *rulename)
*/
void PLGTS::produceIFRule(int counterIF, int counterELSE, booltree::Node *booltree, char *rulename)
{
   assert (booltree != NULL);

   char strcounter_IF[MAX_COUNTER];
   char strcounter_THEN[MAX_COUNTER];
   char strcounter_ELSE[MAX_COUNTER];

   sprintf(strcounter_IF,"%d\0",counterIF);
   sprintf(strcounter_THEN,"%d\0",counterIF+1);
   sprintf(strcounter_ELSE,"%d\0",counterELSE);

   list <RULE*> rulelist;
   using namespace booltree;

   list <CHARLIST> varlist;
   list <CHARLIST> uniquevarlist;
   list <CHARLIST> uniquepathlist;

   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;
   int id_left=1;
   int id_right=1;

   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   booltree->getIdentifierNode(varlist);

   HashTable <string>hashtable;
   for(list<CHARLIST>::iterator itr = varlist.begin(); itr != varlist.end(); itr++) {
      char *var=charlisttochar(*itr);
      if (hashtable.insert(var)==1)
         if ((*itr).size() == 1)
            uniquevarlist.push_back(*itr);
         else
            uniquepathlist.push_back(*itr);
   }

   //uniquevarlist: Variablen
   //uniquepathlist: Pfade
   //pathnumber: Anzahl der Pfade
   list<CHARLIST>::iterator path_itr = uniquepathlist.begin();
   int pathnumber=uniquepathlist.size();


   if (pathnumber==0) {

      for (int rule_i=0; rule_i<=1; rule_i++) {

         id_left=id_right=1;

         RULE *rule=new(RULE);

         HYPERGRAPH *hleft=new(HYPERGRAPH);
         HYPERGRAPH *hright=new(HYPERGRAPH);
         hleft->setName("producelefthandGraph");
         hright->setName("producerighthandGraph");

         EDGE *ecounter_left=new(EDGE);

         ecounter_left->setLabel(strcounter_IF);
         ecounter_left->setIdLabel(catstrint("gel",id_left));
         ecounter_left->setID(id_left);
         hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
         id_left++;

         EDGE *ecounter_right=new(EDGE);
         if (rule_i==0)
            ecounter_right->setLabel(strcounter_THEN);
         else
            ecounter_right->setLabel(strcounter_ELSE);
         ecounter_right->setIdLabel(catstrint("ger",id_right));
         ecounter_right->setID(id_right);
         hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
         id_right++;

         int i=1;
         list <IDTYPE> vlist; 

         for(list<CHARLIST>::iterator itr = uniquevarlist.begin(); itr != uniquevarlist.end(); itr++) {
            list <char*>::iterator itr_=(*itr).begin();
            list <char*> newnode;
            newnode.push_back(catstrint("x",i));
            booltree->changeIdentifierNode(*itr,newnode);

            SymbolEntry *se=getSymbol(symboltable, *itr_);
            assert(se!=NULL);
            char *strtype;
            if (se->type==intType)
               strtype="integer";
            else if (se->type=strType)
               strtype="string";
            else
               assert(false);

            //linke Seite
            leftmap.push_back(id_left);
            produceVar(hleft, LEFTHAND, id_left, *itr_, catstrint("x",i), strtype);
            //recte Seite
            rightmap.push_back(id_right);
            produceVar(hright,RIGHTHAND, id_right, *itr_, catstrint("x",i), strtype);

            i++;
         }

         TYPES types;
         types.push_back(BOOL);
         char *attrvalue=booltree->getExpression();
         if (rule_i==0) {
            char *rulename_=catstrstr(catstrstr(rulename, "  "), attrvalue);
            rule->setName(addRuleID(rulename_));
            EXPRESSION exp(types, attrvalue, "guard");
	    list<EXPRESSION> le;
	    le.push_back(exp);
            rule->setGuard(le);
         }
         else {
            char *rulename_=catstrstr(catstrstr(rulename, "   NOT "), attrvalue);
            rule->setName(addRuleID(rulename_));
            EXPRESSION exp(types, catstrstr("NOT",attrvalue), "guard");
	    list<EXPRESSION> le;
	    le.push_back(exp);
            rule->setGuard(le);
         }


         MATCH *match=new MATCH();
         list<IDTYPE>::iterator itr_right = rightmap.begin();
         for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
         {
            match->setMatch(*itr_left,*itr_right);
            itr_right++;
         }
         rule->setInterface(*match);
         rule->setLeft(hleft);
         rule->setRight(hright);

         rulelist.push_back(rule);

         delete ecounter_left, ecounter_right;
         delete hleft, hright, match;
      }

   }


   else if ((pathnumber==1) && ((*path_itr).size() == 2)) {

      for (int rule_i=0; rule_i<=1; rule_i++) 
      {
         id_left=id_right=1;
         int type=0;
         int i=1;

         RULE *rule=new(RULE);

         HYPERGRAPH *hleft=new(HYPERGRAPH);
         HYPERGRAPH *hright=new(HYPERGRAPH);
         hleft->setName("producelefthandGraph");
         hright->setName("producerighthandGraph");

         EDGE *ecounter_left=new(EDGE);
         ecounter_left->setLabel(strcounter_IF);
         ecounter_left->setIdLabel(catstrint("gel",id_left));
         ecounter_left->setID(id_left);
         hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
         id_left++;

         EDGE *ecounter_right=new(EDGE);
         if (rule_i==0)
            ecounter_right->setLabel(strcounter_THEN);
         else
            ecounter_right->setLabel(strcounter_ELSE);
         ecounter_right->setIdLabel(catstrint("ger",id_right));
         ecounter_right->setID(id_right);
         hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
         id_right++;

         //Pfad
         list<CHARLIST>::iterator itr = uniquepathlist.begin();
         list<char*>::iterator itr_=(*itr).begin();

         char varname[strlen(*itr_)+1];
         strcpy(varname, *itr_++);
         char recordcomp[strlen(*itr_)+1];
         strcpy(recordcomp, *itr_);
         char *recordname=getRecordName(symboltable, varname);
         RecordEntry *re=getRecordComp(symboltable, recordcomp, recordname);
         type=re->type;

         char *strtype;
         if (type==0)
            strtype="integer";
         else if (type==1)
            strtype="string";
         else
            assert(false);

         int edge_id=producePVar(hleft, LEFTHAND, id_left, varname, recordcomp, recordname, catstrint("x", i), strtype);
         edge_id=producePVar(hright, RIGHTHAND, id_right, varname, recordcomp, recordname, catstrint("x", i), strtype);
         list <char*> newnode;
         newnode.push_back(catstrint("x",i));
         booltree->changeIdentifierNode(*itr,newnode);
         list<IDTYPE> vertexlist = hleft->getConnectedVertices(edge_id);
         list<IDTYPE>::iterator itredgelist = vertexlist.begin();
         while(itredgelist != vertexlist.end()){
            //linke Seite
            leftmap.push_back(*itredgelist);
            //rechte Seite
            rightmap.push_back(*itredgelist);
            itredgelist++;
         }
         i++;

         //Variablen
         itr = uniquevarlist.begin();
         while (itr != uniquevarlist.end()) {
            list <char*>::iterator itr_=(*itr).begin();
            list <char*> newnode;
            newnode.push_back(catstrint("x",i));
            booltree->changeIdentifierNode(*itr,newnode);

            SymbolEntry *se=getSymbol(symboltable, *itr_);
            assert(se!=NULL);
            char *strtype;
            if (se->type==intType)
               strtype="integer";
            else if (se->type==strType)
               strtype="string";
            else
               assert(false);

            //linke Seite
            leftmap.push_back(id_left);
            produceVar(hleft, LEFTHAND, id_left, *itr_, catstrint("x",i),strtype);
            //recte Seite
            rightmap.push_back(id_right);
            produceVar(hright,RIGHTHAND, id_right, *itr_, catstrint("x",i),strtype);

            i++;
            itr++;
         }

         TYPES types;
         types.push_back(BOOL);
         char *attrvalue=booltree->getExpression();
         if (rule_i==0) {
            char *rulename_=catstrstr(catstrstr(rulename, "  "), attrvalue);
            rule->setName(addRuleID(rulename_));
            EXPRESSION exp(types, attrvalue, "guard");
	    list<EXPRESSION> le;
	    le.push_back(exp);
            rule->setGuard(le);
         }
         else {
            char *rulename_=catstrstr(catstrstr(rulename, "   NOT "), attrvalue);
            rule->setName(addRuleID(rulename_));
            EXPRESSION exp(types, catstrstr("NOT",attrvalue), "guard");
	    list<EXPRESSION> le;
	    le.push_back(exp);
            rule->setGuard(le);
         }

         MATCH *match=new MATCH();
         list<IDTYPE>::iterator itr_right = rightmap.begin();
         for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
         {
            match->setMatch(*itr_left,*itr_right);
            itr_right++;
         }
         rule->setInterface(*match);
         rule->setLeft(hleft);
         rule->setRight(hright);

         rulelist.push_back(rule);
         if (rule_i==1)
            rulelist.push_back(produceError(strcounter_IF, varname, catstrstr(rulename, " (produce Error Rule)")));
         delete ecounter_left, ecounter_right;
         delete hleft, hright, match;


      }

   }
   else 
   {

      list<CHARLIST>::iterator itr = uniquepathlist.begin();
      list<int> typeslist;
      int type;

      int helpcounter=1;
      int i=1;
      int returnhelpcounter=1;
      list <RULE*> lr;

      if (pathnumber==1)
         lr=gotoLastPathRule(counterIF, helpcounter, *itr, "#h", rulename, 0, returnhelpcounter, type);
      else
         lr=gotoLastPathRule(counterIF, helpcounter, *itr, catstrint("#h",i), rulename, 1, returnhelpcounter, type);
      typeslist.push_back(type);
      helpcounter=returnhelpcounter;
      i++;

      rulelist.merge(lr);
      itr++;


     //Hilfsvariable zur neuen Hyperkante
      while (itr != uniquepathlist.end()) {
         int type;
         list <RULE*> lr=gotoLastPathRule(counterIF, helpcounter, *itr, catstrint("#h",i), rulename, 3, returnhelpcounter, type);
         typeslist.push_back(type);
         helpcounter=returnhelpcounter;
         rulelist.merge(lr);

         itr++;

         RULE *rule=new(RULE);
         char *rulename_=catstrstr(rulename, " (help var to new edge)");
         rule->setName(addRuleID(rulename_));

         HYPERGRAPH *hleft=new(HYPERGRAPH);
         HYPERGRAPH *hright=new(HYPERGRAPH);
         hleft->setName(hleftname);
         hright->setName(hrightname);

         int id=1;

         //linke Seite
         EDGE *ecounter_left=new(EDGE);
         ecounter_left->setLabel(catstrint(catstrstr(strcounter_IF,"#"), helpcounter));
         ecounter_left->setIdLabel(catstrint("gel",id_left));
         ecounter_left->setID(id_left);
         hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
         id_left++;

         if (itr == uniquepathlist.end())
         {
            EDGE *ehelpcounter=new(EDGE);
            ehelpcounter->setLabel(catstrstr(strcounter_IF,"_"));
            ehelpcounter->setIdLabel(catstrint("gel",id_left));
            ehelpcounter->setID(id_left);
            hleft->addEdge(*ehelpcounter,ehelpcounter->getID(),lnull);
            id_left++;

            EDGE *ecounter_right=new(EDGE);
            ecounter_right->setLabel(catstrstr(strcounter_IF,"_e"));
            ecounter_right->setIdLabel(catstrint("ger",id_right));
            ecounter_right->setID(id_right);
            hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
            id_right++;

            delete ehelpcounter, ecounter_right;
         }

         else 
         {
            EDGE *ecounter_right=new(EDGE);
            ecounter_right->setLabel(catstrint(catstrstr(strcounter_IF,"#"), ++helpcounter));
            ecounter_right->setIdLabel(catstrint("ger",id_right));
            ecounter_right->setID(id_right);
            hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
            id_right++;

            delete ecounter_right;
         }

         int id_vertex=id_left;
         char *strtype;
         if (type==0)
            strtype="integer";
         else if (type==1)
            strtype="string";
         else
            assert(false);
         produceVar(hleft, LEFTHAND, id_left, catstrint("#h",i), catstrint("x",i), strtype);
         produceVar(hright, RIGHTHAND, id_right, catstrint("#h",i), catstrint("x",i), strtype);

         VERTEX *ve=new (VERTEX);
         ve->setIdLabel(catstrint("ger",id_right));
         ve->setID(id_right);
         hright->addVertex(*ve,ve->getID());
         id_right++;

         list <IDTYPE> vlist; 
         vlist.push_back(ve->getID());

         EDGE *evartype = new(EDGE);
         evartype->setLabel(strtype);
         evartype->setIdLabel(catstrint("ger",id_right));
         evartype->setID(id_right);
         TYPES types;
         if (type==0)
           types.push_back(INTEGER);
         else if (type==1)
           types.push_back(STRING);
         else
            assert(false);
         evartype->setType(types);
         EXPRESSION *exp=new EXPRESSION(types, catstrint("x",i), "value");
         evartype->addAttributes(*exp);
         hright->addEdge(*evartype,evartype->getID(),vlist);
         id_right++;

         MATCH *match=new MATCH();
         match->setMatch(id_vertex,ve->getID());
         rule->setInterface(*match);
         rule->setLeft(hleft);
         rule->setRight(hright);

         rulelist.push_back(rule);
         i++;

         delete ve, ecounter_left, evartype, exp;
         delete hleft, hright, match;

      }

     //jetzt kommt die "grosse" Regel mit Hilfsvariablen #h1, #h2,...
     for (int rule_i=0; rule_i<=1; rule_i++)
     {

        list<int>::iterator types_itr=typeslist.begin();

        id_left=id_right=1;
        RULE *rule=new(RULE);

        HYPERGRAPH *hleft=new(HYPERGRAPH);
        HYPERGRAPH *hright=new(HYPERGRAPH);
        hleft->setName("producelefthandGraph");
        hright->setName("producerighthandGraph");

        EDGE *ecounter_left=new(EDGE);
        ecounter_left->setLabel(catstrstr(strcounter_IF, "_e"));
        ecounter_left->setIdLabel(catstrint("gel",id_left));
        ecounter_left->setID(id_left);
        hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
        id_left++;

        EDGE *ecounter_right=new(EDGE);
        if (rule_i==0)
           ecounter_right->setLabel(strcounter_THEN);
        else
           ecounter_right->setLabel(strcounter_ELSE);
        ecounter_right->setIdLabel(catstrint("ger",id_right));
        ecounter_right->setID(id_right);
        hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
        id_right++;

        i=1;
        //Pfade
        path_itr = uniquepathlist.begin();

        list <char*> newnode;
        newnode.push_back(catstrint("x",i));
        booltree->changeIdentifierNode(*path_itr,newnode);
        leftmap.push_back(id_left);

        type=*types_itr;
        char *strtype;
        if (type==0)
           strtype="integer";
        else if (type==1)
           strtype="string";
        else
           assert(false);
        types_itr++;

        if (pathnumber==1) {
           produceVar(hleft, LEFTHAND, id_left, "#h", catstrint("x",i),strtype); 
        }
        else {
           produceVar(hleft, LEFTHAND, id_left, catstrint("#h",i), catstrint("x",i),strtype); 
        }

        VERTEX *ve=new (VERTEX);
        ve->setIdLabel(catstrint("ger",id_right));
        ve->setID(id_right);
        hright->addVertex(*ve,ve->getID());
        id_right++;
        rightmap.push_back(ve->getID());

        EDGE *evartype = new(EDGE);
        evartype->setLabel(strtype);
        evartype->setIdLabel(catstrint("ger",id_right));
        evartype->setID(id_right);
        TYPES types;
        if (type==0)
           types.push_back(INTEGER);
        else if (type==1)
           types.push_back(STRING);
        else
           assert(false);
        evartype->setType(types);
        EXPRESSION *exp=new EXPRESSION(types, "x1", "value");
        evartype->addAttributes(*exp);
        list <IDTYPE> vlist;
        vlist.push_back(ve->getID());
        hright->addEdge(*evartype,evartype->getID(),vlist);
        id_right++;

        i++;
        path_itr++;


        //weiter Pfade
        while (path_itr != uniquepathlist.end()) {
           //linke Seite
           list <char*> newnode;
           newnode.push_back(catstrint("x",i));
           booltree->changeIdentifierNode(*path_itr,newnode);
           leftmap.push_back(id_left);

           type=*types_itr;
           char *strtype;
           if (type==0)
              strtype="integer";
           else if (type==1)
              strtype="string";
           else
              assert(false);
           types_itr++;

           produceVar(hleft, LEFTHAND, id_left, catstrint("#h",i), catstrint("x",i),strtype);
           //rechte Seite
           VERTEX *ve=new (VERTEX);
           ve->setIdLabel(catstrint("ger",id_right));
           ve->setID(id_right);
           hright->addVertex(*ve,ve->getID());
           rightmap.push_back(id_right);
           id_right++;

           i++;
           path_itr++;
           delete ve;
        }

        //Variablen
        list<CHARLIST>::iterator var_itr = uniquevarlist.begin();

        while (var_itr != uniquevarlist.end()) {

           list <char*>::iterator itr_=(*var_itr).begin();
           list <char*> newnode;
           newnode.push_back(catstrint("x",i));
           booltree->changeIdentifierNode(*var_itr,newnode);


           SymbolEntry *se=getSymbol(symboltable, *itr_);
           assert(se!=NULL);
           if (se->type==intType) {
              //linke Seite
              leftmap.push_back(id_left);
              produceVar(hleft, LEFTHAND, id_left, *itr_, catstrint("x",i), "integer");
              //recte Seite
              rightmap.push_back(id_right);
              produceVar(hright,RIGHTHAND, id_right, *itr_, catstrint("x",i), "integer");
            }
           else if(se->type==strType) {
              //linke Seite
              leftmap.push_back(id_left);
              produceVar(hleft, LEFTHAND, id_left, *itr_, catstrint("x",i), "string");
              //recte Seite
              rightmap.push_back(id_right);
              produceVar(hright,RIGHTHAND, id_right, *itr_, catstrint("x",i), "string");
           }
           else {
               assert(false);
           }

           i++;
           var_itr++;
        }

         TYPES types_;
         types_.push_back(BOOL);
         char *attrvalue=booltree->getExpression();
         if (rule_i==0) {
            char *rulename_=catstrstr(catstrstr(rulename, "  "), attrvalue);
            rule->setName(addRuleID(rulename_));
            EXPRESSION exp(types, attrvalue, "guard");
	    list<EXPRESSION> le;
	    le.push_back(exp);
            rule->setGuard(le);
         }
         else {
            char *rulename_=catstrstr(catstrstr(rulename, "   NOT "), attrvalue);
            rule->setName(addRuleID(rulename_));
            EXPRESSION exp(types, catstrstr("NOT",attrvalue), "guard");
    	    list<EXPRESSION> le;
	    le.push_back(exp);
            rule->setGuard(le);
         }

        MATCH *match=new MATCH();
        list<IDTYPE>::iterator itr_right = rightmap.begin();
        for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
        {
          match->setMatch(*itr_left,*itr_right);
          itr_right++;
        }
        rule->setInterface(*match);
        rule->setLeft(hleft);
        rule->setRight(hright);

        rulelist.push_back(rule);

        delete evartype, ecounter_left, ecounter_right, exp;
        delete hleft, hright, match;

     }

   }

   for (list<RULE*>::iterator itr=rulelist.begin(); itr != rulelist.end(); itr++) {
      (*itr)->setID(rule_counter++);
      GraphGrammar.addRule(*itr);
      delete *itr;
   }

}




/*
   void PLGTS::produceIFRule(int counterIF, int counterELSE, list<char*> left, list <char*> right, char *rulename, bool equal)
*/
void PLGTS::produceIFRule(int counterIF, int counterELSE, list<char*> left, list <char*> right, char *rulename, bool equal)
{
   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   int lengthleft=left.size();
   int lengthright=right.size();

   assert (lengthleft >0 && lengthright >0);
   list <RULE*> rulelist;
   int id=1;

   char strcounter_IF[MAX_COUNTER];
   char strcounter_THEN[MAX_COUNTER];
   char strcounter_ELSE[MAX_COUNTER];

   sprintf(strcounter_IF,"%d\0",counterIF);
   if (equal) {
      sprintf(strcounter_THEN,"%d\0",counterIF+1);
      sprintf(strcounter_ELSE,"%d\0",counterELSE);
   }
   else {
      sprintf(strcounter_THEN,"%d\0",counterELSE);
      sprintf(strcounter_ELSE,"%d\0",counterIF+1);
   }

   list<char*>::iterator itr_left=left.begin();
   list<char*>::iterator itr_right=right.begin();

   if (lengthleft==1)
   {
      if (lengthright==1) {
         char *recordname=getRecordName(symboltable, *itr_left);
	 if (peqp_2rule)
            rulelist=producePEqPRule_2Rules(strcounter_IF, strcounter_THEN, strcounter_ELSE, *itr_right, *itr_left, rulename);
         else 
            rulelist=producePEqPRule(strcounter_IF, strcounter_THEN, strcounter_ELSE, *itr_right, *itr_left, recordname, rulename);
      }
      else {
         int returnhelpcounter=1;
         char *returnrecordname;
         rulelist=gotoLastPathRule(counterIF, 1, right, "#h", rulename, 0, returnhelpcounter, &returnrecordname);
         if (peqp_2rule) {
            list <RULE*> tmp=producePEqPRule_2Rules(catstrstr(strcounter_IF,"_e"), strcounter_THEN, strcounter_ELSE, "#h", *itr_left, rulename, false, true);
            rulelist.merge(tmp);
         }
         else {
            list <RULE*> tmp=producePEqPRule(catstrstr(strcounter_IF,"_e"), strcounter_THEN, strcounter_ELSE, "#h", *itr_left, returnrecordname, rulename,false, true);
            rulelist.merge(tmp);
         }
      }
   }
   else if(lengthright==1)
   {
      int returnhelpcounter=1;
      char *returnrecordname;
      rulelist=gotoLastPathRule(counterIF, 1, left, "#h", rulename, 0, returnhelpcounter, &returnrecordname);
      if (peqp_2rule) {
         list <RULE*> tmp=producePEqPRule_2Rules(catstrstr(strcounter_IF,"_e"), strcounter_THEN, strcounter_ELSE, "#h", *itr_right, rulename,true, false);
         rulelist.merge(tmp);
      }
      else {
         list <RULE*> tmp=producePEqPRule(catstrstr(strcounter_IF,"_e"), strcounter_THEN, strcounter_ELSE, "#h", *itr_right, returnrecordname, rulename, true, false);
         rulelist.merge(tmp);
      }

   }
   else {
      int returnhelpcounter=1;
      char *returnrecordname;
      //rulelist=gotoLastPathRule(counterIF, 1, left, "#h1", rulename, 1, returnhelpcounter);

      rulelist=gotoLastPathRule(counterIF, 1, left, "#h1", rulename, 1, returnhelpcounter, &returnrecordname);
      int returnhelpcounter_2=1;
      list <RULE*> rulelist_=gotoLastPathRule(counterIF, returnhelpcounter, right, "#h2", rulename, 2, returnhelpcounter_2);
      rulelist.merge(rulelist_);

      if (peqp_2rule) {
         list <RULE*> tmp=producePEqPRule_2Rules(catstrstr(strcounter_IF,"_e"), strcounter_THEN, strcounter_ELSE, "#h1", "#h2", rulename, true, true);
         rulelist.merge(tmp);
      }
      else {
         list <RULE*> tmp=producePEqPRule(catstrstr(strcounter_IF,"_e"), strcounter_THEN, strcounter_ELSE, "#h1", "#h2", returnrecordname, rulename, true, true);
         rulelist.merge(tmp);
      }
   }


   for (list<RULE*>::iterator itr=rulelist.begin(); itr != rulelist.end(); itr++) {
      (*itr)->setID(rule_counter++);
      GraphGrammar.addRule(*itr);
   }
}





/*
void PLGTS::produceIFNULLRule(int counterIF, int counterELSE, list<char*> path, char *rulename, bool equal)
*/
void PLGTS::produceIFNULLRule(int counterIF, int counterELSE, list<char*> path, char *rulename, bool equal)
{
   int pathlength=path.size();
   assert(path.size() > 0);

   list <RULE*> rulelist;
   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   char strcounter_IF[MAX_COUNTER];
   char strcounter_THEN[MAX_COUNTER];
   char strcounter_ELSE[MAX_COUNTER];

   sprintf(strcounter_IF,"%d\0",counterIF);
   if (equal) {
      sprintf(strcounter_THEN,"%d\0",counterIF+1);
      sprintf(strcounter_ELSE,"%d\0",counterELSE);
   }
   else {
      sprintf(strcounter_THEN,"%d\0",counterELSE);
      sprintf(strcounter_ELSE,"%d\0",counterIF+1);
   }

   int id=1;

   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;

   list <char*>::iterator itr=path.begin();

   if (pathlength==1) {
      char *recordname=getRecordName(symboltable,*itr);
      rulelist=producePEqNULL(strcounter_IF, strcounter_THEN, strcounter_ELSE, *itr, recordname, rulename);
   }
   //pathlength > 1
   else {

      int returnhelpcounter=1;
      char *recordname;
      rulelist=gotoLastPathRule(counterIF, 1, path, "#h", rulename, 0, returnhelpcounter, &recordname);

      list <RULE*> rulelist_=producePEqNULL(catstrstr(strcounter_IF, "_e"), strcounter_THEN, strcounter_ELSE, "#h", recordname, rulename, true);
      rulelist.merge(rulelist_);
   }

   for (list<RULE*>::iterator itr=rulelist.begin(); itr != rulelist.end(); itr++) {
      (*itr)->setID(rule_counter++);
      GraphGrammar.addRule(*itr);
   }
}




/*
   void PLGTS::produceWHILERule(int counterIF, int counterOD, booltree::Node *booltree , char *rulename)
*/
void PLGTS::produceWHILERule(int counterWHILE, int counterOD, booltree::Node *booltree , char *rulename)
{
   produceIFRule(counterWHILE, counterOD, booltree, rulename);
}




/*
   void PLGTS::produceWHILERule(int counterWHILE, int counterOD, list<char*> left, list<char*> right, char *rulename, bool equal)
*/
void PLGTS::produceWHILERule(int counterWHILE, int counterOD, list<char*> left, list<char*> right, char *rulename, bool equal)
{
   produceIFRule(counterWHILE, counterOD, left, right, rulename, equal);
}




/*
   void produceWHILENULLRule(int counterWHILE, int counterOD, list<char*> path, char *rulename, bool equal)
*/
void PLGTS::produceWHILENULLRule(int counterWHILE, int counterOD, list<char*> path, char *rulename, bool equal)
{
   produceIFNULLRule(counterWHILE, counterOD, path, rulename, equal);
}




/*
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

list <RULE*> PLGTS::gotoLastPathRule(int counter, list <char*> path, char *helpvar, char *rulename)
{
   char *dummyrecord;
   return gotoLastPathRule(counter, path, helpvar, rulename, &dummyrecord);
}
/*
list <RULE*> gotoLastPathRule(int counter, list <char*> path, char *helpvar, char *rulename)
*/
list <RULE*> PLGTS::gotoLastPathRule(int counter, list <char*> path, char *helpvar, char *rulename, char **returnrecordname)
{
   list <RULE*> rulelist;
   int length=path.size();
   assert(length>=1);

   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];
   char strcounter_rplus1[MAX_COUNTER];
   int rulecounter=1; 

   sprintf(strcounter_l,"%d\0",counter);
   sprintf(strcounter_r,"%d\0",counter+1);
   sprintf(strcounter_rplus1, "%d\0",counter+2);

   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   RULE *rule=new(RULE);
   char *rulename_=catstrstr(rulename, " (add new help var)");
   rule->setName(addRuleID(rulename_));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName(hleftname);
   hright->setName(hrightname);

   list<char*>::iterator itr = path.begin();
   char name[strlen(*itr)+1];
   strcpy(name, *itr);
   char *recordname=getRecordName(symboltable,*itr);
   *returnrecordname=NULL;

   //linke Seite
   int id=1;

   VERTEX *vel_left=new (VERTEX);
   vel_left->setIdLabel(catstrint("gel",id));
   vel_left->setID(id);
   hleft->addVertex(*vel_left,vel_left->getID());
   id++;

   VERTEX *vel_right=new (VERTEX);
   vel_right->setIdLabel(catstrint("gel",id));
   vel_right->setID(id);
   hleft->addVertex(*vel_right,vel_right->getID());
   id++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;


   EDGE *evarl_right = new(EDGE);
   evarl_right->setLabel(name);
   evarl_right->setIdLabel(catstrint("gel",id));
   evarl_right->setID(id);
   list <IDTYPE> listsecondleft;
   listsecondleft.push_back(vel_right->getID());
   hleft->addEdge(*evarl_right,evarl_right->getID(),listsecondleft);
   id++;

   if (length==1) {
      //rechte Seite

      VERTEX *ver_left=new (VERTEX);
      ver_left->setIdLabel(catstrint("ger",id));
      ver_left->setID(id);
      hright->addVertex(*ver_left,ver_left->getID());
      id++;

      VERTEX *ver_right=new (VERTEX);
      ver_right->setIdLabel(catstrint("ger",id));
      ver_right->setID(id);
      hright->addVertex(*ver_right,ver_right->getID());
      id++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id));
      ecounter_right->setID(id);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id++;

      list <IDTYPE> listsecondright;

      EDGE *evarr_right = new(EDGE);
      evarr_right->setLabel(name);
      evarr_right->setIdLabel(catstrint("ger",id));
      evarr_right->setID(id);
      listsecondright.push_back(ver_right->getID());
      hright->addEdge(*evarr_right,evarr_right->getID(),listsecondright);
      id++;

      EDGE *evarr_left = new(EDGE);
      evarr_left->setLabel(helpvar);
      evarr_left->setIdLabel(catstrint("ger",id));
      evarr_left->setID(id);
      hright->addEdge(*evarr_left,evarr_left->getID(),listsecondright);
      id++;

      MATCH *match=new MATCH();
      match->setMatch(vel_left->getID(),ver_left->getID());
      match->setMatch(vel_right->getID(), ver_right->getID());
      rule->setInterface(*match);

      rule->setLeft(hleft);
      rule->setRight(hright);
      rulelist.push_back(rule);

      delete ver_left, ver_right, ecounter_right, evarr_left, evarr_right;
      delete match;
      return rulelist;
   }

   char* strcounter = catstrstr(strcounter_r,"#");
   char* helpcounter= catstrint(strcounter, rulecounter);

   //rechte Seite

   VERTEX *ver_left=new (VERTEX);
   ver_left->setIdLabel(catstrint("ger",id));
   ver_left->setID(id);
   hright->addVertex(*ver_left,ver_left->getID());
   id++;

   VERTEX *ver_right=new (VERTEX);
   ver_right->setIdLabel(catstrint("ger",id));
   ver_right->setID(id);
   hright->addVertex(*ver_right,ver_right->getID());
   id++;

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   EDGE *helpcounter_r=new(EDGE);
   ecounter_right->setLabel(helpcounter);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   list <IDTYPE> listsecondright;

   EDGE *evarr_right = new(EDGE);
   evarr_right->setLabel(name);
   evarr_right->setIdLabel(catstrint("ger",id));
   evarr_right->setID(id);
   listsecondright.push_back(ver_right->getID());
   hright->addEdge(*evarr_right,evarr_right->getID(),listsecondright);
   id++;

   EDGE *evarr_left = new(EDGE);
   evarr_left->setLabel(helpvar);
   evarr_left->setIdLabel(catstrint("ger",id));
   evarr_left->setID(id);
   hright->addEdge(*evarr_left,evarr_left->getID(),listsecondright);
   id++;

   MATCH *match=new MATCH();
   match->setMatch(vel_left->getID(),ver_left->getID());
   match->setMatch(vel_right->getID(), ver_right->getID());
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);
   rulelist.push_back(rule);

   length--;


   while (length > 1)
   {
      const char* helpcounter_left= catstrint(strcounter, rulecounter);
      const char* helpcounter_right= catstrint(strcounter, rulecounter+1);
      itr++;
      RecordEntry *re= getRecordComp(symboltable, *itr, (char*)recordname);
      RULE *lastRule=producePToPcompRule((char*)helpcounter_left,(char*)helpcounter_right, helpvar, *itr, recordname, catstrstr(rulename," (p:=p.comp)"));
      recordname = re->recordname;
      rulelist.push_back(lastRule);
      length--;
      rulecounter++;
   }


   //last
   {
   const char* helpcounter_left= catstrint(strcounter, rulecounter);
   const char* helpcounter_right= catstrint(strcounter, rulecounter+1);
   itr++;

   RULE *rule=new(RULE);
   char *rulename_=catstrstr(rulename," (p:=p.comp)");
   rule->setName(addRuleID(rulename_));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id=1;
   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;


   //linke Seite
   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id));
   ve_left->setID(id);
   hleft->addVertex(*ve_left,ve_left->getID());
   id++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(helpcounter_left);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   EDGE *ecounterstart=new(EDGE);
   ecounterstart->setLabel(strcounter_r);
   ecounterstart->setIdLabel(catstrint("gel",id));
   ecounterstart->setID(id);
   hleft->addEdge(*ecounterstart,ecounterstart->getID(),lnull);
   id++;

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(helpvar);
   evar_left->setIdLabel(catstrint("gel",id));
   evar_left->setID(id);
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),list_left);
   id++;

   int nextvertex;
   int edgeid_l=produceRecord(hleft, LEFTHAND, id, (char*)recordname, ve_left->getID(), *itr, nextvertex);

   list<IDTYPE> vertexlist_left = hleft->getConnectedVertices(edgeid_l);
   list<IDTYPE>::iterator itr_l = vertexlist_left.begin();
   while(itr_l != vertexlist_left.end())
   {
      leftmap.push_back(*itr_l);
      itr_l++;
   }

   //rechte Seite
   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id));
   ve_right->setID(id);
   hright->addVertex(*ve_right,ve_right->getID());
   id++;

   EDGE *ecounterend=new(EDGE);
   ecounterend->setLabel(strcounter_rplus1);
   ecounterend->setIdLabel(catstrint("ger",id));
   ecounterend->setID(id);
   hright->addEdge(*ecounterend,ecounterend->getID(),lnull);
   id++;

   int edgeid_r=produceRecord(hright, RIGHTHAND, id, (char*)recordname, ve_right->getID(), *itr, nextvertex);
   RecordEntry *re= getRecordComp(symboltable, *itr, (char*)recordname);
   if (re->type==ptorecType)
      *returnrecordname = re->recordname;

   EDGE *evar_right = new(EDGE);
   evar_right->setLabel(helpvar);
   evar_right->setIdLabel(catstrint("ger",id));
   evar_right->setID(id);
   list <IDTYPE> list_right;
   list_right.push_back(nextvertex);
   hright->addEdge(*evar_right,evar_right->getID(),list_right);
   id++;

   list<IDTYPE> vertexlist_right = hright->getConnectedVertices(edgeid_r);
   list<IDTYPE>::iterator itr_r = vertexlist_right.begin();
   while(itr_r != vertexlist_right.end())
   {
      rightmap.push_back(*itr_r);
      itr_r++;
   }


   //Match

   MATCH *match=new MATCH();
   list<IDTYPE>::iterator itr_right = rightmap.begin();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
   {
      match->setMatch(*itr_left,*itr_right);
      itr_right++;
   }
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);
   rulelist.push_back(rule);

   delete ve_left,ve_right, ecounter_left, ecounterstart, evar_left, evar_right, ecounterend;
   delete hleft, hright, match;
   }

   //error rule
   RULE *errorRule = produceError(counter+1,helpvar,catstrstr(rulename," (produce Error Rule)"));
   rulelist.push_back(errorRule);

   delete vel_left, vel_right, ecounter_left, evarl_right, ver_left, ver_right, ecounter_right, helpcounter_r, evarr_right, evarr_left;
   delete hleft, hright, match;
   return rulelist;

}



list <RULE*> PLGTS::gotoLastPathRule(int counter, int helpcounter, list <char*> path, char *helpvar, char *rulename, int mode, int &returnhelpcounter)
{
   char *dummyrecord;
   return gotoLastPathRule(counter, helpcounter, path, helpvar, rulename, mode, returnhelpcounter, &dummyrecord);
}
/*
list <RULE*> PLGTS::gotoLastPathRule(int counter, int helpcounter, list <char*> path, char *helpvar, char *rulename, int mode, int &returnhelpcounter)
*/
list <RULE*> PLGTS::gotoLastPathRule(int counter, int helpcounter, list <char*> path, char *helpvar, char *rulename, int mode, int &returnhelpcounter, char **returnrecordname)
{

   list <RULE*> rulelist;
   int length=path.size();
   assert(length>=1);
   if (mode<0 || mode>3)
      mode=0;

   char strcounter[MAX_COUNTER];
   sprintf(strcounter,"%d\0",counter);

   if (mode==0 || mode==1)
      helpcounter=1;

   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   RULE *rule=new(RULE);
   char *rulename_=catstrstr(rulename, " (add new help var)");
   rule->setName(addRuleID(rulename_));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName(hleftname);
   hright->setName(hrightname);

   list<char*>::iterator itr = path.begin();
   char name[strlen(*itr)+1];
   strcpy(name, *itr);
   char *recordname=getRecordName(symboltable,*itr);
   *returnrecordname=NULL;
   int id=1;

   //Hilfsvariable einfuegen
   //linke Seite
   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id));
   ve_left->setID(id);
   hleft->addVertex(*ve_left,ve_left->getID());
   id++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   if (mode==0 || mode==1) {
      ecounter_left->setLabel(strcounter);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   }
   else {
      char strhelpcounter[MAX_COUNTER];
      sprintf(strhelpcounter,"%d\0",helpcounter);
      ecounter_left->setLabel(catstrstr(catstrstr(strcounter,"#"),strhelpcounter));
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      helpcounter++;
   }

   id++;

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(name);
   evar_left->setIdLabel(catstrint("gel",id));
   evar_left->setID(id);
   list <IDTYPE> helpvarleftlist;
   helpvarleftlist.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),helpvarleftlist);
   id++;


   //rechte Seite

   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id));
   ve_right->setID(id);
   hright->addVertex(*ve_right,ve_right->getID());
   id++;

   if ((mode==0) || (mode==1)) {

      EDGE *ecounter_right=new(EDGE);
      if (length==1)
         ecounter_right->setLabel(catstrstr(strcounter,"_e"));
      else
         ecounter_right->setLabel(catstrstr(strcounter,"_"));
      ecounter_right->setIdLabel(catstrint("ger",id));
      ecounter_right->setID(id);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id++;

      if (length >1) {
         EDGE *helpcounter_right=new(EDGE);
         helpcounter_right->setLabel(catstrstr(strcounter,"#1"));
         helpcounter_right->setIdLabel(catstrint("ger",id));
         helpcounter_right->setID(id);
         hright->addEdge(*helpcounter_right,helpcounter_right->getID(),lnull);
         id++;
         delete helpcounter_right;
      }
      delete ecounter_right;
   }
   else {
      EDGE *helpcounter_right=new(EDGE);
      char strhelpcounter[MAX_COUNTER];
      sprintf(strhelpcounter,"%d\0",helpcounter);
      helpcounter_right->setLabel(catstrstr(catstrstr(strcounter,"#"),strhelpcounter));
      helpcounter_right->setIdLabel(catstrint("ger",id));
      helpcounter_right->setID(id);
      hright->addEdge(*helpcounter_right,helpcounter_right->getID(),lnull);
      id++;
      delete helpcounter_right;
   }

   EDGE *evar_right = new(EDGE);
   evar_right->setLabel(name);
   evar_right->setIdLabel(catstrint("ger",id));
   evar_right->setID(id);
   list <IDTYPE> helpvarrightlist;
   helpvarrightlist.push_back(ve_right->getID());
   hright->addEdge(*evar_right,evar_right->getID(),helpvarrightlist);
   id++;

   EDGE *ehelpvar = new(EDGE);
   ehelpvar->setLabel(helpvar);
   ehelpvar->setIdLabel(catstrint("ger",id));
   ehelpvar->setID(id);
   hright->addEdge(*ehelpvar,ehelpvar->getID(),helpvarrightlist);
   id++;

   MATCH *match=new MATCH();
   match->setMatch(ve_left->getID(),ve_right->getID());
   rule->setInterface(*match);
   delete match;

   rule->setLeft(hleft);
   rule->setRight(hright);
   rulelist.push_back(rule);
   if (length==1)
      return rulelist;

   length--;

   //Hilfsvariable aud die vorletzte Komponente 
   while (length > 1)
   {
      const char* helpcounter_left= catstrint(catstrstr(strcounter,"#"), helpcounter);
      helpcounter++;
      const char* helpcounter_right= catstrint(catstrstr(strcounter,"#"), helpcounter);
      itr++;
      RecordEntry *re= getRecordComp(symboltable, *itr, (char*)recordname);
      RULE *lastRule=producePToPcompRule((char*)helpcounter_left,(char*)helpcounter_right, helpvar, *itr, recordname, catstrstr(rulename," (p:=p.comp)"));
      recordname = re->recordname;
      rulelist.push_back(lastRule);
      length--;
   }


   //letzte Regel
   {
   itr++;

   RULE *rule=new(RULE);
   char *rulename_=catstrstr(rulename," (p:=p.comp)");
   rule->setName(addRuleID(rulename_));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id=1;
   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;


   //linke Seite
   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id));
   ve_left->setID(id);
   hleft->addVertex(*ve_left,ve_left->getID());
   id++;

   EDGE *helpcounter_left=new(EDGE);
   char strhelpcounter[MAX_COUNTER];
   sprintf(strhelpcounter,"%d\0",helpcounter);
   helpcounter_left->setLabel(catstrstr(catstrstr(strcounter,"#"),strhelpcounter));
   helpcounter_left->setIdLabel(catstrint("gel",id));
   helpcounter_left->setID(id);
   hleft->addEdge(*helpcounter_left,helpcounter_left->getID(),lnull);
   id++;

   if (mode==0 || mode==2) {
      EDGE *ecounter=new(EDGE);
      ecounter->setLabel(catstrstr(strcounter,"_"));
      ecounter->setIdLabel(catstrint("gel",id));
      ecounter->setID(id);
      hleft->addEdge(*ecounter,ecounter->getID(),lnull);
      id++;
      delete ecounter;
   }

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(helpvar);
   evar_left->setIdLabel(catstrint("gel",id));
   evar_left->setID(id);
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),list_left);
   id++;

   int nextvertex;
   int edgeid_l=produceRecord(hleft, LEFTHAND, id, (char*)recordname, ve_left->getID(), *itr, nextvertex);

   list<IDTYPE> vertexlist_left = hleft->getConnectedVertices(edgeid_l);
   list<IDTYPE>::iterator itr_l = vertexlist_left.begin();
   while(itr_l != vertexlist_left.end())
   {
      leftmap.push_back(*itr_l);
      itr_l++;
   }
   helpcounter++;

   //rechte Seite
   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id));
   ve_right->setID(id);
   hright->addVertex(*ve_right,ve_right->getID());
   id++;

   if (mode==0 || mode==2)
   {
      EDGE *ecounterend=new(EDGE);
      ecounterend->setLabel(catstrstr(strcounter,"_e"));
      ecounterend->setIdLabel(catstrint("ger",id));
      ecounterend->setID(id);
      hright->addEdge(*ecounterend,ecounterend->getID(),lnull);
      id++;
      delete ecounterend;
   }
   else
   {
      EDGE *helpcounter_right=new(EDGE);
      char strhelpcounter[MAX_COUNTER];
      sprintf(strhelpcounter,"%d\0",helpcounter);
      helpcounter_right->setLabel(catstrstr(catstrstr(strcounter,"#"),strhelpcounter));
      helpcounter_right->setIdLabel(catstrint("ger",id));
      helpcounter_right->setID(id);
      hright->addEdge(*helpcounter_right,helpcounter_right->getID(),lnull);
      id++;
      helpcounter++;
      delete helpcounter_right;
   }

   int edgeid_r=produceRecord(hright, RIGHTHAND, id, (char*)recordname, ve_right->getID(), *itr, nextvertex);
   RecordEntry *re= getRecordComp(symboltable, *itr, (char*)recordname);
   if (re->type==ptorecType)
      *returnrecordname = re->recordname;

   EDGE *evar_right = new(EDGE);
   evar_right->setLabel(helpvar);
   evar_right->setIdLabel(catstrint("ger",id));
   evar_right->setID(id);
   list <IDTYPE> list_right;
   list_right.push_back(nextvertex);
   hright->addEdge(*evar_right,evar_right->getID(),list_right);
   id++;

   list<IDTYPE> vertexlist_right = hright->getConnectedVertices(edgeid_r);
   list<IDTYPE>::iterator itr_r = vertexlist_right.begin();
   while(itr_r != vertexlist_right.end())
   {
      rightmap.push_back(*itr_r);
      itr_r++;
   }


   //Match
   MATCH *match=new MATCH();
   list<IDTYPE>::iterator itr_right = rightmap.begin();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
   {
      match->setMatch(*itr_left,*itr_right);
      itr_right++;
   }
   rule->setInterface(*match);


   rule->setLeft(hleft);
   rule->setRight(hright);
   rulelist.push_back(rule);

   delete ve_left, ve_right, helpcounter_left, evar_left, evar_right;
   delete hleft, hright, match;

   }

   //error rule
   RULE *errorRule = produceError(catstrstr(strcounter, "_"),helpvar,catstrstr(rulename," (produce Error Rule)"));
   rulelist.push_back(errorRule);
   returnhelpcounter=helpcounter-1;

   delete ve_left, ve_right, ecounter_left, evar_right, ehelpvar;
   delete hleft, hright, match;
   return rulelist;
}




/*
list <RULE*> PLGTS::gotoLastPathRule(int counter, int helpcounter, list <char*> path, char *helpvar, char *rulename, int mode, int &returnhelpcounter, int &returntype)
*/
list <RULE*> PLGTS::gotoLastPathRule(int counter, int helpcounter, list <char*> path, char *helpvar, char *rulename, int mode, int &returnhelpcounter, int &returntype)
{
   list <RULE*> rulelist;
   int length=path.size();
   assert(length>=1);
   if (mode<0 || mode>3)
      mode=0;

   char strcounter[MAX_COUNTER];
   sprintf(strcounter,"%d\0",counter);

   if (mode==0 || mode==1)
      helpcounter=1;

   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   RULE *rule=new(RULE);
   char *rulename_=catstrstr(rulename, " (add new help var)");
   rule->setName(addRuleID(rulename_));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName(hleftname);
   hright->setName(hrightname);

   list<char*>::iterator itr = path.begin();
   char name[strlen(*itr)+1];
   strcpy(name, *itr);
   char *recordname=getRecordName(symboltable,*itr);

   int id=1;

   //Hilfsvariable einfuegen
   //linke Seite
   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id));
   ve_left->setID(id);
   hleft->addVertex(*ve_left,ve_left->getID());
   id++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   if (mode==0 || mode==1) {
      ecounter_left->setLabel(strcounter);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   }
   else {
      char strhelpcounter[MAX_COUNTER];
      sprintf(strhelpcounter,"%d\0",helpcounter);
      ecounter_left->setLabel(catstrstr(catstrstr(strcounter,"#"),strhelpcounter));
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      helpcounter++;
   }

   id++;

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(name);
   evar_left->setIdLabel(catstrint("gel",id));
   evar_left->setID(id);
   list <IDTYPE> helpvarleftlist;
   helpvarleftlist.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),helpvarleftlist);
   id++;


   //rechte Seite

   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id));
   ve_right->setID(id);
   hright->addVertex(*ve_right,ve_right->getID());
   id++;

   if ((mode==0) || (mode==1)) {

      EDGE *ecounter_right=new(EDGE);
      if (length==1)
         ecounter_right->setLabel(catstrstr(strcounter,"_e"));
      else
         ecounter_right->setLabel(catstrstr(strcounter,"_"));
      ecounter_right->setIdLabel(catstrint("ger",id));
      ecounter_right->setID(id);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id++;

      if (length >1) {
         EDGE *helpcounter_right=new(EDGE);
         helpcounter_right->setLabel(catstrstr(strcounter,"#1"));
         helpcounter_right->setIdLabel(catstrint("ger",id));
         helpcounter_right->setID(id);
         hright->addEdge(*helpcounter_right,helpcounter_right->getID(),lnull);
         id++;
         delete helpcounter_right;
      }
      delete ecounter_right;
   }
   else {
      EDGE *helpcounter_right=new(EDGE);
      char strhelpcounter[MAX_COUNTER];
      sprintf(strhelpcounter,"%d\0",helpcounter);
      helpcounter_right->setLabel(catstrstr(catstrstr(strcounter,"#"),strhelpcounter));
      helpcounter_right->setIdLabel(catstrint("ger",id));
      helpcounter_right->setID(id);
      hright->addEdge(*helpcounter_right,helpcounter_right->getID(),lnull);
      id++;
      delete helpcounter_right;
   }

   EDGE *evar_right = new(EDGE);
   evar_right->setLabel(name);
   evar_right->setIdLabel(catstrint("ger",id));
   evar_right->setID(id);
   list <IDTYPE> helpvarrightlist;
   helpvarrightlist.push_back(ve_right->getID());
   hright->addEdge(*evar_right,evar_right->getID(),helpvarrightlist);
   id++;

   EDGE *ehelpvar = new(EDGE);
   ehelpvar->setLabel(helpvar);
   ehelpvar->setIdLabel(catstrint("ger",id));
   ehelpvar->setID(id);
   hright->addEdge(*ehelpvar,ehelpvar->getID(),helpvarrightlist);
   id++;

   MATCH *match=new MATCH();
   match->setMatch(ve_left->getID(),ve_right->getID());
   rule->setInterface(*match);
   delete match;

   rule->setLeft(hleft);
   rule->setRight(hright);
   rulelist.push_back(rule);
   if (length==1)
      return rulelist;

   length--;

   //Hilfsvariable aud die vorletzte Komponente 
   while (length > 1)
   {
      const char* helpcounter_left= catstrint(catstrstr(strcounter,"#"), helpcounter);
      helpcounter++;
      const char* helpcounter_right= catstrint(catstrstr(strcounter,"#"), helpcounter);
      itr++;
      RecordEntry *re= getRecordComp(symboltable, *itr, (char*)recordname);
      RULE *lastRule=producePToPcompRule((char*)helpcounter_left,(char*)helpcounter_right, helpvar, *itr, recordname, catstrstr(rulename," (p:=p.comp)"));
      recordname = re->recordname;
      rulelist.push_back(lastRule);
      length--;
   }


   //letzte Regel
   {
   itr++;

   RULE *rule=new(RULE);
   char *rulename_=catstrstr(rulename," (p:=p.comp)");
   rule->setName(addRuleID(rulename_));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id=1;
   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;


   //linke Seite
   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id));
   ve_left->setID(id);
   hleft->addVertex(*ve_left,ve_left->getID());
   id++;

   EDGE *helpcounter_left=new(EDGE);
   char strhelpcounter[MAX_COUNTER];
   sprintf(strhelpcounter,"%d\0",helpcounter);
   helpcounter_left->setLabel(catstrstr(catstrstr(strcounter,"#"),strhelpcounter));
   helpcounter_left->setIdLabel(catstrint("gel",id));
   helpcounter_left->setID(id);
   hleft->addEdge(*helpcounter_left,helpcounter_left->getID(),lnull);
   id++;

   if (mode==0 || mode==2) {
      EDGE *ecounter=new(EDGE);
      ecounter->setLabel(catstrstr(strcounter,"_"));
      ecounter->setIdLabel(catstrint("gel",id));
      ecounter->setID(id);
      hleft->addEdge(*ecounter,ecounter->getID(),lnull);
      id++;
      delete ecounter;
   }

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(helpvar);
   evar_left->setIdLabel(catstrint("gel",id));
   evar_left->setID(id);
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),list_left);
   id++;

   int nextvertex;
   int edgeid_l=produceRecord(hleft, LEFTHAND, id, (char*)recordname, ve_left->getID(), *itr, nextvertex);
   RecordEntry *re=getRecordComp(symboltable, *itr, recordname);
   switch(re->type) {
      case intType:  returntype=0; break;
      case strType:  returntype=1; break;
      case ptorecType:  returntype=2; break;
   }

   list<IDTYPE> vertexlist_left = hleft->getConnectedVertices(edgeid_l);
   list<IDTYPE>::iterator itr_l = vertexlist_left.begin();
   while(itr_l != vertexlist_left.end())
   {
      leftmap.push_back(*itr_l);
      itr_l++;
   }
   helpcounter++;

   //rechte Seite
   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id));
   ve_right->setID(id);
   hright->addVertex(*ve_right,ve_right->getID());
   id++;

   if (mode==0 || mode==2)
   {
      EDGE *ecounterend=new(EDGE);
      ecounterend->setLabel(catstrstr(strcounter,"_e"));
      ecounterend->setIdLabel(catstrint("ger",id));
      ecounterend->setID(id);
      hright->addEdge(*ecounterend,ecounterend->getID(),lnull);
      id++;
      delete ecounterend;
   }
   else
   {
      EDGE *helpcounter_right=new(EDGE);
      char strhelpcounter[MAX_COUNTER];
      sprintf(strhelpcounter,"%d\0",helpcounter);
      helpcounter_right->setLabel(catstrstr(catstrstr(strcounter,"#"),strhelpcounter));
      helpcounter_right->setIdLabel(catstrint("ger",id));
      helpcounter_right->setID(id);
      hright->addEdge(*helpcounter_right,helpcounter_right->getID(),lnull);
      id++;
      helpcounter++;
      delete helpcounter_right;
   }

   int edgeid_r=produceRecord(hright, RIGHTHAND, id, (char*)recordname, ve_right->getID(), *itr, nextvertex);

   EDGE *evar_right = new(EDGE);
   evar_right->setLabel(helpvar);
   evar_right->setIdLabel(catstrint("ger",id));
   evar_right->setID(id);
   list <IDTYPE> list_right;
   list_right.push_back(nextvertex);
   hright->addEdge(*evar_right,evar_right->getID(),list_right);
   id++;

   list<IDTYPE> vertexlist_right = hright->getConnectedVertices(edgeid_r);
   list<IDTYPE>::iterator itr_r = vertexlist_right.begin();
   while(itr_r != vertexlist_right.end())
   {
      rightmap.push_back(*itr_r);
      itr_r++;
   }


   //Match
   MATCH *match=new MATCH();
   list<IDTYPE>::iterator itr_right = rightmap.begin();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
   {
      match->setMatch(*itr_left,*itr_right);
      itr_right++;
   }
   rule->setInterface(*match);


   rule->setLeft(hleft);
   rule->setRight(hright);
   rulelist.push_back(rule);

   delete ve_left, ve_right, helpcounter_left, evar_left, evar_right;
   delete hleft, hright, match;

   }

   //error rule
   RULE *errorRule = produceError(catstrstr(strcounter, "_"),helpvar,catstrstr(rulename," (produce Error Rule)"));
   rulelist.push_back(errorRule);
   returnhelpcounter=helpcounter-1;

   delete ve_left, ve_right, ecounter_left, evar_right, ehelpvar;
   delete hleft, hright, match;
   return rulelist;

}




/*
list <RULE*> gotoSecondLastPathRule(int counter, list <char*> path_, char *helpvar, char *rulename, char **returnrecordname)
*/
list <RULE*> PLGTS::gotoSecondLastPathRule(int counter, list <char*> path_, char *helpvar, char *rulename, char **returnrecordname)
{
   path_.pop_back();
   list <char*> path=path_;
   list <RULE*> rulelist;
   int length=path.size();
   assert(length>=1);

   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];
   char strcounter_rplus1[MAX_COUNTER];
   int rulecounter=1; 

   sprintf(strcounter_l,"%d\0",counter);
   sprintf(strcounter_r,"%d\0",counter+1);
   sprintf(strcounter_rplus1, "%d\0",counter+2);

   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";


   RULE *rule=new(RULE);
   char *rulename_=catstrstr(rulename, " (add new help var)");
   rule->setName(addRuleID(rulename_));

   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName(hleftname);
   hright->setName(hrightname);

   list<char*>::iterator itr = path.begin();
   char name[strlen(*itr)+1];
   strcpy(name, *itr);
   char *recordname=getRecordName(symboltable,*itr);

   //linke Seite
   int id=1;

   VERTEX *vel_left=new (VERTEX);
   vel_left->setIdLabel(catstrint("gel",id));
   vel_left->setID(id);
   hleft->addVertex(*vel_left,vel_left->getID());
   id++;

   VERTEX *vel_right=new (VERTEX);
   vel_right->setIdLabel(catstrint("gel",id));
   vel_right->setID(id);
   hleft->addVertex(*vel_right,vel_right->getID());
   id++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   EDGE *evarl_right = new(EDGE);
   evarl_right->setLabel(name);
   evarl_right->setIdLabel(catstrint("gel",id));
   evarl_right->setID(id);
   list <IDTYPE> listsecondleft;
   listsecondleft.push_back(vel_right->getID());
   hleft->addEdge(*evarl_right,evarl_right->getID(),listsecondleft);
   id++;

   *returnrecordname=recordname;

   if (length==1) {
      //rechte Seite

      VERTEX *ver_left=new (VERTEX);
      ver_left->setIdLabel(catstrint("ger",id));
      ver_left->setID(id);
      hright->addVertex(*ver_left,ver_left->getID());
      id++;

      VERTEX *ver_right=new (VERTEX);
      ver_right->setIdLabel(catstrint("ger",id));
      ver_right->setID(id);
      hright->addVertex(*ver_right,ver_right->getID());
      id++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id));
      ecounter_right->setID(id);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id++;

      list <IDTYPE> listsecondright;

      EDGE *evarr_right = new(EDGE);
      evarr_right->setLabel(name);
      evarr_right->setIdLabel(catstrint("ger",id));
      evarr_right->setID(id);
      listsecondright.push_back(ver_right->getID());
      hright->addEdge(*evarr_right,evarr_right->getID(),listsecondright);
      id++;

      EDGE *evarr_left = new(EDGE);
      evarr_left->setLabel(helpvar);
      evarr_left->setIdLabel(catstrint("ger",id));
      evarr_left->setID(id);
      hright->addEdge(*evarr_left,evarr_left->getID(),listsecondright);
      id++;

      MATCH *match=new MATCH();
      match->setMatch(vel_left->getID(),ver_left->getID());
      match->setMatch(vel_right->getID(), ver_right->getID());
      rule->setInterface(*match);

      rule->setLeft(hleft);
      rule->setRight(hright);
      rulelist.push_back(rule);

      delete ver_left, ver_right, ecounter_right, evarr_right, evarr_left;
      delete match;
      return rulelist;
   }

   char* strcounter = catstrstr(strcounter_r,"#");
   char* helpcounter= catstrint(strcounter, rulecounter);

   //rechte Seite

   VERTEX *ver_left=new (VERTEX);
   ver_left->setIdLabel(catstrint("ger",id));
   ver_left->setID(id);
   hright->addVertex(*ver_left,ver_left->getID());
   id++;

   VERTEX *ver_right=new (VERTEX);
   ver_right->setIdLabel(catstrint("ger",id));
   ver_right->setID(id);
   hright->addVertex(*ver_right,ver_right->getID());
   id++;

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   EDGE *helpcounter_r=new(EDGE);
   ecounter_right->setLabel(helpcounter);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   list <IDTYPE> listsecondright;

   EDGE *evarr_right = new(EDGE);
   evarr_right->setLabel(name);
   evarr_right->setIdLabel(catstrint("ger",id));
   evarr_right->setID(id);
   listsecondright.push_back(ver_right->getID());
   hright->addEdge(*evarr_right,evarr_right->getID(),listsecondright);
   id++;

   EDGE *evarr_left = new(EDGE);
   evarr_left->setLabel(helpvar);
   evarr_left->setIdLabel(catstrint("ger",id));
   evarr_left->setID(id);
   hright->addEdge(*evarr_left,evarr_left->getID(),listsecondright);
   id++;

   MATCH *match=new MATCH();
   match->setMatch(vel_left->getID(),ver_left->getID());
   match->setMatch(vel_right->getID(), ver_right->getID());
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);
   rulelist.push_back(rule);

   length--;


   while (length > 1)
   {
      const char* helpcounter_left= catstrint(strcounter, rulecounter);
      const char* helpcounter_right= catstrint(strcounter, rulecounter+1);
      itr++;
      RecordEntry *re= getRecordComp(symboltable, *itr, (char*)recordname);
      char *rulename_=catstrstr(rulename," (p:=p.comp)");
      RULE *lastRule=producePToPcompRule((char*)helpcounter_left,(char*)helpcounter_right, helpvar, *itr, recordname, rulename_);
      recordname = re->recordname;
      rulelist.push_back(lastRule);
      length--;
      rulecounter++;
   }


   //last
   {
   const char* helpcounter_left= catstrint(strcounter, rulecounter);
   const char* helpcounter_right= catstrint(strcounter, rulecounter+1);
   itr++;

   RULE *rule=new(RULE);
   char *rulename_=catstrstr(rulename," (p:=p.comp)");
   rule->setName(addRuleID(rulename_));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id=1;
   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;

   //linke Seite
   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id));
   ve_left->setID(id);
   hleft->addVertex(*ve_left,ve_left->getID());
   id++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(helpcounter_left);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   EDGE *ecounterstart=new(EDGE);
   ecounterstart->setLabel(strcounter_r);
   ecounterstart->setIdLabel(catstrint("gel",id));
   ecounterstart->setID(id);
   hleft->addEdge(*ecounterstart,ecounterstart->getID(),lnull);
   id++;

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(helpvar);
   evar_left->setIdLabel(catstrint("gel",id));
   evar_left->setID(id);
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),list_left);
   id++;

   int nextvertex;
   int edgeid_l=produceRecord(hleft, LEFTHAND, id, (char*)recordname, ve_left->getID(), *itr, nextvertex);

   list<IDTYPE> vertexlist_left = hleft->getConnectedVertices(edgeid_l);
   list<IDTYPE>::iterator itr_l = vertexlist_left.begin();
   while(itr_l != vertexlist_left.end())
   {
      leftmap.push_back(*itr_l);
      itr_l++;
   }

   //rechte Seite
   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id));
   ve_right->setID(id);
   hright->addVertex(*ve_right,ve_right->getID());
   id++;

   EDGE *ecounterend=new(EDGE);
   ecounterend->setLabel(strcounter_rplus1);
   ecounterend->setIdLabel(catstrint("ger",id));
   ecounterend->setID(id);
   hright->addEdge(*ecounterend,ecounterend->getID(),lnull);
   id++;

   int edgeid_r=produceRecord(hright, RIGHTHAND, id, (char*)recordname, ve_right->getID(), *itr, nextvertex);

   RecordEntry *re= getRecordComp(symboltable, *itr, (char*)recordname);
   *returnrecordname = re->recordname;

   EDGE *evar_right = new(EDGE);
   evar_right->setLabel(helpvar);
   evar_right->setIdLabel(catstrint("ger",id));
   evar_right->setID(id);
   list <IDTYPE> list_right;
   list_right.push_back(nextvertex);
   hright->addEdge(*evar_right,evar_right->getID(),list_right);
   id++;

   list<IDTYPE> vertexlist_right = hright->getConnectedVertices(edgeid_r);
   list<IDTYPE>::iterator itr_r = vertexlist_right.begin();
   while(itr_r != vertexlist_right.end())
   {
      rightmap.push_back(*itr_r);
      itr_r++;
   }

   //Match

   MATCH *match=new MATCH();
   list<IDTYPE>::iterator itr_right = rightmap.begin();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
   {
      match->setMatch(*itr_left,*itr_right);
      itr_right++;
   }
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);
   rulelist.push_back(rule);

   delete ve_left, ve_right, ecounter_left, ecounterstart, ecounterend, evar_left, evar_right;
   delete hleft, hright, match;
   }

   //error rule
   RULE *errorRule = produceError(counter+1,helpvar,catstrstr(rulename," (produce Error Rule)"));
   rulelist.push_back(errorRule);

   delete vel_left, ver_right, ver_left, vel_right, ecounter_left, ecounter_right, evarl_right, helpcounter_r, evarr_left, evarr_right;
   delete hleft, hright, match;

   return rulelist;
}




/*
list <RULE*> PLGTS::gotoSecondLastPathRule(int counter, int helpcounter, list <char*> path_, char *helpvar, char *rulename, int mode, int &returnhelpcounter, char **returnrecordname)
*/
list <RULE*> PLGTS::gotoSecondLastPathRule(int counter, int helpcounter, list <char*> path_, char *helpvar, char *rulename, int mode, int &returnhelpcounter, char **returnrecordname)
{
   path_.pop_back();
   list <char*> path=path_;

   list <RULE*> rulelist;
   int length=path.size();
   assert(length>=1);
   if (mode<0 || mode>3)
      mode=0;

   char strcounter[MAX_COUNTER];
   sprintf(strcounter,"%d\0",counter);

   if (mode==0 || mode==1)
      helpcounter=1;

   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   RULE *rule=new(RULE);
   char *rulename_=catstrstr(rulename, " (add new help var)");
   rule->setName(addRuleID(rulename_));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName(hleftname);
   hright->setName(hrightname);

   list<char*>::iterator itr = path.begin();
   char name[strlen(*itr)+1];
   strcpy(name, *itr);
   char *recordname=getRecordName(symboltable,*itr);

   int id=1;


   //Hilfsvariable einfuegen
   //linke Seite
   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id));
   ve_left->setID(id);
   hleft->addVertex(*ve_left,ve_left->getID());
   id++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   if (mode==0 || mode==1) {
      ecounter_left->setLabel(strcounter);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   }
   else {
      char strhelpcounter[MAX_COUNTER];
      sprintf(strhelpcounter,"%d\0",helpcounter);
      ecounter_left->setLabel(catstrstr(catstrstr(strcounter,"#"),strhelpcounter));
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      helpcounter++;
   }
   id++;

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(name);
   evar_left->setIdLabel(catstrint("gel",id));
   evar_left->setID(id);
   list <IDTYPE> helpvarleftlist;
   helpvarleftlist.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),helpvarleftlist);
   id++;


   //rechte Seite

   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id));
   ve_right->setID(id);
   hright->addVertex(*ve_right,ve_right->getID());
   id++;

   if ((mode==0) || (mode==1)) {
      
      EDGE *ecounter_right=new(EDGE);
      if (length==1)
         ecounter_right->setLabel(catstrstr(strcounter,"_e"));
      else
         ecounter_right->setLabel(catstrstr(strcounter,"_"));
      ecounter_right->setIdLabel(catstrint("ger",id));
      ecounter_right->setID(id);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id++;
      delete ecounter_right;

      if (length >1) {
         EDGE *helpcounter_right=new(EDGE);
         helpcounter_right->setLabel(catstrstr(strcounter,"#1"));
         helpcounter_right->setIdLabel(catstrint("ger",id));
         helpcounter_right->setID(id);
         hright->addEdge(*helpcounter_right,helpcounter_right->getID(),lnull);
         id++;
         delete helpcounter_right;
      }
   }
   else {
      EDGE *helpcounter_right=new(EDGE);
      char strhelpcounter[MAX_COUNTER];
      sprintf(strhelpcounter,"%d\0",helpcounter);
      helpcounter_right->setLabel(catstrstr(catstrstr(strcounter,"#"),strhelpcounter));
      helpcounter_right->setIdLabel(catstrint("ger",id));
      helpcounter_right->setID(id);
      hright->addEdge(*helpcounter_right,helpcounter_right->getID(),lnull);
      id++;
      delete helpcounter_right;
   }

   EDGE *evar_right = new(EDGE);
   evar_right->setLabel(name);
   evar_right->setIdLabel(catstrint("ger",id));
   evar_right->setID(id);
   list <IDTYPE> helpvarrightlist;
   helpvarrightlist.push_back(ve_right->getID());
   hright->addEdge(*evar_right,evar_right->getID(),helpvarrightlist);
   id++;

   EDGE *ehelpvar = new(EDGE);
   ehelpvar->setLabel(helpvar);
   ehelpvar->setIdLabel(catstrint("ger",id));
   ehelpvar->setID(id);
   hright->addEdge(*ehelpvar,ehelpvar->getID(),helpvarrightlist);
   id++;

   MATCH *match=new MATCH();
   match->setMatch(ve_left->getID(),ve_right->getID());
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);
   rulelist.push_back(rule);
   *returnrecordname=recordname;
   if (length==1)
      return rulelist;

   length--;

   //Hilfsvariable aud die vorletzte Komponente 
   while (length > 1)
   {
      const char* helpcounter_left= catstrint(catstrstr(strcounter,"#"), helpcounter);
      helpcounter++;
      const char* helpcounter_right= catstrint(catstrstr(strcounter,"#"), helpcounter);
      itr++;
      RecordEntry *re= getRecordComp(symboltable, *itr, (char*)recordname);
      char *rulename_=catstrstr(rulename," (p:=p.comp)");
      RULE *lastRule=producePToPcompRule((char*)helpcounter_left,(char*)helpcounter_right, helpvar, *itr, recordname, rulename_);
      recordname = re->recordname;
      rulelist.push_back(lastRule);
      length--;
   }


   //letzte Regel
   {
   itr++;

   RULE *rule=new(RULE);
   char *rulename_=catstrstr(rulename," (p:=p.comp)");
   rule->setName(addRuleID(rulename_));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id=1;
   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;


   //linke Seite
   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id));
   ve_left->setID(id);
   hleft->addVertex(*ve_left,ve_left->getID());
   id++;

   EDGE *helpcounter_left=new(EDGE);
   char strhelpcounter[MAX_COUNTER];
   sprintf(strhelpcounter,"%d\0",helpcounter);
   helpcounter_left->setLabel(catstrstr(catstrstr(strcounter,"#"),strhelpcounter));
   helpcounter_left->setIdLabel(catstrint("gel",id));
   helpcounter_left->setID(id);
   hleft->addEdge(*helpcounter_left,helpcounter_left->getID(),lnull);
   id++;


   if (mode==0 || mode==2) {
      EDGE *ecounter=new(EDGE);
      ecounter->setLabel(catstrstr(strcounter,"_"));
      ecounter->setIdLabel(catstrint("gel",id));
      ecounter->setID(id);
      hleft->addEdge(*ecounter,ecounter->getID(),lnull);
      id++;
      delete ecounter;
   }

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(helpvar);
   evar_left->setIdLabel(catstrint("gel",id));
   evar_left->setID(id);
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),list_left);
   id++;

   int nextvertex;
   int edgeid_l=produceRecord(hleft, LEFTHAND, id, (char*)recordname, ve_left->getID(), *itr, nextvertex);

   list<IDTYPE> vertexlist_left = hleft->getConnectedVertices(edgeid_l);
   list<IDTYPE>::iterator itr_l = vertexlist_left.begin();
   while(itr_l != vertexlist_left.end())
   {
      leftmap.push_back(*itr_l);
      itr_l++;
   }
   helpcounter++;

   //rechte Seite
   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id));
   ve_right->setID(id);
   hright->addVertex(*ve_right,ve_right->getID());
   id++;
   //delete ve_right;

   if (mode==0 || mode==2)
   {
      EDGE *ecounterend=new(EDGE);
      ecounterend->setLabel(catstrstr(strcounter,"_e"));
      ecounterend->setIdLabel(catstrint("ger",id));
      ecounterend->setID(id);
      hright->addEdge(*ecounterend,ecounterend->getID(),lnull);
      id++;
      delete ecounterend;
   }
   else
   {
      EDGE *helpcounter_right=new(EDGE);
      char strhelpcounter[MAX_COUNTER];
      sprintf(strhelpcounter,"%d\0",helpcounter);
      helpcounter_right->setLabel(catstrstr(catstrstr(strcounter,"#"),strhelpcounter));
      helpcounter_right->setIdLabel(catstrint("ger",id));
      helpcounter_right->setID(id);
      hright->addEdge(*helpcounter_right,helpcounter_right->getID(),lnull);
      id++;
      helpcounter++;
      delete helpcounter_right;
   }

   int edgeid_r=produceRecord(hright, RIGHTHAND, id, (char*)recordname, ve_right->getID(), *itr, nextvertex);
   RecordEntry *re= getRecordComp(symboltable, *itr, (char*)recordname);
   *returnrecordname = re->recordname;

   EDGE *evar_right = new(EDGE);
   evar_right->setLabel(helpvar);
   evar_right->setIdLabel(catstrint("ger",id));
   evar_right->setID(id);
   list <IDTYPE> list_right;
   list_right.push_back(nextvertex);
   hright->addEdge(*evar_right,evar_right->getID(),list_right);
   id++;

   list<IDTYPE> vertexlist_right = hright->getConnectedVertices(edgeid_r);
   list<IDTYPE>::iterator itr_r = vertexlist_right.begin();
   while(itr_r != vertexlist_right.end())
   {
      rightmap.push_back(*itr_r);
      itr_r++;
   }


   //Match
   MATCH *match=new MATCH();
   list<IDTYPE>::iterator itr_right = rightmap.begin();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
   {
      match->setMatch(*itr_left,*itr_right);
      itr_right++;
   }
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);
   rulelist.push_back(rule);
   delete ve_left, ve_right, helpcounter_left, evar_left, evar_right;
   delete hleft, hright, match;
   }

   //error rule
   RULE *errorRule = produceError(catstrstr(strcounter, "_"),helpvar,catstrstr(rulename," (produce Error Rule)"));
   rulelist.push_back(errorRule);
   returnhelpcounter=helpcounter-1;

   delete ve_left, ve_right, ecounter_left, evar_left, evar_right, ehelpvar;
   delete hleft, hright, match;
   return rulelist;
}




/* 
int produceRecord(HYPERGRAPH *hg, GRAPHHAND graphhand, int &id, char *recordname, int vertexid)
*/
int PLGTS::produceRecord(HYPERGRAPH *hg, GRAPHHAND graphhand, int &id, char *recordname, int vertexid)
{

   if (hg==NULL)
      return -1;

   char ge[4];

   if (graphhand==LEFTHAND)
      strcpy(ge,"gel");
   else
      strcpy(ge,"ger");
 
   list <IDTYPE> list_rec;
   list_rec.push_back(vertexid);

   EDGE *erec = new (EDGE);
   erec->setLabel(recordname);
   erec->setIdLabel(catstrint(ge,id));
   erec->setID(id);
   id++;

   int d=1;
   RecordEntry *re=getNRecordComp(symboltable, recordname,d);
   if (re == NULL)
      return -1;

   while (re != NULL) {
      VERTEX *ve=new (VERTEX);
      ve->setIdLabel(catstrint(ge,id));
      ve->setID(id);
      hg->addVertex(*ve,ve->getID());
      list_rec.push_back(ve->getID());

      id++;
      re=getNRecordComp(symboltable, recordname,++d);
      delete ve;
   }

   hg->addEdge(*erec,erec->getID(),list_rec);
   int erecID= erec->getID();
   delete erec;
   return erecID;
}




/* 
int produceRecord(HYPERGRAPH *hg, GRAPHHAND graphhand, int &id, char *recordname, int vertexid, char *nextname, int &vertexnext)
*/
int PLGTS::produceRecord(HYPERGRAPH *hg, GRAPHHAND graphhand, int &id, char *recordname, int vertexid, char *nextname, int &vertexnext)
{

   if (hg==NULL)
      return -1;

   vertexnext=-1;
   char ge[4];

   if (graphhand==LEFTHAND)
      strcpy(ge,"gel");
   else
      strcpy(ge,"ger");
 
   list <IDTYPE> list_rec;
   list_rec.push_back(vertexid);

   EDGE *erec = new (EDGE);
   erec->setLabel(recordname);
   erec->setIdLabel(catstrint(ge,id));
   erec->setID(id);
   id++;

   int d=1;
   RecordEntry *re=getNRecordComp(symboltable, recordname,d);
   if (re == NULL)
      return -1;
   //printRecordEntry(re);cout <<endl;
   while (re != NULL) {
      VERTEX *ve=new (VERTEX);
      ve->setIdLabel(catstrint(ge,id));
      ve->setID(id);
      hg->addVertex(*ve,ve->getID());
      list_rec.push_back(ve->getID());

      if (strcmp(re->name,nextname)==0)
         vertexnext=ve->getID();

      id++;
      re=getNRecordComp(symboltable, recordname,++d);
      delete ve;
   }

   hg->addEdge(*erec,erec->getID(),list_rec);
   int erecID= erec->getID();
   delete erec;
   return erecID;
}




/* 
int produceRecordInit(HYPERGRAPH *hg, GRAPHHAND graphhand, int &id, char *recordname, int vertexid)
 */
int PLGTS::produceRecordInit(HYPERGRAPH *hg, GRAPHHAND graphhand, int &id, char *recordname, int vertexid)
{

   if (hg==NULL)
      return -1;
   char ge[4];

   if (graphhand==LEFTHAND)
      strcpy(ge,"gel");
   else
      strcpy(ge,"ger");

   list <IDTYPE> list_rec;
   list_rec.push_back(vertexid);

   EDGE *erec = new (EDGE);
   erec->setLabel(recordname);
   erec->setIdLabel(catstrint(ge,id));
   erec->setID(id);
   id++;

   int d=1;
   RecordEntry *re=getNRecordComp(symboltable, recordname,d);

   while (re != NULL) {
         switch (re->type) {
            case intType: {
               VERTEX *ve=new (VERTEX);
               ve->setIdLabel(catstrint(ge,id));
               ve->setID(id);
               hg->addVertex(*ve,ve->getID());
               list_rec.push_back(ve->getID());
               id++;

               EDGE *e=new (EDGE);
               e->setLabel("integer");
               e->setIdLabel(catstrint(ge,id));
               e->setID(id);
               TYPES types;
               types.push_back(INTEGER);
               e->setType(types);
               EXPRESSION *exp=new EXPRESSION(types, "0", "value");
               e->addAttributes(*exp);
               list <IDTYPE> list;
               list.push_back(ve->getID());
               hg->addEdge(*e,e->getID(),list);
               id++;
               delete ve, e, exp;
               break;
            }
            case strType: {
               VERTEX *ve=new (VERTEX);
               ve->setIdLabel(catstrint(ge,id));
               ve->setID(id);
               hg->addVertex(*ve,ve->getID());
               list_rec.push_back(ve->getID());
               id++;

               EDGE *e=new (EDGE);
               e->setLabel("string");
               e->setIdLabel(catstrint(ge,id));
               e->setID(id);
               TYPES types;
               types.push_back(STRING);
               e->setType(types);
               //EXPRESSION *exp=new EXPRESSION(types, "\"\"", "value");
	       EXPRESSION *exp=new EXPRESSION(types, "''", "value");
               e->addAttributes(*exp);
               list <IDTYPE> list;
               list.push_back(ve->getID());
               hg->addEdge(*e,e->getID(),list);
               id++;
               delete ve,e, exp;
               break;
            }
            case ptorecType: {
               VERTEX *ve=new (VERTEX);
               ve->setIdLabel(catstrint(ge,id));
               ve->setID(id);
               hg->addVertex(*ve,ve->getID());
               list_rec.push_back(ve->getID());
               id++;

               EDGE *e=new (EDGE);
               e->setLabel("null");
               e->setIdLabel(catstrint(ge,id));
               e->setID(id);
               list <IDTYPE> list;
               list.push_back(ve->getID());
               hg->addEdge(*e,e->getID(),list);
               id++;
               delete ve, e;
               break;
            }
         }
         d++;
         re=getNRecordComp(symboltable, recordname,d);
   }
   hg->addEdge(*erec,erec->getID(),list_rec);
   int erecID=erec->getID();
   delete erec;
   return erecID;
}




/*
   void PLGTS::produceDummyRule(int counter, char *rulename)
*/
void PLGTS::produceDummyRule(int counter, char *rulename)
{

   produceDummyRule(counter, counter+1, rulename);

}




/*
   void PLGTS::produceDummyRule(int counterleft, int counterright, char *rulename)
*/
void PLGTS::produceDummyRule(int counterleft, int counterright, char *rulename)
{
   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];
   sprintf(strcounter_l,"%d\0",counterleft);
   sprintf(strcounter_r,"%d\0",counterright);

   RULE *rule=new(RULE);
   rule->setName(addRuleID(rulename));

   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id=1;
   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   id=1;
   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   rule->setLeft(hleft);
   rule->setRight(hright);
   rule->setID(rule_counter++);

   GraphGrammar.addRule(rule);

   delete ecounter_left, ecounter_right; 
   delete hleft, hright, rule;

}




/*
RULE* PLGTS::produceError(int counter, char *varname, char *rulename)
*/
RULE* PLGTS::produceError(int counter, char *varname, char *rulename) {

   char strcounter[MAX_COUNTER];
   sprintf(strcounter,"%d\0",counter);
   return produceError(strcounter, varname, rulename);
}




/*
RULE* PLGTS::produceError(char *strcounter, char *varname, char *rulename)
*/
RULE* PLGTS::produceError(char *strcounter, char *varname, char *rulename) {

   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   RULE *ruleError=new(RULE);
   ruleError->setName(addRuleID(rulename));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName(hleftname);
   hright->setName(hrightname);

   int id_left, id_right;

   //linke Seite
   id_left=1;

   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id_left));
   ve_left->setID(id_left);
   hleft->addVertex(*ve_left,ve_left->getID());
   id_left++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter);
   ecounter_left->setIdLabel(catstrint("gel",id_left));
   ecounter_left->setID(id_left);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id_left++;

   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(varname);
   evar_left->setIdLabel(catstrint("gel",id_left));
   evar_left->setID(id_left);
   hleft->addEdge(*evar_left,evar_left->getID(),list_left);
   id_left++;

   EDGE *enull_left = new(EDGE);
   enull_left->setLabel("null");
   enull_left->setIdLabel(catstrint("gel",id_left));
   enull_left->setID(id_left);
   hleft->addEdge(*enull_left,enull_left->getID(),list_left);
   id_left++;

   //rechte Seite
   id_right=id_left;

   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id_right));
   ve_right->setID(id_right);
   hright->addVertex(*ve_right,ve_right->getID());
   id_right++;

   list <IDTYPE> list_right;
   list_right.push_back(ve_right->getID());

   EDGE *evar_right = new(EDGE);
   evar_right->setLabel(varname);
   evar_right->setIdLabel(catstrint("ger",id_right));
   evar_right->setID(id_right);
   hright->addEdge(*evar_right,evar_right->getID(),list_right);
   id_right++;

   EDGE *enull_right = new(EDGE);
   enull_right->setLabel("null");
   enull_right->setIdLabel(catstrint("ger",id_right));
   enull_right->setID(id_right);
   hright->addEdge(*enull_right,enull_right->getID(),list_right);
   id_right++;

   EDGE *eerror = new(EDGE);
   eerror->setLabel("error");
   eerror->setIdLabel(catstrint("ger",id_right));
   eerror->setID(id_right);
   hright->addEdge(*eerror,eerror->getID(),lnull);
   id_right++;

   MATCH *match=new MATCH();
   match->setMatch(ve_left->getID(),ve_right->getID());
   ruleError->setInterface(*match);

   ruleError->setLeft(hleft);
   ruleError->setRight(hright);
   delete ve_left, ve_right, ecounter_left, evar_left, evar_right, enull_left, eerror;
   delete hleft, hright, match;
   return ruleError;
}





//ALLGEMEINE REGEL fuer die Pointer-Zuweisung
//moegliche Zyklen in Pfaden werden nicht beruecksichtigt
/*
RULE* producePointerToPointerRule(int counter, list <char*> linke Seite, list <char*> rechte Seite, char *rulename)
*/
RULE* PLGTS::producePointerToPointerRule(int counterleft, int counterright, list <char*> lefthand, list <char*> righthand, char *rulename)
{

   char strcounter_l[MAX_COUNTER];
   char strcounter_r[MAX_COUNTER];
   sprintf(strcounter_l,"%d\0",counterleft);
   sprintf(strcounter_r,"%d\0",counterright);

   RULE *rule=new(RULE);
   rule->setName(addRuleID(rulename));

   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;
   int size_left = lefthand.size();
   int size_right = righthand.size();


   list<char*>::iterator itr_left = lefthand.begin();
   list<char*>::iterator itr_right = righthand.begin();

   char varname_left[strlen(*itr_left)+1];
   char varname_right[strlen(*itr_right)+1];
   strcpy(varname_left, *itr_left);
   strcpy(varname_right, *itr_right);

   char *recordname_first_left  = getRecordName(symboltable,varname_left);
   char *recordname_first_right = getRecordName(symboltable,varname_right);
   assert(recordname_first_left != NULL && recordname_first_right != NULL);

   //linke Seite
    //first
   char *recordname_left=recordname_first_left;
   char *recordname_right=recordname_first_right;

   itr_left++;
   itr_right++;

   int id=1;
   int pathselector_first=1;
   int pathselector_second=1;


   VERTEX *ve_first_left=new (VERTEX);
   ve_first_left->setIdLabel(catstrint("gel",id));
   ve_first_left->setID(id);
   hleft->addVertex(*ve_first_left,ve_first_left->getID());
   leftmap.push_back(ve_first_left->getID());
   id++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   EDGE *evar_first_left = new(EDGE);
   evar_first_left->setLabel(varname_left);
   evar_first_left->setIdLabel(catstrint("gel",id));
   evar_first_left->setID(id);
   list <IDTYPE> list_first_left;
   list_first_left.push_back(ve_first_left->getID());
   hleft->addEdge(*evar_first_left,evar_first_left->getID(),list_first_left);
   id++;
   pathselector_first++;
   int vertexid_left=ve_first_left->getID();

   while (pathselector_first<=size_left) {

      int nextve_left;
      int edgeid_first_l=produceRecord(hleft, LEFTHAND, id, (char*)recordname_left, vertexid_left, *itr_left, nextve_left);
      assert(edgeid_first_l != -1);
      vertexid_left=nextve_left;
      RecordEntry *re= getRecordComp(symboltable, *itr_left, recordname_left);
      assert (re != NULL);
      recordname_left=re->recordname;
      itr_left++;
      pathselector_first++;

      list<IDTYPE> vertexlist = hleft->getConnectedVertices(edgeid_first_l);
      list<IDTYPE>::iterator itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      {
         leftmap.push_back(*itr);
         itr++;
      }
   }

   //linke Seite
    //second
   VERTEX *ve_second_left=new (VERTEX);
   ve_second_left->setIdLabel(catstrint("gel",id));
   ve_second_left->setID(id);
   hleft->addVertex(*ve_second_left,ve_second_left->getID());
   leftmap.push_back(ve_second_left->getID());
   id++;

   EDGE *evar_second_left = new(EDGE);
   evar_second_left->setLabel(varname_right);
   evar_second_left->setIdLabel(catstrint("gel",id));
   evar_second_left->setID(id);
   list <IDTYPE> list_second_left;
   list_second_left.push_back(ve_second_left->getID());
   hleft->addEdge(*evar_second_left,evar_second_left->getID(),list_second_left);
   id++;

   pathselector_second++;
   int vertexid_right=ve_second_left->getID();
   int test_id;
   while (pathselector_second<=size_right) {

      int nextve_right;
      int edgeid_second_l=produceRecord(hleft, LEFTHAND, id, (char*)recordname_right, vertexid_right, *itr_right, nextve_right);
      assert(edgeid_second_l != -1);
      vertexid_right=nextve_right;
      test_id=edgeid_second_l;
      RecordEntry *re= getRecordComp(symboltable, *itr_right, recordname_right);
      assert (re != NULL);
      recordname_right=re->recordname;
      itr_right++;
      pathselector_second++;
      list<IDTYPE> vertexlist = hleft->getConnectedVertices(edgeid_second_l);
      list<IDTYPE>::iterator itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      {
         leftmap.push_back(*itr);
         itr++;
      }
   }

   //rechte Seite
    //first
   itr_left = lefthand.begin();
   itr_right = righthand.begin();

   recordname_left=recordname_first_left;
   recordname_right=recordname_first_right;

   pathselector_first=1;
   pathselector_second=1;
   id=1;

   itr_left++;
   itr_right++;

   VERTEX *ve_first_right=new (VERTEX);
   ve_first_right->setIdLabel(catstrint("ger",id));
   ve_first_right->setID(id);
   hright->addVertex(*ve_first_right,ve_first_right->getID());
   rightmap.push_back(ve_first_right->getID());
   id++;

   VERTEX *ve_new=new (VERTEX);
   ve_new->setIdLabel(catstrint("ger",id));
   ve_new->setID(id);
   hright->addVertex(*ve_new,ve_new->getID());
   id++;

   EDGE *evar_first_right = new(EDGE);
   evar_first_right->setLabel(varname_left);
   evar_first_right->setIdLabel(catstrint("ger",id));
   evar_first_right->setID(id);
   list <IDTYPE> list_first_right;
   list_first_right.push_back(ve_first_right->getID());
   hright->addEdge(*evar_first_right,evar_first_right->getID(),list_first_right);
   id++;

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;
   pathselector_first++;
   vertexid_left=ve_first_right->getID();
   int nextve_left=ve_first_right->getID();
   while (pathselector_first<=size_left) {

      int edgeid_first_r=produceRecord(hright, RIGHTHAND, id, (char*)recordname_left, vertexid_left, *itr_left, nextve_left);
      vertexid_left=nextve_left;

      RecordEntry *re= getRecordComp(symboltable, *itr_left, recordname_left);
      recordname_left=re->recordname;
      itr_left++;
      pathselector_first++;

      list<IDTYPE> vertexlist = hright->getConnectedVertices(edgeid_first_r);
      list<IDTYPE>::iterator itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      {

         if (pathselector_first==size_left+1) {
            if (*itr==nextve_left) 
               rightmap.push_back(ve_new->getID());
            else
               rightmap.push_back(*itr);
            itr++;
         }
         else {
            rightmap.push_back(*itr);
            itr++;
         }
      }
   }

   //rechte Seite
    //second

   VERTEX *ve_second_right=new (VERTEX);
   ve_second_right->setIdLabel(catstrint("ger",id));
   ve_second_right->setID(id);
   hright->addVertex(*ve_second_right,ve_second_right->getID());
   id++;

   EDGE *evar_second_right = new(EDGE);
   evar_second_right->setLabel(varname_right);
   evar_second_right->setIdLabel(catstrint("ger",id));
   evar_second_right->setID(id);
   list <IDTYPE> list_second_right;
   list_second_right.push_back(ve_second_right->getID());
   if (size_right==1) {
      hright->addEdge(*evar_second_right,evar_second_right->getID(),lnull);
      hright->addEdgeToCE(nextve_left, evar_second_right->getID());
      rightmap.push_back((int)nextve_left);
   }
   else {
      hright->addEdge(*evar_second_right,evar_second_right->getID(),list_second_right);
      rightmap.push_back(ve_second_right->getID());
   }
   id++;

   pathselector_second++;
   vertexid_right=ve_second_right->getID();
   int nextve_right=ve_second_right->getID();


   while (pathselector_second<size_right) {

      int edgeid_second_r=produceRecord(hright, RIGHTHAND, id, (char*)recordname_right, vertexid_right, *itr_right, nextve_right);
      vertexid_right=nextve_right;

      RecordEntry *re= getRecordComp(symboltable, *itr_right, recordname_right);
      recordname_right=re->recordname;
      itr_right++;
      pathselector_second++;

      list<IDTYPE> vertexlist = hright->getConnectedVertices(edgeid_second_r);
      list<IDTYPE>::iterator itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      { 
         rightmap.push_back(*itr);
         itr++;
      }

   }
   if (pathselector_second==size_right) {

      EDGE *edgerec = new (EDGE);
      edgerec->setLabel(recordname_right);
      edgerec->setIdLabel(catstrint("ger",id));
      edgerec->setID(id);
      id++;

      int d=1;
      list <IDTYPE> list_rec;
      list_rec.push_back(nextve_right);
      RecordEntry *re=getNRecordComp(symboltable, recordname_right,d);

      while (re != NULL) {
         if (strcmp(re->name, *itr_right)==0) {
            //hright->addEdgeToCE(edgerec->getID(),nextve_left);
            list_rec.push_back(nextve_left);
            rightmap.push_back(nextve_left);
         }
         else {
            VERTEX *ve=new (VERTEX);
            ve->setIdLabel(catstrint("ger",id));
            ve->setID(id);
            hright->addVertex(*ve,ve->getID());
            list_rec.push_back(ve->getID());
            rightmap.push_back(ve->getID());
            id++;
         }
         re=getNRecordComp(symboltable, recordname_right,++d);
      }
      hright->addEdge(*edgerec,edgerec->getID(),list_rec);
   }


   //Match
   MATCH *match=new MATCH();
   list<IDTYPE>::iterator itr_right_map = rightmap.begin();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
   {
      match->setMatch(*itr_left,*itr_right_map);
      itr_right_map++;
   }
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);

   delete ve_first_left, ve_second_left, ve_first_right, ve_second_right, ve_new, ecounter_left, evar_first_left,  evar_second_left, evar_first_right, ecounter_right,  evar_second_right;
   delete hleft, hright, match;
   return rule;
}




//ALLGEMEINE Regel 
//moegliche Zyklen in Pfaden werden nicht beruecksichtigt
/*
list <RULE*> produceErrorRule(int counter, list <char*> path)
*/
list <RULE*> PLGTS::produceErrorRule(int counter, list <char*> path) {

   int size=path.size();
   list <RULE*> rulelist;
   if (size==1)
      return rulelist;

   char strcounter[MAX_COUNTER];
   sprintf(strcounter,"%d\0",counter);

   int id_l=1;
   int id_r=1;
   int pathselector=1;

   RULE *rule=new(RULE);
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);

   vector <int> leftmap;
   vector <int> rightmap;

   list<char*>::iterator itr = path.begin();
   char **varname=&*itr;
   char *recordname=(char*)getRecordName(symboltable,*varname);
   itr++;


   //linke Seite
   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id_l));
   ve_left->setID(id_l);
   hleft->addVertex(*ve_left,ve_left->getID());
   leftmap.push_back(ve_left->getID());
   id_l++;

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(*varname);
   evar_left->setIdLabel(catstrint("gel",id_l));
   evar_left->setID(id_l);
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),list_left);
   id_l++;

   EDGE *enull_left = new(EDGE);
   enull_left->setLabel("null");
   enull_left->setIdLabel(catstrint("gel",id_l));
   enull_left->setID(id_l);
   list <IDTYPE> list_lnull;
   list_lnull.push_back(ve_left->getID());
   hleft->addEdge(*enull_left,enull_left->getID(),list_lnull);
   id_l++;

   EDGE *ecounter=new(EDGE);
   ecounter->setLabel(strcounter);
   ecounter->setIdLabel(catstrint("gel",id_l));
   ecounter->setID(id_l);
   hleft->addEdge(*ecounter,ecounter->getID(),lnull);
   id_l++;


   //rechte Seite
   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id_r));
   ve_right->setID(id_r);
   hright->addVertex(*ve_right,ve_right->getID());
   rightmap.push_back(ve_right->getID());
   id_r++;

   EDGE *evar_right = new(EDGE);
   evar_right->setLabel(*varname);
   evar_right->setIdLabel(catstrint("ger",id_r));
   evar_right->setID(id_r);
   list <IDTYPE> list_right;
   list_right.push_back(ve_right->getID());
   hright->addEdge(*evar_right,evar_right->getID(),list_right);
   id_r++;

   EDGE *enull_right = new(EDGE);
   enull_right->setLabel("null");
   enull_right->setIdLabel(catstrint("ger",id_r));
   enull_right->setID(id_r);
   list <IDTYPE> list_rnull;
   list_rnull.push_back(ve_right->getID());
   hright->addEdge(*enull_right,enull_right->getID(),list_rnull);
   id_r++;

   EDGE *eerror = new(EDGE);
   eerror->setLabel("error");
   eerror->setIdLabel(catstrint("ger",id_r));
   eerror->setID(id_r);
   hright->addEdge(*eerror,eerror->getID(),lnull);
   id_r++;


   int vertexid_left=ve_left->getID();
   int vertexid_right=ve_right->getID();

   rule->setLeft(hleft);
   rule->setRight(hright);
   char *rulename_=catstrint("ruleerror",pathselector);
   rule->setName(addRuleID(rulename_));
   rule->setID(1+pathselector);


   //Match
   MATCH *match=new MATCH();
   match->setMatch(ve_left->getID(),ve_right->getID());
   rule->setInterface(*match);
   rulelist.push_back(rule);



   pathselector++;

   while (pathselector <size) {

      hleft->deleteEdge(enull_left->getID());
      hright->deleteEdge(enull_right->getID());

      hleft->setName(catstrint("left", pathselector));
      hright->setName(catstrint("right", pathselector));
      int nextve_left, nextve_right;

      //linke Seite
      int edgeid_l=produceRecord(hleft, LEFTHAND, id_l, (char*)recordname, vertexid_left, *itr, nextve_left);
      vertexid_left=nextve_left;
      EDGE *enull_left = new(EDGE);
      enull_left->setLabel("null");
      enull_left->setIdLabel(catstrint("gel",id_l));
      enull_left->setID(id_l);
      list <IDTYPE> list_left;
      list_left.push_back(vertexid_left);
      hleft->addEdge(*enull_left,enull_left->getID(),list_left);

      list<IDTYPE> vertexlistleft = hleft->getConnectedVertices(edgeid_l);
      list<IDTYPE>::iterator itr_l = vertexlistleft.begin();
      while(itr_l != vertexlistleft.end()) {
            leftmap.push_back(*itr_l);
            itr_l++;
      }
      id_l++;

      //rechte Seite
      int edgeid_r=produceRecord(hright, RIGHTHAND, id_r, (char*)recordname, vertexid_right, *itr, nextve_right);
      vertexid_right=nextve_right;
      EDGE *enull_right = new(EDGE);
      enull_right->setLabel("null");
      enull_right->setIdLabel(catstrint("ger",id_r));
      enull_right->setID(id_r);
      list <IDTYPE> list_right;
      list_right.push_back(vertexid_right);
      hright->addEdge(*enull_right,enull_right->getID(),list_right);
      list<IDTYPE> vertexlistright = hright->getConnectedVertices(edgeid_r);
      list<IDTYPE>::iterator itr_r = vertexlistright.begin();
      while(itr_r != vertexlistright.end()) {
            rightmap.push_back(*itr_r);
            itr_r++;
      }
      id_r++;

      RecordEntry *re= getRecordComp(symboltable, *itr, recordname);
      recordname=re->recordname;
      itr++;

      rule->setLeft(hleft);
      rule->setRight(hright);
      char *rulename_=catstrint("ruleerror",pathselector);
      rule->setName(addRuleID(rulename_));
      rule->setID(1+pathselector);

      //Match
      MATCH *match=new MATCH();
      vector<int>::iterator itr_right = rightmap.begin();
      for(vector<int>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
      {
         match->setMatch(*itr_left,*itr_right);
         itr_right++;
      }
      rule->setInterface(*match);

      rulelist.push_back(rule);
      pathselector++;
      hleft->deleteEdge(enull_left->getID());
      hright->deleteEdge(enull_right->getID());

      delete enull_left, enull_right;
      delete match;

   }

   delete ve_left, ve_right, evar_left, evar_right, enull_left, enull_right, ecounter, eerror; 
   delete hleft, hright, match;
   return rulelist;
}




/*
int PLGTS::produceVar(HYPERGRAPH *hg, GRAPHHAND graphhand, int &id, char *varname, char *attrvalue, char *type)
*/
int PLGTS::produceVar(HYPERGRAPH *hg, GRAPHHAND graphhand, int &id, char *varname, char *attrvalue, char *type)
{

   char ge[4];
   if (graphhand==LEFTHAND)
      strcpy(ge,"gel");
   else
      strcpy(ge,"ger");

   VERTEX *ve=new (VERTEX);
   ve->setIdLabel(catstrint(ge,id));
   ve->setID(id);
   hg->addVertex(*ve,ve->getID());
   id++;

   list <IDTYPE> list;
   list.push_back(ve->getID());

   EDGE *evar = new(EDGE);
   evar->setLabel(varname);
   evar->setIdLabel(catstrint(ge,id));
   evar->setID(id);
   hg->addEdge(*evar,evar->getID(),list);
   id++;


   EDGE *evartype = new(EDGE);
   evartype->setLabel(type);
   evartype->setIdLabel(catstrint(ge,id));
   evartype->setID(id);
   if (strcmp(type, "integer")==0) {
      TYPES types;
      types.push_back(INTEGER);
      evartype->setType(types);
      EXPRESSION *exp=new EXPRESSION(types, attrvalue, "value");
      evartype->addAttributes(*exp);
      delete exp;
   }
   else {
      TYPES types;
      types.push_back(STRING);
      evartype->setType(types);
      replaceSemicolon(attrvalue);
      EXPRESSION *exp=new EXPRESSION(types,attrvalue, "value");
      evartype->addAttributes(*exp);
      delete exp;
   }
   hg->addEdge(*evartype,evartype->getID(),list);
   id++;

   delete ve, evar, evartype;
   return 1;
}




/*
int PLGTS::producePVar(HYPERGRAPH *hg, GRAPHHAND graphhand, int &id, char *varname, char *recordcomp, char *recordname, char *attrvalue, char *type)
*/

int PLGTS::producePVar(HYPERGRAPH *hg, GRAPHHAND graphhand, int &id, char *varname, char *recordcomp, char *recordname, char *attrvalue, char *type)
{
   char ge[4];
   if (graphhand==LEFTHAND)
      strcpy(ge,"gel");
   else
      strcpy(ge,"ger");

   VERTEX *ve=new (VERTEX);
   ve->setIdLabel(catstrint(ge,id));
   ve->setID(id);
   hg->addVertex(*ve,ve->getID());
   id++;

   list <IDTYPE> listve;
   listve.push_back(ve->getID());

   EDGE *evar = new(EDGE);
   evar->setLabel(varname);
   evar->setIdLabel(catstrint(ge,id));
   evar->setID(id);
   hg->addEdge(*evar,evar->getID(),listve);
   id++;

   int vertexnext =-1;
   int vertexid=produceRecord(hg, graphhand, id, recordname, ve->getID(), recordcomp, vertexnext);
   assert(vertexnext != -1);
   list<IDTYPE> listnext;
   listnext.push_back(vertexnext);

   EDGE *evartype = new(EDGE);
   evartype->setLabel(type);
   evartype->setIdLabel(catstrint(ge,id));
   evartype->setID(id);

 
   if (strcmp(type, "integer")==0) {
      TYPES types;
      types.push_back(INTEGER);
      evartype->setType(types);
      EXPRESSION *exp=new EXPRESSION(types, attrvalue, "value");
      evartype->addAttributes(*exp);
      delete exp;
   }
   else {
      TYPES types;
      types.push_back(STRING);
      evartype->setType(types);
      replaceSemicolon(attrvalue);
      EXPRESSION *exp=new EXPRESSION(types, attrvalue, "value");
      evartype->addAttributes(*exp);
      delete exp;
   }
   hg->addEdge(*evartype,evartype->getID(),listnext);
   id++;

   delete ve, evar, evartype;
   return vertexid;
}




/*
RULE *producePToPRule(char *strcounter_l, char *strcounter_r, char *varnameleft, char *varnameright, char *rulename, bool deleteleftvar, bool deleterightvar)
*/
RULE* PLGTS::producePToPRule(char *strcounter_l, char *strcounter_r, char *varnameleft, char *varnameright, char *rulename, bool deletevarleft, bool deletevarright) {


   RULE *rule=new(RULE);
   rule->setName(addRuleID(rulename));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id=1;

   //linke Seite
   VERTEX *vep1=new (VERTEX);
   vep1->setIdLabel(catstrint("gel",id));
   vep1->setID(id);
   hleft->addVertex(*vep1,vep1->getID());
   id++;

   VERTEX *vep2=new (VERTEX);
   vep2->setIdLabel(catstrint("gel",id));
   vep2->setID(id);
   hleft->addVertex(*vep2,vep2->getID());
   id++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   EDGE *evar1_left = new(EDGE);
   evar1_left->setLabel(varnameleft);
   evar1_left->setIdLabel(catstrint("gel",id));
   evar1_left->setID(id);
   list <IDTYPE> list1_left;
   list1_left.push_back(vep1->getID());
   hleft->addEdge(*evar1_left,evar1_left->getID(),list1_left);
   id++;

   EDGE *evar2_left = new(EDGE);
   evar2_left->setLabel(varnameright);
   evar2_left->setIdLabel(catstrint("gel",id));
   evar2_left->setID(id);
   list <IDTYPE> list2_left;
   list2_left.push_back(vep2->getID());
   hleft->addEdge(*evar2_left,evar2_left->getID(),list2_left);
   id++;

   //rechte Seite

   VERTEX *venew=new (VERTEX);
   venew->setIdLabel(catstrint("ger",id));
   venew->setID(id);
   hright->addVertex(*venew,venew->getID());
   id++;

   VERTEX *vep1p2=new (VERTEX);
   vep1p2->setIdLabel(catstrint("ger",id));
   vep1p2->setID(id);
   hright->addVertex(*vep1p2,vep1p2->getID());
   id++;

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   list <IDTYPE> list_right;
   if (!deletevarleft) {
      EDGE *evar1_right = new(EDGE);
      evar1_right->setLabel(varnameleft);
      evar1_right->setIdLabel(catstrint("ger",id));
      evar1_right->setID(id);
      list_right.push_back(vep1p2->getID());
      hright->addEdge(*evar1_right,evar1_right->getID(),list_right);
      id++;
      delete evar1_right;
   }
   if (!deletevarright) {
      EDGE *evar2_right = new(EDGE);
      evar2_right->setLabel(varnameright);
      evar2_right->setIdLabel(catstrint("ger",id));
      evar2_right->setID(id);
      hright->addEdge(*evar2_right,evar2_right->getID(),list_right);
      id++;
      delete evar2_right;
   }

   MATCH *match=new MATCH();
   match->setMatch(vep1->getID(),venew->getID());
   match->setMatch(vep2->getID(), vep1p2->getID());
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);
   delete vep1, vep2, venew, vep1p2, evar1_left, evar2_left, ecounter_left, ecounter_right;
   delete hleft, hright, match;
   return rule;

}




/*
RULE *producePToPcompRule(char *counterleft, char *counterright, char *varname, char *recordcomp, char *recordname, char *rulename)
*/
RULE *PLGTS::producePToPcompRule(char *strcounter_l, char *strcounter_r, char *varname, char *recordcomp, char *recordname, char *rulename, bool deletevar)
{

   assert(getSymbol(symboltable, recordname) != NULL);

   RULE *rule=new(RULE);
   rule->setName(addRuleID(rulename));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id=1;
   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;


   //linke Seite
   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id));
   ve_left->setID(id);
   hleft->addVertex(*ve_left,ve_left->getID());
   id++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(varname);
   evar_left->setIdLabel(catstrint("gel",id));
   evar_left->setID(id);
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),list_left);
   id++;

   int nextvertex;
   int edgeid_l=produceRecord(hleft, LEFTHAND, id, recordname, ve_left->getID(), recordcomp, nextvertex);

   list<IDTYPE> vertexlist_left = hleft->getConnectedVertices(edgeid_l);
   list<IDTYPE>::iterator itr_l = vertexlist_left.begin();
   while(itr_l != vertexlist_left.end())
   {
      leftmap.push_back(*itr_l);
      itr_l++;
   }

   //rechte Seite
   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id));
   ve_right->setID(id);
   hright->addVertex(*ve_right,ve_right->getID());
   id++;

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   int edgeid_r=produceRecord(hright, RIGHTHAND, id, recordname, ve_right->getID(), recordcomp, nextvertex);

   if (!deletevar) {
      EDGE *evar_right = new(EDGE);
      evar_right->setLabel(varname);
      evar_right->setIdLabel(catstrint("ger",id));
      evar_right->setID(id);
      list <IDTYPE> list_right;
      list_right.push_back(nextvertex);
      hright->addEdge(*evar_right,evar_right->getID(),list_right);
      id++;
      delete evar_right;
   }

   list<IDTYPE> vertexlist_right = hright->getConnectedVertices(edgeid_r);
   list<IDTYPE>::iterator itr_r = vertexlist_right.begin();
   while(itr_r != vertexlist_right.end())
   {
      rightmap.push_back(*itr_r);
      itr_r++;
   }


   //Match

   MATCH *match=new MATCH();
   list<IDTYPE>::iterator itr_right = rightmap.begin();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
   {
      match->setMatch(*itr_left,*itr_right);
      itr_right++;
   }
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);

   delete ecounter_left, ecounter_right, evar_left, ve_left, ve_right;
   delete hleft, hright, match;
   return rule;

}




/*
RULE *producePiToPjcompRule(int counter, char *varleft, char *recordcomp, char *recordname, char *varright, char *rulename,int deletepi, int deletepj)
Pi := Pj.comp
*/
RULE *PLGTS::producePiToPjcompRule(char *strcounter_l, char *strcounter_r, char *varleft, char *varright, char *recordcomp, char *recordname, char *rulename, bool deletepi, bool deletepj)
{

   if (strcmp(varleft,varright)==0)
      return producePToPcompRule(strcounter_l, strcounter_r, varleft, recordcomp, recordname, rulename, deletepi);

   RULE *rule=new(RULE);
   rule->setName(addRuleID(rulename));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id=1;

   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;

   //linke Seite
   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   VERTEX *vepi_left=new (VERTEX);
   vepi_left->setIdLabel(catstrint("gel",id));
   vepi_left->setID(id);
   hleft->addVertex(*vepi_left,vepi_left->getID());
   id++;
   leftmap.push_back(vepi_left->getID());

   EDGE *evarpi_left = new(EDGE);
   evarpi_left->setLabel(varleft);
   evarpi_left->setIdLabel(catstrint("gel",id));
   evarpi_left->setID(id);
   list <IDTYPE> listpi_left;
   listpi_left.push_back(vepi_left->getID());
   hleft->addEdge(*evarpi_left,evarpi_left->getID(),listpi_left);
   id++;

   VERTEX *vepj_left=new (VERTEX);
   vepj_left->setIdLabel(catstrint("gel",id));
   vepj_left->setID(id);
   hleft->addVertex(*vepj_left,vepj_left->getID());
   id++;

   EDGE *evarpj_left = new(EDGE);
   evarpj_left->setLabel(varright);
   evarpj_left->setIdLabel(catstrint("gel",id));
   evarpj_left->setID(id);
   list <IDTYPE> listpj_left;
   listpj_left.push_back(vepj_left->getID());
   hleft->addEdge(*evarpj_left,evarpj_left->getID(),listpj_left);
   id++;

   int nextvertex;
   int edgeid_left=produceRecord(hleft, LEFTHAND, id, recordname, vepj_left->getID(), recordcomp, nextvertex);


   list<IDTYPE> vertexlist_left = hleft->getConnectedVertices(edgeid_left);

   list<IDTYPE>::iterator itr_left = vertexlist_left.begin();
   while(itr_left != vertexlist_left.end())
   {
      leftmap.push_back(*itr_left);
      itr_left++;
   }

   //rechte Seite
   VERTEX *vepj_right=new (VERTEX);
   vepj_right->setIdLabel(catstrint("ger",id));
   vepj_right->setID(id);
   hright->addVertex(*vepj_right,vepj_right->getID());
   id++;

   VERTEX *venew=new (VERTEX);
   venew->setIdLabel(catstrint("ger",id));
   venew->setID(id);
   hright->addVertex(*venew,venew->getID());
   id++;
   rightmap.push_back(venew->getID());

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   int edgeid_right=produceRecord(hright, RIGHTHAND, id, recordname, vepj_right->getID(), recordcomp, nextvertex);

   if (!deletepi) {
      EDGE *evarpi_right = new(EDGE);
      evarpi_right->setLabel(varleft);
      evarpi_right->setIdLabel(catstrint("ger",id));
      evarpi_right->setID(id);
      list <IDTYPE> listpi_right;
      listpi_right.push_back(nextvertex);
      hright->addEdge(*evarpi_right,evarpi_right->getID(),listpi_right);
      id++;
      delete evarpi_right;
   }
   if (!deletepj) {
      EDGE *evarpj_right = new(EDGE);
      evarpj_right->setLabel(varright);
      evarpj_right->setIdLabel(catstrint("ger",id));
      evarpj_right->setID(id);
      list <IDTYPE> listpj_right;
      listpj_right.push_back(vepj_right->getID());
      hright->addEdge(*evarpj_right,evarpj_right->getID(),listpj_right);
      id++;
      delete evarpj_right;
   }

   list<IDTYPE> vertexlist_right = hright->getConnectedVertices(edgeid_right);
   list<IDTYPE>::iterator itr_right = vertexlist_right.begin();
   while(itr_right != vertexlist_right.end())
   {
      rightmap.push_back(*itr_right);
      itr_right++;
   }

  //Match
   MATCH *match=new MATCH();
   list<IDTYPE>::iterator itr_right_ = rightmap.begin();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
   {
      match->setMatch(*itr_left,*itr_right_);
      itr_right_++;
   }
   rule->setInterface(*match);

 
   rule->setLeft(hleft);
   rule->setRight(hright);
   delete vepi_left, vepj_left, vepj_right, venew, evarpi_left, evarpj_left, ecounter_left, ecounter_right, 
   delete hleft, hright, match;
   return rule;
}




/*
RULE *producePcompToPRule(char *strcounter_l, char *strcounter_r, char *varname, char *recordcomp, char *recordname, char *rulename)

varname.recordcomp := varname
varname ist Pointe auf Record recordname
*/
RULE* PLGTS::producePcompToPRule(char *strcounter_l, char *strcounter_r, char *varname, char *recordcomp, char *recordname, char *rulename, bool deletevarright)
{

   RULE *rule=new(RULE);
   rule->setName(addRuleID(rulename));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id=1;

   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;

   //linke Seite
   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id));
   ve_left->setID(id);
   hleft->addVertex(*ve_left,ve_left->getID());
   id++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(varname);
   evar_left->setIdLabel(catstrint("gel",id));
   evar_left->setID(id);
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),list_left);
   id++;

   int nextvertex;
   int edgeid_left=produceRecord(hleft, LEFTHAND, id, recordname, ve_left->getID(), recordcomp, nextvertex);

   list<IDTYPE> vertexlist_left = hleft->getConnectedVertices(edgeid_left);
   list<IDTYPE>::iterator itr_left = vertexlist_left.begin();
   while(itr_left != vertexlist_left.end())
   {
      leftmap.push_back(*itr_left);
      itr_left++;
   }

   //rechte Seite
   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id));
   ve_right->setID(id);
   hright->addVertex(*ve_right,ve_right->getID());
   rightmap.push_back(ve_right->getID());
   id++;

   VERTEX *ve_new=new (VERTEX);
   ve_new->setIdLabel(catstrint("ger",id));
   ve_new->setID(id);
   hright->addVertex(*ve_new,ve_new->getID());
   id++;

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   if (!deletevarright)
   {
      EDGE *evar_right = new(EDGE);
      evar_right->setLabel(varname);
      evar_right->setIdLabel(catstrint("ger",id));
      evar_right->setID(id);
      list <IDTYPE> list_right;
      list_right.push_back(ve_right->getID());
      hright->addEdge(*evar_right,evar_right->getID(),list_right);
      id++;
      delete evar_right;
   }

   EDGE *erec = new (EDGE);
   erec->setLabel(recordname);
   erec->setIdLabel(catstrint("ger",id));
   erec->setID(id);
   id++;

   int d=1;
   list <IDTYPE> list_rec;
   list_rec.push_back(ve_right->getID());

   RecordEntry *re=getNRecordComp(symboltable, recordname,d);
   while (re != NULL) {
      if (strcmp(re->name,recordcomp)==0) {
         list_rec.push_back(ve_right->getID());
         rightmap.push_back(ve_new->getID());
      }
      else {
         VERTEX *ve=new (VERTEX);
         ve->setIdLabel(catstrint("ger",id));
         ve->setID(id);
         hright->addVertex(*ve,ve->getID());
         list_rec.push_back(ve->getID());
         rightmap.push_back(ve->getID());
         id++;
         delete ve;
      }
      re=getNRecordComp(symboltable, recordname,++d);
   }

   hright->addEdge(*erec,erec->getID(),list_rec);


  //Match
   MATCH *match=new MATCH();
   list<IDTYPE>::iterator itr_right = rightmap.begin();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
   {
      match->setMatch(*itr_left,*itr_right);
      itr_right++;
   }
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);
   delete ve_left, ve_new, ecounter_left, ecounter_right, erec;
   delete hleft, hright, match;
   return rule;
}




/*
RULE *producePicompToPjRule(char *strcounter_l, char *strcounter_r, char *varleft, char *recordcomp, char *recordname, char *varright, char *rulename,int deletepi, int deletepj)
*/
RULE *PLGTS::producePicompToPjRule(char *strcounter_l, char *strcounter_r, char *varleft, char *recordcomp, char *recordname, char *varright, char *rulename,bool deletepi, bool deletepj)
{

   if (strcmp(varleft,varright)==0)
      return producePcompToPRule(strcounter_l, strcounter_r, varleft, recordcomp, recordname, rulename);

   RULE *rule=new(RULE);
   rule->setName(addRuleID(rulename));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   int id=1;

   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;

   //linke Seite
   VERTEX *vepi_left=new (VERTEX);
   vepi_left->setIdLabel(catstrint("gel",id));
   vepi_left->setID(id);
   hleft->addVertex(*vepi_left,vepi_left->getID());
   id++;

   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   EDGE *evarpi_left = new(EDGE);
   evarpi_left->setLabel(varleft);
   evarpi_left->setIdLabel(catstrint("gel",id));
   evarpi_left->setID(id);
   list <IDTYPE> listpi_left;
   listpi_left.push_back(vepi_left->getID());
   hleft->addEdge(*evarpi_left,evarpi_left->getID(),listpi_left);
   id++;


   int nextvertex;
   int edgeid_left=produceRecord(hleft, LEFTHAND, id, recordname, vepi_left->getID(), recordcomp, nextvertex);

   list<IDTYPE> vertexlist_left = hleft->getConnectedVertices(edgeid_left);
   list<IDTYPE>::iterator itr_left = vertexlist_left.begin();
   while(itr_left != vertexlist_left.end())
   {
      leftmap.push_back(*itr_left);
      itr_left++;
   }

   VERTEX *vepj_left=new (VERTEX);
   vepj_left->setIdLabel(catstrint("gel",id));
   vepj_left->setID(id);
   hleft->addVertex(*vepj_left,vepj_left->getID());
   id++;

   EDGE *evarpj_left = new(EDGE);
   evarpj_left->setLabel(varright);
   evarpj_left->setIdLabel(catstrint("gel",id));
   evarpj_left->setID(id);
   list <IDTYPE> listpj_left;
   listpj_left.push_back(vepj_left->getID());
   hleft->addEdge(*evarpj_left,evarpj_left->getID(),listpj_left);
   id++;

   leftmap.push_back(vepj_left->getID());


   //rechte Seite
   VERTEX *vepi_right=new (VERTEX);
   vepi_right->setIdLabel(catstrint("ger",id));
   vepi_right->setID(id);
   hright->addVertex(*vepi_right,vepi_right->getID());
   id++;

   VERTEX *vepj_right=new (VERTEX);
   vepj_right->setIdLabel(catstrint("ger",id));
   vepj_right->setID(id);
   hright->addVertex(*vepj_right,vepj_right->getID());
   id++;

   VERTEX *venew=new (VERTEX);
   venew->setIdLabel(catstrint("ger",id));
   venew->setID(id);
   hright->addVertex(*venew,venew->getID());
   id++;

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   if (!deletepi) {
      EDGE *evarpi_right = new(EDGE);
      evarpi_right->setLabel(varleft);
      evarpi_right->setIdLabel(catstrint("ger",id));
      evarpi_right->setID(id);
      list <IDTYPE> listpi_right;
      listpi_right.push_back(vepi_right->getID());
      hright->addEdge(*evarpi_right,evarpi_right->getID(),listpi_right);
      id++;
      delete evarpi_right;
   }
   if (!deletepj) {
      EDGE *evarpj_right = new(EDGE);
      evarpj_right->setLabel(varright);
      evarpj_right->setIdLabel(catstrint("ger",id));
      evarpj_right->setID(id);
      list <IDTYPE> listpj_right;
      listpj_right.push_back(vepj_right->getID());
      hright->addEdge(*evarpj_right,evarpj_right->getID(),listpj_right);
      id++;
      delete evarpj_right;
   }

   EDGE *erec = new (EDGE);
   erec->setLabel(recordname);
   erec->setIdLabel(catstrint("ger",id));
   erec->setID(id);
   id++;

   int d=1;
   list <IDTYPE> list_rec;
   list_rec.push_back(vepi_right->getID());
   rightmap.push_back(vepi_right->getID());

   RecordEntry *re=getNRecordComp(symboltable, recordname,d);
   while (re != NULL) {
      if (strcmp(re->name,recordcomp)==0) {
         hright->addVertex(*vepj_right,vepj_right->getID());
         list_rec.push_back(vepj_right->getID());
         rightmap.push_back(venew->getID());
      }
      else {
         VERTEX *ve=new (VERTEX);
         ve->setIdLabel(catstrint("ger",id));
         ve->setID(id);
         hright->addVertex(*ve,ve->getID());
         list_rec.push_back(ve->getID());
         rightmap.push_back(ve->getID());
         id++;
         delete ve;
      }
      re=getNRecordComp(symboltable, recordname,++d);
   }
   rightmap.push_back(vepj_right->getID());
   hright->addEdge(*erec,erec->getID(),list_rec);

  //Match
   MATCH *match=new MATCH();
   list<IDTYPE>::iterator itr_right = rightmap.begin();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
   {
      match->setMatch(*itr_left,*itr_right);
      itr_right++;
   }
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);

   delete vepi_left, vepj_left, vepi_right, vepj_right,venew, ecounter_left, ecounter_right,  evarpi_left, evarpj_left, erec;
   delete hleft, hright, match;
   return rule;

}




/*
RULE* produceNEWPcompRule(int counter, char *varname, char *recordcomp, char *recordname, char *rulename, bool deleterightvar)
*/

RULE* PLGTS::produceNEWPcompRule(char *strcounter_l, char *strcounter_r, char *varname, char *recordcomp, char *recordname, char *rulename, bool deleterightvar)
{

   RULE *rule=new(RULE);
   rule->setName(addRuleID(rulename));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;

   int id=1;
   int vertexnext = -1;

   //linke Seite
   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id));
   ve_left->setID(id);
   hleft->addVertex(*ve_left,ve_left->getID());
   id++;

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(varname);
   evar_left->setIdLabel(catstrint("gel",id));
   evar_left->setID(id);
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),list_left);
   id++;
   leftmap.push_back(ve_left->getID());

   int edge_id=produceRecord(hleft, LEFTHAND, id, recordname, ve_left->getID(), recordcomp, vertexnext);
   list<IDTYPE> vertexlist = hleft->getConnectedVertices(edge_id);
   list<IDTYPE>::iterator itr = vertexlist.begin();
   itr++;
   while(itr != vertexlist.end())
   { 
      leftmap.push_back(*itr);
      itr++;
   }

   //rechte Seite
   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id));
   ve_right->setID(id);
   hright->addVertex(*ve_right,ve_right->getID());
   id++;

   if (deleterightvar == false) {
      EDGE *evar_right = new(EDGE);
      evar_right->setLabel(varname);
      evar_right->setIdLabel(catstrint("ger",id));
      evar_right->setID(id);
      list <IDTYPE> list_right;
      list_right.push_back(ve_right->getID());
      hright->addEdge(*evar_right,evar_right->getID(),list_right);
      id++;
   }
   rightmap.push_back(ve_right->getID());


   VERTEX *venew=new (VERTEX);
   venew->setIdLabel(catstrint("ger",id));
   venew->setID(id);
   hright->addVertex(*venew,venew->getID());
   id++;

   edge_id=produceRecord(hright, RIGHTHAND, id, recordname, ve_right->getID(), recordcomp, vertexnext);
   vertexlist = hright->getConnectedVertices(edge_id);
   itr = vertexlist.begin();
   itr++;
   while(itr != vertexlist.end())
   { 
      if (*itr==vertexnext)
         rightmap.push_back(venew->getID());
      else
         rightmap.push_back(*itr);
      itr++;
   }
   RecordEntry *re= getRecordComp(symboltable, recordcomp, recordname);
   recordname=re->recordname;
   produceRecordInit(hright, RIGHTHAND, id, recordname, vertexnext);

   //Match
   MATCH *match=new MATCH();
   list<IDTYPE>::iterator itr_right = rightmap.begin();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
   {
      match->setMatch(*itr_left,*itr_right);
      itr_right++;
   }
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);

   delete ecounter_left, ecounter_right, evar_left, ve_left, ve_right, venew;
   delete hleft, hright, match;

   return rule;
}




/*
list<RULE*> PLGTS::produceDELETE_P_Rule(char *strcounter_l, char *strcounter_r, char *varname, char *recordname, char *rulename, bool deletevarright)
*/
list<RULE*> PLGTS::produceDELETE_P_Rule(char *strcounter_l, char *strcounter_r, char *varname, char *recordname, char *rulename, bool deletevarright)
{
   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   list <RULE*> rulelist;
   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;

   int id_left, id_right;
   id_left=id_right=1;
   int vertexnext = -1;

   {
      RULE *rule=new(RULE);
      char *rulename_=catstrstr(rulename, " (1)");
      rule->setName(addRuleID(rulename_));
 
      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName(hleftname);
      hright->setName(hrightname);


      //1. Regel

      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      VERTEX *ve_left=new (VERTEX);
      ve_left->setIdLabel(catstrint("gel",id_left));
      ve_left->setID(id_left);
      hleft->addVertex(*ve_left,ve_left->getID());
      id_left++;

      VERTEX *ve_right=new (VERTEX);
      ve_right->setIdLabel(catstrint("ger",id_right));
      ve_right->setID(id_right);
      hright->addVertex(*ve_right,ve_right->getID());
      id_right++;
      rightmap.push_back(ve_right->getID());

      EDGE *evar_left = new(EDGE);
      evar_left->setLabel(varname);
      evar_left->setIdLabel(catstrint("gel",id_left));
      evar_left->setID(id_left);
      list <IDTYPE> list_left;
      list_left.push_back(ve_left->getID());
      hleft->addEdge(*evar_left,evar_left->getID(),list_left);
      id_left++;
      leftmap.push_back(ve_left->getID());

      list <IDTYPE> list_right;
      list_right.push_back(ve_right->getID());
  
      if (!deletevarright) {
         EDGE *evar_right = new(EDGE);
         evar_right->setLabel(varname);
         evar_right->setIdLabel(catstrint("ger",id_right));
         evar_right->setID(id_right);
         hright->addEdge(*evar_right,evar_right->getID(),list_right);
         id_right++;
      }

      EDGE *enull = new(EDGE);
      enull->setLabel("null");
      enull->setIdLabel(catstrint("ger",id_right));
      enull->setID(id_right);
      hright->addEdge(*enull,enull->getID(),list_right);
      id_right++;

      list <IDTYPE> list_rec_left;
      list_rec_left.push_back(ve_left->getID());

      EDGE *erec_left = new (EDGE);
      erec_left->setLabel(recordname);
      erec_left->setIdLabel(catstrint("gel",id_left));
      erec_left->setID(id_left);
      id_left++;

      int d=1;
      int x=1;
      RecordEntry *re=getNRecordComp(symboltable, recordname,d);
      assert(re!=NULL);

      while (re != NULL) {
         VERTEX *ve=new (VERTEX);
         ve->setIdLabel(catstrint("gel",id_left));
         ve->setID(id_left);
         hleft->addVertex(*ve,ve->getID());
         id_left++;
         list <IDTYPE> list_;
         list_.push_back(ve->getID());
         list_rec_left.push_back(ve->getID());

         VERTEX *ve_right=new (VERTEX);
         ve_right->setIdLabel(catstrint("ger",id_right));
         ve_right->setID(id_right);
         hright->addVertex(*ve_right,ve_right->getID());
         id_right++;

         if(re->type==intType) {
            EDGE *edge=new(EDGE);
            edge->setLabel("integer");
            edge->setIdLabel(catstrint("gel",id_left));
            edge->setID(id_left);
/*
            TYPES types;
            types.push_back(INTEGER);
            edge->setType(types);
            EXPRESSION *exp=new EXPRESSION(types, catstrint("x",x), "value");
            evartype->addAttributes(*exp);*/
            hleft->addEdge(*edge,edge->getID(),list_);
            x++;
            id_left++;
            delete edge;
         }
         else if(re->type==strType) {
            EDGE *edge=new(EDGE);
            edge->setLabel("string");
            edge->setIdLabel(catstrint("gel",id_left));
            edge->setID(id_left);
/*
            TYPES types;
            types.push_back(STRING);
            edge->setType(types);
            EXPRESSION *exp=new EXPRESSION(types, catstrint("x",x), "value");
            evartype->addAttributes(*exp);*/
            hleft->addEdge(*edge,edge->getID(),list_);
	    x++;
            id_left++;
            delete edge;
         }
         leftmap.push_back(ve->getID());
         rightmap.push_back(ve_right->getID());
         re=getNRecordComp(symboltable, recordname,++d);
         delete ve, ve_right;
      }

      hleft->addEdge(*erec_left,erec_left->getID(),list_rec_left);
      delete erec_left;


      //Match

      MATCH *match=new MATCH();
      list<IDTYPE>::iterator itr_right = rightmap.begin();
      for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
      {
         match->setMatch(*itr_left,*itr_right);
         itr_right++;
      }
      rule->setInterface(*match);


      rule->setLeft(hleft);
      rule->setRight(hright);

      rulelist.push_back(rule);

      delete ve_left, ve_right, ecounter_left, ecounter_right, evar_left, enull, erec_left;
      delete hleft, hright, match;
   }


   //2. Regel
   id_left=id_right=1;
   {
/*
      RULE *ruleerror=produceError(strcounter_l, varname, catstrstr(rulename , " (produce Error Rule)"));
      rulelist.push_back(ruleerror);
*/
      RULE *rule=new(RULE);
      char *rulename_=catstrstr(rulename, " (2)");
      rule->setName(addRuleID(rulename_));

      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName(hleftname);
      hright->setName(hrightname);

      //linke Seite
      id_left=1;

      VERTEX *ve_left=new (VERTEX);
      ve_left->setIdLabel(catstrint("gel",id_left));
      ve_left->setID(id_left);
      hleft->addVertex(*ve_left,ve_left->getID());
      id_left++;

      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      list <IDTYPE> list_left;
      list_left.push_back(ve_left->getID());

      EDGE *evar_left = new(EDGE);
      evar_left->setLabel(varname);
      evar_left->setIdLabel(catstrint("gel",id_left));
      evar_left->setID(id_left);
      hleft->addEdge(*evar_left,evar_left->getID(),list_left);
      id_left++;

      EDGE *enull_left = new(EDGE);
      enull_left->setLabel("null");
      enull_left->setIdLabel(catstrint("gel",id_left));
      enull_left->setID(id_left);
      hleft->addEdge(*enull_left,enull_left->getID(),list_left);
      id_left++;

      //rechte Seite
      id_right=id_left;

      VERTEX *ve_right=new (VERTEX);
      ve_right->setIdLabel(catstrint("ger",id_right));
      ve_right->setID(id_right);
      hright->addVertex(*ve_right,ve_right->getID());
      id_right++;

      list <IDTYPE> list_right;
      list_right.push_back(ve_right->getID());

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      EDGE *evar_right = new(EDGE);
      evar_right->setLabel(varname);
      evar_right->setIdLabel(catstrint("ger",id_right));
      evar_right->setID(id_right);
      hright->addEdge(*evar_right,evar_right->getID(),list_right);
      id_right++;

      EDGE *enull_right = new(EDGE);
      enull_right->setLabel("null");
      enull_right->setIdLabel(catstrint("ger",id_right));
      enull_right->setID(id_right);
      hright->addEdge(*enull_right,enull_right->getID(),list_right);
      id_right++;


      MATCH *match=new MATCH();
      match->setMatch(ve_left->getID(),ve_right->getID());
      rule->setInterface(*match);

      rule->setLeft(hleft);
      rule->setRight(hright);

      rulelist.push_back(rule);

      delete ve_left, ve_right, ecounter_left, evar_left, evar_right, enull_left;
      delete hleft, hright, match;
   }

   return rulelist;

}




/*
RULE *produceNULLPcompRule(int counter, char *varname, char *recordcomp, char *recordname, char *rulename, bool deletvar)
*/

RULE *PLGTS::produceNULLPcompRule(char *strcounter_l, char *strcounter_r, char *varname, char *recordcomp, char *recordname, char *rulename, bool deletvar){

   list <RULE*> rulelist;

   RULE *rule=new(RULE);
   rule->setName(addRuleID(rulename));
 
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName("producelefthandGraph");
   hright->setName("producerighthandGraph");

   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;

   int id=1;
   int vertexnext = -1;

   //linke Seite
   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_l);
   ecounter_left->setIdLabel(catstrint("gel",id));
   ecounter_left->setID(id);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id++;

   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id));
   ve_left->setID(id);
   hleft->addVertex(*ve_left,ve_left->getID());
   id++;

   EDGE *evar_left = new(EDGE);
   evar_left->setLabel(varname);
   evar_left->setIdLabel(catstrint("gel",id));
   evar_left->setID(id);
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());
   hleft->addEdge(*evar_left,evar_left->getID(),list_left);
   id++;
   leftmap.push_back(ve_left->getID());

   int edge_id=produceRecord(hleft, LEFTHAND, id, recordname, ve_left->getID(), recordcomp, vertexnext);
   list<IDTYPE> vertexlist = hleft->getConnectedVertices(edge_id);
   list<IDTYPE>::iterator itr = vertexlist.begin();
   itr++;
   while(itr != vertexlist.end())
   { 
      leftmap.push_back(*itr);
      itr++;
   }

   //rechte Seite
   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_r);
   ecounter_right->setIdLabel(catstrint("ger",id));
   ecounter_right->setID(id);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id++;

   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id));
   ve_right->setID(id);
   hright->addVertex(*ve_right,ve_right->getID());
   id++;

   if (!deletvar) {
      EDGE *evar_right = new(EDGE);
      evar_right->setLabel(varname);
      evar_right->setIdLabel(catstrint("ger",id));
      evar_right->setID(id);
      list <IDTYPE> list_right;
      list_right.push_back(ve_right->getID());
      hright->addEdge(*evar_right,evar_right->getID(),list_right);
      id++;

      delete evar_right;
   }


   rightmap.push_back(ve_right->getID());

   VERTEX *ve_new=new (VERTEX);
   ve_new->setIdLabel(catstrint("ger",id));
   ve_new->setID(id);
   hright->addVertex(*ve_new,ve_new->getID());
   id++;

   edge_id=produceRecord(hright, RIGHTHAND, id, recordname, ve_right->getID(), recordcomp, vertexnext);
   vertexlist = hright->getConnectedVertices(edge_id);
   itr = vertexlist.begin();
   itr++;
   while(itr != vertexlist.end())
   { 
      if (*itr==vertexnext)
         rightmap.push_back(ve_new->getID());
      else
         rightmap.push_back(*itr);
      itr++;
   }
   RecordEntry *re= getRecordComp(symboltable, recordcomp, recordname);
   recordname=re->recordname;

   EDGE *enull = new(EDGE);
   enull->setLabel("null");
   enull->setIdLabel(catstrint("ger",id));
   enull->setID(id);
   list <IDTYPE> list_null;
   list_null.push_back(vertexnext);
   hright->addEdge(*enull,enull->getID(),list_null);
   id++;

   //Match
   MATCH *match=new MATCH();
   list<IDTYPE>::iterator itr_right = rightmap.begin();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
   {
      match->setMatch(*itr_left,*itr_right);
      itr_right++;
   }
   rule->setInterface(*match);

   rule->setLeft(hleft);
   rule->setRight(hright);

   delete ecounter_left, ecounter_right, evar_left, enull, ve_left, ve_right, ve_new;
   delete match, hleft, hright;
   return rule;
}





/*
list<RULE*> PLGTS::producePEqNULL(char *strcounter_IF, char *strcounter_THEN, char *strcounter_ELSE, char *pointer, char *rulename)
*/
list<RULE*> PLGTS::producePEqNULL(char *strcounter_IF, char *strcounter_THEN, char *strcounter_ELSE, char *pointer, char *recordname, char *rulename, bool deletevar)
{

   list <RULE*> rulelist;

   int id_left, id_right;
   id_left=id_right=1;

   list <IDTYPE> leftmap;
   list <IDTYPE> rightmap;

   //then
   RULE *rulethen=new(RULE);
   rulethen->setName(addRuleID(catstrstr(rulename, " (1)")));

   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName(hleftname);
   hright->setName(hrightname);

   //linke Seite
   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_IF);
   ecounter_left->setIdLabel(catstrint("gel",id_left));
   ecounter_left->setID(id_left);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id_left++;

   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id_left));
   ve_left->setID(id_left);
   hleft->addVertex(*ve_left,ve_left->getID());
   id_left++;
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());

   EDGE *evar_left=new (EDGE);
   evar_left->setLabel(pointer);
   evar_left->setIdLabel(catstrint("gel",id_left));
   evar_left->setID(id_left);
   hleft->addEdge(*evar_left, evar_left->getID(),list_left);
   id_left++;

   EDGE *enull_left=new (EDGE);
   enull_left->setLabel("null");
   enull_left->setIdLabel(catstrint("gel",id_left));
   enull_left->setID(id_left);
   hleft->addEdge(*enull_left, enull_left->getID(),list_left);
   id_left++;


   //rechte Seite
   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_THEN);
   ecounter_right->setIdLabel(catstrint("ger",id_right));
   ecounter_right->setID(id_right);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id_right++;

   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id_right));
   ve_right->setID(id_right);
   hright->addVertex(*ve_right,ve_right->getID());
   id_right++;
   list <IDTYPE> list_right;
   list_right.push_back(ve_right->getID());

   if (!deletevar) 
   {
      EDGE *evar_right=new (EDGE);
      evar_right->setLabel(pointer);
      evar_right->setIdLabel(catstrint("ger",id_right));
      evar_right->setID(id_right);
      hright->addEdge(*evar_right, evar_right->getID(),list_right);
      id_right++;
      delete evar_right;
   }

   EDGE *enull_right=new (EDGE);
   enull_right->setLabel("null");
   enull_right->setIdLabel(catstrint("ger",id_right));
   enull_right->setID(id_right);
   hright->addEdge(*enull_right, enull_right->getID(),list_right);
   id_right++;
   MATCH *match=new MATCH();
   match->setMatch(ve_left->getID(), ve_right->getID());
   rulethen->setInterface(*match);
   rulethen->setLeft(hleft);
   rulethen->setRight(hright);
   rulelist.push_back(rulethen);

   //else
   {

   id_left=id_right=1;

   RULE *ruleelse=new(RULE);
   ruleelse->setName(addRuleID(catstrstr(rulename, " (2)")));

   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName(hleftname);
   hright->setName(hrightname);

   //linke Seite
   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_IF);
   ecounter_left->setIdLabel(catstrint("gel",id_left));
   ecounter_left->setID(id_left);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id_left++;

   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id_left));
   ve_left->setID(id_left);
   hleft->addVertex(*ve_left,ve_left->getID());
   id_left++;
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());
   leftmap.push_back(ve_left->getID());

   EDGE *evar_left=new (EDGE);
   evar_left->setLabel(pointer);
   evar_left->setIdLabel(catstrint("gel",id_left));
   evar_left->setID(id_left);
   hleft->addEdge(*evar_left, evar_left->getID(),list_left);
   id_left++;

   //char *recordname=getRecordName(symboltable,pointer);
   int edge_id=produceRecord(hleft, LEFTHAND, id_left, recordname, ve_left->getID());
   list<IDTYPE> vertexlist_left = hleft->getConnectedVertices(edge_id);
   list<IDTYPE>::iterator itr_left = vertexlist_left.begin();
   while(itr_left != vertexlist_left.end())
   {
      leftmap.push_back(*itr_left);
      itr_left++;
   }

   //rechte Seite
   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_ELSE);
   ecounter_right->setIdLabel(catstrint("ger",id_right));
   ecounter_right->setID(id_right);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id_right++;

   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id_right));
   ve_right->setID(id_right);
   hright->addVertex(*ve_right,ve_right->getID());
   id_right++;
   list <IDTYPE> list_right;
   list_right.push_back(ve_right->getID());
   rightmap.push_back(ve_right->getID());

   if (!deletevar) 
   {
      EDGE *evar_right=new (EDGE);
      evar_right->setLabel(pointer);
      evar_right->setIdLabel(catstrint("ger",id_right));
      evar_right->setID(id_right);
      hright->addEdge(*evar_right, evar_right->getID(),list_right);
      id_right++;
      delete evar_right;
   }

   edge_id=produceRecord(hright, RIGHTHAND, id_right, recordname, ve_right->getID());
   list<IDTYPE> vertexlist_right = hright->getConnectedVertices(edge_id);
   list<IDTYPE>::iterator itr_right = vertexlist_right.begin();
   while(itr_right != vertexlist_right.end())
   {
      rightmap.push_back(*itr_right);
      itr_right++;
   }

   MATCH *match=new MATCH();
   for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++) {
      match->setMatch(*itr_left,*itr_right);
      itr_right++;
   }
   ruleelse->setInterface(*match);


   ruleelse->setLeft(hleft);
   ruleelse->setRight(hright);
   rulelist.push_back(ruleelse);

   delete ve_left, ve_right, ecounter_left, ecounter_right, evar_left;
   delete hleft, hright;
   }

   delete hleft, hright;
   delete ve_left, ve_right, evar_left, ecounter_left, ecounter_right, enull_left, enull_right;
   return rulelist;

}



/*
   list <RULE*> PLGTS::producePEqPRule(char *strcounter_IF, char* strcounter_THEN, char *strcounter_ELSE, char *left, char *right, char *rulename)
*/

list <RULE*> PLGTS::producePEqPRule_2Rules(char *strcounter_IF, char* strcounter_THEN, char *strcounter_ELSE, char *left, char *right, char *rulename, bool deletevarleft, bool deletevarright)
{
   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   list <RULE*> rulelist;
   int id_left,id_right;
   id_left=id_right=1;
   //then:
   {
   RULE *rulethen=new(RULE);
   rulethen->setName(addRuleID(catstrstr(rulename, " (1)")));

   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName(hleftname);
   hright->setName(hrightname);

   //linke Seite
   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_IF);
   ecounter_left->setIdLabel(catstrint("gel",id_left));
   ecounter_left->setID(id_left);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id_left++;

   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id_left));
   ve_left->setID(id_left);
   hleft->addVertex(*ve_left,ve_left->getID());
   id_left++;
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());

   EDGE *eleft_left = new(EDGE);
   eleft_left->setLabel(left);
   eleft_left->setIdLabel(catstrint("gel",id_left));
   eleft_left->setID(id_left);
   hleft->addEdge(*eleft_left,eleft_left->getID(),list_left);
   id_left++;

   EDGE *eright_left = new(EDGE);
   eright_left->setLabel(right);
   eright_left->setIdLabel(catstrint("gel",id_left));
   eright_left->setID(id_left);
   hleft->addEdge(*eright_left,eright_left->getID(),list_left);
   id_left++;

   //rechte Seite

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_THEN);
   ecounter_right->setIdLabel(catstrint("ger",id_right));
   ecounter_right->setID(id_right);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id_right++;

   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id_right));
   ve_right->setID(id_right);
   hright->addVertex(*ve_right,ve_right->getID());
   id_right++;
   list <IDTYPE> list_right;
   list_right.push_back(ve_right->getID());

   if (!deletevarleft) 
   {
      EDGE *eleft_right = new(EDGE);
      eleft_right->setLabel(left);
      eleft_right->setIdLabel(catstrint("ger",id_right));
      eleft_right->setID(id_right);
      hright->addEdge(*eleft_right,eleft_right->getID(),list_right);
      id_right++;
      delete eleft_right;
   }

   if (!deletevarright) 
   {
      EDGE *eright_right = new(EDGE);
      eright_right->setLabel(right);
      eright_right->setIdLabel(catstrint("ger",id_right));
      eright_right->setID(id_right);
      hright->addEdge(*eright_right,eright_right->getID(),list_right);
      id_right++;
      delete eright_right;
   }

   MATCH *match=new MATCH();
   match->setMatch(ve_left->getID(),ve_right->getID());
   rulethen->setInterface(*match);
   rulethen->setLeft(hleft);
   rulethen->setRight(hright);

   rulelist.push_back(rulethen);

   delete ve_left, ve_right, ecounter_left, ecounter_right;
   delete hleft, hright, match;
   }

   id_left=id_right=1;
   //else:
   {
   RULE *ruleelse=new(RULE);
   ruleelse->setName(addRuleID(catstrstr(rulename, " (2)")));

   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName(hleftname);
   hright->setName(hrightname);

   //linke Seite
   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_IF);
   ecounter_left->setIdLabel(catstrint("gel",id_left));
   ecounter_left->setID(id_left);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id_left++;

   list <IDTYPE> list1_left;
   VERTEX *ve1_left=new (VERTEX);
   ve1_left->setIdLabel(catstrint("gel",id_left));
   ve1_left->setID(id_left);
   hleft->addVertex(*ve1_left,ve1_left->getID());
   id_left++;
   list1_left.push_back(ve1_left->getID());

   list <IDTYPE> list2_left;
   VERTEX *ve2_left=new (VERTEX);
   ve2_left->setIdLabel(catstrint("gel",id_left));
   ve2_left->setID(id_left);
   hleft->addVertex(*ve2_left,ve2_left->getID());
   id_left++;
   list2_left.push_back(ve2_left->getID());

   EDGE *eleft_left = new(EDGE);
   eleft_left->setLabel(left);
   eleft_left->setIdLabel(catstrint("gel",id_left));
   eleft_left->setID(id_left);
   hleft->addEdge(*eleft_left,eleft_left->getID(),list1_left);
   id_left++;

   EDGE *eright_left = new(EDGE);
   eright_left->setLabel(right);
   eright_left->setIdLabel(catstrint("gel",id_left));
   eright_left->setID(id_left);
   hleft->addEdge(*eright_left,eright_left->getID(),list2_left);
   id_left++;

   //rechte Seite

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_ELSE);
   ecounter_right->setIdLabel(catstrint("ger",id_right));
   ecounter_right->setID(id_right);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id_right++;

   list <IDTYPE> list1_right;
   VERTEX *ve1_right=new (VERTEX);
   ve1_right->setIdLabel(catstrint("ger",id_right));
   ve1_right->setID(id_right);
   hright->addVertex(*ve1_right,ve1_right->getID());
   id_right++;
   list1_right.push_back(ve1_right->getID());

   list <IDTYPE> list2_right;
   VERTEX *ve2_right=new (VERTEX);
   ve2_right->setIdLabel(catstrint("ger",id_right));
   ve2_right->setID(id_right);
   hright->addVertex(*ve2_right,ve2_right->getID());
   id_right++;
   list2_right.push_back(ve2_right->getID());

   if (!deletevarleft) {
      EDGE *eleft_right = new(EDGE);
      eleft_right->setLabel(left);
      eleft_right->setIdLabel(catstrint("ger",id_right));
      eleft_right->setID(id_right);
      hright->addEdge(*eleft_right,eleft_right->getID(),list1_right);
      id_right++;
      delete eleft_right;
   }

   if (!deletevarright)
   {
      EDGE *eright_right = new(EDGE);
      eright_right->setLabel(right);
      eright_right->setIdLabel(catstrint("ger",id_right));
      eright_right->setID(id_right);
      hright->addEdge(*eright_right,eright_right->getID(),list2_right);
      id_right++;
      delete eright_right;
   }

   MATCH *match=new MATCH();
   match->setMatch(ve1_left->getID(),ve1_right->getID());
   match->setMatch(ve2_left->getID(),ve2_right->getID());
   ruleelse->setInterface(*match);
   ruleelse->setLeft(hleft);
   ruleelse->setRight(hright);

   rulelist.push_back(ruleelse);

   delete ecounter_left, ecounter_right, ve1_left, ve1_right, ve2_left, ve2_right, eleft_left, eright_left;
   delete hleft, hright, match;
   }

   return rulelist;
}






/*
   list <RULE*> PLGTS::producePEqPRule(char *strcounter_IF, char* strcounter_THEN, char *strcounter_ELSE, char *left, char *right, char *rulename)
*/
list <RULE*> PLGTS::producePEqPRule(char *strcounter_IF, char* strcounter_THEN, char *strcounter_ELSE, char *left, char *right, char *recordname, char *rulename, bool deletevarleft, bool deletevarright)
{
   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   list <RULE*> rulelist;
   int id_left, id_right;
   id_left=id_right=1;

   //then:
   {

   //Regel 1:
   {
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName(hleftname);
   hright->setName(hrightname);

   RULE *rulethen_1=new(RULE);
   rulethen_1->setName(addRuleID(catstrstr(rulename, "(1)")));

   //linke Seite
   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_IF);
   ecounter_left->setIdLabel(catstrint("gel",id_left));
   ecounter_left->setID(id_left);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id_left++;

   VERTEX *ve_left=new (VERTEX);
   ve_left->setIdLabel(catstrint("gel",id_left));
   ve_left->setID(id_left);
   hleft->addVertex(*ve_left,ve_left->getID());
   id_left++;
   list <IDTYPE> list_left;
   list_left.push_back(ve_left->getID());

   EDGE *eleft_left = new(EDGE);
   eleft_left->setLabel(left);
   eleft_left->setIdLabel(catstrint("gel",id_left));
   eleft_left->setID(id_left);
   hleft->addEdge(*eleft_left,eleft_left->getID(),list_left);
   id_left++;

   EDGE *eright_left = new(EDGE);
   eright_left->setLabel(right);
   eright_left->setIdLabel(catstrint("gel",id_left));
   eright_left->setID(id_left);
   hleft->addEdge(*eright_left,eright_left->getID(),list_left);
   id_left++;

   //rechte Seite

   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_THEN);
   ecounter_right->setIdLabel(catstrint("ger",id_right));
   ecounter_right->setID(id_right);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id_right++;

   VERTEX *ve_right=new (VERTEX);
   ve_right->setIdLabel(catstrint("ger",id_right));
   ve_right->setID(id_right);
   hright->addVertex(*ve_right,ve_right->getID());
   id_right++;
   list <IDTYPE> list_right;
   list_right.push_back(ve_right->getID());

   if (!deletevarleft) {
      EDGE *eleft_right = new(EDGE);
      eleft_right->setLabel(left);
      eleft_right->setIdLabel(catstrint("ger",id_right));
      eleft_right->setID(id_right);
      hright->addEdge(*eleft_right,eleft_right->getID(),list_right);
      id_right++;
      delete eleft_right;
   }
   if (!deletevarright) {
      EDGE *eright_right = new(EDGE);
      eright_right->setLabel(right);
      eright_right->setIdLabel(catstrint("ger",id_right));
      eright_right->setID(id_right);
      hright->addEdge(*eright_right,eright_right->getID(),list_right);
      id_right++;
      delete eright_right;
   }

   MATCH *match=new MATCH();
   match->setMatch(ve_left->getID(),ve_right->getID());
   rulethen_1->setInterface(*match);
   rulethen_1->setLeft(hleft);
   rulethen_1->setRight(hright);

   rulelist.push_back(rulethen_1);

   delete ve_left, ve_right, ecounter_left, ecounter_right;
   delete hleft, hright, match;
   }

   //Regel 2
   id_left=id_right=1;
   {
   HYPERGRAPH *hleft=new(HYPERGRAPH);
   HYPERGRAPH *hright=new(HYPERGRAPH);
   hleft->setName(hleftname);
   hright->setName(hrightname);

   RULE *rulethen_2=new(RULE);
   rulethen_2->setName(addRuleID(catstrstr(rulename, "(2)")));

   //linke Seite
   EDGE *ecounter_left=new(EDGE);
   ecounter_left->setLabel(strcounter_IF);
   ecounter_left->setIdLabel(catstrint("gel",id_left));
   ecounter_left->setID(id_left);
   hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
   id_left++;

   list <IDTYPE> list1_left;
   VERTEX *ve1_left=new (VERTEX);
   ve1_left->setIdLabel(catstrint("gel",id_left));
   ve1_left->setID(id_left);
   hleft->addVertex(*ve1_left,ve1_left->getID());
   id_left++;
   list1_left.push_back(ve1_left->getID());

   list <IDTYPE> list2_left;
   VERTEX *ve2_left=new (VERTEX);
   ve2_left->setIdLabel(catstrint("gel",id_left));
   ve2_left->setID(id_left);
   hleft->addVertex(*ve2_left,ve2_left->getID());
   id_left++;
   list2_left.push_back(ve2_left->getID());

   EDGE *eleft_left = new(EDGE);
   eleft_left->setLabel(left);
   eleft_left->setIdLabel(catstrint("gel",id_left));
   eleft_left->setID(id_left);
   hleft->addEdge(*eleft_left,eleft_left->getID(),list1_left);
   id_left++;

   EDGE *eleft_null_1 = new(EDGE);
   eleft_null_1->setLabel("null");
   eleft_null_1->setIdLabel(catstrint("gel",id_left));
   eleft_null_1->setID(id_left);
   hleft->addEdge(*eleft_null_1,eleft_null_1->getID(),list1_left);
   id_left++;

   EDGE *eright_left = new(EDGE);
   eright_left->setLabel(right);
   eright_left->setIdLabel(catstrint("gel",id_left));
   eright_left->setID(id_left);
   hleft->addEdge(*eright_left,eright_left->getID(),list2_left);
   id_left++;

   EDGE *eleft_null_2 = new(EDGE);
   eleft_null_2->setLabel("null");
   eleft_null_2->setIdLabel(catstrint("gel",id_left));
   eleft_null_2->setID(id_left);
   hleft->addEdge(*eleft_null_2,eleft_null_2->getID(),list2_left);
   id_left++;

   //rechte Seite
   EDGE *ecounter_right=new(EDGE);
   ecounter_right->setLabel(strcounter_THEN);
   ecounter_right->setIdLabel(catstrint("ger",id_right));
   ecounter_right->setID(id_right);
   hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
   id_right++;

   list <IDTYPE> list1_right;
   VERTEX *ve1_right=new (VERTEX);
   ve1_right->setIdLabel(catstrint("ger",id_right));
   ve1_right->setID(id_right);
   hright->addVertex(*ve1_right,ve1_right->getID());
   id_right++;
   list1_right.push_back(ve1_right->getID());

   list <IDTYPE> list2_right;
   VERTEX *ve2_right=new (VERTEX);
   ve2_right->setIdLabel(catstrint("ger",id_right));
   ve2_right->setID(id_right);
   hright->addVertex(*ve2_right,ve2_right->getID());
   id_right++;
   list2_right.push_back(ve2_right->getID());

   if (!deletevarleft) {
      EDGE *eleft_right = new(EDGE);
      eleft_right->setLabel(left);
      eleft_right->setIdLabel(catstrint("ger",id_right));
      eleft_right->setID(id_right);
      hright->addEdge(*eleft_right,eleft_right->getID(),list1_right);
      id_right++;
      delete eleft_right;
   }

   EDGE *eright_null_1 = new(EDGE);
   eright_null_1->setLabel("null");
   eright_null_1->setIdLabel(catstrint("ger",id_right));
   eright_null_1->setID(id_right);
   hright->addEdge(*eright_null_1,eright_null_1->getID(),list1_right);
   id_right++;

   if (!deletevarright) {
      EDGE *eright_right = new(EDGE);
      eright_right->setLabel(right);
      eright_right->setIdLabel(catstrint("ger",id_right));
      eright_right->setID(id_right);
      hright->addEdge(*eright_right,eright_right->getID(),list2_right);
      id_right++;
      delete eright_right;
   }

   EDGE *eright_null_2 = new(EDGE);
   eright_null_2->setLabel("null");
   eright_null_2->setIdLabel(catstrint("ger",id_right));
   eright_null_2->setID(id_right);
   hright->addEdge(*eright_null_2,eright_null_2->getID(),list2_right);
   id_right++;

   MATCH *match=new MATCH();
   match->setMatch(ve1_left->getID(),ve1_right->getID());
   match->setMatch(ve2_left->getID(),ve2_right->getID());
   rulethen_2->setInterface(*match);
   rulethen_2->setLeft(hleft);
   rulethen_2->setRight(hright);

   rulelist.push_back(rulethen_2);

   delete ve1_left, ve2_left, ve1_right, ve2_right, ecounter_left, ecounter_right,eright_null_1, eright_null_2, eleft_null_1, eleft_null_2, eleft_left, eright_left;
   delete hleft, hright, match;
   }

   }
   

   //else:
   id_left=id_right=1;
   {

   //Regel 1
   //record record
   {

      RULE *ruleelse_1=new(RULE);
      ruleelse_1->setName(addRuleID(catstrstr(rulename, "(3)")));

      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName(hleftname);
      hright->setName(hrightname);

      list <IDTYPE> leftmap;
      list <IDTYPE> rightmap;
      //linke Seite
      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_IF);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      VERTEX *ve_left_1=new (VERTEX);
      ve_left_1->setIdLabel(catstrint("gel",id_left));
      ve_left_1->setID(id_left);
      hleft->addVertex(*ve_left_1,ve_left_1->getID());
      id_left++;

      EDGE *evar_left_1 = new(EDGE);
      evar_left_1->setLabel(left);
      evar_left_1->setIdLabel(catstrint("gel",id_left));
      evar_left_1->setID(id_left);
      list <IDTYPE> list_left_1;
      list_left_1.push_back(ve_left_1->getID());
      hleft->addEdge(*evar_left_1,evar_left_1->getID(),list_left_1);
      id_left++;
      leftmap.push_back(ve_left_1->getID());

      int edge_id=produceRecord(hleft, LEFTHAND, id_left, recordname, ve_left_1->getID());
      list<IDTYPE> vertexlist = hleft->getConnectedVertices(edge_id);
      list<IDTYPE>::iterator itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      { 
         leftmap.push_back(*itr);
         itr++;
      }

      VERTEX *ve_left_2=new (VERTEX);
      ve_left_2->setIdLabel(catstrint("gel",id_left));
      ve_left_2->setID(id_left);
      hleft->addVertex(*ve_left_2,ve_left_2->getID());
      id_left++;

      EDGE *evar_left_2 = new(EDGE);
      evar_left_2->setLabel(right);
      evar_left_2->setIdLabel(catstrint("gel",id_left));
      evar_left_2->setID(id_left);
      list <IDTYPE> list_left_2;
      list_left_2.push_back(ve_left_2->getID());
      hleft->addEdge(*evar_left_2,evar_left_2->getID(),list_left_2);
      id_left++;
      leftmap.push_back(ve_left_2->getID());

      edge_id=produceRecord(hleft, LEFTHAND, id_left, recordname, ve_left_2->getID());
      vertexlist = hleft->getConnectedVertices(edge_id);
      itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      { 
         leftmap.push_back(*itr);
         itr++;
      }


      //rechte Seite
      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_ELSE);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      VERTEX *ve_right_1=new (VERTEX);
      ve_right_1->setIdLabel(catstrint("ger",id_right));
      ve_right_1->setID(id_right);
      hright->addVertex(*ve_right_1,ve_right_1->getID());
      id_right++;
      rightmap.push_back(ve_right_1->getID());

      if (!deletevarleft)
      {
         EDGE *evar_right_1 = new(EDGE);
         evar_right_1->setLabel(left);
         evar_right_1->setIdLabel(catstrint("ger",id_right));
         evar_right_1->setID(id_right);
         list <IDTYPE> list_right_1;
         list_right_1.push_back(ve_right_1->getID());
         hright->addEdge(*evar_right_1,evar_right_1->getID(),list_right_1);
         id_right++;
         delete evar_right_1;
      }

      edge_id=produceRecord(hright, RIGHTHAND, id_right, recordname, ve_right_1->getID());
      vertexlist = hright->getConnectedVertices(edge_id);
      itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      { 
         rightmap.push_back(*itr);
         itr++;
      }

      VERTEX *ve_right_2=new (VERTEX);
      ve_right_2->setIdLabel(catstrint("ger",id_right));
      ve_right_2->setID(id_right);
      hright->addVertex(*ve_right_2,ve_right_2->getID());
      id_right++;
      rightmap.push_back(ve_right_2->getID());

      if (!deletevarright) 
      {
         EDGE *evar_right_2 = new(EDGE);
         evar_right_2->setLabel(right);
         evar_right_2->setIdLabel(catstrint("ger",id_right));
         evar_right_2->setID(id_right);
         list <IDTYPE> list_right_2;
         list_right_2.push_back(ve_right_2->getID());
         hright->addEdge(*evar_right_2,evar_right_2->getID(),list_right_2);
         id_right++;
         delete evar_right_2;
      }

      edge_id=produceRecord(hright, RIGHTHAND, id_right, recordname, ve_right_2->getID());
      vertexlist = hright->getConnectedVertices(edge_id);
      itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      { 
         rightmap.push_back(*itr);
         itr++;
      }

      //Match
      MATCH *match=new MATCH();
      list<IDTYPE>::iterator itr_right = rightmap.begin();
      assert(leftmap.size()==rightmap.size());
      for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
      {
         match->setMatch(*itr_left,*itr_right);
         itr_right++;
      }
      ruleelse_1->setInterface(*match);

      ruleelse_1->setLeft(hleft);
      ruleelse_1->setRight(hright);

      rulelist.push_back(ruleelse_1);
      delete ve_left_1, ve_right_1, ve_left_2, ve_right_2, ecounter_left, ecounter_right, evar_left_1, evar_left_2;
      delete hleft, hright, match;





   }

   //Regel 2
   //record null
   {

      RULE *ruleelse_2=new(RULE);
      ruleelse_2->setName(addRuleID(catstrstr(rulename, "(4)")));

      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName(hleftname);
      hright->setName(hrightname);

      list <IDTYPE> leftmap;
      list <IDTYPE> rightmap;
      id_left=id_right=1;

      //linke Seite
      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_IF);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;


      VERTEX *ve_left_1=new (VERTEX);
      ve_left_1->setIdLabel(catstrint("gel",id_left));
      ve_left_1->setID(id_left);
      hleft->addVertex(*ve_left_1,ve_left_1->getID());
      id_left++;

      EDGE *evar_left_1 = new(EDGE);
      evar_left_1->setLabel(left);
      evar_left_1->setIdLabel(catstrint("gel",id_left));
      evar_left_1->setID(id_left);
      list <IDTYPE> list_left_1;
      list_left_1.push_back(ve_left_1->getID());
      hleft->addEdge(*evar_left_1,evar_left_1->getID(),list_left_1);
      id_left++;
      leftmap.push_back(ve_left_1->getID());

      int edge_id=produceRecord(hleft, LEFTHAND, id_left, recordname, ve_left_1->getID());
      list<IDTYPE> vertexlist = hleft->getConnectedVertices(edge_id);
      list<IDTYPE>::iterator itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      { 
         leftmap.push_back(*itr);
         itr++;
      }
      VERTEX *ve_left_2=new (VERTEX);
      ve_left_2->setIdLabel(catstrint("gel",id_left));
      ve_left_2->setID(id_left);
      hleft->addVertex(*ve_left_2,ve_left_2->getID());
      id_left++;

      EDGE *evar_left_2 = new(EDGE);
      evar_left_2->setLabel(right);
      evar_left_2->setIdLabel(catstrint("gel",id_left));
      evar_left_2->setID(id_left);
      list <IDTYPE> list_left_2;
      list_left_2.push_back(ve_left_2->getID());
      hleft->addEdge(*evar_left_2,evar_left_2->getID(),list_left_2);
      id_left++;
      leftmap.push_back(ve_left_2->getID());

      EDGE *enull_left = new (EDGE);
      enull_left->setLabel("null");
      enull_left->setIdLabel(catstrint("gel",id_left));
      enull_left->setID(id_left);
      list <IDTYPE> list_left_null;
      list_left_null.push_back(ve_left_2->getID());
      hleft->addEdge(*enull_left,enull_left->getID(),list_left_null);
      id_left++;


      //rechte Seite
      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_ELSE);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      VERTEX *ve_right_1=new (VERTEX);
      ve_right_1->setIdLabel(catstrint("ger",id_right));
      ve_right_1->setID(id_right);
      hright->addVertex(*ve_right_1,ve_right_1->getID());
      id_right++;
      rightmap.push_back(ve_right_1->getID());

      if (!deletevarleft) {
         EDGE *evar_right_1 = new(EDGE);
         evar_right_1->setLabel(left);
         evar_right_1->setIdLabel(catstrint("ger",id_right));
         evar_right_1->setID(id_right);
         list <IDTYPE> list_right_1;
         list_right_1.push_back(ve_right_1->getID());
         hright->addEdge(*evar_right_1,evar_right_1->getID(),list_right_1);
         id_right++;
         delete evar_right_1;
      }

      edge_id=produceRecord(hright, RIGHTHAND, id_right, recordname, ve_right_1->getID());
      vertexlist = hright->getConnectedVertices(edge_id);
      itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      { 
         rightmap.push_back(*itr);
         itr++;
      }

      VERTEX *ve_right_2=new (VERTEX);
      ve_right_2->setIdLabel(catstrint("ger",id_right));
      ve_right_2->setID(id_right);
      hright->addVertex(*ve_right_2,ve_right_2->getID());
      id_right++;
      rightmap.push_back(ve_right_2->getID());

      if (!deletevarright) {
         EDGE *evar_right_2 = new(EDGE);
         evar_right_2->setLabel(right);
         evar_right_2->setIdLabel(catstrint("ger",id_right));
         evar_right_2->setID(id_right);
         list <IDTYPE> list_right_2;
         list_right_2.push_back(ve_right_2->getID());
         hright->addEdge(*evar_right_2,evar_right_2->getID(),list_right_2);
         id_right++;
         delete evar_right_2;
      }

      EDGE *enull_right = new (EDGE);
      enull_right->setLabel("null");
      enull_right->setIdLabel(catstrint("ger",id_right));
      enull_right->setID(id_right);
      list <IDTYPE> list_right_null;
      list_right_null.push_back(ve_right_2->getID());
      hright->addEdge(*enull_right,enull_right->getID(),list_right_null);
      id_right++;

      //Match
      MATCH *match=new MATCH();
      list<IDTYPE>::iterator itr_right = rightmap.begin();
      assert(leftmap.size()==rightmap.size());
      for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
      {
         match->setMatch(*itr_left,*itr_right);
         itr_right++;
      }
      ruleelse_2->setInterface(*match);

      ruleelse_2->setLeft(hleft);
      ruleelse_2->setRight(hright);

      rulelist.push_back(ruleelse_2);

      delete ve_left_1, ve_right_1, ve_left_2, ve_right_2, ecounter_left, ecounter_right, evar_left_1, evar_left_2, enull_right, enull_left;
      delete hleft, hright, match;
   }

   //Regel 3
   //null record
   {

      RULE *ruleelse_3=new(RULE);
      ruleelse_3->setName(addRuleID(catstrstr(rulename, "(5)")));

      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName(hleftname);
      hright->setName(hrightname);

      list <IDTYPE> leftmap;
      list <IDTYPE> rightmap;
      id_left=id_right=1;

      //linke Seite
      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_IF);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      VERTEX *ve_left_1=new (VERTEX);
      ve_left_1->setIdLabel(catstrint("gel",id_left));
      ve_left_1->setID(id_left);
      hleft->addVertex(*ve_left_1,ve_left_1->getID());
      id_left++;

      EDGE *evar_left_1 = new(EDGE);
      evar_left_1->setLabel(left);
      evar_left_1->setIdLabel(catstrint("gel",id_left));
      evar_left_1->setID(id_left);
      list <IDTYPE> list_left_1;
      list_left_1.push_back(ve_left_1->getID());
      hleft->addEdge(*evar_left_1,evar_left_1->getID(),list_left_1);
      id_left++;
      leftmap.push_back(ve_left_1->getID());

      EDGE *enull_left = new (EDGE);
      enull_left->setLabel("null");
      enull_left->setIdLabel(catstrint("gel",id_left));
      enull_left->setID(id_left);
      list <IDTYPE> list_left_null;
      list_left_null.push_back(ve_left_1->getID());
      hleft->addEdge(*enull_left,enull_left->getID(),list_left_null);
      id_left++;

      VERTEX *ve_left_2=new (VERTEX);
      ve_left_2->setIdLabel(catstrint("gel",id_left));
      ve_left_2->setID(id_left);
      hleft->addVertex(*ve_left_2,ve_left_2->getID());
      id_left++;

      EDGE *evar_left_2 = new(EDGE);
      evar_left_2->setLabel(right);
      evar_left_2->setIdLabel(catstrint("gel",id_left));
      evar_left_2->setID(id_left);
      list <IDTYPE> list_left_2;
      list_left_2.push_back(ve_left_2->getID());
      hleft->addEdge(*evar_left_2,evar_left_2->getID(),list_left_2);
      id_left++;
      leftmap.push_back(ve_left_2->getID());

      int edge_id=produceRecord(hleft, LEFTHAND, id_left, recordname, ve_left_2->getID());
      list<IDTYPE> vertexlist = hleft->getConnectedVertices(edge_id);
      list<IDTYPE>::iterator itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      { 
         leftmap.push_back(*itr);
         itr++;
      }

      //rechte Seite
      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_ELSE);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      VERTEX *ve_right_1=new (VERTEX);
      ve_right_1->setIdLabel(catstrint("ger",id_right));
      ve_right_1->setID(id_right);
      hright->addVertex(*ve_right_1,ve_right_1->getID());
      id_right++;
      rightmap.push_back(ve_right_1->getID());

      if (!deletevarleft) {
         EDGE *evar_right_1 = new(EDGE);
         evar_right_1->setLabel(left);
         evar_right_1->setIdLabel(catstrint("ger",id_right));
         evar_right_1->setID(id_right);
         list <IDTYPE> list_right_1;
         list_right_1.push_back(ve_right_1->getID());
         hright->addEdge(*evar_right_1,evar_right_1->getID(),list_right_1);
         id_right++;
         delete evar_right_1;
      }

      EDGE *enull_right = new (EDGE);
      enull_right->setLabel("null");
      enull_right->setIdLabel(catstrint("ger",id_right));
      enull_right->setID(id_right);
      list <IDTYPE> list_right_null;
      list_right_null.push_back(ve_right_1->getID());
      hright->addEdge(*enull_right,enull_right->getID(),list_right_null);
      id_right++;

      VERTEX *ve_right_2=new (VERTEX);
      ve_right_2->setIdLabel(catstrint("ger",id_right));
      ve_right_2->setID(id_right);
      hright->addVertex(*ve_right_2,ve_right_2->getID());
      id_right++;
      rightmap.push_back(ve_right_2->getID());

      if (!deletevarright) {
         EDGE *evar_right_2 = new(EDGE);
         evar_right_2->setLabel(right);
         evar_right_2->setIdLabel(catstrint("ger",id_right));
         evar_right_2->setID(id_right);
         list <IDTYPE> list_right_2;
         list_right_2.push_back(ve_right_2->getID());
         hright->addEdge(*evar_right_2,evar_right_2->getID(),list_right_2);
         id_right++;
         delete evar_right_2;
      }

      edge_id=produceRecord(hright, RIGHTHAND, id_right, recordname, ve_right_2->getID());
      vertexlist = hright->getConnectedVertices(edge_id);
      itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      { 
         rightmap.push_back(*itr);
         itr++;
      }


      //Match
      MATCH *match=new MATCH();
      list<IDTYPE>::iterator itr_right = rightmap.begin();
      assert(leftmap.size()==rightmap.size());
      for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
      {
         match->setMatch(*itr_left,*itr_right);
         itr_right++;
      }
      ruleelse_3->setInterface(*match);

      ruleelse_3->setLeft(hleft);
      ruleelse_3->setRight(hright);

      rulelist.push_back(ruleelse_3);

      delete ve_left_1, ve_right_1, ve_left_2, ve_right_2, ecounter_left, ecounter_right, evar_left_1, evar_left_2,  enull_right, enull_left;
      delete hleft, hright, match;
   }

   }

   return rulelist;
}







/*
   list<RULE*> PLGTS::produceDELETE_PComp_Rule(char *strcounter_l, char *strcounter_r, char *varname, char *recordcomp, char *recordname, char *rulename, bool deletevarright)
*/

list<RULE*> PLGTS::produceDELETE_PComp_Rule(char *strcounter_l, char *strcounter_r, char *varname, char *recordcomp, char *recordname, char *rulename, bool deletevarright)
{
   const string hleftname="producelefthandGraph";
   const string hrightname="producerighthandGraph";

   list <RULE*> rulelist;
   int id_left, id_right;
   id_left=id_right=1;

   //1 Regel
   {

      RULE *rule=new(RULE);
      char *rulename_=catstrstr(rulename, "(1)");
      rule->setName(addRuleID(rulename_));

      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName(hleftname);
      hright->setName(hrightname);

      list <IDTYPE> leftmap;
      list <IDTYPE> rightmap;

      int id_left, id_right;
      id_left=id_right=1;
      int vertexnext_left = -1;
      int vertexnext_right = -1;

      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      VERTEX *ve_left=new (VERTEX);
      ve_left->setIdLabel(catstrint("gel",id_left));
      ve_left->setID(id_left);
      hleft->addVertex(*ve_left,ve_left->getID());
      id_left++;
      leftmap.push_back(ve_left->getID());

      VERTEX *ve_right=new (VERTEX);
      ve_right->setIdLabel(catstrint("ger",id_right));
      ve_right->setID(id_right);
      hright->addVertex(*ve_right,ve_right->getID());
      id_right++;
      rightmap.push_back(ve_right->getID());

      EDGE *evar_left = new(EDGE);
      evar_left->setLabel(varname);
      evar_left->setIdLabel(catstrint("gel",id_left));
      evar_left->setID(id_left);
      list <IDTYPE> list_varleft;
      list_varleft.push_back(ve_left->getID());
      hleft->addEdge(*evar_left,evar_left->getID(),list_varleft);
      id_left++;

      if (!deletevarright) {
         EDGE *evar_right = new(EDGE);
         evar_right->setLabel(varname);
         evar_right->setIdLabel(catstrint("ger",id_right));
         evar_right->setID(id_right);
         list <IDTYPE> list_varright;
         list_varright.push_back(ve_right->getID());
         hright->addEdge(*evar_right,evar_right->getID(),list_varright);
         id_right++;
         delete evar_right;
      }


      int edge_id=produceRecord(hleft, LEFTHAND, id_left, recordname, ve_left->getID(), recordcomp, vertexnext_left);
      list<IDTYPE> vertexlist = hleft->getConnectedVertices(edge_id);
      list<IDTYPE>::iterator itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      { 
         leftmap.push_back(*itr);
         itr++;
      }

      VERTEX *ve_new=new (VERTEX);
      ve_new->setIdLabel(catstrint("ger",id_right));
      ve_new->setID(id_right);
      hright->addVertex(*ve_new,ve_new->getID());
      id_right++;

      edge_id=produceRecord(hright, RIGHTHAND, id_right, recordname, ve_right->getID(), recordcomp, vertexnext_right);
      vertexlist = hright->getConnectedVertices(edge_id);
      itr = vertexlist.begin();
      itr++;
      while(itr != vertexlist.end())
      { 
         if (*itr==vertexnext_right) {
            list <IDTYPE> list_null;
            list_null.push_back(*itr);
            EDGE *enull = new(EDGE);
            enull->setLabel("null");
            enull->setIdLabel(catstrint("ger",id_right));
            enull->setID(id_right);
            hright->addEdge(*enull,enull->getID(),list_null);
            id_right++;
            rightmap.push_back(ve_new->getID());
            delete enull;
         }
         else
            rightmap.push_back(*itr);
         itr++;
      }


      RecordEntry *re_last= getRecordComp(symboltable, recordcomp, recordname);
      char *recordname_2Comp=re_last->recordname;

      int d=1;
      int x=1;
      list <IDTYPE> list_rec_left;
      list_rec_left.push_back(vertexnext_left);

      EDGE *erec_left = new (EDGE);
      erec_left->setLabel(recordname_2Comp);
      erec_left->setIdLabel(catstrint("gel",id_left));
      erec_left->setID(id_left);
      id_left++;

      RecordEntry *re=getNRecordComp(symboltable, recordname_2Comp,d);
      assert(re!=NULL);

      while (re != NULL) {
         VERTEX *ve=new (VERTEX);
         ve->setIdLabel(catstrint("gel",id_left));
         ve->setID(id_left);
         hleft->addVertex(*ve,ve->getID());
         list <IDTYPE> list_;
         list_.push_back(ve->getID());
         list_rec_left.push_back(ve->getID());
         id_left++;

         VERTEX *ve_right=new (VERTEX);
         ve_right->setIdLabel(catstrint("ger",id_right));
         ve_right->setID(id_right);
         hright->addVertex(*ve_right,ve_right->getID());
         id_right++;

         if(re->type==intType) {
            EDGE *edge=new(EDGE);
            edge->setLabel("integer");
            edge->setIdLabel(catstrint("gel",id_left));
            edge->setID(id_left);/*
         TYPES types;
         types.push_back(INTEGER);
         edge->setType(types);
         EXPRESSION *exp=new EXPRESSION(types, catstrint("x",x), "value");
         edge->addAttributes(*exp);*/
            hleft->addEdge(*edge,edge->getID(),list_);
            x++;
            id_left++;
            delete edge;
         }
         else if(re->type==strType) {
            EDGE *edge=new(EDGE);
            edge->setLabel("string");
            edge->setIdLabel(catstrint("gel",id_left));
            edge->setID(id_left);/*
         TYPES types;
         types.push_back(STRING);
         edge->setType(types);
         EXPRESSION *exp=new EXPRESSION(types, catstrint("x",x), "value");
         edge->addAttributes(*exp);*/
            hleft->addEdge(*edge,edge->getID(),list_);
	    x++;
            id_left++;
            delete edge;
         }
         leftmap.push_back(ve->getID());
         rightmap.push_back(ve_right->getID());
         re=getNRecordComp(symboltable, recordname_2Comp,++d);
         delete ve, ve_right;
      }

      hleft->addEdge(*erec_left,erec_left->getID(),list_rec_left);

      //Match
      MATCH *match=new MATCH();
      list<IDTYPE>::iterator itr_right = rightmap.begin();
      for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
      {
         match->setMatch(*itr_left,*itr_right);
         itr_right++;
      }
      rule->setInterface(*match);

      rule->setLeft(hleft);
      rule->setRight(hright);
      rulelist.push_back(rule);

      delete ve_left, ve_right, ve_new, ecounter_left, ecounter_right, evar_left, erec_left;
      delete hleft, hright, match;

   }
   //2 Regel
   {
      RULE *rule=new(RULE);
      char *rulename_=catstrstr(rulename, "(2)");
      rule->setName(addRuleID(rulename_));

      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName(hleftname);
      hright->setName(hrightname);

      list <IDTYPE> leftmap;
      list <IDTYPE> rightmap;

      int id_left, id_right;
      id_left=id_right=1;
      int vertexnext_left = -1;
      int vertexnext_right = -1;

      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      EDGE *ecounter_right=new(EDGE);
      ecounter_right->setLabel(strcounter_r);
      ecounter_right->setIdLabel(catstrint("ger",id_right));
      ecounter_right->setID(id_right);
      hright->addEdge(*ecounter_right,ecounter_right->getID(),lnull);
      id_right++;

      VERTEX *ve_left=new (VERTEX);
      ve_left->setIdLabel(catstrint("gel",id_left));
      ve_left->setID(id_left);
      hleft->addVertex(*ve_left,ve_left->getID());
      id_left++;
      leftmap.push_back(ve_left->getID());

      VERTEX *ve_right=new (VERTEX);
      ve_right->setIdLabel(catstrint("ger",id_right));
      ve_right->setID(id_right);
      hright->addVertex(*ve_right,ve_right->getID());
      id_right++;

      VERTEX *venull=new (VERTEX);
      venull->setIdLabel(catstrint("ger",id_right));
      venull->setID(id_right);
      hright->addVertex(*venull,venull->getID());
      id_right++;
      rightmap.push_back(venull->getID());

      EDGE *evar_left = new(EDGE);
      evar_left->setLabel(varname);
      evar_left->setIdLabel(catstrint("gel",id_left));
      evar_left->setID(id_left);
      list <IDTYPE> list_varleft;
      list_varleft.push_back(ve_left->getID());
      hleft->addEdge(*evar_left,evar_left->getID(),list_varleft);
      id_left++;

      list <IDTYPE> list_varright;
      if (!deletevarright) {
         EDGE *evar_right = new(EDGE);
         evar_right->setLabel(varname);
         evar_right->setIdLabel(catstrint("ger",id_right));
         evar_right->setID(id_right);
         list_varright.push_back(ve_right->getID());
         hright->addEdge(*evar_right,evar_right->getID(),list_varright);
         id_right++;
         delete evar_right;
      }

      EDGE *enull = new(EDGE);
      enull->setLabel("null");
      enull->setIdLabel(catstrint("ger",id_right));
      enull->setID(id_right);
      hright->addEdge(*enull,enull->getID(),list_varright);
      id_right++;

      int d=1;
      int x=1;
      list <IDTYPE> list_rec_left;
      list_rec_left.push_back(ve_left->getID());

      EDGE *erec_left = new (EDGE);
      erec_left->setLabel(recordname);
      erec_left->setIdLabel(catstrint("gel",id_left));
      erec_left->setID(id_left);
      id_left++;

      RecordEntry *re=getNRecordComp(symboltable, recordname,d);
      assert(re!=NULL);

      while (re != NULL) {
         if (strcmp(re->name, recordcomp)==0) {
            list_rec_left.push_back(ve_left->getID());
         }
         else {
            VERTEX *ve=new (VERTEX);
            ve->setIdLabel(catstrint("gel",id_left));
            ve->setID(id_left);
            hleft->addVertex(*ve,ve->getID());
            id_left++;
            list <IDTYPE> list_;
            list_.push_back(ve->getID());
            list_rec_left.push_back(ve->getID());
            leftmap.push_back(ve->getID());

            VERTEX *ve_right=new (VERTEX);
            ve_right->setIdLabel(catstrint("ger",id_right));
            ve_right->setID(id_right);
            hright->addVertex(*ve_right,ve_right->getID());
            id_right++;
            rightmap.push_back(ve_right->getID());

            if(re->type==intType) {

               EDGE *edge=new(EDGE);
               edge->setLabel("integer");
               edge->setIdLabel(catstrint("gel",id_left));
               edge->setID(id_left);/*
               TYPES types;
               types.push_back(INTEGER);
               edge->setType(types);
               EXPRESSION *exp=new EXPRESSION(types, catstrint("x",x), "value");
               edge->addAttributes(*exp);*/
               hleft->addEdge(*edge,edge->getID(),list_);
               x++;
               id_left++;
               delete edge;
            }

            else if(re->type==strType) {
               EDGE *edge=new(EDGE);
               edge->setLabel("string");
               edge->setIdLabel(catstrint("gel",id_left));
               edge->setID(id_left);/*
               TYPES types;
               types.push_back(STRING);
               edge->setType(types);
               EXPRESSION *exp=new EXPRESSION(types, catstrint("x",x), "value");
               edge->addAttributes(*exp);*/
               hleft->addEdge(*edge,edge->getID(),list_);
	       x++;
               id_left++;
               delete edge;
            }
            delete ve, ve_right;
         }
         re=getNRecordComp(symboltable, recordname,++d);
      }
      hleft->addEdge(*erec_left,erec_left->getID(),list_rec_left);

      //Match
      MATCH *match=new MATCH();
      list<IDTYPE>::iterator itr_right = rightmap.begin();
      for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
      {
         match->setMatch(*itr_left,*itr_right);
         itr_right++;
      }
      rule->setInterface(*match);

      rule->setLeft(hleft);
      rule->setRight(hright);
      rulelist.push_back(rule);
      delete ve_left, ve_right, venull, ecounter_left, ecounter_right, evar_left, erec_left;
      delete hleft, hright, match;
   }
   //3 Regel
   {
      RULE *ruleerror=produceError(strcounter_l, varname, catstrstr(rulename , " (produce Error Rule) (3)"));
      rulelist.push_back(ruleerror);
   }
   //4 Regel
   {

      RULE *rule=new(RULE);
      char *rulename_=catstrstr(rulename , " (produce Error Rule) (4)");
      rule->setName(addRuleID(rulename_));
 
      HYPERGRAPH *hleft=new(HYPERGRAPH);
      HYPERGRAPH *hright=new(HYPERGRAPH);
      hleft->setName("producelefthandGraph");
      hright->setName("producerighthandGraph");

      list <IDTYPE> leftmap;
      list <IDTYPE> rightmap;

      int id_left, id_right;
      int vertexnext = -1;
      id_left=id_right=1;

      //linke Seite
      EDGE *ecounter_left=new(EDGE);
      ecounter_left->setLabel(strcounter_l);
      ecounter_left->setIdLabel(catstrint("gel",id_left));
      ecounter_left->setID(id_left);
      hleft->addEdge(*ecounter_left,ecounter_left->getID(),lnull);
      id_left++;

      VERTEX *ve_left=new (VERTEX);
      ve_left->setIdLabel(catstrint("gel",id_left));
      ve_left->setID(id_left);
      hleft->addVertex(*ve_left,ve_left->getID());
      id_left++;
      leftmap.push_back(ve_left->getID());

      EDGE *evar_left = new(EDGE);
      evar_left->setLabel(varname);
      evar_left->setIdLabel(catstrint("gel",id_left));
      evar_left->setID(id_left);
      list <IDTYPE> list_left;
      list_left.push_back(ve_left->getID());
      hleft->addEdge(*evar_left,evar_left->getID(),list_left);
      id_left++;

      int edge_id=produceRecord(hleft, LEFTHAND, id_left, recordname, ve_left->getID(), recordcomp, vertexnext);
      list<IDTYPE> lnull_left;
      lnull_left.push_back(vertexnext);
      list<IDTYPE> vertexlist_left = hleft->getConnectedVertices(edge_id);
      list<IDTYPE>::iterator itr_l = vertexlist_left.begin();
      while(itr_l != vertexlist_left.end())
      {
         leftmap.push_back(*itr_l);
         itr_l++;
      }

      EDGE *enull_left = new(EDGE);
      enull_left->setLabel("null");
      enull_left->setIdLabel(catstrint("gel",id_left));
      enull_left->setID(id_left);
      hleft->addEdge(*enull_left,enull_left->getID(),lnull_left);
      id_left++;

      //rechte Seite
      id_right=id_left;
      EDGE *eerror = new(EDGE);
      eerror->setLabel("error");
      eerror->setIdLabel(catstrint("ger",id_right));
      eerror->setID(id_right);
      hright->addEdge(*eerror,eerror->getID(),lnull);
      id_right++;

      VERTEX *ve_right=new (VERTEX);
      ve_right->setIdLabel(catstrint("ger",id_right));
      ve_right->setID(id_right);
      hright->addVertex(*ve_right,ve_right->getID());
      id_right++;
      rightmap.push_back(ve_right->getID());

      EDGE *evar_right = new(EDGE);
      evar_right->setLabel(varname);
      evar_right->setIdLabel(catstrint("ger",id_right));
      evar_right->setID(id_right);
      list <IDTYPE> list_right;
      list_right.push_back(ve_right->getID());
      hright->addEdge(*evar_right,evar_right->getID(),list_right);
      id_right++;

      edge_id=produceRecord(hright, RIGHTHAND, id_right, recordname, ve_right->getID(), recordcomp, vertexnext);
      list<IDTYPE> lnull_right;
      lnull_right.push_back(vertexnext);
      list<IDTYPE> vertexlist_right = hright->getConnectedVertices(edge_id);
      list<IDTYPE>::iterator itr_r = vertexlist_right.begin();
      while(itr_r != vertexlist_right.end())
      {
         rightmap.push_back(*itr_r);
         itr_r++;
      }

      EDGE *enull_right = new(EDGE);
      enull_right->setLabel("null");
      enull_right->setIdLabel(catstrint("ger",id_right));
      enull_right->setID(id_right);
      hright->addEdge(*enull_right,enull_right->getID(),lnull_right);
      id_right++;

      //Match
      MATCH *match=new MATCH();
      list<IDTYPE>::iterator itr_right = rightmap.begin();
      for(list<IDTYPE>::iterator itr_left = leftmap.begin(); itr_left != leftmap.end(); itr_left++)
      {
         match->setMatch(*itr_left,*itr_right);
         itr_right++;
      }

      rule->setInterface(*match);

      rule->setLeft(hleft);
      rule->setRight(hright);
      rulelist.push_back(rule);

      delete ve_left, ve_right, ecounter_left, eerror, evar_left, evar_right, enull_left, enull_right;
      delete hleft, hright, match;
   }

   return rulelist;

}

char *PLGTS::addRuleID(char *rulename)
{
   char *rulename_=catstrstr(rulename, "::");
   char *rulename_with_ID=catstrint(rulename_, rule_id);
   rule_id++;
   return rulename_with_ID;
}



void PLGTS::replaceSemicolon(char *str)
{
   int length=strlen(str)-1;
   if (str[0]=='"' && str[length]=='"') {
      str[0]='\'';
      str[length]='\'';
   }
}


